C "c40: COLLOC, a FORTRAN Program to calculate the eigenvalues of a circular  
Cmembrane in CARTESIAN COORDINATES "     
        PROGRAM COLLOC
	IMPLICIT NONE
	INTEGER P,I,J,III,IT,L
	PARAMETER (IT=80,P=8)
	INTEGER INDX(P)
	DOUBLE PRECISION  DETN(P,P),DET(P,P),EIGENVALUE,BETA(P),DELTA
	DOUBLE PRECISION DEIGENVALUE,D,DETV(IT),X0(P),Y0(P)
	OPEN (UNIT=2, FILE="COLLOCRes")	     
C  GUESS OF EIGENVALUE	  
C	L=1
C	IF(L.GT.1) GOTO 22
	WRITE(6,*)'GIVE GUESS OF EIGENVALUE'
	READ (5,*) EIGENVALUE
 22	DEIGENVALUE=EIGENVALUE/10
	WRITE(2,*)'FIRST EIGENVALUE= ',EIGENVALUE
	DELTA=EIGENVALUE/P
	BETA(1)=EIGENVALUE-0.0001
	DO 44 I=1,P-1
	     BETA(I+1)=BETA(I)-DELTA
 44	CONTINUE
 	DO 444 I=1,P
	  WRITE(2,*)' BETA(',I,')=',BETA(I)
 444  CONTINUE
 		 CALL DATA (P,X0,Y0,L)
C	WRITE(2,*) ' EIGENVALUE = ,        DETERMINANT = '
	DO 999 III=1,IT
	   CALL FILLUP (DETN,EIGENVALUE,BETA,X0,Y0,P)
	   CALL LUD(DETN,P,INDX,D)
	   DO 20 J=1,P
	      D=D*DETN(J,J)
 20	CONTINUE
	DETV(III)=D
	IF(III.EQ.1)GOTO 999
C IS THERE A CHANGE OF SIGN ? 
	IF(DETV(III)*DETV(III-1).LT.0.)THEN
	DEIGENVALUE=-DEIGENVALUE/2
	ENDIF
C	WRITE(2,77) EIGENVALUE,DETV(III)
C 77	FORMAT(1X, D19.13,3X,D19.13)	
	EIGENVALUE=EIGENVALUE+DEIGENVALUE
 999  CONTINUE 	   
	WRITE(2,*)'LAST EIGENVALUE:  '
	WRITE(6,*)'LAST EIGENVALUE:  '
 55	FORMAT(F16.10)	
		 CALL FILLUP (DETN,EIGENVALUE,BETA,X0,Y0,P)
C	WRITE(2,55) EIGENVALUE-DEIGENVALUE
	WRITE(6,55) EIGENVALUE-DEIGENVALUE	  	
C FILL DET WHICH  WILL BE MODIFIED IN LUD AND DETN WILL BE NEEDED	  
	DO 1 I=1,P
	  DO 2 J=1,P
	     DET(I,J)=DETN(I,J)
 2	  CONTINUE
 1	CONTINUE 
         CALL LINEQ (DET,DETN)	
C     LOOK FOR NEXT EIGENVALUE      
C	L=L+1
C	IF(L.GT.1)THEN
C	EIGENVALUE=EIGENVALUE+0.1
C	IF(L.GT.6)GOTO 100
C	GOTO 22
C	ENDIF
 100  WRITE(6,*)'I HAVE FINISHED '
	WRITE(6,*) CHAR(7)
	STOP
	END
	  
	SUBROUTINE DATA (P,X0,Y0,L)
C23456  CALCULATION OF COLLOCATION POINTS ON CIRCULAR BOUNDARY      
	IMPLICIT NONE
	INTEGER P,I,L
	DOUBLE PRECISION DTH,TH,AR,X0(P),Y0(P)
	AR=1.
	DTH=3.1415926535/P
	TH=DTH/2	
	DO 10 I=1,P
	X0(I)=AR*COS(TH)
	Y0(I)=AR*SIN(TH)
	  IF(L.EQ.1) WRITE(2,*)'X,Y',X0(I),Y0(I)
        TH=TH+DTH/2
 10   CONTINUE
	RETURN
	END
	  
	 SUBROUTINE FILLUP (DETN,EIGENVALUE,BETA,X0,Y0,P)
C23456  FILLING OF DETERMINANT	
	IMPLICIT NONE
	INTEGER P,I,N
	DOUBLE PRECISION TT,EIGENVALUE,DETN(P,P),X0(P),Y0(P),BETA(P) 	  
	DO 1 I=1,P
	  DO 2 N=1,P
	    TT=SQRT(EIGENVALUE**2-BETA(N)**2)
	    DETN(I,N)=COS(BETA(N)*Y0(I))*COS(TT*X0(I))
 2	CONTINUE
 1	CONTINUE
 	RETURN 
	END


      SUBROUTINE LUD(A,P,INDX,D)
C23456  CALCULATES DETERMINANT  BY LU DECOMPOSITION     
	 IMPLICIT NONE
	 INTEGER NMAX, P,K,IMAX,J,I, INDX
	 PARAMETER (NMAX=100)
	 DOUBLE PRECISION A(P,P),D,AAMAX,SUM,DUM, TINY,VV(NMAX)
	 PARAMETER(TINY=1.0E-40)
	 DIMENSION INDX(P)
	 D=1.
       DO 12 I=1,P
          AAMAX=0.
       DO 11 J=1,P
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))	
 11    CONTINUE
           IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
	   VV(I)=1./AAMAX
 12    CONTINUE
       DO 19 J=1,P
          DO 14 I=1,J-1
          SUM=A(I,J)
            DO 13 K=1,I-1
            SUM=SUM-A(I,K)*A(K,J)
 13         CONTINUE
          A(I,J)=SUM
  14	CONTINUE         
      AAMAX=0.
        DO 16 I=J,P
          SUM=A(I,J)
            DO 15 K=1,J-1
            SUM=SUM-A(I,K)*A(K,J)
 15     CONTINUE
        A(I,J)=SUM
        DUM=VV(I)*ABS(SUM)
        IF (DUM.GE.AAMAX) THEN
        IMAX=I
        AAMAX=DUM
        ENDIF
 16     CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,P
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
 17       CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
          IF(A(J,J).EQ.0.)A(J,J)=TINY
          IF(J.NE.P)THEN
	  DUM=1./A(J,J)
          DO 18 I=J+1,P
          A(I,J)=A(I,J)*DUM
 18       CONTINUE
        ENDIF
 19     CONTINUE
	    RETURN
        END
	
      SUBROUTINE LINEQ (DET,DETN)	
C23456  SOLVES  SYSTEM HOMOG. LINEAR EQUATIONS     
	IMPLICIT NONE
	INTEGER P,I,J,JF,L,K,NF,IF
	PARAMETER(P=8)
	DOUBLE PRECISION AF(P-1,P-1),BF(P-1),A(P),DETN(P,P), BOUNDARY(P)
	DOUBLE PRECISION C(P-1,P-1),X(P-1),PQ,DET(P,P)
	INTEGER INDX(P-1)
	A(P)=1.000000
C	REDUCTION OF SIZE OF HOMOG. LINEAR SYSTEM
      NF=P-1
	DO 501 IF=1,NF
         BF(IF)=-DET(IF,P)
         DO 501 JF=1,NF
         AF(IF,JF)=DET(IF,JF)
 501  CONTINUE
      DO 12 L=1,NF
	  DO 11 K=1,NF
           C(K,L)=AF(K,L)
 11   CONTINUE
 12   CONTINUE
         CALL LUD(C,NF,INDX,PQ)
 	DO 13 L=1,NF  
	   X(L)=BF(L)       
  13   CONTINUE
          CALL LUB(C,NF,INDX,X)
	 DO 33 I=1,NF
	   A(I)=X(I)
 33	 CONTINUE	
	 WRITE(2,*) 'PARTIAL AMPLITUDES ARE: '
	 WRITE(6,*) 'PARTIAL AMPLITUDES ARE: '
	 WRITE(2,'(1X,6F12.4)') (A(L), L=1,P)
	 WRITE(6,'(1X,6F12.4)') (A(L), L=1,P)
	 DO 10 I=1,P
          BOUNDARY(I)=0.
       DO 10 J=1,P
          BOUNDARY(I)=BOUNDARY(I)+DETN(I,J)*A(J)		  		
 10    CONTINUE
	 DO 4 I=1,P
           WRITE(2,*)'BOUNDARY(',I,')=  ', BOUNDARY(I)
	     WRITE(6,*)'BOUNDARY(',I,')=  ', BOUNDARY(I)  
 4     CONTINUE	
	 RETURN
	 END

	SUBROUTINE LUB(A,NF,INDX,B)
C23456  SOLVES REDUCED LINEAR EQUATIONS      
	IMPLICIT NONE
	INTEGER NF,I,LL,J,II,INDX(NF)
	DOUBLE PRECISION A(NF,NF),B(NF),SUM
	II=0
      DO 12 I=1,NF
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
           SUM=SUM-A(I,J)*B(J)
 11       CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
 12   CONTINUE
      DO 14 I=NF,1,-1
        SUM=B(I)
        IF(I.LT.NF)THEN
          DO 13 J=I+1,NF
            SUM=SUM-A(I,J)*B(J)
 13        CONTINUE
        ENDIF
        B(I)=SUM/A(I,I)
 14   CONTINUE
	RETURN
      END
	
