(************** Content-type: application/mathematica **************

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    202797,       4828]*)
(*NotebookOutlinePosition[    203428,       4850]*)
(*  CellTagsIndexPosition[    203384,       4846]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    RowBox[{"(*", 
      RowBox[{\(\(\ \)\(c39 : \ 
            Nontrivial\ homogeneous\ boundary\ value\ problem\ of\ the\ \
Laplace\ equation . 
                For\ the\ calculation\ of\ the\ numerical\ values\ see\ \
equations\ \((4.8  .6)\)\ to\ 4.8  .8\)\()\)\), ",", " ", 
        RowBox[{
        "page", " ", "226", " ", "of", " ", "the", " ", "book", " ", 
          "Mathematical", " ", "Methods", " ", "in", " ", "Physics", " ", 
          "and", " ", "Engineering", " ", "with", " ", 
          StyleBox["Mathematica",
            FontSlant->"Italic"]}], 
        StyleBox[",",
          FontSlant->"Italic"], 
        StyleBox[" ",
          FontSlant->"Italic"], \(CRC\ Press\), ",", 
        StyleBox[" ",
          FontSlant->"Italic"], \(ISBN\ 1584884029\)}], " ", "*)"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(Plot3D[\(-Log[Sqrt[\((x^2 + y^2)\)/20]]\) + 
        Cos[Pi\ 1*x/8] Cosh[Pi\ 1*y/8]*\((\(-0.546985\))\) + 
        Cos[Pi\ 1*y/4] Cosh[Pi\ 1*x/4]*\((\(-0.00977812\))\) + 
        Cos[Pi\ 3*x/8] Cosh[Pi\ 3*y/8]*\((\(-0.013602\))\) + 
        Cos[Pi\ 3*y/4] Cosh[Pi\ 3*x/4]*\((3.4562\ 10^\(-7\))\) + 
        Cos[Pi\ 5*x/8] Cosh[Pi\ 5*y/8]*\((\(-0.00023172\))\) + 
        Cos[Pi\ 5*y/4] Cosh[Pi\ 5*x/4]*\((\(-1.47646\)\ 10^\(-10\))\) + 
        Cos[Pi\ 7*x/8] Cosh[Pi\ 7*y/8]*\((\(-0.00001538\))\) + 
        Cos[Pi\ 7*y/4] Cosh[Pi\ 7*x/4]*\((1.01088\ 10^\(-13\))\), {x, \(-4\), 
        4}, {y, \(-2\), 2}, PlotPoints \[Rule] 45]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .81114 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% SurfaceGraphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0 1.04977 -0.0679587 1.04977 [
[.02757 .24618 -12 -8.70276 ]
[.02757 .24618 0 .29724 ]
[.17646 .18758 -11.7989 -9 ]
[.17646 .18758 .20112 0 ]
[.3345 .12542 -5.5867 -9 ]
[.3345 .12542 .4133 0 ]
[.50253 .05935 -5.27396 -9 ]
[.50253 .05935 .72604 0 ]
[.68156 -0.01098 -4.96123 -9 ]
[.68156 -0.01098 1.03877 0 ]
[.70096 -0.00478 0 -6.26206 ]
[.70096 -0.00478 12 2.73794 ]
[.78313 .12104 0 -6.13858 ]
[.78313 .12104 12 2.86142 ]
[.8565 .23339 0 -6.03127 ]
[.8565 .23339 6 2.96873 ]
[.9224 .33431 0 -5.93715 ]
[.9224 .33431 6 3.06285 ]
[.98191 .42546 0 -5.85393 ]
[.98191 .42546 6 3.14607 ]
[.0241 .26519 -6 -2.74238 ]
[.0241 .26519 0 6.25762 ]
[.01304 .33451 -18 -2.80103 ]
[.01304 .33451 0 6.19897 ]
[.00147 .40703 -6 -2.86266 ]
[.00147 .40703 0 6.13734 ]
[-0.01065 .48297 -18 -2.92749 ]
[-0.01065 .48297 0 6.07251 ]
[ 0 0 0 0 ]
[ 1 .81114 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.03716 .25514 m
.68874 0 L
s
.03716 .25514 m
.04196 .25962 L
s
[(-4)] .02757 .24618 1 .93395 Mshowa
.18558 .19702 m
.19014 .20174 L
s
[(-2)] .17646 .18758 .96648 1 Mshowa
.34306 .13535 m
.34735 .14032 L
s
[(0)] .3345 .12542 .86223 1 Mshowa
.51046 .06981 m
.51442 .07504 L
s
[(2)] .50253 .05935 .75799 1 Mshowa
.68874 0 m
.69233 .00549 L
s
[(4)] .68156 -0.01098 .65374 1 Mshowa
.125 Mabswid
.07346 .24092 m
.0763 .24365 L
s
.11029 .2265 m
.1131 .22926 L
s
.14766 .21187 m
.15043 .21466 L
s
.22407 .18195 m
.22677 .18482 L
s
.26314 .16665 m
.2658 .16956 L
s
.3028 .15112 m
.30541 .15406 L
s
.38395 .11935 m
.38647 .12237 L
s
.42547 .10309 m
.42794 .10615 L
s
.46763 .08658 m
.47006 .08968 L
s
.55397 .05277 m
.55629 .05595 L
s
.59817 .03546 m
.60044 .03868 L
s
.64309 .01787 m
.6453 .02113 L
s
.25 Mabswid
.68874 0 m
.96935 .42924 L
s
.68874 0 m
.68263 .00239 L
s
[(-2)] .70096 -0.00478 -1 .39157 Mshowa
.7708 .12553 m
.76464 .12778 L
s
[(-1)] .78313 .12104 -1 .36413 Mshowa
.84407 .23761 m
.83786 .23973 L
s
[(0)] .8565 .23339 -1 .34028 Mshowa
.9099 .3383 m
.90365 .34029 L
s
[(1)] .9224 .33431 -1 .31937 Mshowa
.96935 .42924 m
.96306 .43113 L
s
[(2)] .98191 .42546 -1 .30087 Mshowa
.125 Mabswid
.70593 .0263 m
.70226 .02771 L
s
.72272 .05198 m
.71904 .05338 L
s
.73912 .07706 m
.73543 .07845 L
s
.75514 .10158 m
.75145 .10294 L
s
.78611 .14895 m
.78241 .15028 L
s
.80108 .17185 m
.79737 .17317 L
s
.81573 .19425 m
.81201 .19555 L
s
.83006 .21617 m
.82633 .21745 L
s
.8578 .2586 m
.85407 .25986 L
s
.87123 .27915 m
.8675 .28039 L
s
.88439 .29928 m
.88065 .3005 L
s
.89727 .31899 m
.89353 .3202 L
s
.92227 .35722 m
.91851 .3584 L
s
.93439 .37576 m
.93063 .37693 L
s
.94627 .39394 m
.94251 .3951 L
s
.95792 .41176 m
.95416 .41291 L
s
.25 Mabswid
.03716 .25514 m
0 .48963 L
s
.03632 .26041 m
.04244 .25803 L
s
[(0)] .0241 .26519 1 -0.39058 Mshowa
.02532 .32988 m
.03145 .32756 L
s
[(0.5)] .01304 .33451 1 -0.37755 Mshowa
.0138 .40255 m
.01997 .4003 L
s
[(1)] .00147 .40703 1 -0.36385 Mshowa
.00174 .47864 m
.00794 .47648 L
s
[(1.5)] -0.01065 .48297 1 -0.34945 Mshowa
.125 Mabswid
.03416 .27406 m
.03783 .27264 L
s
.03198 .28783 m
.03565 .28641 L
s
.02978 .30172 m
.03345 .30031 L
s
.02756 .31574 m
.03124 .31434 L
s
.02305 .34415 m
.02674 .34277 L
s
.02077 .35855 m
.02446 .35718 L
s
.01847 .37308 m
.02216 .37172 L
s
.01615 .38774 m
.01984 .38639 L
s
.01143 .41748 m
.01514 .41615 L
s
.00904 .43256 m
.01275 .43123 L
s
.00663 .44778 m
.01034 .44646 L
s
.0042 .46314 m
.00791 .46183 L
s
.25 Mabswid
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.39787 .81114 L
s
.39787 .81114 m
.40529 .59895 L
s
.40529 .59895 m
.03716 .25514 L
s
.68874 0 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.68874 0 m
.03716 .25514 L
s
.40529 .59895 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.39787 .81114 L
s
.39787 .81114 m
.40529 .59895 L
s
0 0 m
1 0 L
1 .81114 L
0 .81114 L
closepath
clip
newpath
.5 Mabswid
.659 .741 .911 r
.39818 .59735 .40512 .60379 .41677 .60022 .40985 .59398 Metetra
.656 .747 .917 r
.40985 .59398 .41677 .60022 .42846 .59671 .42157 .59066 Metetra
.654 .753 .923 r
.42157 .59066 .42846 .59671 .4402 .59323 .43334 .58737 Metetra
.653 .76 .928 r
.43334 .58737 .4402 .59323 .452 .58973 .44517 .58407 Metetra
.651 .767 .934 r
.44517 .58407 .452 .58973 .46385 .5862 .45705 .58077 Metetra
.649 .775 .94 r
.45705 .58077 .46385 .5862 .47575 .58264 .46898 .57747 Metetra
.647 .784 .947 r
.46898 .57747 .47575 .58264 .4877 .57904 .48097 .57416 Metetra
.643 .795 .955 r
.48097 .57416 .4877 .57904 .49971 .57542 .49301 .57086 Metetra
.637 .806 .964 r
.49301 .57086 .49971 .57542 .51176 .57178 .50511 .56759 Metetra
.629 .818 .973 r
.50511 .56759 .51176 .57178 .52388 .56814 .51726 .56435 Metetra
.618 .831 .982 r
.51726 .56435 .52388 .56814 .53604 .56449 .52947 .56115 Metetra
.603 .845 .99 r
.52947 .56115 .53604 .56449 .54826 .56084 .54174 .55798 Metetra
.583 .858 .995 r
.54174 .55798 .54826 .56084 .56053 .55717 .55407 .55485 Metetra
.556 .869 .995 r
.55407 .55485 .56053 .55717 .57286 .55348 .56646 .55174 Metetra
.519 .874 .986 r
.56646 .55174 .57286 .55348 .58524 .54977 .57891 .54864 Metetra
.471 .87 .963 r
.57891 .54864 .58524 .54977 .59768 .54603 .59142 .54554 Metetra
.411 .853 .922 r
.59142 .54554 .59768 .54603 .61017 .54227 .60399 .54242 Metetra
.345 .822 .865 r
.60399 .54242 .61017 .54227 .62272 .5385 .61662 .53924 Metetra
.28 .782 .798 r
.61662 .53924 .62272 .5385 .63533 .53472 .62931 .53597 Metetra
.226 .742 .732 r
.62931 .53597 .63533 .53472 .64799 .53092 .64206 .53258 Metetra
.64206 .53258 .64799 .53092 .66071 .52711 .65486 .52901 Metetra
.65486 .52901 .66071 .52711 .67349 .52328 .66772 .52525 Metetra
.66772 .52525 .67349 .52328 .68633 .51943 .68063 .52129 Metetra
.68063 .52129 .68633 .51943 .69922 .51556 .69359 .51712 Metetra
.262 .762 .714 r
.69359 .51712 .69922 .51556 .71218 .51167 .70659 .51278 Metetra
.326 .808 .774 r
.70659 .51278 .71218 .51167 .72519 .50777 .71965 .50831 Metetra
.396 .854 .839 r
.71965 .50831 .72519 .50777 .73826 .50385 .73276 .50375 Metetra
.465 .889 .898 r
.73276 .50375 .73826 .50385 .75139 .49992 .74592 .49913 Metetra
.525 .908 .942 r
.74592 .49913 .75139 .49992 .76459 .49596 .75913 .49448 Metetra
.572 .913 .97 r
.75913 .49448 .76459 .49596 .77784 .49199 .77241 .48982 Metetra
.606 .907 .983 r
.77241 .48982 .77784 .49199 .79116 .48798 .78574 .48517 Metetra
.628 .893 .987 r
.78574 .48517 .79116 .48798 .80453 .48396 .79913 .48054 Metetra
.643 .877 .984 r
.79913 .48054 .80453 .48396 .81797 .47992 .81259 .47594 Metetra
.653 .86 .978 r
.81259 .47594 .81797 .47992 .83147 .47586 .8261 .47138 Metetra
.659 .843 .971 r
.8261 .47138 .83147 .47586 .84504 .4718 .83969 .46684 Metetra
.663 .828 .963 r
.83969 .46684 .84504 .4718 .85867 .46773 .85333 .46234 Metetra
.665 .814 .955 r
.85333 .46234 .85867 .46773 .87237 .46365 .86705 .45786 Metetra
.667 .802 .947 r
.86705 .45786 .87237 .46365 .88612 .45953 .88083 .45338 Metetra
.668 .791 .94 r
.88083 .45338 .88612 .45953 .89995 .45538 .89467 .4489 Metetra
.669 .781 .933 r
.89467 .4489 .89995 .45538 .91383 .45119 .90857 .4444 Metetra
.67 .773 .927 r
.90857 .4444 .91383 .45119 .92778 .44696 .92255 .43989 Metetra
.67 .765 .922 r
.92255 .43989 .92778 .44696 .94179 .44272 .93658 .43539 Metetra
.669 .758 .917 r
.93658 .43539 .94179 .44272 .95588 .43849 .95069 .4309 Metetra
.668 .751 .912 r
.95069 .4309 .95588 .43849 .97004 .43432 .96487 .42645 Metetra
.651 .738 .913 r
.39118 .59083 .39818 .59735 .40985 .59398 .40288 .58768 Metetra
.649 .745 .92 r
.40288 .58768 .40985 .59398 .42157 .59066 .41462 .58455 Metetra
.646 .751 .925 r
.41462 .58455 .42157 .59066 .43334 .58737 .42642 .58145 Metetra
.644 .757 .931 r
.42642 .58145 .43334 .58737 .44517 .58407 .43828 .57837 Metetra
.642 .765 .938 r
.43828 .57837 .44517 .58407 .45705 .58077 .45019 .5753 Metetra
.638 .772 .944 r
.45019 .5753 .45705 .58077 .46898 .57747 .46215 .57225 Metetra
.634 .781 .952 r
.46215 .57225 .46898 .57747 .48097 .57416 .47417 .56923 Metetra
.628 .791 .96 r
.47417 .56923 .48097 .57416 .49301 .57086 .48625 .56626 Metetra
.619 .801 .969 r
.48625 .56626 .49301 .57086 .50511 .56759 .49839 .56335 Metetra
.608 .812 .978 r
.49839 .56335 .50511 .56759 .51726 .56435 .51058 .56051 Metetra
.593 .824 .987 r
.51058 .56051 .51726 .56435 .52947 .56115 .52284 .55775 Metetra
.573 .835 .995 r
.52284 .55775 .52947 .56115 .54174 .55798 .53516 .55508 Metetra
.546 .845 .998 r
.53516 .55508 .54174 .55798 .55407 .55485 .54754 .55249 Metetra
.511 .852 .995 r
.54754 .55249 .55407 .55485 .56646 .55174 .55998 .54997 Metetra
.465 .851 .981 r
.55998 .54997 .56646 .55174 .57891 .54864 .5725 .5475 Metetra
.408 .84 .951 r
.5725 .5475 .57891 .54864 .59142 .54554 .58508 .54505 Metetra
.343 .815 .902 r
.58508 .54505 .59142 .54554 .60399 .54242 .59772 .54257 Metetra
.276 .779 .838 r
.59772 .54257 .60399 .54242 .61662 .53924 .61044 .54 Metetra
.216 .739 .768 r
.61044 .54 .61662 .53924 .62931 .53597 .62321 .53727 Metetra
.174 .705 .705 r
.62321 .53727 .62931 .53597 .64206 .53258 .63605 .53429 Metetra
.63605 .53429 .64206 .53258 .65486 .52901 .64893 .53099 Metetra
.64893 .53099 .65486 .52901 .66772 .52525 .66187 .5273 Metetra
.66187 .5273 .66772 .52525 .68063 .52129 .67485 .52322 Metetra
.236 .739 .676 r
.67485 .52322 .68063 .52129 .69359 .51712 .68787 .51874 Metetra
.301 .787 .727 r
.68787 .51874 .69359 .51712 .70659 .51278 .70093 .51394 Metetra
.376 .839 .789 r
.70093 .51394 .70659 .51278 .71965 .50831 .71404 .50888 Metetra
.451 .884 .852 r
.71404 .50888 .71965 .50831 .73276 .50375 .72718 .50365 Metetra
.519 .914 .906 r
.72718 .50365 .73276 .50375 .74592 .49913 .74037 .49833 Metetra
.573 .929 .944 r
.74037 .49833 .74592 .49913 .75913 .49448 .75361 .49297 Metetra
.613 .928 .968 r
.75361 .49297 .75913 .49448 .77241 .48982 .76691 .48762 Metetra
.64 .918 .979 r
.76691 .48762 .77241 .48982 .78574 .48517 .78026 .48231 Metetra
.657 .902 .981 r
.78026 .48231 .78574 .48517 .79913 .48054 .79367 .47708 Metetra
.667 .884 .978 r
.79367 .47708 .79913 .48054 .81259 .47594 .80714 .47191 Metetra
.673 .865 .972 r
.80714 .47191 .81259 .47594 .8261 .47138 .82067 .46683 Metetra
.676 .848 .965 r
.82067 .46683 .8261 .47138 .83969 .46684 .83428 .46182 Metetra
.677 .832 .958 r
.83428 .46182 .83969 .46684 .85333 .46234 .84794 .45689 Metetra
.678 .818 .95 r
.84794 .45689 .85333 .46234 .86705 .45786 .86168 .452 Metetra
.678 .805 .943 r
.86168 .452 .86705 .45786 .88083 .45338 .87547 .44716 Metetra
.678 .794 .937 r
.87547 .44716 .88083 .45338 .89467 .4489 .88934 .44235 Metetra
.677 .784 .93 r
.88934 .44235 .89467 .4489 .90857 .4444 .90327 .43755 Metetra
.677 .775 .925 r
.90327 .43755 .90857 .4444 .92255 .43989 .91726 .43276 Metetra
.677 .768 .919 r
.91726 .43276 .92255 .43989 .93658 .43539 .93133 .42798 Metetra
.676 .76 .915 r
.93133 .42798 .93658 .43539 .95069 .4309 .94546 .42322 Metetra
.674 .753 .91 r
.94546 .42322 .95069 .4309 .96487 .42645 .95966 .41849 Metetra
.643 .736 .916 r
.38413 .58426 .39118 .59083 .40288 .58768 .39585 .58131 Metetra
.641 .742 .922 r
.39585 .58131 .40288 .58768 .41462 .58455 .40762 .57838 Metetra
.638 .749 .928 r
.40762 .57838 .41462 .58455 .42642 .58145 .41945 .57548 Metetra
.635 .755 .934 r
.41945 .57548 .42642 .58145 .43828 .57837 .43133 .5726 Metetra
.632 .762 .941 r
.43133 .5726 .43828 .57837 .45019 .5753 .44327 .56976 Metetra
.627 .769 .948 r
.44327 .56976 .45019 .5753 .46215 .57225 .45526 .56697 Metetra
.621 .777 .956 r
.45526 .56697 .46215 .57225 .47417 .56923 .46731 .56424 Metetra
.612 .786 .964 r
.46731 .56424 .47417 .56923 .48625 .56626 .47943 .56159 Metetra
.601 .795 .974 r
.47943 .56159 .48625 .56626 .49839 .56335 .4916 .55904 Metetra
.586 .805 .983 r
.4916 .55904 .49839 .56335 .51058 .56051 .50384 .55661 Metetra
.566 .814 .992 r
.50384 .55661 .51058 .56051 .52284 .55775 .51614 .5543 Metetra
.54 .823 .998 r
.51614 .5543 .52284 .55775 .53516 .55508 .5285 .55212 Metetra
.506 .829 1 r
.5285 .55212 .53516 .55508 .54754 .55249 .54093 .55008 Metetra
.462 .83 .993 r
.54093 .55008 .54754 .55249 .55998 .54997 .55344 .54816 Metetra
.406 .822 .972 r
.55344 .54816 .55998 .54997 .5725 .5475 .56601 .54633 Metetra
.339 .802 .933 r
.56601 .54633 .5725 .5475 .58508 .54505 .57866 .54455 Metetra
.268 .77 .875 r
.57866 .54455 .58508 .54505 .59772 .54257 .59138 .54274 Metetra
.2 .729 .804 r
.59138 .54274 .59772 .54257 .61044 .54 .60417 .54081 Metetra
.147 .689 .731 r
.60417 .54081 .61044 .54 .62321 .53727 .61703 .53865 Metetra
.61703 .53865 .62321 .53727 .63605 .53429 .62995 .53611 Metetra
.62995 .53611 .63605 .53429 .64893 .53099 .64293 .53308 Metetra
.64293 .53308 .64893 .53099 .66187 .5273 .65594 .52948 Metetra
.65594 .52948 .66187 .5273 .67485 .52322 .669 .52527 Metetra
.255 .75 .677 r
.669 .52527 .67485 .52322 .68787 .51874 .68209 .52047 Metetra
.336 .809 .734 r
.68209 .52047 .68787 .51874 .70093 .51394 .6952 .51518 Metetra
.422 .865 .799 r
.6952 .51518 .70093 .51394 .71404 .50888 .70835 .5095 Metetra
.502 .909 .86 r
.70835 .5095 .71404 .50888 .72718 .50365 .72153 .50358 Metetra
.568 .936 .909 r
.72153 .50358 .72718 .50365 .74037 .49833 .73476 .49752 Metetra
.618 .945 .944 r
.73476 .49752 .74037 .49833 .75361 .49297 .74802 .49143 Metetra
.651 .94 .963 r
.74802 .49143 .75361 .49297 .76691 .48762 .76134 .48537 Metetra
.672 .926 .972 r
.76134 .48537 .76691 .48762 .78026 .48231 .77471 .4794 Metetra
.684 .908 .974 r
.77471 .4794 .78026 .48231 .79367 .47708 .78814 .47354 Metetra
.69 .889 .971 r
.78814 .47354 .79367 .47708 .80714 .47191 .80163 .46781 Metetra
.692 .87 .966 r
.80163 .46781 .80714 .47191 .82067 .46683 .81519 .46221 Metetra
.692 .852 .959 r
.81519 .46221 .82067 .46683 .83428 .46182 .82881 .45673 Metetra
.691 .836 .953 r
.82881 .45673 .83428 .46182 .84794 .45689 .84249 .45136 Metetra
.689 .821 .946 r
.84249 .45136 .84794 .45689 .86168 .452 .85625 .44608 Metetra
.688 .808 .939 r
.85625 .44608 .86168 .452 .87547 .44716 .87007 .44087 Metetra
.687 .797 .933 r
.87007 .44087 .87547 .44716 .88934 .44235 .88396 .43573 Metetra
.685 .787 .927 r
.88396 .43573 .88934 .44235 .90327 .43755 .89791 .43062 Metetra
.684 .778 .922 r
.89791 .43062 .90327 .43755 .91726 .43276 .91193 .42554 Metetra
.683 .77 .917 r
.91193 .42554 .91726 .43276 .93133 .42798 .92602 .42049 Metetra
.682 .762 .912 r
.92602 .42049 .93133 .42798 .94546 .42322 .94017 .41546 Metetra
.681 .755 .907 r
.94017 .41546 .94546 .42322 .95966 .41849 .95439 .41044 Metetra
.635 .733 .919 r
.37703 .57763 .38413 .58426 .39585 .58131 .38876 .57488 Metetra
.633 .74 .925 r
.38876 .57488 .39585 .58131 .40762 .57838 .40056 .57215 Metetra
.63 .746 .931 r
.40056 .57215 .40762 .57838 .41945 .57548 .41241 .56944 Metetra
.626 .752 .937 r
.41241 .56944 .41945 .57548 .43133 .5726 .42432 .56677 Metetra
.621 .758 .944 r
.42432 .56677 .43133 .5726 .44327 .56976 .43628 .56417 Metetra
.615 .765 .951 r
.43628 .56417 .44327 .56976 .45526 .56697 .44831 .56163 Metetra
.607 .772 .959 r
.44831 .56163 .45526 .56697 .46731 .56424 .46039 .55919 Metetra
.596 .78 .968 r
.46039 .55919 .46731 .56424 .47943 .56159 .47254 .55686 Metetra
.582 .788 .977 r
.47254 .55686 .47943 .56159 .4916 .55904 .48475 .55466 Metetra
.563 .796 .987 r
.48475 .55466 .4916 .55904 .50384 .55661 .49702 .55263 Metetra
.538 .803 .995 r
.49702 .55263 .50384 .55661 .51614 .5543 .50936 .55077 Metetra
.506 .809 .999 r
.50936 .55077 .51614 .5543 .5285 .55212 .52177 .5491 Metetra
.463 .81 .998 r
.52177 .5491 .5285 .55212 .54093 .55008 .53426 .54762 Metetra
.408 .804 .986 r
.53426 .54762 .54093 .55008 .55344 .54816 .54681 .54631 Metetra
.341 .787 .958 r
.54681 .54631 .55344 .54816 .56601 .54633 .55945 .54514 Metetra
.265 .757 .909 r
.55945 .54514 .56601 .54633 .57866 .54455 .57216 .54405 Metetra
.187 .716 .84 r
.57216 .54405 .57866 .54455 .59138 .54274 .58496 .54295 Metetra
.118 .67 .761 r
.58496 .54295 .59138 .54274 .60417 .54081 .59783 .54169 Metetra
.59783 .54169 .60417 .54081 .61703 .53865 .61077 .54013 Metetra
.61077 .54013 .61703 .53865 .62995 .53611 .62378 .53807 Metetra
.62378 .53807 .62995 .53611 .64293 .53308 .63684 .53535 Metetra
.63684 .53535 .64293 .53308 .65594 .52948 .64994 .53184 Metetra
.64994 .53184 .65594 .52948 .669 .52527 .66307 .52749 Metetra
.269 .758 .671 r
.66307 .52749 .669 .52527 .68209 .52047 .67622 .52234 Metetra
.369 .827 .736 r
.67622 .52234 .68209 .52047 .6952 .51518 .6894 .51652 Metetra
.466 .888 .804 r
.6894 .51652 .6952 .51518 .70835 .5095 .70259 .51019 Metetra
.55 .931 .864 r
.70259 .51019 .70835 .5095 .72153 .50358 .71581 .50353 Metetra
.614 .954 .91 r
.71581 .50353 .72153 .50358 .73476 .49752 .72907 .49671 Metetra
.659 .958 .94 r
.72907 .49671 .73476 .49752 .74802 .49143 .74236 .48986 Metetra
.687 .949 .957 r
.74236 .48986 .74802 .49143 .76134 .48537 .7557 .48308 Metetra
.702 .933 .964 r
.7557 .48308 .76134 .48537 .77471 .4794 .7691 .47643 Metetra
.709 .913 .965 r
.7691 .47643 .77471 .4794 .78814 .47354 .78255 .46994 Metetra
.711 .893 .963 r
.78255 .46994 .78814 .47354 .80163 .46781 .79606 .46363 Metetra
.709 .873 .958 r
.79606 .46363 .80163 .46781 .81519 .46221 .80964 .4575 Metetra
.707 .855 .953 r
.80964 .4575 .81519 .46221 .82881 .45673 .82328 .45154 Metetra
.704 .838 .947 r
.82328 .45154 .82881 .45673 .84249 .45136 .83699 .44574 Metetra
.701 .823 .941 r
.83699 .44574 .84249 .45136 .85625 .44608 .85077 .44007 Metetra
.698 .81 .935 r
.85077 .44007 .85625 .44608 .87007 .44087 .86461 .4345 Metetra
.695 .799 .929 r
.86461 .4345 .87007 .44087 .88396 .43573 .87852 .42903 Metetra
.693 .789 .924 r
.87852 .42903 .88396 .43573 .89791 .43062 .8925 .42362 Metetra
.691 .78 .919 r
.8925 .42362 .89791 .43062 .91193 .42554 .90655 .41825 Metetra
.689 .772 .914 r
.90655 .41825 .91193 .42554 .92602 .42049 .92066 .41293 Metetra
.688 .764 .91 r
.92066 .41293 .92602 .42049 .94017 .41546 .93484 .40763 Metetra
.687 .758 .905 r
.93484 .40763 .94017 .41546 .95439 .41044 .94908 .40233 Metetra
.627 .731 .922 r
.36986 .57095 .37703 .57763 .38876 .57488 .38162 .56839 Metetra
.625 .737 .928 r
.38162 .56839 .38876 .57488 .40056 .57215 .39344 .56585 Metetra
.621 .743 .934 r
.39344 .56585 .40056 .57215 .41241 .56944 .40531 .56334 Metetra
.617 .749 .94 r
.40531 .56334 .41241 .56944 .42432 .56677 .41724 .56088 Metetra
.611 .755 .947 r
.41724 .56088 .42432 .56677 .43628 .56417 .42924 .5585 Metetra
.603 .761 .954 r
.42924 .5585 .43628 .56417 .44831 .56163 .44129 .55621 Metetra
.593 .767 .963 r
.44129 .55621 .44831 .56163 .46039 .55919 .45341 .55405 Metetra
.58 .774 .971 r
.45341 .55405 .46039 .55919 .47254 .55686 .46559 .55204 Metetra
.562 .78 .981 r
.46559 .55204 .47254 .55686 .48475 .55466 .47783 .5502 Metetra
.539 .786 .989 r
.47783 .5502 .48475 .55466 .49702 .55263 .49014 .54856 Metetra
.508 .79 .996 r
.49014 .54856 .49702 .55263 .50936 .55077 .50252 .54716 Metetra
.469 .792 .999 r
.50252 .54716 .50936 .55077 .52177 .5491 .51497 .54599 Metetra
.417 .787 .994 r
.51497 .54599 .52177 .5491 .53426 .54762 .5275 .54508 Metetra
.351 .773 .976 r
.5275 .54508 .53426 .54762 .54681 .54631 .54011 .5444 Metetra
.272 .746 .938 r
.54011 .5444 .54681 .54631 .55945 .54514 .55281 .54391 Metetra
.185 .705 .877 r
.55281 .54391 .55945 .54514 .57216 .54405 .56559 .54354 Metetra
.1 .653 .797 r
.56559 .54354 .57216 .54405 .58496 .54295 .57845 .54318 Metetra
.031 .602 .71 r
.57845 .54318 .58496 .54295 .59783 .54169 .5914 .54266 Metetra
.01 0 0 r
.5914 .54266 .59783 .54169 .61077 .54013 .60443 .54176 Metetra
.017 0 0 r
.60443 .54176 .61077 .54013 .62378 .53807 .61752 .54023 Metetra
.61752 .54023 .62378 .53807 .63684 .53535 .63067 .53785 Metetra
.63067 .53785 .63684 .53535 .64994 .53184 .64385 .53444 Metetra
.64385 .53444 .64994 .53184 .66307 .52749 .65706 .52994 Metetra
.28 .762 .66 r
.65706 .52994 .66307 .52749 .67622 .52234 .67028 .5244 Metetra
.399 .843 .734 r
.67028 .5244 .67622 .52234 .6894 .51652 .68351 .518 Metetra
.508 .908 .805 r
.68351 .518 .6894 .51652 .70259 .51019 .69676 .51096 Metetra
.595 .95 .864 r
.69676 .51096 .70259 .51019 .71581 .50353 .71002 .50351 Metetra
.658 .968 .907 r
.71002 .50351 .71581 .50353 .72907 .49671 .72331 .49589 Metetra
.697 .968 .934 r
.72331 .49589 .72907 .49671 .74236 .48986 .73663 .48825 Metetra
.719 .955 .949 r
.73663 .48825 .74236 .48986 .7557 .48308 .75 .48071 Metetra
.729 .937 .955 r
.75 .48071 .7557 .48308 .7691 .47643 .76342 .47336 Metetra
.731 .916 .956 r
.76342 .47336 .7691 .47643 .78255 .46994 .77689 .46624 Metetra
.73 .895 .954 r
.77689 .46624 .78255 .46994 .79606 .46363 .79042 .45935 Metetra
.726 .875 .951 r
.79042 .45935 .79606 .46363 .80964 .4575 .80402 .4527 Metetra
.721 .857 .946 r
.80402 .4527 .80964 .4575 .82328 .45154 .81769 .44626 Metetra
.716 .84 .941 r
.81769 .44626 .82328 .45154 .83699 .44574 .83142 .44003 Metetra
.711 .825 .936 r
.83142 .44003 .83699 .44574 .85077 .44007 .84523 .43397 Metetra
.707 .812 .931 r
.84523 .43397 .85077 .44007 .86461 .4345 .8591 .42804 Metetra
.703 .801 .926 r
.8591 .42804 .86461 .4345 .87852 .42903 .87303 .42224 Metetra
.7 .791 .921 r
.87303 .42224 .87852 .42903 .8925 .42362 .88704 .41653 Metetra
.698 .782 .916 r
.88704 .41653 .8925 .42362 .90655 .41825 .90111 .41088 Metetra
.695 .774 .912 r
.90111 .41088 .90655 .41825 .92066 .41293 .91525 .40528 Metetra
.694 .766 .907 r
.91525 .40528 .92066 .41293 .93484 .40763 .92946 .39971 Metetra
.693 .76 .903 r
.92946 .39971 .93484 .40763 .94908 .40233 .94372 .39414 Metetra
.619 .729 .925 r
.36264 .56422 .36986 .57095 .38162 .56839 .37441 .56185 Metetra
.616 .735 .931 r
.37441 .56185 .38162 .56839 .39344 .56585 .38625 .55948 Metetra
.613 .74 .936 r
.38625 .55948 .39344 .56585 .40531 .56334 .39815 .55716 Metetra
.607 .746 .943 r
.39815 .55716 .40531 .56334 .41724 .56088 .41011 .55491 Metetra
.6 .751 .95 r
.41011 .55491 .41724 .56088 .42924 .5585 .42213 .55275 Metetra
.591 .756 .957 r
.42213 .55275 .42924 .5585 .44129 .55621 .43421 .55071 Metetra
.579 .762 .965 r
.43421 .55071 .44129 .55621 .45341 .55405 .44636 .54882 Metetra
.563 .767 .974 r
.44636 .54882 .45341 .55405 .46559 .55204 .45857 .54712 Metetra
.542 .772 .983 r
.45857 .54712 .46559 .55204 .47783 .5502 .47084 .54563 Metetra
.514 .775 .991 r
.47084 .54563 .47783 .5502 .49014 .54856 .48319 .5444 Metetra
.478 .776 .997 r
.48319 .5444 .49014 .54856 .50252 .54716 .49561 .54344 Metetra
.43 .772 .997 r
.49561 .54344 .50252 .54716 .51497 .54599 .5081 .54279 Metetra
.368 .761 .987 r
.5081 .54279 .51497 .54599 .5275 .54508 .52068 .54245 Metetra
.29 .737 .961 r
.52068 .54245 .5275 .54508 .54011 .5444 .53334 .54241 Metetra
.198 .699 .912 r
.53334 .54241 .54011 .5444 .55281 .54391 .54609 .54263 Metetra
.1 .645 .837 r
.54609 .54263 .55281 .54391 .56559 .54354 .55893 .54303 Metetra
.009 .583 .745 r
.55893 .54303 .56559 .54354 .57845 .54318 .57186 .54347 Metetra
.06 0 0 r
.57186 .54347 .57845 .54318 .5914 .54266 .58489 .54374 Metetra
.096 0 0 r
.58489 .54374 .5914 .54266 .60443 .54176 .598 .54356 Metetra
.092 0 0 r
.598 .54356 .60443 .54176 .61752 .54023 .61118 .54263 Metetra
.049 0 0 r
.61118 .54263 .61752 .54023 .63067 .53785 .62441 .54064 Metetra
.62441 .54064 .63067 .53785 .64385 .53444 .63768 .53735 Metetra
.63768 .53735 .64385 .53444 .65706 .52994 .65097 .53269 Metetra
.65097 .53269 .65706 .52994 .67028 .5244 .66427 .52671 Metetra
.428 .856 .727 r
.66427 .52671 .67028 .5244 .68351 .518 .67756 .51966 Metetra
.548 .926 .802 r
.67756 .51966 .68351 .518 .69676 .51096 .69085 .51183 Metetra
.639 .966 .861 r
.69085 .51183 .69676 .51096 .71002 .50351 .70415 .50354 Metetra
.698 .979 .901 r
.70415 .50354 .71002 .50351 .72331 .49589 .71747 .49505 Metetra
.732 .974 .925 r
.71747 .49505 .72331 .49589 .73663 .48825 .73083 .48658 Metetra
.748 .959 .939 r
.73083 .48658 .73663 .48825 .75 .48071 .74422 .47827 Metetra
.754 .939 .945 r
.74422 .47827 .75 .48071 .76342 .47336 .75766 .47021 Metetra
.752 .917 .946 r
.75766 .47021 .76342 .47336 .77689 .46624 .77116 .46243 Metetra
.747 .896 .945 r
.77116 .46243 .77689 .46624 .79042 .45935 .78472 .45496 Metetra
.741 .876 .942 r
.78472 .45496 .79042 .45935 .80402 .4527 .79834 .44778 Metetra
.734 .857 .939 r
.79834 .44778 .80402 .4527 .81769 .44626 .81204 .44087 Metetra
.727 .841 .935 r
.81204 .44087 .81769 .44626 .83142 .44003 .8258 .43421 Metetra
.721 .826 .93 r
.8258 .43421 .83142 .44003 .84523 .43397 .83962 .42776 Metetra
.715 .814 .926 r
.83962 .42776 .84523 .43397 .8591 .42804 .85352 .42149 Metetra
.711 .802 .922 r
.85352 .42149 .8591 .42804 .87303 .42224 .86749 .41536 Metetra
.707 .792 .917 r
.86749 .41536 .87303 .42224 .88704 .41653 .88152 .40935 Metetra
.704 .783 .913 r
.88152 .40935 .88704 .41653 .90111 .41088 .89562 .40342 Metetra
.701 .775 .909 r
.89562 .40342 .90111 .41088 .91525 .40528 .90979 .39755 Metetra
.699 .768 .905 r
.90979 .39755 .91525 .40528 .92946 .39971 .92402 .39172 Metetra
.698 .762 .901 r
.92402 .39172 .92946 .39971 .94372 .39414 .93831 .38588 Metetra
.611 .727 .928 r
.35535 .55744 .36264 .56422 .37441 .56185 .36715 .55524 Metetra
.608 .732 .933 r
.36715 .55524 .37441 .56185 .38625 .55948 .37901 .55305 Metetra
.604 .737 .939 r
.37901 .55305 .38625 .55948 .39815 .55716 .39093 .55092 Metetra
.598 .742 .945 r
.39093 .55092 .39815 .55716 .41011 .55491 .40292 .54886 Metetra
.59 .747 .952 r
.40292 .54886 .41011 .55491 .42213 .55275 .41496 .54692 Metetra
.579 .751 .959 r
.41496 .54692 .42213 .55275 .43421 .55071 .42707 .54512 Metetra
.565 .755 .967 r
.42707 .54512 .43421 .55071 .44636 .54882 .43924 .5435 Metetra
.546 .759 .976 r
.43924 .5435 .44636 .54882 .45857 .54712 .45148 .5421 Metetra
.521 .762 .984 r
.45148 .5421 .45857 .54712 .47084 .54563 .46379 .54096 Metetra
.489 .763 .992 r
.46379 .54096 .47084 .54563 .48319 .5444 .47617 .54012 Metetra
.446 .759 .995 r
.47617 .54012 .48319 .5444 .49561 .54344 .48862 .53961 Metetra
.39 .75 .992 r
.48862 .53961 .49561 .54344 .5081 .54279 .50116 .53947 Metetra
.317 .731 .977 r
.50116 .53947 .5081 .54279 .52068 .54245 .51377 .53971 Metetra
.226 .697 .942 r
.51377 .53971 .52068 .54245 .53334 .54241 .52648 .54033 Metetra
.121 .645 .88 r
.52648 .54033 .53334 .54241 .54609 .54263 .53928 .54129 Metetra
.012 .578 .791 r
.53928 .54129 .54609 .54263 .55893 .54303 .55218 .5425 Metetra
.085 0 0 r
.55218 .5425 .55893 .54303 .57186 .54347 .56519 .54379 Metetra
.154 0 0 r
.56519 .54379 .57186 .54347 .58489 .54374 .57829 .54493 Metetra
.184 0 0 r
.57829 .54493 .58489 .54374 .598 .54356 .59148 .54558 Metetra
.172 0 0 r
.59148 .54558 .598 .54356 .61118 .54263 .60475 .54534 Metetra
.115 0 0 r
.60475 .54534 .61118 .54263 .62441 .54064 .61808 .5438 Metetra
.013 0 0 r
.61808 .5438 .62441 .54064 .63768 .53735 .63144 .54066 Metetra
.63144 .54066 .63768 .53735 .65097 .53269 .64481 .5358 Metetra
.64481 .5358 .65097 .53269 .66427 .52671 .65817 .52933 Metetra
.456 .867 .716 r
.65817 .52933 .66427 .52671 .67756 .51966 .67152 .52154 Metetra
.588 .942 .796 r
.67152 .52154 .67756 .51966 .69085 .51183 .68486 .51283 Metetra
.68 .979 .854 r
.68486 .51283 .69085 .51183 .70415 .50354 .69821 .5036 Metetra
.736 .987 .892 r
.69821 .5036 .70415 .50354 .71747 .49505 .71156 .49419 Metetra
.764 .978 .915 r
.71156 .49419 .71747 .49505 .73083 .48658 .72495 .48485 Metetra
.775 .961 .928 r
.72495 .48485 .73083 .48658 .74422 .47827 .73837 .47573 Metetra
.776 .939 .934 r
.73837 .47573 .74422 .47827 .75766 .47021 .75184 .46693 Metetra
.771 .917 .936 r
.75184 .46693 .75766 .47021 .77116 .46243 .76536 .4585 Metetra
.763 .895 .936 r
.76536 .4585 .77116 .46243 .78472 .45496 .77895 .45044 Metetra
.755 .876 .934 r
.77895 .45044 .78472 .45496 .79834 .44778 .7926 .44274 Metetra
.746 .857 .932 r
.7926 .44274 .79834 .44778 .81204 .44087 .80632 .43536 Metetra
.737 .841 .928 r
.80632 .43536 .81204 .44087 .8258 .43421 .82011 .42827 Metetra
.73 .827 .925 r
.82011 .42827 .8258 .43421 .83962 .42776 .83396 .42144 Metetra
.723 .814 .921 r
.83396 .42144 .83962 .42776 .85352 .42149 .84789 .41482 Metetra
.718 .803 .918 r
.84789 .41482 .85352 .42149 .86749 .41536 .86189 .40838 Metetra
.713 .793 .914 r
.86189 .40838 .86749 .41536 .88152 .40935 .87595 .40207 Metetra
.71 .785 .91 r
.87595 .40207 .88152 .40935 .89562 .40342 .89008 .39587 Metetra
.707 .777 .906 r
.89008 .39587 .89562 .40342 .90979 .39755 .90428 .38974 Metetra
.705 .77 .903 r
.90428 .38974 .90979 .39755 .92402 .39172 .91854 .38364 Metetra
.703 .763 .899 r
.91854 .38364 .92402 .39172 .93831 .38588 .93286 .37756 Metetra
.603 .725 .93 r
.34801 .55061 .35535 .55744 .36715 .55524 .35983 .54857 Metetra
.6 .729 .935 r
.35983 .54857 .36715 .55524 .37901 .55305 .37171 .54655 Metetra
.595 .734 .941 r
.37171 .54655 .37901 .55305 .39093 .55092 .38365 .54459 Metetra
.588 .738 .947 r
.38365 .54459 .39093 .55092 .40292 .54886 .39566 .54273 Metetra
.579 .742 .954 r
.39566 .54273 .40292 .54886 .41496 .54692 .40773 .54099 Metetra
.567 .746 .961 r
.40773 .54099 .41496 .54692 .42707 .54512 .41986 .53943 Metetra
.55 .749 .969 r
.41986 .53943 .42707 .54512 .43924 .5435 .43206 .53807 Metetra
.529 .751 .977 r
.43206 .53807 .43924 .5435 .45148 .5421 .44433 .53697 Metetra
.501 .751 .985 r
.44433 .53697 .45148 .5421 .46379 .54096 .45667 .53617 Metetra
.463 .749 .991 r
.45667 .53617 .46379 .54096 .47617 .54012 .46908 .53571 Metetra
.414 .742 .993 r
.46908 .53571 .47617 .54012 .48862 .53961 .48156 .53565 Metetra
.349 .726 .986 r
.48156 .53565 .48862 .53961 .50116 .53947 .49413 .53602 Metetra
.265 .698 .964 r
.49413 .53602 .50116 .53947 .51377 .53971 .50679 .53685 Metetra
.161 .652 .918 r
.50679 .53685 .51377 .53971 .52648 .54033 .51954 .53815 Metetra
.042 .586 .842 r
.51954 .53815 .52648 .54033 .53928 .54129 .5324 .53987 Metetra
0 .505 .738 r
.5324 .53987 .53928 .54129 .55218 .5425 .54535 .54194 Metetra
.179 0 0 r
.54535 .54194 .55218 .5425 .56519 .54379 .55842 .54417 Metetra
.248 0 0 r
.55842 .54417 .56519 .54379 .57829 .54493 .5716 .54627 Metetra
.274 0 0 r
.5716 .54627 .57829 .54493 .59148 .54558 .58487 .54786 Metetra
.255 0 0 r
.58487 .54786 .59148 .54558 .60475 .54534 .59823 .54841 Metetra
.187 0 0 r
.59823 .54841 .60475 .54534 .61808 .5438 .61166 .54741 Metetra
.066 0 0 r
.61166 .54741 .61808 .5438 .63144 .54066 .62511 .54445 Metetra
.62511 .54445 .63144 .54066 .64481 .5358 .63856 .53937 Metetra
.63856 .53937 .64481 .5358 .65817 .52933 .652 .53231 Metetra
.485 .877 .7 r
.652 .53231 .65817 .52933 .67152 .52154 .66541 .52367 Metetra
.628 .955 .787 r
.66541 .52367 .67152 .52154 .68486 .51283 .6788 .51397 Metetra
.721 .989 .845 r
.6788 .51397 .68486 .51283 .69821 .5036 .69218 .50371 Metetra
.771 .992 .882 r
.69218 .50371 .69821 .5036 .71156 .49419 .70557 .4933 Metetra
.794 .98 .903 r
.70557 .4933 .71156 .49419 .72495 .48485 .71899 .48303 Metetra
.8 .96 .915 r
.71899 .48303 .72495 .48485 .73837 .47573 .73244 .47307 Metetra
.796 .937 .922 r
.73244 .47307 .73837 .47573 .75184 .46693 .74594 .46352 Metetra
.788 .915 .925 r
.74594 .46352 .75184 .46693 .76536 .4585 .75949 .45443 Metetra
.778 .894 .926 r
.75949 .45443 .76536 .4585 .77895 .45044 .77311 .44578 Metetra
.767 .874 .926 r
.77311 .44578 .77895 .45044 .7926 .44274 .78679 .43755 Metetra
.757 .857 .924 r
.78679 .43755 .7926 .44274 .80632 .43536 .80053 .42971 Metetra
.747 .841 .922 r
.80053 .42971 .80632 .43536 .82011 .42827 .81435 .42221 Metetra
.738 .827 .919 r
.81435 .42221 .82011 .42827 .83396 .42144 .82824 .415 Metetra
.731 .815 .917 r
.82824 .415 .83396 .42144 .84789 .41482 .8422 .40804 Metetra
.725 .804 .914 r
.8422 .40804 .84789 .41482 .86189 .40838 .85622 .40129 Metetra
.719 .794 .91 r
.85622 .40129 .86189 .40838 .87595 .40207 .87032 .39469 Metetra
.715 .785 .907 r
.87032 .39469 .87595 .40207 .89008 .39587 .88448 .38822 Metetra
.712 .778 .904 r
.88448 .38822 .89008 .39587 .90428 .38974 .89871 .38183 Metetra
.71 .771 .9 r
.89871 .38183 .90428 .38974 .91854 .38364 .913 .37549 Metetra
.708 .765 .897 r
.913 .37549 .91854 .38364 .93286 .37756 .92735 .36916 Metetra
.596 .722 .933 r
.3406 .54372 .34801 .55061 .35983 .54857 .35244 .54183 Metetra
.592 .727 .937 r
.35244 .54183 .35983 .54857 .37171 .54655 .36434 .53998 Metetra
.587 .731 .943 r
.36434 .53998 .37171 .54655 .38365 .54459 .37631 .53819 Metetra
.579 .734 .949 r
.37631 .53819 .38365 .54459 .39566 .54273 .38834 .53651 Metetra
.569 .738 .955 r
.38834 .53651 .39566 .54273 .40773 .54099 .40043 .53497 Metetra
.555 .74 .963 r
.40043 .53497 .40773 .54099 .41986 .53943 .41259 .53363 Metetra
.536 .742 .97 r
.41259 .53363 .41986 .53943 .43206 .53807 .42482 .53252 Metetra
.512 .742 .978 r
.42482 .53252 .43206 .53807 .44433 .53697 .43711 .53171 Metetra
.48 .74 .985 r
.43711 .53171 .44433 .53697 .45667 .53617 .44948 .53123 Metetra
.438 .735 .99 r
.44948 .53123 .45667 .53617 .46908 .53571 .46192 .53116 Metetra
.382 .723 .989 r
.46192 .53116 .46908 .53571 .48156 .53565 .47444 .53154 Metetra
.308 .701 .978 r
.47444 .53154 .48156 .53565 .49413 .53602 .48704 .53242 Metetra
.212 .663 .948 r
.48704 .53242 .49413 .53602 .50679 .53685 .49973 .53385 Metetra
.095 .605 .891 r
.49973 .53385 .50679 .53685 .51954 .53815 .51253 .53583 Metetra
0 .524 .8 r
.51253 .53583 .51954 .53815 .5324 .53987 .52543 .53836 Metetra
.165 0 0 r
.52543 .53836 .5324 .53987 .54535 .54194 .53844 .54133 Metetra
.271 0 0 r
.53844 .54133 .54535 .54194 .55842 .54417 .55157 .54457 Metetra
.338 0 0 r
.55157 .54457 .55842 .54417 .5716 .54627 .56482 .54776 Metetra
.362 0 0 r
.56482 .54776 .5716 .54627 .58487 .54786 .57817 .55042 Metetra
.338 0 0 r
.57817 .55042 .58487 .54786 .59823 .54841 .59163 .55192 Metetra
.261 0 0 r
.59163 .55192 .59823 .54841 .61166 .54741 .60515 .55158 Metetra
.125 0 0 r
.60515 .55158 .61166 .54741 .62511 .54445 .61869 .54884 Metetra
.61869 .54884 .62511 .54445 .63856 .53937 .63223 .54349 Metetra
.63223 .54349 .63856 .53937 .652 .53231 .64574 .53573 Metetra
.515 .886 .681 r
.64574 .53573 .652 .53231 .66541 .52367 .65921 .52609 Metetra
.669 .966 .774 r
.65921 .52609 .66541 .52367 .6788 .51397 .67265 .51526 Metetra
.759 .996 .833 r
.67265 .51526 .6788 .51397 .69218 .50371 .68608 .50385 Metetra
.804 .994 .869 r
.68608 .50385 .69218 .50371 .70557 .4933 .69951 .49236 Metetra
.82 .978 .89 r
.69951 .49236 .70557 .4933 .71899 .48303 .71295 .4811 Metetra
.821 .957 .902 r
.71295 .4811 .71899 .48303 .73244 .47307 .72643 .47027 Metetra
.814 .934 .91 r
.72643 .47027 .73244 .47307 .74594 .46352 .73996 .45996 Metetra
.803 .912 .914 r
.73996 .45996 .74594 .46352 .75949 .45443 .75355 .45019 Metetra
.791 .891 .916 r
.75355 .45019 .75949 .45443 .77311 .44578 .76719 .44095 Metetra
.778 .872 .917 r
.76719 .44095 .77311 .44578 .78679 .43755 .7809 .43221 Metetra
.766 .855 .917 r
.7809 .43221 .78679 .43755 .80053 .42971 .79468 .42391 Metetra
.756 .84 .915 r
.79468 .42391 .80053 .42971 .81435 .42221 .80853 .416 Metetra
.746 .826 .914 r
.80853 .416 .81435 .42221 .82824 .415 .82245 .40843 Metetra
.738 .814 .912 r
.82245 .40843 .82824 .415 .8422 .40804 .83644 .40114 Metetra
.731 .804 .909 r
.83644 .40114 .8422 .40804 .85622 .40129 .8505 .39408 Metetra
.725 .794 .907 r
.8505 .39408 .85622 .40129 .87032 .39469 .86463 .38721 Metetra
.72 .786 .904 r
.86463 .38721 .87032 .39469 .88448 .38822 .87883 .38047 Metetra
.717 .779 .901 r
.87883 .38047 .88448 .38822 .89871 .38183 .89309 .37383 Metetra
.714 .772 .898 r
.89309 .37383 .89871 .38183 .913 .37549 .90741 .36725 Metetra
.712 .766 .895 r
.90741 .36725 .913 .37549 .92735 .36916 .9218 .36068 Metetra
.588 .72 .935 r
.33314 .53677 .3406 .54372 .35244 .54183 .34499 .53503 Metetra
.584 .724 .939 r
.34499 .53503 .35244 .54183 .36434 .53998 .35692 .53333 Metetra
.579 .727 .944 r
.35692 .53333 .36434 .53998 .37631 .53819 .3689 .5317 Metetra
.57 .73 .95 r
.3689 .5317 .37631 .53819 .38834 .53651 .38096 .53019 Metetra
.559 .733 .957 r
.38096 .53019 .38834 .53651 .40043 .53497 .39307 .52885 Metetra
.543 .734 .964 r
.39307 .52885 .40043 .53497 .41259 .53363 .40526 .52772 Metetra
.523 .735 .971 r
.40526 .52772 .41259 .53363 .42482 .53252 .41751 .52685 Metetra
.496 .733 .978 r
.41751 .52685 .42482 .53252 .43711 .53171 .42983 .52631 Metetra
.46 .729 .984 r
.42983 .52631 .43711 .53171 .44948 .53123 .44222 .52615 Metetra
.413 .72 .987 r
.44222 .52615 .44948 .53123 .46192 .53116 .45469 .52645 Metetra
.35 .703 .984 r
.45469 .52645 .46192 .53116 .47444 .53154 .46723 .52726 Metetra
.267 .674 .968 r
.46723 .52726 .47444 .53154 .48704 .53242 .47987 .52865 Metetra
.16 .626 .931 r
.47987 .52865 .48704 .53242 .49973 .53385 .4926 .53067 Metetra
.03 .555 .862 r
.4926 .53067 .49973 .53385 .51253 .53583 .50543 .53336 Metetra
0 .459 .756 r
.50543 .53336 .51253 .53583 .52543 .53836 .51837 .53671 Metetra
.249 0 0 r
.51837 .53671 .52543 .53836 .53844 .54133 .53143 .54065 Metetra
.357 0 0 r
.53143 .54065 .53844 .54133 .55157 .54457 .54462 .545 Metetra
.424 0 0 r
.54462 .545 .55157 .54457 .56482 .54776 .55794 .54941 Metetra
.445 0 0 r
.55794 .54941 .56482 .54776 .57817 .55042 .57138 .55332 Metetra
.419 0 0 r
.57138 .55332 .57817 .55042 .59163 .55192 .58493 .55596 Metetra
.337 0 0 r
.58493 .55596 .59163 .55192 .60515 .55158 .59855 .55642 Metetra
.187 0 0 r
.59855 .55642 .60515 .55158 .61869 .54884 .61219 .55397 Metetra
.61219 .55397 .61869 .54884 .63223 .54349 .62582 .54829 Metetra
.62582 .54829 .63223 .54349 .64574 .53573 .63941 .53967 Metetra
.547 .892 .658 r
.63941 .53967 .64574 .53573 .65921 .52609 .65294 .52885 Metetra
.709 .975 .759 r
.65294 .52885 .65921 .52609 .67265 .51526 .66643 .5167 Metetra
.796 .999 .819 r
.66643 .5167 .67265 .51526 .68608 .50385 .67989 .50401 Metetra
.834 .993 .854 r
.67989 .50401 .68608 .50385 .69951 .49236 .69335 .49134 Metetra
.844 .975 .875 r
.69335 .49134 .69951 .49236 .71295 .4811 .70683 .47904 Metetra
.841 .952 .889 r
.70683 .47904 .71295 .4811 .72643 .47027 .72035 .4673 Metetra
.83 .929 .897 r
.72035 .4673 .72643 .47027 .73996 .45996 .73391 .45621 Metetra
.816 .907 .903 r
.73391 .45621 .73996 .45996 .75355 .45019 .74752 .44577 Metetra
.802 .887 .906 r
.74752 .44577 .75355 .45019 .76719 .44095 .7612 .43594 Metetra
.788 .869 .908 r
.7612 .43594 .76719 .44095 .7809 .43221 .77494 .42669 Metetra
.775 .853 .909 r
.77494 .42669 .7809 .43221 .79468 .42391 .78876 .41794 Metetra
.763 .838 .909 r
.78876 .41794 .79468 .42391 .80853 .416 .80264 .40964 Metetra
.753 .825 .908 r
.80264 .40964 .80853 .416 .82245 .40843 .8166 .40171 Metetra
.744 .814 .907 r
.8166 .40171 .82245 .40843 .83644 .40114 .83062 .3941 Metetra
.736 .804 .905 r
.83062 .3941 .83644 .40114 .8505 .39408 .84472 .38675 Metetra
.73 .795 .903 r
.84472 .38675 .8505 .39408 .86463 .38721 .85889 .37961 Metetra
.725 .787 .901 r
.85889 .37961 .86463 .38721 .87883 .38047 .87312 .37262 Metetra
.721 .779 .899 r
.87312 .37262 .87883 .38047 .89309 .37383 .88741 .36574 Metetra
.718 .773 .896 r
.88741 .36574 .89309 .37383 .90741 .36725 .90177 .35892 Metetra
.717 .768 .893 r
.90177 .35892 .90741 .36725 .9218 .36068 .91619 .35213 Metetra
.581 .717 .936 r
.32561 .52976 .33314 .53677 .34499 .53503 .33748 .52816 Metetra
.577 .721 .941 r
.33748 .52816 .34499 .53503 .35692 .53333 .34943 .5266 Metetra
.571 .724 .946 r
.34943 .5266 .35692 .53333 .3689 .5317 .36143 .52512 Metetra
.562 .726 .951 r
.36143 .52512 .3689 .5317 .38096 .53019 .37351 .52378 Metetra
.549 .728 .958 r
.37351 .52378 .38096 .53019 .39307 .52885 .38565 .52261 Metetra
.532 .729 .964 r
.38565 .52261 .39307 .52885 .40526 .52772 .39786 .52168 Metetra
.51 .727 .971 r
.39786 .52168 .40526 .52772 .41751 .52685 .41013 .52104 Metetra
.48 .724 .978 r
.41013 .52104 .41751 .52685 .42983 .52631 .42247 .52076 Metetra
.441 .717 .983 r
.42247 .52076 .42983 .52631 .44222 .52615 .43489 .52091 Metetra
.389 .704 .984 r
.43489 .52091 .44222 .52615 .45469 .52645 .44739 .52156 Metetra
.32 .682 .978 r
.44739 .52156 .45469 .52645 .46723 .52726 .45996 .52279 Metetra
.228 .646 .957 r
.45996 .52279 .46723 .52726 .47987 .52865 .47263 .52467 Metetra
.11 .588 .912 r
.47263 .52467 .47987 .52865 .4926 .53067 .48539 .52729 Metetra
0 .504 .831 r
.48539 .52729 .4926 .53067 .50543 .53336 .49825 .53069 Metetra
0 .394 .71 r
.49825 .53069 .50543 .53336 .51837 .53671 .51123 .5349 Metetra
.328 0 0 r
.51123 .5349 .51837 .53671 .53143 .54065 .52434 .53987 Metetra
.437 0 0 r
.52434 .53987 .53143 .54065 .54462 .545 .53758 .54543 Metetra
.503 0 0 r
.53758 .54543 .54462 .545 .55794 .54941 .55096 .55122 Metetra
.523 0 0 r
.55096 .55122 .55794 .54941 .57138 .55332 .56449 .5566 Metetra
.495 0 0 r
.56449 .5566 .57138 .55332 .58493 .55596 .57813 .56061 Metetra
.411 0 0 r
.57813 .56061 .58493 .55596 .59855 .55642 .59185 .56209 Metetra
.251 0 0 r
.59185 .56209 .59855 .55642 .61219 .55397 .6056 .56001 Metetra
.6056 .56001 .61219 .55397 .62582 .54829 .61933 .55392 Metetra
.61933 .55392 .62582 .54829 .63941 .53967 .63299 .54424 Metetra
.582 .898 .633 r
.63299 .54424 .63941 .53967 .65294 .52885 .64658 .53198 Metetra
.751 .981 .741 r
.64658 .53198 .65294 .52885 .66643 .5167 .66011 .5183 Metetra
.832 1 .803 r
.66011 .5183 .66643 .5167 .67989 .50401 .67362 .50416 Metetra
.861 .989 .838 r
.67362 .50416 .67989 .50401 .69335 .49134 .68711 .4902 Metetra
.865 .968 .86 r
.68711 .4902 .69335 .49134 .70683 .47904 .70063 .4768 Metetra
.857 .945 .875 r
.70063 .4768 .70683 .47904 .72035 .4673 .71418 .46413 Metetra
.844 .923 .885 r
.71418 .46413 .72035 .4673 .73391 .45621 .72777 .45225 Metetra
.828 .902 .892 r
.72777 .45225 .73391 .45621 .74752 .44577 .74142 .44113 Metetra
.812 .883 .896 r
.74142 .44113 .74752 .44577 .7612 .43594 .75513 .43073 Metetra
.797 .865 .9 r
.75513 .43073 .7612 .43594 .77494 .42669 .76891 .42098 Metetra
.783 .85 .902 r
.76891 .42098 .77494 .42669 .78876 .41794 .78276 .4118 Metetra
.77 .836 .903 r
.78276 .4118 .78876 .41794 .80264 .40964 .79668 .40311 Metetra
.759 .824 .903 r
.79668 .40311 .80264 .40964 .8166 .40171 .81068 .39484 Metetra
.749 .813 .902 r
.81068 .39484 .8166 .40171 .83062 .3941 .82474 .38692 Metetra
.741 .803 .901 r
.82474 .38692 .83062 .3941 .84472 .38675 .83887 .37929 Metetra
.735 .794 .9 r
.83887 .37929 .84472 .38675 .85889 .37961 .85308 .37189 Metetra
.729 .787 .898 r
.85308 .37189 .85889 .37961 .87312 .37262 .86735 .36466 Metetra
.725 .78 .896 r
.86735 .36466 .87312 .37262 .88741 .36574 .88168 .35755 Metetra
.722 .774 .894 r
.88168 .35755 .88741 .36574 .90177 .35892 .89608 .35051 Metetra
.72 .769 .891 r
.89608 .35051 .90177 .35892 .91619 .35213 .91053 .3435 Metetra
.574 .715 .938 r
.31802 .5227 .32561 .52976 .33748 .52816 .32991 .52122 Metetra
.57 .718 .942 r
.32991 .52122 .33748 .52816 .34943 .5266 .34187 .51979 Metetra
.563 .721 .947 r
.34187 .51979 .34943 .5266 .36143 .52512 .3539 .51845 Metetra
.553 .722 .952 r
.3539 .51845 .36143 .52512 .37351 .52378 .366 .51726 Metetra
.54 .723 .958 r
.366 .51726 .37351 .52378 .38565 .52261 .37816 .51626 Metetra
.522 .723 .965 r
.37816 .51626 .38565 .52261 .39786 .52168 .39039 .51551 Metetra
.498 .72 .971 r
.39039 .51551 .39786 .52168 .41013 .52104 .40269 .51509 Metetra
.466 .715 .977 r
.40269 .51509 .41013 .52104 .42247 .52076 .41505 .51506 Metetra
.424 .705 .981 r
.41505 .51506 .42247 .52076 .43489 .52091 .4275 .51549 Metetra
.367 .689 .981 r
.4275 .51549 .43489 .52091 .44739 .52156 .44001 .51648 Metetra
.292 .662 .972 r
.44001 .51648 .44739 .52156 .45996 .52279 .45262 .51811 Metetra
.192 .618 .946 r
.45262 .51811 .45996 .52279 .47263 .52467 .46531 .52048 Metetra
.063 .551 .892 r
.46531 .52048 .47263 .52467 .48539 .52729 .47809 .52368 Metetra
0 .454 .8 r
.47809 .52368 .48539 .52729 .49825 .53069 .49099 .5278 Metetra
0 .331 .664 r
.49099 .5278 .49825 .53069 .51123 .5349 .504 .53289 Metetra
.399 0 0 r
.504 .53289 .51123 .5349 .52434 .53987 .51715 .53893 Metetra
.509 0 0 r
.51715 .53893 .52434 .53987 .53758 .54543 .53044 .54581 Metetra
.573 .004 0 r
.53044 .54581 .53758 .54543 .55096 .55122 .54389 .55316 Metetra
.592 .048 0 r
.54389 .55316 .55096 .55122 .56449 .5566 .55749 .56027 Metetra
.566 .042 0 r
.55749 .56027 .56449 .5566 .57813 .56061 .57123 .56599 Metetra
.482 0 0 r
.57123 .56599 .57813 .56061 .59185 .56209 .58506 .56878 Metetra
.315 0 0 r
.58506 .56878 .59185 .56209 .6056 .56001 .59892 .56718 Metetra
.037 0 0 r
.59892 .56718 .6056 .56001 .61933 .55392 .61274 .56057 Metetra
.61274 .56057 .61933 .55392 .63299 .54424 .62648 .54953 Metetra
.621 .903 .605 r
.62648 .54953 .63299 .54424 .64658 .53198 .64013 .53551 Metetra
.792 .984 .721 r
.64013 .53551 .64658 .53198 .66011 .5183 .65371 .52003 Metetra
.864 .996 .785 r
.65371 .52003 .66011 .5183 .67362 .50416 .66725 .50426 Metetra
.885 .982 .821 r
.66725 .50426 .67362 .50416 .68711 .4902 .68079 .48892 Metetra
.883 .96 .844 r
.68079 .48892 .68711 .4902 .70063 .4768 .69434 .47436 Metetra
.871 .937 .86 r
.69434 .47436 .70063 .4768 .71418 .46413 .70792 .46073 Metetra
.855 .915 .872 r
.70792 .46073 .71418 .46413 .72777 .45225 .72155 .44805 Metetra
.838 .895 .88 r
.72155 .44805 .72777 .45225 .74142 .44113 .73524 .43626 Metetra
.82 .877 .887 r
.73524 .43626 .74142 .44113 .75513 .43073 .74899 .4253 Metetra
.804 .861 .891 r
.74899 .4253 .75513 .43073 .76891 .42098 .76281 .41506 Metetra
.789 .846 .894 r
.76281 .41506 .76891 .42098 .78276 .4118 .7767 .40546 Metetra
.776 .833 .896 r
.7767 .40546 .78276 .4118 .79668 .40311 .79066 .39641 Metetra
.764 .822 .897 r
.79066 .39641 .79668 .40311 .81068 .39484 .80469 .38781 Metetra
.754 .811 .898 r
.80469 .38781 .81068 .39484 .82474 .38692 .81879 .3796 Metetra
.746 .802 .897 r
.81879 .3796 .82474 .38692 .83887 .37929 .83297 .3717 Metetra
.739 .794 .897 r
.83297 .3717 .83887 .37929 .85308 .37189 .84721 .36405 Metetra
.733 .787 .895 r
.84721 .36405 .85308 .37189 .86735 .36466 .86152 .35658 Metetra
.729 .78 .894 r
.86152 .35658 .86735 .36466 .88168 .35755 .87589 .34925 Metetra
.726 .775 .891 r
.87589 .34925 .88168 .35755 .89608 .35051 .89033 .342 Metetra
.724 .77 .889 r
.89033 .342 .89608 .35051 .91053 .3435 .90482 .33478 Metetra
.567 .713 .94 r
.31036 .51557 .31802 .5227 .32991 .52122 .32227 .51421 Metetra
.563 .715 .944 r
.32227 .51421 .32991 .52122 .34187 .51979 .33425 .5129 Metetra
.556 .717 .948 r
.33425 .5129 .34187 .51979 .3539 .51845 .3463 .51169 Metetra
.546 .718 .953 r
.3463 .51169 .3539 .51845 .366 .51726 .35842 .51063 Metetra
.531 .718 .959 r
.35842 .51063 .366 .51726 .37816 .51626 .37061 .50978 Metetra
.512 .717 .965 r
.37061 .50978 .37816 .51626 .39039 .51551 .38286 .50921 Metetra
.487 .713 .971 r
.38286 .50921 .39039 .51551 .40269 .51509 .39518 .50898 Metetra
.453 .706 .976 r
.39518 .50898 .40269 .51509 .41505 .51506 .40757 .50918 Metetra
.407 .694 .979 r
.40757 .50918 .41505 .51506 .4275 .51549 .42003 .50988 Metetra
.347 .674 .977 r
.42003 .50988 .4275 .51549 .44001 .51648 .43257 .51119 Metetra
.266 .642 .965 r
.43257 .51119 .44001 .51648 .45262 .51811 .4452 .5132 Metetra
.158 .591 .934 r
.4452 .5132 .45262 .51811 .46531 .52048 .45791 .51604 Metetra
.021 .514 .873 r
.45791 .51604 .46531 .52048 .47809 .52368 .47073 .51981 Metetra
0 .406 .77 r
.47073 .51981 .47809 .52368 .49099 .5278 .48365 .52464 Metetra
.312 0 0 r
.48365 .52464 .49099 .5278 .504 .53289 .49669 .53062 Metetra
.462 0 0 r
.49669 .53062 .504 .53289 .51715 .53893 .50987 .53779 Metetra
.571 0 0 r
.50987 .53779 .51715 .53893 .53044 .54581 .52321 .54609 Metetra
.634 .082 0 r
.52321 .54609 .53044 .54581 .54389 .55316 .53671 .55519 Metetra
.653 .129 0 r
.53671 .55519 .54389 .55316 .55749 .56027 .55038 .56436 Metetra
.629 .127 .039 r
.55038 .56436 .55749 .56027 .57123 .56599 .56422 .57221 Metetra
.548 .062 .054 r
.56422 .57221 .57123 .56599 .58506 .56878 .57817 .57672 Metetra
.378 0 .002 r
.57817 .57672 .58506 .56878 .59892 .56718 .59215 .57579 Metetra
.073 0 0 r
.59215 .57579 .59892 .56718 .61274 .56057 .60607 .56847 Metetra
.60607 .56847 .61274 .56057 .62648 .54953 .61989 .55568 Metetra
.665 .906 .576 r
.61989 .55568 .62648 .54953 .64013 .53551 .63359 .53946 Metetra
.833 .983 .7 r
.63359 .53946 .64013 .53551 .65371 .52003 .64721 .52186 Metetra
.894 .989 .766 r
.64721 .52186 .65371 .52003 .66725 .50426 .66079 .50426 Metetra
.906 .971 .804 r
.66079 .50426 .66725 .50426 .68079 .48892 .67436 .48741 Metetra
.899 .949 .829 r
.67436 .48741 .68079 .48892 .69434 .47436 .68795 .47165 Metetra
.883 .927 .846 r
.68795 .47165 .69434 .47436 .70792 .46073 .70158 .45704 Metetra
.864 .906 .86 r
.70158 .45704 .70792 .46073 .72155 .44805 .71525 .44357 Metetra
.846 .888 .87 r
.71525 .44357 .72155 .44805 .73524 .43626 .72897 .43113 Metetra
.827 .871 .877 r
.72897 .43113 .73524 .43626 .74899 .4253 .74277 .41962 Metetra
.81 .856 .883 r
.74277 .41962 .74899 .4253 .76281 .41506 .75663 .40892 Metetra
.795 .842 .887 r
.75663 .40892 .76281 .41506 .7767 .40546 .77056 .39892 Metetra
.781 .83 .89 r
.77056 .39892 .7767 .40546 .79066 .39641 .78456 .38951 Metetra
.769 .819 .892 r
.78456 .38951 .79066 .39641 .80469 .38781 .79863 .3806 Metetra
.759 .809 .893 r
.79863 .3806 .80469 .38781 .81879 .3796 .81278 .37211 Metetra
.75 .801 .894 r
.81278 .37211 .81879 .3796 .83297 .3717 .82699 .36396 Metetra
.742 .793 .893 r
.82699 .36396 .83297 .3717 .84721 .36405 .84128 .35608 Metetra
.737 .786 .893 r
.84128 .35608 .84721 .36405 .86152 .35658 .85563 .34839 Metetra
.732 .78 .891 r
.85563 .34839 .86152 .35658 .87589 .34925 .87005 .34085 Metetra
.729 .775 .889 r
.87005 .34085 .87589 .34925 .89033 .342 .88452 .3334 Metetra
.727 .77 .887 r
.88452 .3334 .89033 .342 .90482 .33478 .89905 .32597 Metetra
.561 .71 .941 r
.30264 .50837 .31036 .51557 .32227 .51421 .31457 .50712 Metetra
.557 .713 .945 r
.31457 .50712 .32227 .51421 .33425 .5129 .32657 .50592 Metetra
.549 .714 .949 r
.32657 .50592 .33425 .5129 .3463 .51169 .33864 .50482 Metetra
.539 .715 .954 r
.33864 .50482 .3463 .51169 .35842 .51063 .35078 .50389 Metetra
.524 .714 .959 r
.35078 .50389 .35842 .51063 .37061 .50978 .36299 .50318 Metetra
.503 .711 .964 r
.36299 .50318 .37061 .50978 .38286 .50921 .37526 .50276 Metetra
.476 .706 .97 r
.37526 .50276 .38286 .50921 .39518 .50898 .3876 .50271 Metetra
.441 .697 .974 r
.3876 .50271 .39518 .50898 .40757 .50918 .40001 .50311 Metetra
.393 .682 .976 r
.40001 .50311 .40757 .50918 .42003 .50988 .4125 .50407 Metetra
.329 .659 .972 r
.4125 .50407 .42003 .50988 .43257 .51119 .42506 .50567 Metetra
.243 .623 .958 r
.42506 .50567 .43257 .51119 .4452 .5132 .43771 .50804 Metetra
.129 .566 .923 r
.43771 .50804 .4452 .5132 .45791 .51604 .45045 .51132 Metetra
0 .481 .856 r
.45045 .51132 .45791 .51604 .47073 .51981 .46328 .51564 Metetra
0 .362 .743 r
.46328 .51564 .47073 .51981 .48365 .52464 .47623 .52116 Metetra
.364 0 0 r
.47623 .52116 .48365 .52464 .49669 .53062 .48929 .52804 Metetra
.516 0 0 r
.48929 .52804 .49669 .53062 .50987 .53779 .5025 .53637 Metetra
.625 .06 0 r
.5025 .53637 .50987 .53779 .52321 .54609 .51587 .54619 Metetra
.687 .152 0 r
.51587 .54619 .52321 .54609 .53671 .55519 .52942 .55725 Metetra
.707 .203 .037 r
.52942 .55725 .53671 .55519 .55038 .56436 .54317 .56885 Metetra
.686 .206 .107 r
.54317 .56885 .55038 .56436 .56422 .57221 .5571 .5794 Metetra
.61 .147 .13 r
.5571 .5794 .56422 .57221 .57817 .57672 .57116 .58622 Metetra
.438 0 .086 r
.57116 .58622 .57817 .57672 .59215 .57579 .58527 .58622 Metetra
.105 0 0 r
.58527 .58622 .59215 .57579 .60607 .56847 .59931 .57794 Metetra
.59931 .57794 .60607 .56847 .61989 .55568 .6132 .56279 Metetra
.713 .908 .548 r
.6132 .56279 .61989 .55568 .63359 .53946 .62695 .54382 Metetra
.872 .978 .679 r
.62695 .54382 .63359 .53946 .64721 .52186 .64062 .52371 Metetra
.92 .977 .747 r
.64062 .52371 .64721 .52186 .66079 .50426 .65424 .50407 Metetra
.923 .958 .787 r
.65424 .50407 .66079 .50426 .67436 .48741 .66785 .48562 Metetra
.91 .936 .813 r
.66785 .48562 .67436 .48741 .68795 .47165 .68148 .46861 Metetra
.892 .915 .833 r
.68148 .46861 .68795 .47165 .70158 .45704 .69514 .45303 Metetra
.872 .896 .848 r
.69514 .45303 .70158 .45704 .71525 .44357 .70885 .43878 Metetra
.852 .879 .859 r
.70885 .43878 .71525 .44357 .72897 .43113 .72263 .42571 Metetra
.833 .864 .868 r
.72263 .42571 .72897 .43113 .74277 .41962 .73646 .41368 Metetra
.815 .85 .875 r
.73646 .41368 .74277 .41962 .75663 .40892 .75036 .40253 Metetra
.799 .838 .88 r
.75036 .40253 .75663 .40892 .77056 .39892 .76434 .39215 Metetra
.785 .826 .884 r
.76434 .39215 .77056 .39892 .78456 .38951 .77838 .38242 Metetra
.773 .816 .887 r
.77838 .38242 .78456 .38951 .79863 .3806 .7925 .37322 Metetra
.762 .807 .889 r
.7925 .37322 .79863 .3806 .81278 .37211 .80669 .36447 Metetra
.753 .799 .89 r
.80669 .36447 .81278 .37211 .82699 .36396 .82095 .35608 Metetra
.746 .792 .89 r
.82095 .35608 .82699 .36396 .84128 .35608 .83528 .34797 Metetra
.74 .786 .89 r
.83528 .34797 .84128 .35608 .85563 .34839 .84968 .34008 Metetra
.735 .78 .889 r
.84968 .34008 .85563 .34839 .87005 .34085 .86414 .33235 Metetra
.732 .775 .888 r
.86414 .33235 .87005 .34085 .88452 .3334 .87866 .3247 Metetra
.73 .771 .886 r
.87866 .3247 .88452 .3334 .89905 .32597 .89323 .31709 Metetra
.555 .708 .942 r
.29486 .50112 .30264 .50837 .31457 .50712 .3068 .49996 Metetra
.551 .71 .945 r
.3068 .49996 .31457 .50712 .32657 .50592 .31883 .49885 Metetra
.544 .711 .949 r
.31883 .49885 .32657 .50592 .33864 .50482 .33092 .49785 Metetra
.532 .711 .954 r
.33092 .49785 .33864 .50482 .35078 .50389 .34308 .49703 Metetra
.517 .709 .959 r
.34308 .49703 .35078 .50389 .36299 .50318 .3553 .49644 Metetra
.496 .705 .964 r
.3553 .49644 .36299 .50318 .37526 .50276 .3676 .49616 Metetra
.468 .699 .968 r
.3676 .49616 .37526 .50276 .3876 .50271 .37996 .49627 Metetra
.43 .688 .972 r
.37996 .49627 .3876 .50271 .40001 .50311 .3924 .49686 Metetra
.38 .672 .973 r
.3924 .49686 .40001 .50311 .4125 .50407 .4049 .49803 Metetra
.313 .646 .968 r
.4049 .49803 .4125 .50407 .42506 .50567 .41749 .49991 Metetra
.224 .605 .951 r
.41749 .49991 .42506 .50567 .43771 .50804 .43015 .50261 Metetra
.105 .543 .913 r
.43015 .50261 .43771 .50804 .45045 .51132 .44291 .5063 Metetra
0 .45 .84 r
.44291 .5063 .45045 .51132 .46328 .51564 .45576 .51114 Metetra
0 .323 .72 r
.45576 .51114 .46328 .51564 .47623 .52116 .46872 .51733 Metetra
.407 0 0 r
.46872 .51733 .47623 .52116 .48929 .52804 .48181 .52508 Metetra
.561 0 0 r
.48181 .52508 .48929 .52804 .5025 .53637 .49504 .53459 Metetra
.67 .118 0 r
.49504 .53459 .5025 .53637 .51587 .54619 .50844 .54599 Metetra
.731 .214 0 r
.50844 .54599 .51587 .54619 .52942 .55725 .52203 .55923 Metetra
.752 .269 .09 r
.52203 .55923 .52942 .55725 .54317 .56885 .53583 .5737 Metetra
.736 .279 .166 r
.53583 .5737 .54317 .56885 .5571 .5794 .54985 .58768 Metetra
.666 .227 .198 r
.54985 .58768 .5571 .5794 .57116 .58622 .56404 .59768 Metetra
.494 .071 .166 r
.56404 .59768 .57116 .58622 .58527 .58622 .57829 .59905 Metetra
.13 0 .013 r
.57829 .59905 .58527 .58622 .59931 .57794 .59244 .58937 Metetra
.59244 .58937 .59931 .57794 .6132 .56279 .60641 .571 Metetra
.766 .909 .523 r
.60641 .571 .6132 .56279 .62695 .54382 .62021 .54852 Metetra
.908 .968 .659 r
.62021 .54852 .62695 .54382 .64062 .52371 .63392 .52547 Metetra
.941 .962 .729 r
.63392 .52547 .64062 .52371 .65424 .50407 .64758 .50357 Metetra
.936 .942 .77 r
.64758 .50357 .65424 .50407 .66785 .48562 .66123 .48345 Metetra
.919 .922 .799 r
.66123 .48345 .66785 .48562 .68148 .46861 .6749 .46518 Metetra
.899 .903 .82 r
.6749 .46518 .68148 .46861 .69514 .45303 .68861 .44864 Metetra
.877 .886 .836 r
.68861 .44864 .69514 .45303 .70885 .43878 .70237 .43364 Metetra
.856 .87 .849 r
.70237 .43364 .70885 .43878 .72263 .42571 .71619 .41997 Metetra
.837 .857 .859 r
.71619 .41997 .72263 .42571 .73646 .41368 .73007 .40744 Metetra
.819 .844 .868 r
.73007 .40744 .73646 .41368 .75036 .40253 .74402 .39589 Metetra
.803 .833 .874 r
.74402 .39589 .75036 .40253 .76434 .39215 .75805 .38515 Metetra
.789 .822 .879 r
.75805 .38515 .76434 .39215 .77838 .38242 .77214 .37511 Metetra
.776 .813 .882 r
.77214 .37511 .77838 .38242 .7925 .37322 .7863 .36564 Metetra
.765 .805 .885 r
.7863 .36564 .7925 .37322 .80669 .36447 .80054 .35665 Metetra
.756 .797 .886 r
.80054 .35665 .80669 .36447 .82095 .35608 .81485 .34804 Metetra
.748 .791 .887 r
.81485 .34804 .82095 .35608 .83528 .34797 .82922 .33973 Metetra
.742 .785 .887 r
.82922 .33973 .83528 .34797 .84968 .34008 .84367 .33165 Metetra
.738 .78 .887 r
.84367 .33165 .84968 .34008 .86414 .33235 .85817 .32373 Metetra
.734 .775 .886 r
.85817 .32373 .86414 .33235 .87866 .3247 .87274 .31591 Metetra
.733 .772 .884 r
.87274 .31591 .87866 .3247 .89323 .31709 .88735 .30812 Metetra
.55 .706 .943 r
.287 .49381 .29486 .50112 .3068 .49996 .29897 .49273 Metetra
.546 .708 .946 r
.29897 .49273 .3068 .49996 .31883 .49885 .31101 .4917 Metetra
.538 .708 .95 r
.31101 .4917 .31883 .49885 .33092 .49785 .32313 .49078 Metetra
.527 .708 .954 r
.32313 .49078 .33092 .49785 .34308 .49703 .33531 .49004 Metetra
.511 .705 .958 r
.33531 .49004 .34308 .49703 .3553 .49644 .34755 .48956 Metetra
.489 .7 .963 r
.34755 .48956 .3553 .49644 .3676 .49616 .35987 .4894 Metetra
.46 .692 .967 r
.35987 .4894 .3676 .49616 .37996 .49627 .37225 .48965 Metetra
.422 .68 .97 r
.37225 .48965 .37996 .49627 .3924 .49686 .38471 .4904 Metetra
.37 .662 .97 r
.38471 .4904 .3924 .49686 .4049 .49803 .39724 .49177 Metetra
.301 .633 .964 r
.39724 .49177 .4049 .49803 .41749 .49991 .40984 .49389 Metetra
.209 .589 .945 r
.40984 .49389 .41749 .49991 .43015 .50261 .42252 .49689 Metetra
.086 .523 .905 r
.42252 .49689 .43015 .50261 .44291 .5063 .4353 .50095 Metetra
0 .424 .828 r
.4353 .50095 .44291 .5063 .45576 .51114 .44817 .50626 Metetra
0 .29 .702 r
.44817 .50626 .45576 .51114 .46872 .51733 .46114 .51308 Metetra
.44 0 0 r
.46114 .51308 .46872 .51733 .48181 .52508 .47425 .52167 Metetra
.597 .031 0 r
.47425 .52167 .48181 .52508 .49504 .53459 .48749 .53233 Metetra
.706 .168 0 r
.48749 .53233 .49504 .53459 .50844 .54599 .50091 .54537 Metetra
.768 .267 .015 r
.50091 .54537 .50844 .54599 .52203 .55923 .51453 .56095 Metetra
.792 .327 .134 r
.51453 .56095 .52203 .55923 .53583 .5737 .52837 .57876 Metetra
.78 .344 .216 r
.52837 .57876 .53583 .5737 .54985 .58768 .54247 .59713 Metetra
.718 .303 .258 r
.54247 .59713 .54985 .58768 .56404 .59768 .5568 .61165 Metetra
.548 .149 .238 r
.5568 .61165 .56404 .59768 .57829 .59905 .5712 .61511 Metetra
.144 0 .085 r
.5712 .61511 .57829 .59905 .59244 .58937 .58547 .60332 Metetra
.58547 .60332 .59244 .58937 .60641 .571 .59951 .58038 Metetra
.822 .908 .503 r
.59951 .58038 .60641 .571 .62021 .54852 .61336 .55344 Metetra
.939 .954 .642 r
.61336 .55344 .62021 .54852 .63392 .52547 .62711 .52697 Metetra
.957 .944 .712 r
.62711 .52697 .63392 .52547 .64758 .50357 .64081 .50265 Metetra
.945 .924 .755 r
.64081 .50265 .64758 .50357 .66123 .48345 .65451 .4808 Metetra
.925 .906 .785 r
.65451 .4808 .66123 .48345 .6749 .46518 .66823 .46129 Metetra
.903 .889 .808 r
.66823 .46129 .6749 .46518 .68861 .44864 .68199 .44383 Metetra
.881 .874 .826 r
.68199 .44383 .68861 .44864 .70237 .43364 .6958 .42811 Metetra
.859 .861 .84 r
.6958 .42811 .70237 .43364 .71619 .41997 .70967 .41388 Metetra
.84 .849 .851 r
.70967 .41388 .71619 .41997 .73007 .40744 .7236 .4009 Metetra
.822 .838 .861 r
.7236 .4009 .73007 .40744 .74402 .39589 .7376 .38896 Metetra
.806 .827 .868 r
.7376 .38896 .74402 .39589 .75805 .38515 .75168 .3779 Metetra
.791 .818 .873 r
.75168 .3779 .75805 .38515 .77214 .37511 .76582 .36758 Metetra
.778 .81 .878 r
.76582 .36758 .77214 .37511 .7863 .36564 .78003 .35786 Metetra
.768 .802 .881 r
.78003 .35786 .7863 .36564 .80054 .35665 .79432 .34865 Metetra
.758 .795 .883 r
.79432 .34865 .80054 .35665 .81485 .34804 .80868 .33984 Metetra
.751 .789 .884 r
.80868 .33984 .81485 .34804 .82922 .33973 .8231 .33134 Metetra
.744 .784 .885 r
.8231 .33134 .82922 .33973 .84367 .33165 .83759 .32309 Metetra
.74 .779 .885 r
.83759 .32309 .84367 .33165 .85817 .32373 .85215 .315 Metetra
.737 .775 .884 r
.85215 .315 .85817 .32373 .87274 .31591 .86676 .30701 Metetra
.735 .772 .883 r
.86676 .30701 .87274 .31591 .88735 .30812 .88142 .29906 Metetra
.546 .705 .944 r
.27909 .48643 .287 .49381 .29897 .49273 .29107 .48541 Metetra
.542 .706 .947 r
.29107 .48541 .29897 .49273 .31101 .4917 .30313 .48445 Metetra
.534 .706 .95 r
.30313 .48445 .31101 .4917 .32313 .49078 .31527 .4836 Metetra
.522 .704 .953 r
.31527 .4836 .32313 .49078 .33531 .49004 .32747 .48294 Metetra
.506 .701 .957 r
.32747 .48294 .33531 .49004 .34755 .48956 .33974 .48253 Metetra
.484 .695 .962 r
.33974 .48253 .34755 .48956 .35987 .4894 .35208 .48247 Metetra
.454 .687 .965 r
.35208 .48247 .35987 .4894 .37225 .48965 .36448 .48284 Metetra
.415 .673 .968 r
.36448 .48284 .37225 .48965 .38471 .4904 .37696 .48373 Metetra
.362 .653 .967 r
.37696 .48373 .38471 .4904 .39724 .49177 .3895 .48527 Metetra
.292 .622 .96 r
.3895 .48527 .39724 .49177 .40984 .49389 .40213 .48759 Metetra
.198 .576 .94 r
.40213 .48759 .40984 .49389 .42252 .49689 .41483 .49085 Metetra
.073 .506 .898 r
.41483 .49085 .42252 .49689 .4353 .50095 .42762 .49523 Metetra
0 .403 .82 r
.42762 .49523 .4353 .50095 .44817 .50626 .4405 .50098 Metetra
0 .264 .691 r
.4405 .50098 .44817 .50626 .46114 .51308 .45349 .50836 Metetra
.463 0 0 r
.45349 .50836 .46114 .51308 .47425 .52167 .4666 .51773 Metetra
.624 .068 0 r
.4666 .51773 .47425 .52167 .48749 .53233 .47986 .52949 Metetra
.735 .209 0 r
.47986 .52949 .48749 .53233 .50091 .54537 .49328 .54415 Metetra
.799 .312 .043 r
.49328 .54415 .50091 .54537 .51453 .56095 .50691 .56218 Metetra
.825 .377 .167 r
.50691 .56218 .51453 .56095 .52837 .57876 .52079 .58377 Metetra
.818 .402 .256 r
.52079 .58377 .52837 .57876 .54247 .59713 .53495 .60773 Metetra
.679 .263 .25 r
.53495 .60773 .54247 .59713 .5568 .61165 .54934 .61937 Metetra
.191 0 0 r
.54934 .61937 .5568 .61165 .5712 .61511 .56375 .6152 Metetra
.384 .845 .876 r
.56375 .6152 .5712 .61511 .58547 .60332 .57825 .611 Metetra
.731 .915 .555 r
.57825 .611 .58547 .60332 .59951 .58038 .5925 .59091 Metetra
.877 .903 .491 r
.5925 .59091 .59951 .58038 .61336 .55344 .60639 .55832 Metetra
.964 .935 .628 r
.60639 .55832 .61336 .55344 .62711 .52697 .62018 .52797 Metetra
.968 .922 .698 r
.62018 .52797 .62711 .52697 .64081 .50265 .63393 .5011 Metetra
.95 .905 .742 r
.63393 .5011 .64081 .50265 .65451 .4808 .64768 .47755 Metetra
.928 .889 .773 r
.64768 .47755 .65451 .4808 .66823 .46129 .66145 .45685 Metetra
.904 .875 .797 r
.66145 .45685 .66823 .46129 .68199 .44383 .67527 .43853 Metetra
.882 .862 .816 r
.67527 .43853 .68199 .44383 .6958 .42811 .68914 .42216 Metetra
.861 .851 .831 r
.68914 .42216 .6958 .42811 .70967 .41388 .70306 .40741 Metetra
.841 .84 .844 r
.70306 .40741 .70967 .41388 .7236 .4009 .71705 .39402 Metetra
.824 .831 .854 r
.71705 .39402 .7236 .4009 .7376 .38896 .7311 .38174 Metetra
.807 .822 .862 r
.7311 .38174 .7376 .38896 .75168 .3779 .74523 .37039 Metetra
.793 .814 .868 r
.74523 .37039 .75168 .3779 .76582 .36758 .75942 .35981 Metetra
.78 .806 .873 r
.75942 .35981 .76582 .36758 .78003 .35786 .77369 .34988 Metetra
.769 .799 .877 r
.77369 .34988 .78003 .35786 .79432 .34865 .78803 .34046 Metetra
.76 .793 .88 r
.78803 .34046 .79432 .34865 .80868 .33984 .80243 .33147 Metetra
.752 .788 .882 r
.80243 .33147 .80868 .33984 .8231 .33134 .81691 .32281 Metetra
.746 .783 .883 r
.81691 .32281 .8231 .33134 .83759 .32309 .83145 .31439 Metetra
.742 .779 .883 r
.83145 .31439 .83759 .32309 .85215 .315 .84606 .30616 Metetra
.738 .775 .883 r
.84606 .30616 .85215 .315 .86676 .30701 .86072 .29802 Metetra
.737 .772 .882 r
.86072 .29802 .86676 .30701 .88142 .29906 .87544 .28992 Metetra
.542 .704 .945 r
.2711 .479 .27909 .48643 .29107 .48541 .28311 .47802 Metetra
.538 .704 .947 r
.28311 .47802 .29107 .48541 .30313 .48445 .29519 .4771 Metetra
.53 .704 .95 r
.29519 .4771 .30313 .48445 .31527 .4836 .30734 .4763 Metetra
.519 .701 .953 r
.30734 .4763 .31527 .4836 .32747 .48294 .31957 .4757 Metetra
.502 .697 .957 r
.31957 .4757 .32747 .48294 .33974 .48253 .33186 .47536 Metetra
.48 .691 .96 r
.33186 .47536 .33974 .48253 .35208 .48247 .34422 .47538 Metetra
.45 .681 .964 r
.34422 .47538 .35208 .48247 .36448 .48284 .35664 .47583 Metetra
.41 .667 .965 r
.35664 .47583 .36448 .48284 .37696 .48373 .36914 .47684 Metetra
.357 .645 .964 r
.36914 .47684 .37696 .48373 .3895 .48527 .38171 .47851 Metetra
.287 .613 .956 r
.38171 .47851 .3895 .48527 .40213 .48759 .39435 .481 Metetra
.192 .564 .936 r
.39435 .481 .40213 .48759 .41483 .49085 .40706 .48448 Metetra
.066 .492 .894 r
.40706 .48448 .41483 .49085 .42762 .49523 .41987 .48914 Metetra
0 .387 .815 r
.41987 .48914 .42762 .49523 .4405 .50098 .43276 .49525 Metetra
0 .245 .687 r
.43276 .49525 .4405 .50098 .45349 .50836 .44576 .50312 Metetra
.476 0 0 r
.44576 .50312 .45349 .50836 .4666 .51773 .45888 .51318 Metetra
.641 .095 0 r
.45888 .51318 .4666 .51773 .47986 .52949 .47214 .52594 Metetra
.756 .24 0 r
.47214 .52594 .47986 .52949 .49328 .54415 .48556 .54212 Metetra
.823 .348 .061 r
.48556 .54212 .49328 .54415 .50691 .56218 .49919 .5626 Metetra
.852 .419 .19 r
.49919 .5626 .50691 .56218 .52079 .58377 .51307 .58829 Metetra
.839 .43 .268 r
.51307 .58829 .52079 .58377 .53495 .60773 .52728 .61584 Metetra
.199 0 0 r
.52728 .61584 .53495 .60773 .54934 .61937 .54167 .61165 Metetra
.645 .763 .934 r
.54167 .61165 .54934 .61937 .56375 .6152 .55613 .60744 Metetra
.645 .763 .934 r
.55613 .60744 .56375 .6152 .57825 .611 .57067 .6032 Metetra
.645 .763 .934 r
.57067 .6032 .57825 .611 .5925 .59091 .58529 .59895 Metetra
.96 .916 .562 r
.58529 .59895 .5925 .59091 .60639 .55832 .59928 .5627 Metetra
.981 .912 .619 r
.59928 .5627 .60639 .55832 .62018 .52797 .61312 .52815 Metetra
.973 .898 .687 r
.61312 .52815 .62018 .52797 .63393 .5011 .62693 .49874 Metetra
.951 .884 .73 r
.62693 .49874 .63393 .5011 .64768 .47755 .64074 .47358 Metetra
.927 .871 .762 r
.64074 .47358 .64768 .47755 .66145 .45685 .65458 .45179 Metetra
.904 .86 .787 r
.65458 .45179 .66145 .45685 .67527 .43853 .66845 .43268 Metetra
.882 .85 .807 r
.66845 .43268 .67527 .43853 .68914 .42216 .68238 .41574 Metetra
.861 .841 .823 r
.68238 .41574 .68914 .42216 .70306 .40741 .69636 .40055 Metetra
.842 .832 .837 r
.69636 .40055 .70306 .40741 .71705 .39402 .71041 .38679 Metetra
.824 .824 .848 r
.71041 .38679 .71705 .39402 .7311 .38174 .72452 .37421 Metetra
.808 .816 .857 r
.72452 .37421 .7311 .38174 .74523 .37039 .7387 .36261 Metetra
.794 .809 .864 r
.7387 .36261 .74523 .37039 .75942 .35981 .75295 .35181 Metetra
.781 .802 .869 r
.75295 .35181 .75942 .35981 .77369 .34988 .76727 .34168 Metetra
.771 .796 .874 r
.76727 .34168 .77369 .34988 .78803 .34046 .78166 .33209 Metetra
.761 .791 .877 r
.78166 .33209 .78803 .34046 .80243 .33147 .79612 .32293 Metetra
.754 .786 .879 r
.79612 .32293 .80243 .33147 .81691 .32281 .81066 .31412 Metetra
.748 .782 .881 r
.81066 .31412 .81691 .32281 .83145 .31439 .82525 .30557 Metetra
.743 .778 .881 r
.82525 .30557 .83145 .31439 .84606 .30616 .83991 .29719 Metetra
.74 .775 .881 r
.83991 .29719 .84606 .30616 .86072 .29802 .85463 .28893 Metetra
.738 .772 .881 r
.85463 .28893 .86072 .29802 .87544 .28992 .86939 .2807 Metetra
.539 .703 .945 r
.26304 .4715 .2711 .479 .28311 .47802 .27507 .47055 Metetra
.535 .703 .947 r
.27507 .47055 .28311 .47802 .29519 .4771 .28718 .46966 Metetra
.528 .702 .95 r
.28718 .46966 .29519 .4771 .30734 .4763 .29935 .4689 Metetra
.516 .699 .952 r
.29935 .4689 .30734 .4763 .31957 .4757 .3116 .46833 Metetra
.499 .694 .956 r
.3116 .46833 .31957 .4757 .33186 .47536 .32391 .46804 Metetra
.477 .687 .959 r
.32391 .46804 .33186 .47536 .34422 .47538 .33629 .46811 Metetra
.447 .676 .962 r
.33629 .46811 .34422 .47538 .35664 .47583 .34874 .46863 Metetra
.408 .661 .963 r
.34874 .46863 .35664 .47583 .36914 .47684 .36126 .46972 Metetra
.355 .638 .961 r
.36126 .46972 .36914 .47684 .38171 .47851 .37384 .4715 Metetra
.285 .605 .953 r
.37384 .4715 .38171 .47851 .39435 .481 .3865 .47411 Metetra
.191 .556 .933 r
.3865 .47411 .39435 .481 .40706 .48448 .39924 .47775 Metetra
.066 .483 .891 r
.39924 .47775 .40706 .48448 .41987 .48914 .41205 .48264 Metetra
0 .377 .815 r
.41205 .48264 .41987 .48914 .43276 .49525 .42496 .48904 Metetra
0 .235 .689 r
.42496 .48904 .43276 .49525 .44576 .50312 .43797 .49731 Metetra
.478 0 0 r
.43797 .49731 .44576 .50312 .45888 .51318 .45109 .50794 Metetra
.648 .111 0 r
.45109 .50794 .45888 .51318 .47214 .52594 .46434 .52156 Metetra
.769 .261 0 r
.46434 .52156 .47214 .52594 .48556 .54212 .47776 .53908 Metetra
.841 .375 .067 r
.47776 .53908 .48556 .54212 .49919 .5626 .49137 .56182 Metetra
.875 .453 .202 r
.49137 .56182 .49919 .5626 .51307 .58829 .50524 .59165 Metetra
.764 .299 .142 r
.50524 .59165 .51307 .58829 .52728 .61584 .51948 .60809 Metetra
.645 .763 .934 r
.51948 .60809 .52728 .61584 .54167 .61165 .53392 .60386 Metetra
.645 .763 .934 r
.53392 .60386 .54167 .61165 .55613 .60744 .54843 .59961 Metetra
.645 .763 .934 r
.54843 .59961 .55613 .60744 .57067 .6032 .56303 .59533 Metetra
.645 .763 .934 r
.56303 .59533 .57067 .6032 .58529 .59895 .57769 .59103 Metetra
.9 .791 .731 r
.57769 .59103 .58529 .59895 .59928 .5627 .59203 .5659 Metetra
.99 .884 .616 r
.59203 .5659 .59928 .5627 .61312 .52815 .60593 .52711 Metetra
.972 .872 .679 r
.60593 .52711 .61312 .52815 .62693 .49874 .61981 .49535 Metetra
.948 .862 .721 r
.61981 .49535 .62693 .49874 .64074 .47358 .63369 .46875 Metetra
.924 .853 .753 r
.63369 .46875 .64074 .47358 .65458 .45179 .64759 .44602 Metetra
.902 .845 .778 r
.64759 .44602 .65458 .45179 .66845 .43268 .66154 .42625 Metetra
.88 .837 .799 r
.66154 .42625 .66845 .43268 .68238 .41574 .67553 .40882 Metetra
.86 .83 .816 r
.67553 .40882 .68238 .41574 .69636 .40055 .68958 .39325 Metetra
.841 .823 .831 r
.68958 .39325 .69636 .40055 .71041 .38679 .70368 .37919 Metetra
.824 .816 .842 r
.70368 .37919 .71041 .38679 .72452 .37421 .71785 .36635 Metetra
.808 .81 .852 r
.71785 .36635 .72452 .37421 .7387 .36261 .73209 .35454 Metetra
.794 .804 .86 r
.73209 .35454 .7387 .36261 .75295 .35181 .7464 .34355 Metetra
.782 .798 .866 r
.7464 .34355 .75295 .35181 .76727 .34168 .76078 .33326 Metetra
.771 .793 .871 r
.76078 .33326 .76727 .34168 .78166 .33209 .77523 .32351 Metetra
.762 .788 .874 r
.77523 .32351 .78166 .33209 .79612 .32293 .78975 .31422 Metetra
.755 .784 .877 r
.78975 .31422 .79612 .32293 .81066 .31412 .80433 .30528 Metetra
.749 .78 .879 r
.80433 .30528 .81066 .31412 .82525 .30557 .81898 .2966 Metetra
.744 .777 .88 r
.81898 .2966 .82525 .30557 .83991 .29719 .8337 .28811 Metetra
.741 .774 .88 r
.8337 .28811 .83991 .29719 .85463 .28893 .84847 .27973 Metetra
.739 .772 .88 r
.84847 .27973 .85463 .28893 .86939 .2807 .86329 .27139 Metetra
.538 .702 .946 r
.25492 .46394 .26304 .4715 .27507 .47055 .26697 .463 Metetra
.534 .702 .947 r
.26697 .463 .27507 .47055 .28718 .46966 .2791 .46212 Metetra
.526 .7 .949 r
.2791 .46212 .28718 .46966 .29935 .4689 .2913 .46137 Metetra
.514 .697 .952 r
.2913 .46137 .29935 .4689 .3116 .46833 .30356 .46083 Metetra
.498 .691 .954 r
.30356 .46083 .3116 .46833 .32391 .46804 .3159 .46056 Metetra
.476 .684 .957 r
.3159 .46056 .32391 .46804 .33629 .46811 .3283 .46066 Metetra
.446 .673 .96 r
.3283 .46066 .33629 .46811 .34874 .46863 .34077 .46122 Metetra
.407 .656 .961 r
.34077 .46122 .34874 .46863 .36126 .46972 .35331 .46236 Metetra
.355 .633 .959 r
.35331 .46236 .36126 .46972 .37384 .4715 .36592 .46421 Metetra
.286 .599 .95 r
.36592 .46421 .37384 .4715 .3865 .47411 .37859 .46691 Metetra
.194 .55 .931 r
.37859 .46691 .3865 .47411 .39924 .47775 .39134 .47067 Metetra
.073 .477 .891 r
.39134 .47067 .39924 .47775 .41205 .48264 .40417 .47571 Metetra
0 .373 .818 r
.40417 .47571 .41205 .48264 .42496 .48904 .41709 .48232 Metetra
0 .232 .698 r
.41709 .48232 .42496 .48904 .43797 .49731 .43011 .49089 Metetra
.469 0 0 r
.43011 .49089 .43797 .49731 .45109 .50794 .44323 .50194 Metetra
.644 .116 0 r
.44323 .50194 .45109 .50794 .46434 .52156 .45648 .51621 Metetra
.773 .272 0 r
.45648 .51621 .46434 .52156 .47776 .53908 .46988 .53479 Metetra
.852 .393 .059 r
.46988 .53479 .47776 .53908 .49137 .56182 .48346 .5594 Metetra
.892 .478 .201 r
.48346 .5594 .49137 .56182 .50524 .59165 .49729 .59294 Metetra
.56 0 0 r
.49729 .59294 .50524 .59165 .51948 .60809 .51161 .60026 Metetra
.645 .763 .934 r
.51161 .60026 .51948 .60809 .53392 .60386 .5261 .59599 Metetra
.645 .763 .934 r
.5261 .59599 .53392 .60386 .54843 .59961 .54066 .5917 Metetra
.645 .763 .934 r
.54066 .5917 .54843 .59961 .56303 .59533 .5553 .58738 Metetra
.645 .763 .934 r
.5553 .58738 .56303 .59533 .57769 .59103 .57002 .58304 Metetra
.846 .8 .807 r
.57002 .58304 .57769 .59103 .59203 .5659 .58462 .56701 Metetra
.988 .853 .617 r
.58462 .56701 .59203 .5659 .60593 .52711 .5986 .52442 Metetra
.965 .845 .674 r
.5986 .52442 .60593 .52711 .61981 .49535 .61256 .49069 Metetra
.942 .839 .714 r
.61256 .49069 .61981 .49535 .63369 .46875 .62653 .46294 Metetra
.919 .834 .745 r
.62653 .46294 .63369 .46875 .64759 .44602 .64051 .43947 Metetra
.898 .829 .771 r
.64051 .43947 .64759 .44602 .66154 .42625 .65453 .41919 Metetra
.877 .825 .792 r
.65453 .41919 .66154 .42625 .67553 .40882 .66859 .40137 Metetra
.858 .82 .81 r
.66859 .40137 .67553 .40882 .68958 .39325 .6827 .3855 Metetra
.84 .814 .825 r
.6827 .3855 .68958 .39325 .70368 .37919 .69687 .3712 Metetra
.823 .809 .837 r
.69687 .3712 .70368 .37919 .71785 .36635 .71111 .35817 Metetra
.808 .804 .847 r
.71111 .35817 .71785 .36635 .73209 .35454 .72541 .34618 Metetra
.794 .799 .856 r
.72541 .34618 .73209 .35454 .7464 .34355 .73977 .33504 Metetra
.782 .794 .862 r
.73977 .33504 .7464 .34355 .76078 .33326 .75421 .32461 Metetra
.771 .789 .868 r
.75421 .32461 .76078 .33326 .77523 .32351 .76872 .31474 Metetra
.762 .785 .872 r
.76872 .31474 .77523 .32351 .78975 .31422 .7833 .30533 Metetra
.755 .782 .875 r
.7833 .30533 .78975 .31422 .80433 .30528 .79794 .29628 Metetra
.749 .779 .877 r
.79794 .29628 .80433 .30528 .81898 .2966 .81265 .2875 Metetra
.745 .776 .878 r
.81265 .2875 .81898 .2966 .8337 .28811 .82742 .2789 Metetra
.741 .774 .879 r
.82742 .2789 .8337 .28811 .84847 .27973 .84225 .27043 Metetra
.74 .772 .879 r
.84225 .27043 .84847 .27973 .86329 .27139 .85713 .26199 Metetra
.536 .702 .946 r
.24672 .45631 .25492 .46394 .26697 .463 .25879 .45537 Metetra
.533 .701 .947 r
.25879 .45537 .26697 .463 .2791 .46212 .27095 .45448 Metetra
.525 .699 .949 r
.27095 .45448 .2791 .46212 .2913 .46137 .28317 .45373 Metetra
.514 .695 .951 r
.28317 .45373 .2913 .46137 .30356 .46083 .29546 .45318 Metetra
.498 .689 .953 r
.29546 .45318 .30356 .46083 .3159 .46056 .30782 .45292 Metetra
.476 .681 .956 r
.30782 .45292 .3159 .46056 .3283 .46066 .32025 .45302 Metetra
.447 .669 .958 r
.32025 .45302 .3283 .46066 .34077 .46122 .33274 .4536 Metetra
.409 .653 .958 r
.33274 .4536 .34077 .46122 .35331 .46236 .3453 .45476 Metetra
.358 .629 .956 r
.3453 .45476 .35331 .46236 .36592 .46421 .35793 .45664 Metetra
.291 .595 .948 r
.35793 .45664 .36592 .46421 .37859 .46691 .37062 .45939 Metetra
.202 .547 .93 r
.37062 .45939 .37859 .46691 .39134 .47067 .38339 .46321 Metetra
.085 .476 .893 r
.38339 .46321 .39134 .47067 .40417 .47571 .39623 .46833 Metetra
0 .375 .825 r
.39623 .46833 .40417 .47571 .41709 .48232 .40916 .47507 Metetra
0 .238 .714 r
.40916 .47507 .41709 .48232 .43011 .49089 .42218 .48382 Metetra
0 .07 .551 r
.42218 .48382 .43011 .49089 .44323 .50194 .43531 .49513 Metetra
.627 .109 0 r
.43531 .49513 .44323 .50194 .45648 .51621 .44855 .50982 Metetra
.766 .271 0 r
.44855 .50982 .45648 .51621 .46988 .53479 .46193 .52908 Metetra
.855 .4 .035 r
.46193 .52908 .46988 .53479 .48346 .5594 .47549 .55494 Metetra
.903 .493 .185 r
.47549 .55494 .48346 .5594 .49729 .59294 .48926 .59111 Metetra
.034 .593 .812 r
.48926 .59111 .49729 .59294 .51161 .60026 .50366 .59236 Metetra
.645 .763 .934 r
.50366 .59236 .51161 .60026 .5261 .59599 .5182 .58804 Metetra
.645 .763 .934 r
.5182 .58804 .5261 .59599 .54066 .5917 .53281 .58371 Metetra
.645 .763 .934 r
.53281 .58371 .54066 .5917 .5553 .58738 .54751 .57935 Metetra
.645 .763 .934 r
.54751 .57935 .5553 .58738 .57002 .58304 .56228 .57497 Metetra
.772 .795 .872 r
.56228 .57497 .57002 .58304 .58462 .56701 .57704 .56497 Metetra
.976 .819 .622 r
.57704 .56497 .58462 .56701 .5986 .52442 .59114 .51966 Metetra
.954 .818 .671 r
.59114 .51966 .5986 .52442 .61256 .49069 .6052 .48459 Metetra
.932 .817 .709 r
.6052 .48459 .61256 .49069 .62653 .46294 .61925 .45606 Metetra
.912 .816 .74 r
.61925 .45606 .62653 .46294 .64051 .43947 .63332 .43209 Metetra
.892 .815 .765 r
.63332 .43209 .64051 .43947 .65453 .41919 .64742 .41146 Metetra
.873 .812 .787 r
.64742 .41146 .65453 .41919 .66859 .40137 .66155 .39338 Metetra
.854 .809 .805 r
.66155 .39338 .66859 .40137 .6827 .3855 .67574 .3773 Metetra
.837 .805 .82 r
.67574 .3773 .6827 .3855 .69687 .3712 .68998 .36282 Metetra
.821 .802 .833 r
.68998 .36282 .69687 .3712 .71111 .35817 .70428 .34964 Metetra
.806 .798 .844 r
.70428 .34964 .71111 .35817 .72541 .34618 .71864 .33752 Metetra
.793 .793 .852 r
.71864 .33752 .72541 .34618 .73977 .33504 .73307 .32627 Metetra
.781 .79 .859 r
.73307 .32627 .73977 .33504 .75421 .32461 .74757 .31572 Metetra
.771 .786 .865 r
.74757 .31572 .75421 .32461 .76872 .31474 .76214 .30576 Metetra
.762 .782 .87 r
.76214 .30576 .76872 .31474 .7833 .30533 .77678 .29626 Metetra
.755 .779 .873 r
.77678 .29626 .7833 .30533 .79794 .29628 .79148 .28712 Metetra
.749 .777 .876 r
.79148 .28712 .79794 .29628 .81265 .2875 .80625 .27825 Metetra
.745 .775 .877 r
.80625 .27825 .81265 .2875 .82742 .2789 .82108 .26957 Metetra
.742 .773 .878 r
.82108 .26957 .82742 .2789 .84225 .27043 .83597 .26101 Metetra
.74 .772 .879 r
.83597 .26101 .84225 .27043 .85713 .26199 .85091 .2525 Metetra
.536 .701 .946 r
.23845 .44861 .24672 .45631 .25879 .45537 .25055 .44765 Metetra
.532 .7 .947 r
.25055 .44765 .25879 .45537 .27095 .45448 .26273 .44674 Metetra
.525 .698 .948 r
.26273 .44674 .27095 .45448 .28317 .45373 .27498 .44597 Metetra
.514 .694 .95 r
.27498 .44597 .28317 .45373 .29546 .45318 .28729 .4454 Metetra
.498 .687 .952 r
.28729 .4454 .29546 .45318 .30782 .45292 .29968 .44512 Metetra
.477 .679 .954 r
.29968 .44512 .30782 .45292 .32025 .45302 .31213 .44521 Metetra
.449 .667 .955 r
.31213 .44521 .32025 .45302 .33274 .4536 .32465 .44577 Metetra
.412 .65 .956 r
.32465 .44577 .33274 .4536 .3453 .45476 .33723 .44692 Metetra
.363 .626 .954 r
.33723 .44692 .3453 .45476 .35793 .45664 .34987 .44879 Metetra
.299 .593 .946 r
.34987 .44879 .35793 .45664 .37062 .45939 .36259 .45154 Metetra
.215 .546 .929 r
.36259 .45154 .37062 .45939 .38339 .46321 .37537 .45536 Metetra
.103 .478 .896 r
.37537 .45536 .38339 .46321 .39623 .46833 .38823 .4605 Metetra
0 .382 .835 r
.38823 .4605 .39623 .46833 .40916 .47507 .40117 .46727 Metetra
0 .251 .734 r
.40117 .46727 .40916 .47507 .42218 .48382 .4142 .47607 Metetra
0 .089 .585 r
.4142 .47607 .42218 .48382 .43531 .49513 .42733 .48747 Metetra
.596 .089 0 r
.42733 .48747 .43531 .49513 .44855 .50982 .44056 .5023 Metetra
.745 .256 0 r
.44056 .5023 .44855 .50982 .46193 .52908 .45393 .52181 Metetra
.846 .393 0 r
.45393 .52181 .46193 .52908 .47549 .55494 .46745 .54813 Metetra
.906 .496 .148 r
.46745 .54813 .47549 .55494 .48926 .59111 .48117 .58529 Metetra
.462 .754 .993 r
.48117 .58529 .48926 .59111 .50366 .59236 .49563 .58438 Metetra
.645 .763 .934 r
.49563 .58438 .50366 .59236 .5182 .58804 .51022 .58002 Metetra
.645 .763 .934 r
.51022 .58002 .5182 .58804 .53281 .58371 .52489 .57564 Metetra
.645 .763 .934 r
.52489 .57564 .53281 .58371 .54751 .57935 .53963 .57124 Metetra
.645 .763 .934 r
.53963 .57124 .54751 .57935 .56228 .57497 .55446 .56681 Metetra
.732 .788 .897 r
.55446 .56681 .56228 .57497 .57704 .56497 .56931 .55892 Metetra
.956 .784 .629 r
.56931 .55892 .57704 .56497 .59114 .51966 .58355 .51252 Metetra
.938 .791 .671 r
.58355 .51252 .59114 .51966 .6052 .48459 .59772 .47689 Metetra
.92 .796 .706 r
.59772 .47689 .6052 .48459 .61925 .45606 .61188 .44804 Metetra
.902 .799 .736 r
.61188 .44804 .61925 .45606 .63332 .43209 .62603 .42383 Metetra
.885 .8 .761 r
.62603 .42383 .63332 .43209 .64742 .41146 .64021 .40303 Metetra
.867 .8 .782 r
.64021 .40303 .64742 .41146 .66155 .39338 .65443 .38481 Metetra
.85 .799 .801 r
.65443 .38481 .66155 .39338 .67574 .3773 .66869 .36861 Metetra
.834 .797 .816 r
.66869 .36861 .67574 .3773 .68998 .36282 .683 .35403 Metetra
.818 .794 .829 r
.683 .35403 .68998 .36282 .70428 .34964 .69736 .34076 Metetra
.804 .791 .84 r
.69736 .34076 .70428 .34964 .71864 .33752 .71179 .32855 Metetra
.792 .788 .849 r
.71179 .32855 .71864 .33752 .73307 .32627 .72629 .31722 Metetra
.78 .785 .857 r
.72629 .31722 .73307 .32627 .74757 .31572 .74085 .30661 Metetra
.77 .782 .863 r
.74085 .30661 .74757 .31572 .76214 .30576 .75548 .29657 Metetra
.762 .779 .868 r
.75548 .29657 .76214 .30576 .77678 .29626 .77018 .287 Metetra
.755 .777 .871 r
.77018 .287 .77678 .29626 .79148 .28712 .78495 .27779 Metetra
.749 .775 .874 r
.78495 .27779 .79148 .28712 .80625 .27825 .79978 .26886 Metetra
.745 .773 .876 r
.79978 .26886 .80625 .27825 .82108 .26957 .81467 .26011 Metetra
.742 .772 .878 r
.81467 .26011 .82108 .26957 .83597 .26101 .82962 .25149 Metetra
.74 .772 .878 r
.82962 .25149 .83597 .26101 .85091 .2525 .84463 .24292 Metetra
.536 .701 .946 r
.23011 .44085 .23845 .44861 .25055 .44765 .24224 .43984 Metetra
.533 .7 .946 r
.24224 .43984 .25055 .44765 .26273 .44674 .25444 .4389 Metetra
.526 .697 .947 r
.25444 .4389 .26273 .44674 .27498 .44597 .26671 .43808 Metetra
.515 .693 .949 r
.26671 .43808 .27498 .44597 .28729 .4454 .27906 .43748 Metetra
.5 .686 .95 r
.27906 .43748 .28729 .4454 .29968 .44512 .29147 .43715 Metetra
.48 .677 .952 r
.29147 .43715 .29968 .44512 .31213 .44521 .30395 .4372 Metetra
.453 .665 .953 r
.30395 .4372 .31213 .44521 .32465 .44577 .31649 .43772 Metetra
.417 .648 .953 r
.31649 .43772 .32465 .44577 .33723 .44692 .32909 .43883 Metetra
.371 .625 .951 r
.32909 .43883 .33723 .44692 .34987 .44879 .34176 .44065 Metetra
.31 .592 .944 r
.34176 .44065 .34987 .44879 .36259 .45154 .3545 .44335 Metetra
.231 .547 .929 r
.3545 .44335 .36259 .45154 .37537 .45536 .3673 .44712 Metetra
.127 .483 .9 r
.3673 .44712 .37537 .45536 .38823 .4605 .38018 .45221 Metetra
0 .393 .846 r
.38018 .45221 .38823 .4605 .40117 .46727 .39313 .45891 Metetra
0 .271 .758 r
.39313 .45891 .40117 .46727 .4142 .47607 .40617 .46764 Metetra
0 .118 .625 r
.40617 .46764 .4142 .47607 .42733 .48747 .4193 .47894 Metetra
.547 .055 0 r
.4193 .47894 .42733 .48747 .44056 .5023 .43253 .49363 Metetra
.705 .224 0 r
.43253 .49363 .44056 .5023 .45393 .52181 .44589 .51292 Metetra
.821 .369 0 r
.44589 .51292 .45393 .52181 .46745 .54813 .45938 .53884 Metetra
.895 .481 .084 r
.45938 .53884 .46745 .54813 .48117 .58529 .47305 .57512 Metetra
.453 .627 .928 r
.47305 .57512 .48117 .58529 .49563 .58438 .48753 .57632 Metetra
.645 .763 .934 r
.48753 .57632 .49563 .58438 .51022 .58002 .50216 .57192 Metetra
.645 .763 .934 r
.50216 .57192 .51022 .58002 .52489 .57564 .51688 .5675 Metetra
.645 .763 .934 r
.51688 .5675 .52489 .57564 .53963 .57124 .53168 .56305 Metetra
.645 .763 .934 r
.53168 .56305 .53963 .57124 .55446 .56681 .54656 .55858 Metetra
.772 .795 .872 r
.54656 .55858 .55446 .56681 .56931 .55892 .56145 .54847 Metetra
.93 .75 .637 r
.56145 .54847 .56931 .55892 .58355 .51252 .57584 .50287 Metetra
.92 .765 .673 r
.57584 .50287 .58355 .51252 .59772 .47689 .59014 .46756 Metetra
.907 .775 .705 r
.59014 .46756 .59772 .47689 .61188 .44804 .6044 .43883 Metetra
.892 .782 .733 r
.6044 .43883 .61188 .44804 .62603 .42383 .61865 .41468 Metetra
.876 .786 .757 r
.61865 .41468 .62603 .42383 .64021 .40303 .63292 .39389 Metetra
.86 .788 .779 r
.63292 .39389 .64021 .40303 .65443 .38481 .64721 .37566 Metetra
.845 .789 .797 r
.64721 .37566 .65443 .38481 .66869 .36861 .66155 .35944 Metetra
.83 .788 .813 r
.66155 .35944 .66869 .36861 .683 .35403 .67593 .34483 Metetra
.815 .787 .826 r
.67593 .34483 .683 .35403 .69736 .34076 .69037 .33153 Metetra
.802 .785 .837 r
.69037 .33153 .69736 .34076 .71179 .32855 .70487 .31928 Metetra
.789 .783 .847 r
.70487 .31928 .71179 .32855 .72629 .31722 .71943 .30791 Metetra
.778 .781 .854 r
.71943 .30791 .72629 .31722 .74085 .30661 .73406 .29725 Metetra
.769 .778 .861 r
.73406 .29725 .74085 .30661 .75548 .29657 .74876 .28717 Metetra
.761 .776 .866 r
.74876 .28717 .75548 .29657 .77018 .287 .76352 .27755 Metetra
.754 .775 .87 r
.76352 .27755 .77018 .287 .78495 .27779 .77835 .2683 Metetra
.748 .773 .873 r
.77835 .2683 .78495 .27779 .79978 .26886 .79324 .25932 Metetra
.744 .772 .876 r
.79324 .25932 .79978 .26886 .81467 .26011 .8082 .25053 Metetra
.741 .771 .877 r
.8082 .25053 .81467 .26011 .82962 .25149 .82322 .24186 Metetra
.74 .771 .878 r
.82322 .24186 .82962 .25149 .84463 .24292 .83828 .23323 Metetra
.538 .702 .946 r
.2217 .43301 .23011 .44085 .24224 .43984 .23385 .43195 Metetra
.535 .7 .946 r
.23385 .43195 .24224 .43984 .25444 .4389 .24608 .43095 Metetra
.528 .697 .946 r
.24608 .43095 .25444 .4389 .26671 .43808 .25838 .43008 Metetra
.518 .692 .947 r
.25838 .43008 .26671 .43808 .27906 .43748 .27075 .42941 Metetra
.503 .685 .949 r
.27075 .42941 .27906 .43748 .29147 .43715 .28319 .42902 Metetra
.484 .676 .95 r
.28319 .42902 .29147 .43715 .30395 .4372 .2957 .42901 Metetra
.458 .664 .951 r
.2957 .42901 .30395 .4372 .31649 .43772 .30826 .42945 Metetra
.424 .647 .951 r
.30826 .42945 .31649 .43772 .32909 .43883 .32089 .43048 Metetra
.381 .624 .949 r
.32089 .43048 .32909 .43883 .34176 .44065 .33359 .43222 Metetra
.324 .593 .942 r
.33359 .43222 .34176 .44065 .3545 .44335 .34634 .43483 Metetra
.25 .55 .929 r
.34634 .43483 .3545 .44335 .3673 .44712 .35917 .4385 Metetra
.154 .49 .904 r
.35917 .4385 .3673 .44712 .38018 .45221 .37206 .44345 Metetra
.031 .408 .858 r
.37206 .44345 .38018 .45221 .39313 .45891 .38503 .45 Metetra
0 .297 .783 r
.38503 .45 .39313 .45891 .40617 .46764 .39808 .45852 Metetra
0 .155 .67 r
.39808 .45852 .40617 .46764 .4193 .47894 .41122 .46955 Metetra
0 0 .518 r
.41122 .46955 .4193 .47894 .43253 .49363 .42446 .48382 Metetra
.642 .174 0 r
.42446 .48382 .43253 .49363 .44589 .51292 .43781 .50245 Metetra
.77 .322 0 r
.43781 .50245 .44589 .51292 .45938 .53884 .45129 .52717 Metetra
.856 .441 0 r
.45129 .52717 .45938 .53884 .47305 .57512 .46494 .56091 Metetra
.254 .43 .843 r
.46494 .56091 .47305 .57512 .48753 .57632 .47934 .56818 Metetra
.645 .763 .934 r
.47934 .56818 .48753 .57632 .50216 .57192 .49403 .56374 Metetra
.645 .763 .934 r
.49403 .56374 .50216 .57192 .51688 .5675 .5088 .55927 Metetra
.645 .763 .934 r
.5088 .55927 .51688 .5675 .53168 .56305 .52365 .55478 Metetra
.645 .763 .934 r
.52365 .55478 .53168 .56305 .54656 .55858 .53858 .55026 Metetra
.846 .8 .807 r
.53858 .55026 .54656 .55858 .56145 .54847 .55349 .53394 Metetra
.903 .72 .644 r
.55349 .53394 .56145 .54847 .57584 .50287 .56802 .4908 Metetra
.901 .742 .676 r
.56802 .4908 .57584 .50287 .59014 .46756 .58245 .45661 Metetra
.892 .756 .705 r
.58245 .45661 .59014 .46756 .6044 .43883 .59682 .42847 Metetra
.88 .766 .732 r
.59682 .42847 .6044 .43883 .61865 .41468 .61118 .40465 Metetra
.867 .773 .755 r
.61118 .40465 .61865 .41468 .63292 .39389 .62553 .38405 Metetra
.853 .777 .776 r
.62553 .38405 .63292 .39389 .64721 .37566 .63991 .36594 Metetra
.839 .779 .794 r
.63991 .36594 .64721 .37566 .66155 .35944 .65432 .34979 Metetra
.825 .78 .81 r
.65432 .34979 .66155 .35944 .67593 .34483 .66878 .33522 Metetra
.811 .779 .823 r
.66878 .33522 .67593 .34483 .69037 .33153 .68329 .32194 Metetra
.798 .779 .835 r
.68329 .32194 .69037 .33153 .70487 .31928 .69786 .3097 Metetra
.787 .777 .844 r
.69786 .3097 .70487 .31928 .71943 .30791 .7125 .29833 Metetra
.776 .776 .852 r
.7125 .29833 .71943 .30791 .73406 .29725 .72719 .28765 Metetra
.767 .775 .859 r
.72719 .28765 .73406 .29725 .74876 .28717 .74195 .27756 Metetra
.759 .773 .865 r
.74195 .27756 .74876 .28717 .76352 .27755 .75678 .26792 Metetra
.752 .772 .869 r
.75678 .26792 .76352 .27755 .77835 .2683 .77168 .25864 Metetra
.747 .771 .872 r
.77168 .25864 .77835 .2683 .79324 .25932 .78664 .24963 Metetra
.743 .77 .875 r
.78664 .24963 .79324 .25932 .8082 .25053 .80166 .24081 Metetra
.741 .77 .877 r
.80166 .24081 .8082 .25053 .82322 .24186 .81674 .23211 Metetra
.739 .77 .878 r
.81674 .23211 .82322 .24186 .83828 .23323 .83188 .22345 Metetra
.54 .703 .945 r
.21321 .4251 .2217 .43301 .23385 .43195 .22539 .42397 Metetra
.537 .7 .945 r
.22539 .42397 .23385 .43195 .24608 .43095 .23765 .4229 Metetra
.531 .697 .945 r
.23765 .4229 .24608 .43095 .25838 .43008 .24998 .42195 Metetra
.521 .692 .946 r
.24998 .42195 .25838 .43008 .27075 .42941 .26238 .4212 Metetra
.507 .685 .947 r
.26238 .4212 .27075 .42941 .28319 .42902 .27485 .42073 Metetra
.489 .676 .948 r
.27485 .42073 .28319 .42902 .2957 .42901 .28738 .42062 Metetra
.464 .663 .948 r
.28738 .42062 .2957 .42901 .30826 .42945 .29997 .42097 Metetra
.433 .647 .948 r
.29997 .42097 .30826 .42945 .32089 .43048 .31263 .42189 Metetra
.392 .625 .946 r
.31263 .42189 .32089 .43048 .33359 .43222 .32535 .42351 Metetra
.339 .595 .941 r
.32535 .42351 .33359 .43222 .34634 .43483 .33813 .42598 Metetra
.272 .555 .929 r
.33813 .42598 .34634 .43483 .35917 .4385 .35098 .42948 Metetra
.185 .5 .907 r
.35098 .42948 .35917 .4385 .37206 .44345 .3639 .43424 Metetra
.074 .425 .87 r
.3639 .43424 .37206 .44345 .38503 .45 .37688 .44054 Metetra
0 .326 .808 r
.37688 .44054 .38503 .45 .39808 .45852 .38995 .44874 Metetra
0 .2 .715 r
.38995 .44874 .39808 .45852 .41122 .46955 .4031 .45931 Metetra
0 .051 .588 r
.4031 .45931 .41122 .46955 .42446 .48382 .41635 .47293 Metetra
0 0 .438 r
.41635 .47293 .42446 .48382 .43781 .50245 .4297 .4905 Metetra
.682 .247 0 r
.4297 .4905 .43781 .50245 .45129 .52717 .44319 .51338 Metetra
.772 .363 0 r
.44319 .51338 .45129 .52717 .46494 .56091 .45683 .54346 Metetra
0 .145 .684 r
.45683 .54346 .46494 .56091 .47934 .56818 .47107 .55996 Metetra
.645 .763 .934 r
.47107 .55996 .47934 .56818 .49403 .56374 .48581 .55547 Metetra
.645 .763 .934 r
.48581 .55547 .49403 .56374 .5088 .55927 .50063 .55096 Metetra
.645 .763 .934 r
.50063 .55096 .5088 .55927 .52365 .55478 .51553 .54642 Metetra
.645 .763 .934 r
.51553 .54642 .52365 .55478 .53858 .55026 .53051 .54186 Metetra
.9 .791 .731 r
.53051 .54186 .53858 .55026 .55349 .53394 .54545 .51615 Metetra
.877 .695 .652 r
.54545 .51615 .55349 .53394 .56802 .4908 .56013 .47659 Metetra
.881 .722 .68 r
.56013 .47659 .56802 .4908 .58245 .45661 .57468 .44417 Metetra
.877 .739 .707 r
.57468 .44417 .58245 .45661 .59682 .42847 .58916 .417 Metetra
.868 .752 .732 r
.58916 .417 .59682 .42847 .61118 .40465 .60361 .39375 Metetra
.857 .76 .754 r
.60361 .39375 .61118 .40465 .62553 .38405 .61806 .37352 Metetra
.845 .766 .775 r
.61806 .37352 .62553 .38405 .63991 .36594 .63252 .35565 Metetra
.832 .769 .792 r
.63252 .35565 .63991 .36594 .65432 .34979 .64702 .33966 Metetra
.819 .771 .808 r
.64702 .33966 .65432 .34979 .66878 .33522 .66155 .32521 Metetra
.807 .772 .821 r
.66155 .32521 .66878 .33522 .68329 .32194 .67614 .312 Metetra
.795 .772 .833 r
.67614 .312 .68329 .32194 .69786 .3097 .69078 .29981 Metetra
.784 .772 .843 r
.69078 .29981 .69786 .3097 .7125 .29833 .70548 .28847 Metetra
.774 .771 .851 r
.70548 .28847 .7125 .29833 .72719 .28765 .72025 .27782 Metetra
.765 .771 .858 r
.72025 .27782 .72719 .28765 .74195 .27756 .73508 .26773 Metetra
.757 .77 .863 r
.73508 .26773 .74195 .27756 .75678 .26792 .74998 .25809 Metetra
.751 .769 .868 r
.74998 .25809 .75678 .26792 .77168 .25864 .76494 .24881 Metetra
.746 .769 .872 r
.76494 .24881 .77168 .25864 .78664 .24963 .77997 .2398 Metetra
.742 .769 .875 r
.77997 .2398 .78664 .24963 .80166 .24081 .79506 .23097 Metetra
.74 .769 .877 r
.79506 .23097 .80166 .24081 .81674 .23211 .8102 .22225 Metetra
.738 .77 .878 r
.8102 .22225 .81674 .23211 .83188 .22345 .82541 .21357 Metetra
.542 .704 .945 r
.20464 .41712 .21321 .4251 .22539 .42397 .21686 .41591 Metetra
.54 .701 .944 r
.21686 .41591 .22539 .42397 .23765 .4229 .22915 .41474 Metetra
.534 .697 .944 r
.22915 .41474 .23765 .4229 .24998 .42195 .24151 .4137 Metetra
.525 .692 .944 r
.24151 .4137 .24998 .42195 .26238 .4212 .25394 .41285 Metetra
.512 .685 .945 r
.25394 .41285 .26238 .4212 .27485 .42073 .26644 .41227 Metetra
.495 .676 .945 r
.26644 .41227 .27485 .42073 .28738 .42062 .279 .41205 Metetra
.472 .663 .946 r
.279 .41205 .28738 .42062 .29997 .42097 .29162 .41227 Metetra
.442 .647 .945 r
.29162 .41227 .29997 .42097 .31263 .42189 .30431 .41305 Metetra
.405 .626 .943 r
.30431 .41305 .31263 .42189 .32535 .42351 .31706 .41451 Metetra
.357 .598 .938 r
.31706 .41451 .32535 .42351 .33813 .42598 .32987 .4168 Metetra
.295 .561 .929 r
.32987 .4168 .33813 .42598 .35098 .42948 .34274 .42009 Metetra
.217 .511 .911 r
.34274 .42009 .35098 .42948 .3639 .43424 .35568 .42458 Metetra
.12 .444 .88 r
.35568 .42458 .3639 .43424 .37688 .44054 .36869 .43055 Metetra
0 .357 .83 r
.36869 .43055 .37688 .44054 .38995 .44874 .38177 .43831 Metetra
0 .247 .756 r
.38177 .43831 .38995 .44874 .4031 .45931 .39494 .44829 Metetra
0 .119 .657 r
.39494 .44829 .4031 .45931 .41635 .47293 .4082 .46103 Metetra
0 0 .539 r
.4082 .46103 .41635 .47293 .4297 .4905 .42157 .47725 Metetra
0 0 .421 r
.42157 .47725 .4297 .4905 .44319 .51338 .43507 .49786 Metetra
0 0 .334 r
.43507 .49786 .44319 .51338 .45683 .54346 .44874 .52381 Metetra
0 0 .419 r
.44874 .52381 .45683 .54346 .47107 .55996 .46272 .55166 Metetra
.645 .763 .934 r
.46272 .55166 .47107 .55996 .48581 .55547 .47751 .54712 Metetra
.645 .763 .934 r
.47751 .54712 .48581 .55547 .50063 .55096 .49238 .54257 Metetra
.645 .763 .934 r
.49238 .54257 .50063 .55096 .51553 .54642 .50734 .53799 Metetra
.645 .763 .934 r
.50734 .53799 .51553 .54642 .53051 .54186 .52237 .53338 Metetra
.93 .776 .67 r
.52237 .53338 .53051 .54186 .54545 .51615 .53737 .49613 Metetra
.853 .675 .661 r
.53737 .49613 .54545 .51615 .56013 .47659 .55217 .46064 Metetra
.862 .704 .685 r
.55217 .46064 .56013 .47659 .57468 .44417 .56683 .43041 Metetra
.862 .724 .709 r
.56683 .43041 .57468 .44417 .58916 .417 .58142 .4045 Metetra
.856 .738 .733 r
.58142 .4045 .58916 .417 .60361 .39375 .59597 .38205 Metetra
.847 .748 .754 r
.59597 .38205 .60361 .39375 .61806 .37352 .61051 .36233 Metetra
.836 .755 .774 r
.61051 .36233 .61806 .37352 .63252 .35565 .62506 .3448 Metetra
.825 .76 .791 r
.62506 .3448 .63252 .35565 .64702 .33966 .63963 .32906 Metetra
.813 .763 .806 r
.63963 .32906 .64702 .33966 .66155 .32521 .65425 .31478 Metetra
.801 .765 .82 r
.65425 .31478 .66155 .32521 .67614 .312 .66891 .3017 Metetra
.79 .766 .831 r
.66891 .3017 .67614 .312 .69078 .29981 .68362 .28961 Metetra
.78 .767 .841 r
.68362 .28961 .69078 .29981 .70548 .28847 .69839 .27834 Metetra
.77 .767 .85 r
.69839 .27834 .70548 .28847 .72025 .27782 .71323 .26774 Metetra
.762 .767 .857 r
.71323 .26774 .72025 .27782 .73508 .26773 .72813 .25769 Metetra
.755 .767 .863 r
.72813 .25769 .73508 .26773 .74998 .25809 .74309 .24808 Metetra
.749 .767 .867 r
.74309 .24808 .74998 .25809 .76494 .24881 .75813 .23882 Metetra
.744 .767 .871 r
.75813 .23882 .76494 .24881 .77997 .2398 .77322 .22981 Metetra
.74 .767 .874 r
.77322 .22981 .77997 .2398 .79506 .23097 .78838 .22099 Metetra
.738 .768 .877 r
.78838 .22099 .79506 .23097 .8102 .22225 .8036 .21228 Metetra
.737 .769 .878 r
.8036 .21228 .8102 .22225 .82541 .21357 .81887 .2036 Metetra
.546 .705 .944 r
.196 .40908 .20464 .41712 .21686 .41591 .20825 .40775 Metetra
.544 .702 .943 r
.20825 .40775 .21686 .41591 .22915 .41474 .22057 .40648 Metetra
.539 .698 .943 r
.22057 .40648 .22915 .41474 .24151 .4137 .23297 .40532 Metetra
.53 .693 .943 r
.23297 .40532 .24151 .4137 .25394 .41285 .24543 .40435 Metetra
.518 .685 .943 r
.24543 .40435 .25394 .41285 .26644 .41227 .25796 .40365 Metetra
.502 .676 .943 r
.25796 .40365 .26644 .41227 .279 .41205 .27055 .40329 Metetra
.48 .664 .943 r
.27055 .40329 .279 .41205 .29162 .41227 .28321 .40336 Metetra
.453 .648 .942 r
.28321 .40336 .29162 .41227 .30431 .41305 .29593 .40397 Metetra
.419 .628 .941 r
.29593 .40397 .30431 .41305 .31706 .41451 .3087 .40524 Metetra
.375 .602 .936 r
.3087 .40524 .31706 .41451 .32987 .4168 .32154 .4073 Metetra
.32 .568 .928 r
.32154 .4073 .32987 .4168 .34274 .42009 .33444 .41032 Metetra
.252 .523 .913 r
.33444 .41032 .34274 .42009 .35568 .42458 .34741 .41449 Metetra
.167 .464 .888 r
.34741 .41449 .35568 .42458 .36869 .43055 .36044 .42004 Metetra
.065 .389 .849 r
.36044 .42004 .36869 .43055 .38177 .43831 .37355 .42727 Metetra
0 .296 .793 r
.37355 .42727 .38177 .43831 .39494 .44829 .38674 .43653 Metetra
0 .188 .718 r
.38674 .43653 .39494 .44829 .4082 .46103 .40003 .44824 Metetra
0 .076 .631 r
.40003 .44824 .4082 .46103 .42157 .47725 .41342 .46291 Metetra
0 0 .55 r
.41342 .46291 .42157 .47725 .43507 .49786 .42695 .48105 Metetra
0 0 .504 r
.42695 .48105 .43507 .49786 .44874 .52381 .44066 .50284 Metetra
0 0 .534 r
.44066 .50284 .44874 .52381 .46272 .55166 .45462 .52708 Metetra
.285 .324 .728 r
.45462 .52708 .46272 .55166 .47751 .54712 .46913 .53869 Metetra
.645 .763 .934 r
.46913 .53869 .47751 .54712 .49238 .54257 .48405 .53409 Metetra
.645 .763 .934 r
.48405 .53409 .49238 .54257 .50734 .53799 .49906 .52946 Metetra
.876 .796 .767 r
.49906 .52946 .50734 .53799 .52237 .53338 .5142 .50852 Metetra
.821 .64 .658 r
.5142 .50852 .52237 .53338 .53737 .49613 .52926 .47478 Metetra
.832 .66 .67 r
.52926 .47478 .53737 .49613 .55217 .46064 .54415 .44337 Metetra
.844 .69 .691 r
.54415 .44337 .55217 .46064 .56683 .43041 .55892 .41553 Metetra
.846 .711 .713 r
.55892 .41553 .56683 .43041 .58142 .4045 .57361 .3911 Metetra
.843 .726 .735 r
.57361 .3911 .58142 .4045 .59597 .38205 .58825 .36959 Metetra
.836 .738 .755 r
.58825 .36959 .59597 .38205 .61051 .36233 .60288 .3505 Metetra
.827 .746 .774 r
.60288 .3505 .61051 .36233 .62506 .3448 .61751 .33343 Metetra
.817 .752 .791 r
.61751 .33343 .62506 .3448 .63963 .32906 .63217 .31801 Metetra
.807 .756 .806 r
.63217 .31801 .63963 .32906 .65425 .31478 .64686 .30397 Metetra
.796 .758 .819 r
.64686 .30397 .65425 .31478 .66891 .3017 .66159 .29106 Metetra
.786 .76 .83 r
.66159 .29106 .66891 .3017 .68362 .28961 .67638 .27911 Metetra
.776 .762 .84 r
.67638 .27911 .68362 .28961 .69839 .27834 .69123 .26794 Metetra
.767 .762 .849 r
.69123 .26794 .69839 .27834 .71323 .26774 .70613 .25743 Metetra
.759 .763 .856 r
.70613 .25743 .71323 .26774 .72813 .25769 .7211 .24744 Metetra
.752 .763 .862 r
.7211 .24744 .72813 .25769 .74309 .24808 .73614 .23788 Metetra
.746 .764 .867 r
.73614 .23788 .74309 .24808 .75813 .23882 .75124 .22865 Metetra
.742 .764 .871 r
.75124 .22865 .75813 .23882 .77322 .22981 .76641 .21968 Metetra
.738 .765 .874 r
.76641 .21968 .77322 .22981 .78838 .22099 .78164 .21088 Metetra
.736 .766 .877 r
.78164 .21088 .78838 .22099 .8036 .21228 .79693 .20218 Metetra
.736 .768 .879 r
.79693 .20218 .8036 .21228 .81887 .2036 .81227 .19352 Metetra
.55 .707 .943 r
.18728 .40096 .196 .40908 .20825 .40775 .19956 .39951 Metetra
.548 .703 .942 r
.19956 .39951 .20825 .40775 .22057 .40648 .21192 .39811 Metetra
.544 .699 .941 r
.21192 .39811 .22057 .40648 .23297 .40532 .22435 .39682 Metetra
.536 .693 .941 r
.22435 .39682 .23297 .40532 .24543 .40435 .23685 .39571 Metetra
.524 .686 .941 r
.23685 .39571 .24543 .40435 .25796 .40365 .24941 .39486 Metetra
.509 .677 .94 r
.24941 .39486 .25796 .40365 .27055 .40329 .26204 .39434 Metetra
.49 .665 .94 r
.26204 .39434 .27055 .40329 .28321 .40336 .27473 .39423 Metetra
.465 .65 .939 r
.27473 .39423 .28321 .40336 .29593 .40397 .28748 .39464 Metetra
.434 .631 .937 r
.28748 .39464 .29593 .40397 .3087 .40524 .30029 .39568 Metetra
.394 .607 .934 r
.30029 .39568 .3087 .40524 .32154 .4073 .31316 .39748 Metetra
.346 .575 .926 r
.31316 .39748 .32154 .4073 .33444 .41032 .32609 .40019 Metetra
.286 .535 .914 r
.32609 .40019 .33444 .41032 .34741 .41449 .33909 .40398 Metetra
.214 .484 .894 r
.33909 .40398 .34741 .41449 .36044 .42004 .35215 .40906 Metetra
.128 .42 .864 r
.35215 .40906 .36044 .42004 .37355 .42727 .36529 .41567 Metetra
.032 .342 .821 r
.36529 .41567 .37355 .42727 .38674 .43653 .37851 .4241 Metetra
0 .256 .767 r
.37851 .4241 .38674 .43653 .40003 .44824 .39182 .43467 Metetra
0 .169 .707 r
.39182 .43467 .40003 .44824 .41342 .46291 .40525 .44768 Metetra
0 .098 .654 r
.40525 .44768 .41342 .46291 .42695 .48105 .41882 .46332 Metetra
0 .071 .633 r
.41882 .46332 .42695 .48105 .44066 .50284 .43257 .48124 Metetra
0 .126 .657 r
.43257 .48124 .44066 .50284 .45462 .52708 .44659 .49977 Metetra
.235 .271 .696 r
.44659 .49977 .45462 .52708 .46913 .53869 .46096 .51434 Metetra
.486 .455 .748 r
.46096 .51434 .46913 .53869 .48405 .53409 .47575 .51752 Metetra
.744 .661 .768 r
.47575 .51752 .48405 .53409 .49906 .52946 .49086 .50497 Metetra
.78 .622 .684 r
.49086 .50497 .49906 .52946 .5142 .50852 .50604 .48094 Metetra
.785 .611 .664 r
.50604 .48094 .5142 .50852 .52926 .47478 .52113 .45281 Metetra
.813 .649 .679 r
.52113 .45281 .52926 .47478 .54415 .44337 .5361 .42517 Metetra
.827 .678 .698 r
.5361 .42517 .54415 .44337 .55892 .41553 .55095 .39975 Metetra
.832 .699 .718 r
.55095 .39975 .55892 .41553 .57361 .3911 .56573 .37689 Metetra
.83 .715 .738 r
.56573 .37689 .57361 .3911 .58825 .36959 .58046 .35644 Metetra
.825 .728 .757 r
.58046 .35644 .58825 .36959 .60288 .3505 .59517 .3381 Metetra
.818 .737 .775 r
.59517 .3381 .60288 .3505 .61751 .33343 .60989 .32155 Metetra
.809 .743 .791 r
.60989 .32155 .61751 .33343 .63217 .31801 .62462 .30652 Metetra
.8 .748 .805 r
.62462 .30652 .63217 .31801 .64686 .30397 .63939 .29277 Metetra
.79 .752 .818 r
.63939 .29277 .64686 .30397 .66159 .29106 .6542 .28009 Metetra
.78 .754 .83 r
.6542 .28009 .66159 .29106 .67638 .27911 .66907 .26831 Metetra
.771 .756 .84 r
.66907 .26831 .67638 .27911 .69123 .26794 .68398 .25728 Metetra
.763 .758 .848 r
.68398 .25728 .69123 .26794 .70613 .25743 .69896 .24687 Metetra
.755 .759 .855 r
.69896 .24687 .70613 .25743 .7211 .24744 .714 .23697 Metetra
.749 .76 .862 r
.714 .23697 .7211 .24744 .73614 .23788 .72911 .22749 Metetra
.744 .761 .867 r
.72911 .22749 .73614 .23788 .75124 .22865 .74428 .21832 Metetra
.739 .762 .871 r
.74428 .21832 .75124 .22865 .76641 .21968 .75952 .20939 Metetra
.736 .763 .875 r
.75952 .20939 .76641 .21968 .78164 .21088 .77483 .20064 Metetra
.734 .765 .877 r
.77483 .20064 .78164 .21088 .79693 .20218 .79019 .19198 Metetra
.734 .767 .879 r
.79019 .19198 .79693 .20218 .81227 .19352 .80561 .18335 Metetra
.555 .708 .942 r
.17849 .39277 .18728 .40096 .19956 .39951 .1908 .39118 Metetra
.554 .705 .941 r
.1908 .39118 .19956 .39951 .21192 .39811 .2032 .38963 Metetra
.549 .7 .939 r
.2032 .38963 .21192 .39811 .22435 .39682 .21566 .3882 Metetra
.542 .695 .939 r
.21566 .3882 .22435 .39682 .23685 .39571 .2282 .38693 Metetra
.532 .687 .938 r
.2282 .38693 .23685 .39571 .24941 .39486 .2408 .38591 Metetra
.518 .678 .938 r
.2408 .38591 .24941 .39486 .26204 .39434 .25346 .3852 Metetra
.5 .667 .937 r
.25346 .3852 .26204 .39434 .27473 .39423 .26619 .3849 Metetra
.477 .652 .936 r
.26619 .3849 .27473 .39423 .28748 .39464 .27897 .38508 Metetra
.449 .634 .934 r
.27897 .38508 .28748 .39464 .30029 .39568 .29182 .38586 Metetra
.414 .612 .931 r
.29182 .38586 .30029 .39568 .31316 .39748 .30472 .38736 Metetra
.372 .583 .924 r
.30472 .38736 .31316 .39748 .32609 .40019 .31769 .38971 Metetra
.32 .547 .914 r
.31769 .38971 .32609 .40019 .33909 .40398 .33072 .39307 Metetra
.259 .503 .898 r
.33072 .39307 .33909 .40398 .35215 .40906 .34382 .39761 Metetra
.189 .448 .874 r
.34382 .39761 .35215 .40906 .36529 .41567 .35699 .40355 Metetra
.113 .385 .842 r
.35699 .40355 .36529 .41567 .37851 .4241 .37024 .41109 Metetra
.038 .317 .803 r
.37024 .41109 .37851 .4241 .39182 .43467 .38359 .42045 Metetra
0 .251 .761 r
.38359 .42045 .39182 .43467 .40525 .44768 .39706 .43177 Metetra
0 .204 .727 r
.39706 .43177 .40525 .44768 .41882 .46332 .41067 .44498 Metetra
0 .197 .712 r
.41067 .44498 .41882 .46332 .43257 .48124 .42447 .45947 Metetra
.133 .249 .719 r
.42447 .45947 .43257 .48124 .44659 .49977 .43854 .47347 Metetra
.342 .348 .722 r
.43854 .47347 .44659 .49977 .46096 .51434 .45293 .48336 Metetra
.532 .444 .702 r
.45293 .48336 .46096 .51434 .47575 .51752 .4677 .48431 Metetra
.652 .513 .681 r
.4677 .48431 .47575 .51752 .49086 .50497 .48274 .47383 Metetra
.724 .564 .673 r
.48274 .47383 .49086 .50497 .50604 .48094 .49788 .45435 Metetra
.769 .606 .677 r
.49788 .45435 .50604 .48094 .52113 .45281 .51299 .43065 Metetra
.796 .641 .689 r
.51299 .43065 .52113 .45281 .5361 .42517 .52801 .40635 Metetra
.811 .668 .705 r
.52801 .40635 .5361 .42517 .55095 .39975 .54293 .38327 Metetra
.817 .689 .723 r
.54293 .38327 .55095 .39975 .56573 .37689 .55779 .36202 Metetra
.818 .706 .741 r
.55779 .36202 .56573 .37689 .58046 .35644 .5726 .34269 Metetra
.814 .718 .759 r
.5726 .34269 .58046 .35644 .59517 .3381 .5874 .32515 Metetra
.808 .728 .776 r
.5874 .32515 .59517 .3381 .60989 .32155 .60219 .3092 Metetra
.801 .735 .791 r
.60219 .3092 .60989 .32155 .62462 .30652 .61701 .29461 Metetra
.792 .741 .806 r
.61701 .29461 .62462 .30652 .63939 .29277 .63185 .2812 Metetra
.783 .745 .818 r
.63185 .2812 .63939 .29277 .6542 .28009 .64674 .26879 Metetra
.775 .749 .829 r
.64674 .26879 .6542 .28009 .66907 .26831 .66167 .25722 Metetra
.766 .751 .839 r
.66167 .25722 .66907 .26831 .68398 .25728 .67666 .24636 Metetra
.759 .753 .848 r
.67666 .24636 .68398 .25728 .69896 .24687 .69172 .23609 Metetra
.752 .755 .855 r
.69172 .23609 .69896 .24687 .714 .23697 .70683 .2263 Metetra
.746 .757 .862 r
.70683 .2263 .714 .23697 .72911 .22749 .72201 .21691 Metetra
.741 .758 .867 r
.72201 .21691 .72911 .22749 .74428 .21832 .73726 .20782 Metetra
.737 .76 .871 r
.73726 .20782 .74428 .21832 .75952 .20939 .75257 .19896 Metetra
.734 .761 .875 r
.75257 .19896 .75952 .20939 .77483 .20064 .76794 .19026 Metetra
.732 .763 .878 r
.76794 .19026 .77483 .20064 .79019 .19198 .78338 .18165 Metetra
.731 .766 .88 r
.78338 .18165 .79019 .19198 .80561 .18335 .79888 .17308 Metetra
.561 .711 .941 r
.16961 .38451 .17849 .39277 .1908 .39118 .18197 .38276 Metetra
.56 .707 .939 r
.18197 .38276 .1908 .39118 .2032 .38963 .1944 .38106 Metetra
.556 .702 .938 r
.1944 .38106 .2032 .38963 .21566 .3882 .2069 .37945 Metetra
.549 .696 .937 r
.2069 .37945 .21566 .3882 .2282 .38693 .21948 .37801 Metetra
.539 .689 .936 r
.21948 .37801 .2282 .38693 .2408 .38591 .23212 .3768 Metetra
.527 .68 .935 r
.23212 .3768 .2408 .38591 .25346 .3852 .24482 .37589 Metetra
.51 .668 .934 r
.24482 .37589 .25346 .3852 .26619 .3849 .25758 .37536 Metetra
.49 .655 .933 r
.25758 .37536 .26619 .3849 .27897 .38508 .27041 .37529 Metetra
.465 .638 .931 r
.27041 .37529 .27897 .38508 .29182 .38586 .28329 .37578 Metetra
.434 .617 .927 r
.28329 .37578 .29182 .38586 .30472 .38736 .29623 .37694 Metetra
.397 .591 .922 r
.29623 .37694 .30472 .38736 .31769 .38971 .30923 .3789 Metetra
.354 .559 .913 r
.30923 .3789 .31769 .38971 .33072 .39307 .3223 .38178 Metetra
.303 .52 .9 r
.3223 .38178 .33072 .39307 .34382 .39761 .33544 .38575 Metetra
.246 .475 .881 r
.33544 .38575 .34382 .39761 .35699 .40355 .34864 .39096 Metetra
.187 .423 .856 r
.34864 .39096 .35699 .40355 .37024 .41109 .36194 .39756 Metetra
.132 .369 .827 r
.36194 .39756 .37024 .41109 .38359 .42045 .37533 .40568 Metetra
.094 .321 .797 r
.37533 .40568 .38359 .42045 .39706 .43177 .38884 .41533 Metetra
.09 .29 .771 r
.38884 .41533 .39706 .43177 .41067 .44498 .4025 .42628 Metetra
.141 .291 .757 r
.4025 .42628 .41067 .44498 .42447 .45947 .41636 .43779 Metetra
.257 .332 .749 r
.41636 .43779 .42447 .45947 .43854 .47347 .43046 .44822 Metetra
.411 .4 .737 r
.43046 .44822 .43854 .47347 .45293 .48336 .44488 .45477 Metetra
.55 .468 .715 r
.44488 .45477 .45293 .48336 .4677 .48431 .45962 .45424 Metetra
.648 .522 .695 r
.45962 .45424 .4677 .48431 .48274 .47383 .47461 .4451 Metetra
.712 .565 .687 r
.47461 .4451 .48274 .47383 .49788 .45435 .48972 .42882 Metetra
.754 .603 .689 r
.48972 .42882 .49788 .45435 .51299 .43065 .50483 .40858 Metetra
.781 .634 .699 r
.50483 .40858 .51299 .43065 .52801 .40635 .51988 .38717 Metetra
.796 .66 .713 r
.51988 .38717 .52801 .40635 .54293 .38327 .53487 .36626 Metetra
.804 .681 .728 r
.53487 .36626 .54293 .38327 .55779 .36202 .5498 .34659 Metetra
.805 .697 .745 r
.5498 .34659 .55779 .36202 .5726 .34269 .56468 .32841 Metetra
.803 .71 .762 r
.56468 .32841 .5726 .34269 .5874 .32515 .57956 .31172 Metetra
.799 .72 .778 r
.57956 .31172 .5874 .32515 .60219 .3092 .59443 .2964 Metetra
.792 .728 .793 r
.59443 .2964 .60219 .3092 .61701 .29461 .60932 .28231 Metetra
.785 .734 .806 r
.60932 .28231 .61701 .29461 .63185 .2812 .62424 .26928 Metetra
.777 .739 .819 r
.62424 .26928 .63185 .2812 .64674 .26879 .6392 .25717 Metetra
.769 .743 .83 r
.6392 .25717 .64674 .26879 .66167 .25722 .65421 .24585 Metetra
.761 .746 .839 r
.65421 .24585 .66167 .25722 .67666 .24636 .66927 .23519 Metetra
.754 .749 .848 r
.66927 .23519 .67666 .24636 .69172 .23609 .6844 .22508 Metetra
.747 .751 .855 r
.6844 .22508 .69172 .23609 .70683 .2263 .69958 .21542 Metetra
.742 .753 .862 r
.69958 .21542 .70683 .2263 .72201 .21691 .71483 .20614 Metetra
.737 .755 .867 r
.71483 .20614 .72201 .21691 .73726 .20782 .73015 .19715 Metetra
.733 .757 .872 r
.73015 .19715 .73726 .20782 .75257 .19896 .74554 .18837 Metetra
.731 .759 .876 r
.74554 .18837 .75257 .19896 .76794 .19026 .76099 .17975 Metetra
.729 .762 .879 r
.76099 .17975 .76794 .19026 .78338 .18165 .7765 .17121 Metetra
.729 .764 .881 r
.7765 .17121 .78338 .18165 .79888 .17308 .79208 .1627 Metetra
.567 .713 .94 r
.16065 .37618 .16961 .38451 .18197 .38276 .17305 .37425 Metetra
.566 .709 .937 r
.17305 .37425 .18197 .38276 .1944 .38106 .18552 .37237 Metetra
.562 .704 .936 r
.18552 .37237 .1944 .38106 .2069 .37945 .19807 .37058 Metetra
.556 .698 .934 r
.19807 .37058 .2069 .37945 .21948 .37801 .21068 .36895 Metetra
.548 .69 .933 r
.21068 .36895 .21948 .37801 .23212 .3768 .22336 .36754 Metetra
.536 .681 .932 r
.22336 .36754 .23212 .3768 .24482 .37589 .23611 .3664 Metetra
.521 .671 .931 r
.23611 .3664 .24482 .37589 .25758 .37536 .24891 .36562 Metetra
.503 .658 .929 r
.24891 .36562 .25758 .37536 .27041 .37529 .26177 .36527 Metetra
.481 .642 .927 r
.26177 .36527 .27041 .37529 .28329 .37578 .2747 .36545 Metetra
.454 .622 .924 r
.2747 .36545 .28329 .37578 .29623 .37694 .28768 .36625 Metetra
.423 .599 .918 r
.28768 .36625 .29623 .37694 .30923 .3789 .30073 .36778 Metetra
.386 .57 .911 r
.30073 .36778 .30923 .3789 .3223 .38178 .31383 .37015 Metetra
.344 .537 .899 r
.31383 .37015 .3223 .38178 .33544 .38575 .32701 .3735 Metetra
.298 .498 .884 r
.32701 .3735 .33544 .38575 .34864 .39096 .34026 .37794 Metetra
.253 .456 .865 r
.34026 .37794 .34864 .39096 .36194 .39756 .3536 .38358 Metetra
.215 .413 .842 r
.3536 .38358 .36194 .39756 .37533 .40568 .36703 .39046 Metetra
.192 .377 .818 r
.36703 .39046 .37533 .40568 .38884 .41533 .38059 .3985 Metetra
.2 .356 .797 r
.38059 .3985 .38884 .41533 .4025 .42628 .3943 .40739 Metetra
.25 .359 .78 r
.3943 .40739 .4025 .42628 .41636 .43779 .40821 .41635 Metetra
.342 .389 .765 r
.40821 .41635 .41636 .43779 .43046 .44822 .42236 .42394 Metetra
.458 .437 .747 r
.42236 .42394 .43046 .44822 .44488 .45477 .43679 .42804 Metetra
.565 .487 .726 r
.43679 .42804 .44488 .45477 .45962 .45424 .45151 .42646 Metetra
.646 .53 .708 r
.45151 .42646 .45962 .45424 .47461 .4451 .46646 .41822 Metetra
.702 .568 .7 r
.46646 .41822 .47461 .4451 .48972 .42882 .48154 .40427 Metetra
.741 .601 .701 r
.48154 .40427 .48972 .42882 .50483 .40858 .49665 .38675 Metetra
.766 .629 .709 r
.49665 .38675 .50483 .40858 .51988 .38717 .51173 .3678 Metetra
.782 .653 .72 r
.51173 .3678 .51988 .38717 .53487 .36626 .52676 .34885 Metetra
.79 .673 .734 r
.52676 .34885 .53487 .36626 .5498 .34659 .54175 .3307 Metetra
.793 .689 .75 r
.54175 .3307 .5498 .34659 .56468 .32841 .55671 .31367 Metetra
.792 .702 .765 r
.55671 .31367 .56468 .32841 .57956 .31172 .57165 .29785 Metetra
.789 .712 .78 r
.57165 .29785 .57956 .31172 .59443 .2964 .5866 .28321 Metetra
.783 .721 .794 r
.5866 .28321 .59443 .2964 .60932 .28231 .60156 .26964 Metetra
.777 .728 .807 r
.60156 .26964 .60932 .28231 .62424 .26928 .61655 .25703 Metetra
.77 .733 .819 r
.61655 .25703 .62424 .26928 .6392 .25717 .63159 .24526 Metetra
.762 .738 .83 r
.63159 .24526 .6392 .25717 .65421 .24585 .64667 .2342 Metetra
.755 .741 .84 r
.64667 .2342 .65421 .24585 .66927 .23519 .6618 .22377 Metetra
.749 .745 .848 r
.6618 .22377 .66927 .23519 .6844 .22508 .677 .21384 Metetra
.743 .747 .856 r
.677 .21384 .6844 .22508 .69958 .21542 .69226 .20434 Metetra
.738 .75 .862 r
.69226 .20434 .69958 .21542 .71483 .20614 .70758 .19519 Metetra
.733 .752 .868 r
.70758 .19519 .71483 .20614 .73015 .19715 .72298 .18631 Metetra
.73 .755 .872 r
.72298 .18631 .73015 .19715 .74554 .18837 .73844 .17763 Metetra
.728 .757 .876 r
.73844 .17763 .74554 .18837 .76099 .17975 .75396 .1691 Metetra
.726 .76 .88 r
.75396 .1691 .76099 .17975 .7765 .17121 .76955 .16065 Metetra
.726 .763 .882 r
.76955 .16065 .7765 .17121 .79208 .1627 .78521 .15222 Metetra
.574 .715 .938 r
.15161 .36777 .16065 .37618 .17305 .37425 .16405 .36565 Metetra
.573 .711 .936 r
.16405 .36565 .17305 .37425 .18552 .37237 .17657 .36358 Metetra
.569 .705 .934 r
.17657 .36358 .18552 .37237 .19807 .37058 .18916 .3616 Metetra
.564 .699 .932 r
.18916 .3616 .19807 .37058 .21068 .36895 .20182 .35976 Metetra
.556 .692 .93 r
.20182 .35976 .21068 .36895 .22336 .36754 .21454 .35812 Metetra
.546 .683 .929 r
.21454 .35812 .22336 .36754 .23611 .3664 .22733 .35674 Metetra
.533 .673 .927 r
.22733 .35674 .23611 .3664 .24891 .36562 .24017 .35569 Metetra
.517 .661 .926 r
.24017 .35569 .24891 .36562 .26177 .36527 .25308 .35504 Metetra
.497 .646 .923 r
.25308 .35504 .26177 .36527 .2747 .36545 .26605 .35488 Metetra
.474 .628 .92 r
.26605 .35488 .2747 .36545 .28768 .36625 .27908 .35528 Metetra
.447 .606 .915 r
.27908 .35528 .28768 .36625 .30073 .36778 .29216 .35636 Metetra
.416 .581 .908 r
.29216 .35636 .30073 .36778 .31383 .37015 .30532 .35819 Metetra
.382 .552 .898 r
.30532 .35819 .31383 .37015 .32701 .3735 .31854 .3609 Metetra
.346 .519 .885 r
.31854 .3609 .32701 .3735 .34026 .37794 .33183 .36455 Metetra
.312 .484 .868 r
.33183 .36455 .34026 .37794 .3536 .38358 .34522 .36921 Metetra
.285 .45 .85 r
.34522 .36921 .3536 .38358 .36703 .39046 .35871 .37488 Metetra
.273 .422 .829 r
.35871 .37488 .36703 .39046 .38059 .3985 .37232 .38141 Metetra
.286 .406 .81 r
.37232 .38141 .38059 .3985 .3943 .40739 .38608 .38843 Metetra
.33 .409 .792 r
.38608 .38843 .3943 .40739 .40821 .41635 .40003 .3952 Metetra
.403 .43 .774 r
.40003 .3952 .40821 .41635 .42236 .42394 .41422 .40052 Metetra
.492 .464 .755 r
.41422 .40052 .42236 .42394 .43679 .42804 .42866 .40277 Metetra
.576 .502 .735 r
.42866 .40277 .43679 .42804 .45151 .42646 .44337 .40043 Metetra
.644 .538 .72 r
.44337 .40043 .45151 .42646 .46646 .41822 .45829 .39282 Metetra
.694 .57 .712 r
.45829 .39282 .46646 .41822 .48154 .40427 .47334 .38059 Metetra
.729 .599 .712 r
.47334 .38059 .48154 .40427 .49665 .38675 .48845 .36522 Metetra
.753 .625 .718 r
.48845 .36522 .49665 .38675 .51173 .3678 .50355 .34834 Metetra
.769 .647 .728 r
.50355 .34834 .51173 .3678 .52676 .34885 .51862 .33116 Metetra
.778 .666 .74 r
.51862 .33116 .52676 .34885 .54175 .3307 .53366 .31443 Metetra
.781 .682 .754 r
.53366 .31443 .54175 .3307 .55671 .31367 .54867 .29852 Metetra
.781 .695 .768 r
.54867 .29852 .55671 .31367 .57165 .29785 .56368 .28359 Metetra
.779 .705 .783 r
.56368 .28359 .57165 .29785 .5866 .28321 .5787 .26964 Metetra
.774 .714 .796 r
.5787 .26964 .5866 .28321 .60156 .26964 .59373 .25662 Metetra
.768 .721 .809 r
.59373 .25662 .60156 .26964 .61655 .25703 .60879 .24446 Metetra
.762 .727 .82 r
.60879 .24446 .61655 .25703 .63159 .24526 .6239 .23305 Metetra
.756 .732 .831 r
.6239 .23305 .63159 .24526 .64667 .2342 .63905 .2223 Metetra
.749 .737 .84 r
.63905 .2223 .64667 .2342 .6618 .22377 .65426 .2121 Metetra
.743 .74 .849 r
.65426 .2121 .6618 .22377 .677 .21384 .66953 .20239 Metetra
.738 .744 .856 r
.66953 .20239 .677 .21384 .69226 .20434 .68486 .19307 Metetra
.733 .746 .863 r
.68486 .19307 .69226 .20434 .70758 .19519 .70026 .18406 Metetra
.729 .749 .868 r
.70026 .18406 .70758 .19519 .72298 .18631 .71573 .17531 Metetra
.726 .752 .873 r
.71573 .17531 .72298 .18631 .73844 .17763 .73126 .16675 Metetra
.724 .755 .877 r
.73126 .16675 .73844 .17763 .75396 .1691 .74686 .15832 Metetra
.723 .758 .881 r
.74686 .15832 .75396 .1691 .76955 .16065 .76253 .14996 Metetra
.722 .761 .884 r
.76253 .14996 .76955 .16065 .78521 .15222 .77827 .14163 Metetra
.581 .717 .936 r
.14249 .35927 .15161 .36777 .16405 .36565 .15498 .35696 Metetra
.58 .713 .934 r
.15498 .35696 .16405 .36565 .17657 .36358 .16754 .35468 Metetra
.577 .707 .931 r
.16754 .35468 .17657 .36358 .18916 .3616 .18018 .35249 Metetra
.572 .701 .929 r
.18018 .35249 .18916 .3616 .20182 .35976 .19288 .35042 Metetra
.565 .694 .927 r
.19288 .35042 .20182 .35976 .21454 .35812 .20565 .34854 Metetra
.556 .686 .926 r
.20565 .34854 .21454 .35812 .22733 .35674 .21848 .3469 Metetra
.544 .676 .924 r
.21848 .3469 .22733 .35674 .24017 .35569 .23137 .34557 Metetra
.53 .664 .922 r
.23137 .34557 .24017 .35569 .25308 .35504 .24433 .3446 Metetra
.513 .65 .919 r
.24433 .3446 .25308 .35504 .26605 .35488 .25734 .34407 Metetra
.493 .633 .915 r
.25734 .34407 .26605 .35488 .27908 .35528 .27041 .34406 Metetra
.47 .614 .91 r
.27041 .34406 .27908 .35528 .29216 .35636 .28355 .34466 Metetra
.444 .591 .904 r
.28355 .34466 .29216 .35636 .30532 .35819 .29675 .34593 Metetra
.416 .565 .895 r
.29675 .34593 .30532 .35819 .31854 .3609 .31002 .34797 Metetra
.388 .537 .883 r
.31002 .34797 .31854 .3609 .33183 .36455 .32337 .35082 Metetra
.362 .508 .869 r
.32337 .35082 .33183 .36455 .34522 .36921 .3368 .35452 Metetra
.344 .48 .853 r
.3368 .35452 .34522 .36921 .35871 .37488 .35034 .35901 Metetra
.339 .458 .835 r
.35034 .35901 .35871 .37488 .37232 .38141 .364 .36412 Metetra
.353 .445 .817 r
.364 .36412 .37232 .38141 .38608 .38843 .37782 .36946 Metetra
.39 .447 .798 r
.37782 .36946 .38608 .38843 .40003 .3952 .39182 .37438 Metetra
.449 .461 .78 r
.39182 .37438 .40003 .3952 .41422 .40052 .40604 .37786 Metetra
.518 .487 .761 r
.40604 .37786 .41422 .40052 .42866 .40277 .4205 .37867 Metetra
.585 .516 .743 r
.4205 .37867 .42866 .40277 .44337 .40043 .4352 .37574 Metetra
.642 .545 .73 r
.4352 .37574 .44337 .40043 .45829 .39282 .45009 .36859 Metetra
.686 .573 .722 r
.45009 .36859 .45829 .39282 .47334 .38059 .46512 .35766 Metetra
.718 .599 .722 r
.46512 .35766 .47334 .38059 .48845 .36522 .48022 .34401 Metetra
.741 .622 .727 r
.48022 .34401 .48845 .36522 .50355 .34834 .49533 .32889 Metetra
.756 .642 .735 r
.49533 .32889 .50355 .34834 .51862 .33116 .51043 .31328 Metetra
.765 .66 .746 r
.51043 .31328 .51862 .33116 .53366 .31443 .52552 .29787 Metetra
.769 .675 .759 r
.52552 .29787 .53366 .31443 .54867 .29852 .54059 .28304 Metetra
.77 .688 .772 r
.54059 .28304 .54867 .29852 .56368 .28359 .55566 .26898 Metetra
.768 .699 .785 r
.55566 .26898 .56368 .28359 .5787 .26964 .57073 .25573 Metetra
.765 .708 .798 r
.57073 .25573 .5787 .26964 .59373 .25662 .58583 .24329 Metetra
.76 .715 .81 r
.58583 .24329 .59373 .25662 .60879 .24446 .60097 .23159 Metetra
.755 .722 .822 r
.60097 .23159 .60879 .24446 .6239 .23305 .61614 .22057 Metetra
.749 .727 .832 r
.61614 .22057 .6239 .23305 .63905 .2223 .63137 .21014 Metetra
.743 .732 .841 r
.63137 .21014 .63905 .2223 .65426 .2121 .64664 .20021 Metetra
.738 .736 .85 r
.64664 .20021 .65426 .2121 .66953 .20239 .66199 .19072 Metetra
.733 .74 .857 r
.66199 .19072 .66953 .20239 .68486 .19307 .67739 .18159 Metetra
.729 .743 .863 r
.67739 .18159 .68486 .19307 .70026 .18406 .69286 .17276 Metetra
.725 .746 .869 r
.69286 .17276 .70026 .18406 .71573 .17531 .7084 .16415 Metetra
.722 .75 .874 r
.7084 .16415 .71573 .17531 .73126 .16675 .72401 .15572 Metetra
.72 .753 .878 r
.72401 .15572 .73126 .16675 .74686 .15832 .73969 .1474 Metetra
.719 .756 .882 r
.73969 .1474 .74686 .15832 .76253 .14996 .75544 .13915 Metetra
.719 .76 .885 r
.75544 .13915 .76253 .14996 .77827 .14163 .77125 .13093 Metetra
.588 .72 .934 r
.13328 .3507 .14249 .35927 .15498 .35696 .14582 .34817 Metetra
.587 .715 .931 r
.14582 .34817 .15498 .35696 .16754 .35468 .15843 .34568 Metetra
.585 .709 .929 r
.15843 .34568 .16754 .35468 .18018 .35249 .17112 .34326 Metetra
.58 .703 .927 r
.17112 .34326 .18018 .35249 .19288 .35042 .18387 .34096 Metetra
.574 .696 .925 r
.18387 .34096 .19288 .35042 .20565 .34854 .19668 .33883 Metetra
.566 .688 .922 r
.19668 .33883 .20565 .34854 .21848 .3469 .20956 .33691 Metetra
.556 .678 .92 r
.20956 .33691 .21848 .3469 .23137 .34557 .2225 .33527 Metetra
.543 .667 .918 r
.2225 .33527 .23137 .34557 .24433 .3446 .23551 .33396 Metetra
.529 .654 .915 r
.23551 .33396 .24433 .3446 .25734 .34407 .24857 .33305 Metetra
.512 .638 .911 r
.24857 .33305 .25734 .34407 .27041 .34406 .26169 .33261 Metetra
.492 .621 .906 r
.26169 .33261 .27041 .34406 .28355 .34466 .27488 .3327 Metetra
.471 .6 .9 r
.27488 .3327 .28355 .34466 .29675 .34593 .28813 .33339 Metetra
.448 .578 .891 r
.28813 .33339 .29675 .34593 .31002 .34797 .30145 .33475 Metetra
.426 .553 .881 r
.30145 .33475 .31002 .34797 .32337 .35082 .31485 .3368 Metetra
.407 .529 .868 r
.31485 .3368 .32337 .35082 .3368 .35452 .32834 .33955 Metetra
.394 .505 .853 r
.32834 .33955 .3368 .35452 .35034 .35901 .34194 .34291 Metetra
.392 .487 .837 r
.34194 .34291 .35034 .35901 .364 .36412 .35565 .3467 Metetra
.406 .476 .819 r
.35565 .3467 .364 .36412 .37782 .36946 .36952 .35054 Metetra
.437 .476 .802 r
.36952 .35054 .37782 .36946 .39182 .37438 .38357 .35386 Metetra
.484 .486 .784 r
.38357 .35386 .39182 .37438 .40604 .37786 .39782 .35583 Metetra
.539 .504 .766 r
.39782 .35583 .40604 .37786 .4205 .37867 .41229 .3555 Metetra
.593 .527 .75 r
.41229 .3555 .4205 .37867 .4352 .37574 .42699 .35209 Metetra
.641 .551 .738 r
.42699 .35209 .4352 .37574 .45009 .36859 .44187 .34528 Metetra
.679 .575 .732 r
.44187 .34528 .45009 .36859 .46512 .35766 .45688 .33536 Metetra
.708 .598 .731 r
.45688 .33536 .46512 .35766 .48022 .34401 .47196 .32311 Metetra
.729 .619 .735 r
.47196 .32311 .48022 .34401 .49533 .32889 .48708 .30947 Metetra
.744 .638 .742 r
.48708 .30947 .49533 .32889 .51043 .31328 .50221 .29526 Metetra
.753 .654 .752 r
.50221 .29526 .51043 .31328 .52552 .29787 .51733 .28106 Metetra
.758 .669 .764 r
.51733 .28106 .52552 .29787 .54059 .28304 .53245 .26726 Metetra
.759 .682 .776 r
.53245 .26726 .54059 .28304 .55566 .26898 .54757 .25405 Metetra
.758 .692 .789 r
.54757 .25405 .55566 .26898 .57073 .25573 .56271 .24152 Metetra
.755 .701 .801 r
.56271 .24152 .57073 .25573 .58583 .24329 .57787 .22966 Metetra
.751 .709 .812 r
.57787 .22966 .58583 .24329 .60097 .23159 .59307 .21845 Metetra
.747 .716 .823 r
.59307 .21845 .60097 .23159 .61614 .22057 .60831 .20783 Metetra
.742 .722 .833 r
.60831 .20783 .61614 .22057 .63137 .21014 .62361 .19773 Metetra
.737 .727 .842 r
.62361 .19773 .63137 .21014 .64664 .20021 .63896 .1881 Metetra
.732 .732 .851 r
.63896 .1881 .64664 .20021 .66199 .19072 .65437 .17885 Metetra
.727 .736 .858 r
.65437 .17885 .66199 .19072 .67739 .18159 .66984 .16993 Metetra
.724 .74 .864 r
.66984 .16993 .67739 .18159 .69286 .17276 .68539 .16127 Metetra
.72 .743 .87 r
.68539 .16127 .69286 .17276 .7084 .16415 .701 .15283 Metetra
.718 .747 .875 r
.701 .15283 .7084 .16415 .72401 .15572 .71669 .14453 Metetra
.716 .751 .879 r
.71669 .14453 .72401 .15572 .73969 .1474 .73245 .13635 Metetra
.715 .754 .883 r
.73245 .13635 .73969 .1474 .75544 .13915 .74827 .12822 Metetra
.715 .758 .886 r
.74827 .12822 .75544 .13915 .77125 .13093 .76417 .12011 Metetra
.596 .722 .932 r
.12399 .34204 .13328 .3507 .14582 .34817 .13658 .3393 Metetra
.595 .717 .929 r
.13658 .3393 .14582 .34817 .15843 .34568 .14924 .33657 Metetra
.592 .712 .926 r
.14924 .33657 .15843 .34568 .17112 .34326 .16198 .33392 Metetra
.589 .705 .924 r
.16198 .33392 .17112 .34326 .18387 .34096 .17478 .33137 Metetra
.583 .698 .921 r
.17478 .33137 .18387 .34096 .19668 .33883 .18764 .32896 Metetra
.576 .69 .919 r
.18764 .32896 .19668 .33883 .20956 .33691 .20058 .32675 Metetra
.567 .681 .916 r
.20058 .32675 .20956 .33691 .2225 .33527 .21357 .32479 Metetra
.556 .67 .914 r
.21357 .32479 .2225 .33527 .23551 .33396 .22662 .32313 Metetra
.544 .658 .91 r
.22662 .32313 .23551 .33396 .24857 .33305 .23974 .32182 Metetra
.529 .644 .906 r
.23974 .32182 .24857 .33305 .26169 .33261 .25292 .32092 Metetra
.513 .627 .901 r
.25292 .32092 .26169 .33261 .27488 .3327 .26616 .3205 Metetra
.495 .609 .895 r
.26616 .3205 .27488 .3327 .28813 .33339 .27946 .3206 Metetra
.477 .589 .887 r
.27946 .3206 .28813 .33339 .30145 .33475 .29284 .32126 Metetra
.46 .568 .877 r
.29284 .32126 .30145 .33475 .31485 .3368 .3063 .32252 Metetra
.445 .546 .865 r
.3063 .32252 .31485 .3368 .32834 .33955 .31984 .32433 Metetra
.436 .526 .851 r
.31984 .32433 .32834 .33955 .34194 .34291 .33349 .32662 Metetra
.437 .51 .836 r
.33349 .32662 .34194 .34291 .35565 .3467 .34727 .32918 Metetra
.449 .5 .82 r
.34727 .32918 .35565 .3467 .36952 .35054 .36119 .33168 Metetra
.474 .499 .803 r
.36119 .33168 .36952 .35054 .38357 .35386 .37528 .33362 Metetra
.511 .505 .786 r
.37528 .33362 .38357 .35386 .39782 .35583 .38956 .33433 Metetra
.555 .519 .77 r
.38956 .33433 .39782 .35583 .41229 .3555 .40405 .33307 Metetra
.599 .537 .756 r
.40405 .33307 .41229 .3555 .42699 .35209 .41874 .32928 Metetra
.639 .557 .746 r
.41874 .32928 .42699 .35209 .44187 .34528 .4336 .32272 Metetra
.673 .577 .74 r
.4336 .32272 .44187 .34528 .45688 .33536 .4486 .3136 Metetra
.699 .597 .739 r
.4486 .3136 .45688 .33536 .47196 .32311 .46368 .30249 Metetra
.719 .616 .742 r
.46368 .30249 .47196 .32311 .48708 .30947 .4788 .29012 Metetra
.732 .634 .749 r
.4788 .29012 .48708 .30947 .50221 .29526 .49394 .27713 Metetra
.741 .649 .758 r
.49394 .27713 .50221 .29526 .51733 .28106 .50909 .26406 Metetra
.746 .663 .769 r
.50909 .26406 .51733 .28106 .53245 .26726 .52425 .25124 Metetra
.748 .675 .78 r
.52425 .25124 .53245 .26726 .54757 .25405 .53943 .23886 Metetra
.748 .686 .792 r
.53943 .23886 .54757 .25405 .56271 .24152 .55462 .22702 Metetra
.746 .696 .804 r
.55462 .22702 .56271 .24152 .57787 .22966 .56985 .21575 Metetra
.742 .704 .815 r
.56985 .21575 .57787 .22966 .59307 .21845 .58511 .20504 Metetra
.738 .711 .825 r
.58511 .20504 .59307 .21845 .60831 .20783 .60041 .19484 Metetra
.734 .717 .835 r
.60041 .19484 .60831 .20783 .62361 .19773 .61577 .1851 Metetra
.73 .723 .844 r
.61577 .1851 .62361 .19773 .63896 .1881 .63119 .17577 Metetra
.726 .728 .852 r
.63119 .17577 .63896 .1881 .65437 .17885 .64667 .16678 Metetra
.722 .732 .859 r
.64667 .16678 .65437 .17885 .66984 .16993 .66222 .15808 Metetra
.718 .736 .865 r
.66222 .15808 .66984 .16993 .68539 .16127 .67784 .14962 Metetra
.715 .74 .871 r
.67784 .14962 .68539 .16127 .701 .15283 .69353 .14135 Metetra
.713 .744 .876 r
.69353 .14135 .701 .15283 .71669 .14453 .70929 .13321 Metetra
.712 .748 .881 r
.70929 .13321 .71669 .14453 .73245 .13635 .72513 .12516 Metetra
.711 .752 .884 r
.72513 .12516 .73245 .13635 .74827 .12822 .74103 .11717 Metetra
.711 .756 .888 r
.74103 .11717 .74827 .12822 .76417 .12011 .75701 .10918 Metetra
.603 .724 .93 r
.11462 .3333 .12399 .34204 .13658 .3393 .12726 .33033 Metetra
.603 .719 .927 r
.12726 .33033 .13658 .3393 .14924 .33657 .13997 .32737 Metetra
.6 .714 .924 r
.13997 .32737 .14924 .33657 .16198 .33392 .15276 .32446 Metetra
.597 .708 .921 r
.15276 .32446 .16198 .33392 .17478 .33137 .16561 .32164 Metetra
.592 .701 .918 r
.16561 .32164 .17478 .33137 .18764 .32896 .17853 .31896 Metetra
.586 .693 .916 r
.17853 .31896 .18764 .32896 .20058 .32675 .19152 .31645 Metetra
.578 .684 .913 r
.19152 .31645 .20058 .32675 .21357 .32479 .20456 .31415 Metetra
.569 .674 .91 r
.20456 .31415 .21357 .32479 .22662 .32313 .21767 .31211 Metetra
.559 .662 .906 r
.21767 .31211 .22662 .32313 .23974 .32182 .23085 .31039 Metetra
.546 .649 .902 r
.23085 .31039 .23974 .32182 .25292 .32092 .24408 .30902 Metetra
.533 .634 .896 r
.24408 .30902 .25292 .32092 .26616 .3205 .25738 .30807 Metetra
.518 .617 .89 r
.25738 .30807 .26616 .3205 .27946 .3206 .27074 .30757 Metetra
.503 .599 .882 r
.27074 .30757 .27946 .3206 .29284 .32126 .28418 .30754 Metetra
.49 .58 .873 r
.28418 .30754 .29284 .32126 .3063 .32252 .2977 .308 Metetra
.479 .561 .862 r
.2977 .308 .3063 .32252 .31984 .32433 .3113 .30891 Metetra
.472 .544 .849 r
.3113 .30891 .31984 .32433 .33349 .32662 .32501 .31017 Metetra
.473 .529 .834 r
.32501 .31017 .33349 .32662 .34727 .32918 .33884 .3116 Metetra
.484 .52 .819 r
.33884 .3116 .34727 .32918 .36119 .33168 .35281 .3129 Metetra
.505 .517 .803 r
.35281 .3129 .36119 .33168 .37528 .33362 .36694 .31363 Metetra
.534 .521 .788 r
.36694 .31363 .37528 .33362 .38956 .33433 .38126 .31326 Metetra
.569 .531 .773 r
.38126 .31326 .38956 .33433 .40405 .33307 .39576 .31124 Metetra
.605 .545 .761 r
.39576 .31124 .40405 .33307 .41874 .32928 .41045 .30713 Metetra
.638 .562 .752 r
.41045 .30713 .41874 .32928 .4336 .32272 .4253 .30075 Metetra
.667 .579 .747 r
.4253 .30075 .4336 .32272 .4486 .3136 .44028 .29227 Metetra
.69 .597 .746 r
.44028 .29227 .4486 .3136 .46368 .30249 .45535 .28211 Metetra
.708 .614 .749 r
.45535 .28211 .46368 .30249 .4788 .29012 .47048 .27083 Metetra
.721 .63 .755 r
.47048 .27083 .4788 .29012 .49394 .27713 .48564 .25894 Metetra
.73 .644 .764 r
.48564 .25894 .49394 .27713 .50909 .26406 .50082 .2469 Metetra
.735 .658 .774 r
.50082 .2469 .50909 .26406 .52425 .25124 .51601 .23499 Metetra
.737 .67 .784 r
.51601 .23499 .52425 .25124 .53943 .23886 .53123 .22342 Metetra
.737 .68 .795 r
.53123 .22342 .53943 .23886 .55462 .22702 .54648 .21227 Metetra
.736 .69 .807 r
.54648 .21227 .55462 .22702 .56985 .21575 .56175 .2016 Metetra
.733 .698 .817 r
.56175 .2016 .56985 .21575 .58511 .20504 .57708 .19139 Metetra
.73 .706 .827 r
.57708 .19139 .58511 .20504 .60041 .19484 .59245 .18162 Metetra
.726 .712 .837 r
.59245 .18162 .60041 .19484 .61577 .1851 .60787 .17225 Metetra
.723 .718 .846 r
.60787 .17225 .61577 .1851 .63119 .17577 .62336 .16323 Metetra
.719 .723 .853 r
.62336 .16323 .63119 .17577 .64667 .16678 .63891 .15452 Metetra
.716 .728 .86 r
.63891 .15452 .64667 .16678 .66222 .15808 .65453 .14606 Metetra
.713 .733 .867 r
.65453 .14606 .66222 .15808 .67784 .14962 .67022 .1378 Metetra
.71 .737 .872 r
.67022 .1378 .67784 .14962 .69353 .14135 .68598 .12971 Metetra
.708 .742 .877 r
.68598 .12971 .69353 .14135 .70929 .13321 .70182 .12173 Metetra
.707 .746 .882 r
.70182 .12173 .70929 .13321 .72513 .12516 .71773 .11384 Metetra
.706 .75 .886 r
.71773 .11384 .72513 .12516 .74103 .11717 .73371 .10599 Metetra
.707 .754 .889 r
.73371 .10599 .74103 .11717 .75701 .10918 .74977 .09813 Metetra
.611 .727 .928 r
.10515 .32448 .11462 .3333 .12726 .33033 .11785 .32126 Metetra
.61 .722 .924 r
.11785 .32126 .12726 .33033 .13997 .32737 .13062 .31805 Metetra
.609 .716 .921 r
.13062 .31805 .13997 .32737 .15276 .32446 .14346 .31489 Metetra
.606 .71 .918 r
.14346 .31489 .15276 .32446 .16561 .32164 .15637 .3118 Metetra
.601 .703 .915 r
.15637 .3118 .16561 .32164 .17853 .31896 .16935 .30882 Metetra
.596 .695 .912 r
.16935 .30882 .17853 .31896 .19152 .31645 .18239 .30599 Metetra
.59 .687 .909 r
.18239 .30599 .19152 .31645 .20456 .31415 .19549 .30335 Metetra
.582 .677 .905 r
.19549 .30335 .20456 .31415 .21767 .31211 .20866 .30093 Metetra
.573 .666 .901 r
.20866 .30093 .21767 .31211 .23085 .31039 .22189 .29877 Metetra
.563 .654 .897 r
.22189 .29877 .23085 .31039 .24408 .30902 .23518 .29693 Metetra
.551 .64 .891 r
.23518 .29693 .24408 .30902 .25738 .30807 .24854 .29543 Metetra
.539 .625 .885 r
.24854 .29543 .25738 .30807 .27074 .30757 .26197 .29432 Metetra
.527 .608 .877 r
.26197 .29432 .27074 .30757 .28418 .30754 .27547 .2936 Metetra
.517 .591 .868 r
.27547 .2936 .28418 .30754 .2977 .308 .28905 .29328 Metetra
.508 .574 .857 r
.28905 .29328 .2977 .308 .3113 .30891 .30271 .29331 Metetra
.503 .559 .845 r
.30271 .29331 .3113 .30891 .32501 .31017 .31648 .2936 Metetra
.505 .546 .832 r
.31648 .2936 .32501 .31017 .33884 .3116 .33037 .29397 Metetra
.513 .537 .818 r
.33037 .29397 .33884 .3116 .35281 .3129 .34439 .29417 Metetra
.529 .533 .803 r
.34439 .29417 .35281 .3129 .36694 .31363 .35857 .29384 Metetra
.553 .535 .789 r
.35857 .29384 .36694 .31363 .38126 .31326 .37291 .29255 Metetra
.58 .542 .776 r
.37291 .29255 .38126 .31326 .39576 .31124 .38743 .28988 Metetra
.609 .552 .765 r
.38743 .28988 .39576 .31124 .41045 .30713 .40212 .28549 Metetra
.637 .566 .758 r
.40212 .28549 .41045 .30713 .4253 .30075 .41697 .27926 Metetra
.662 .581 .753 r
.41697 .27926 .4253 .30075 .44028 .29227 .43194 .2713 Metetra
.682 .596 .753 r
.43194 .2713 .44028 .29227 .45535 .28211 .447 .26194 Metetra
.698 .611 .756 r
.447 .26194 .45535 .28211 .47048 .27083 .46212 .2516 Metetra
.71 .626 .761 r
.46212 .2516 .47048 .27083 .48564 .25894 .47729 .2407 Metetra
.718 .64 .769 r
.47729 .2407 .48564 .25894 .50082 .2469 .49249 .22959 Metetra
.723 .652 .778 r
.49249 .22959 .50082 .2469 .51601 .23499 .50772 .21856 Metetra
.726 .664 .788 r
.50772 .21856 .51601 .23499 .53123 .22342 .52298 .20776 Metetra
.727 .675 .799 r
.52298 .20776 .53123 .22342 .54648 .21227 .53827 .19729 Metetra
.726 .684 .81 r
.53827 .19729 .54648 .21227 .56175 .2016 .5536 .18721 Metetra
.724 .693 .82 r
.5536 .18721 .56175 .2016 .57708 .19139 .56898 .17751 Metetra
.721 .7 .83 r
.56898 .17751 .57708 .19139 .59245 .18162 .58441 .16818 Metetra
.718 .707 .839 r
.58441 .16818 .59245 .18162 .60787 .17225 .5999 .15919 Metetra
.715 .714 .847 r
.5999 .15919 .60787 .17225 .62336 .16323 .61545 .1505 Metetra
.712 .719 .855 r
.61545 .1505 .62336 .16323 .63891 .15452 .63107 .14207 Metetra
.709 .725 .862 r
.63107 .14207 .63891 .15452 .65453 .14606 .64675 .13386 Metetra
.707 .73 .868 r
.64675 .13386 .65453 .14606 .67022 .1378 .66252 .12582 Metetra
.705 .734 .874 r
.66252 .12582 .67022 .1378 .68598 .12971 .67835 .11792 Metetra
.703 .739 .879 r
.67835 .11792 .68598 .12971 .70182 .12173 .69427 .11012 Metetra
.702 .743 .883 r
.69427 .11012 .70182 .12173 .71773 .11384 .71026 .10238 Metetra
.702 .748 .887 r
.71026 .10238 .71773 .11384 .73371 .10599 .72632 .09468 Metetra
.702 .752 .891 r
.72632 .09468 .73371 .10599 .74977 .09813 .74246 .08697 Metetra
.619 .729 .925 r
.0956 .31558 .10515 .32448 .11785 .32126 .10835 .31211 Metetra
.618 .724 .922 r
.10835 .31211 .11785 .32126 .13062 .31805 .12118 .30864 Metetra
.617 .718 .918 r
.12118 .30864 .13062 .31805 .14346 .31489 .13408 .3052 Metetra
.614 .712 .915 r
.13408 .3052 .14346 .31489 .15637 .3118 .14705 .30183 Metetra
.61 .705 .912 r
.14705 .30183 .15637 .3118 .16935 .30882 .16008 .29855 Metetra
.606 .698 .908 r
.16008 .29855 .16935 .30882 .18239 .30599 .17318 .2954 Metetra
.601 .69 .905 r
.17318 .2954 .18239 .30599 .19549 .30335 .18635 .29239 Metetra
.594 .68 .901 r
.18635 .29239 .19549 .30335 .20866 .30093 .19958 .28958 Metetra
.586 .67 .897 r
.19958 .28958 .20866 .30093 .22189 .29877 .21287 .28698 Metetra
.578 .658 .892 r
.21287 .28698 .22189 .29877 .23518 .29693 .22622 .28465 Metetra
.569 .646 .886 r
.22622 .28465 .23518 .29693 .24854 .29543 .23965 .2826 Metetra
.559 .632 .88 r
.23965 .2826 .24854 .29543 .26197 .29432 .25314 .28087 Metetra
.549 .617 .872 r
.25314 .28087 .26197 .29432 .27547 .2936 .2667 .27947 Metetra
.541 .601 .863 r
.2667 .27947 .27547 .2936 .28905 .29328 .28035 .27837 Metetra
.534 .586 .853 r
.28035 .27837 .28905 .29328 .30271 .29331 .29408 .27755 Metetra
.53 .572 .841 r
.29408 .27755 .30271 .29331 .31648 .2936 .30791 .27691 Metetra
.531 .559 .829 r
.30791 .27691 .31648 .2936 .33037 .29397 .32186 .2763 Metetra
.538 .551 .816 r
.32186 .2763 .33037 .29397 .34439 .29417 .33593 .2755 Metetra
.551 .546 .802 r
.33593 .2755 .34439 .29417 .35857 .29384 .35015 .27422 Metetra
.568 .546 .79 r
.35015 .27422 .35857 .29384 .37291 .29255 .36452 .27212 Metetra
.59 .55 .778 r
.36452 .27212 .37291 .29255 .38743 .28988 .37906 .26888 Metetra
.613 .558 .769 r
.37906 .26888 .38743 .28988 .40212 .28549 .39376 .26425 Metetra
.636 .569 .762 r
.39376 .26425 .40212 .28549 .41697 .27926 .40859 .25813 Metetra
.657 .582 .759 r
.40859 .25813 .41697 .27926 .43194 .2713 .42355 .25062 Metetra
.675 .595 .759 r
.42355 .25062 .43194 .2713 .447 .26194 .4386 .24194 Metetra
.689 .609 .761 r
.4386 .24194 .447 .26194 .46212 .2516 .45373 .23242 Metetra
.699 .622 .767 r
.45373 .23242 .46212 .2516 .47729 .2407 .4689 .2224 Metetra
.707 .635 .774 r
.4689 .2224 .47729 .2407 .49249 .22959 .48412 .21217 Metetra
.712 .647 .783 r
.48412 .21217 .49249 .22959 .50772 .21856 .49938 .20195 Metetra
.715 .658 .793 r
.49938 .20195 .50772 .21856 .52298 .20776 .51467 .1919 Metetra
.716 .669 .803 r
.51467 .1919 .52298 .20776 .53827 .19729 .53 .1821 Metetra
.716 .679 .813 r
.53 .1821 .53827 .19729 .5536 .18721 .54538 .17261 Metetra
.714 .687 .823 r
.54538 .17261 .5536 .18721 .56898 .17751 .56081 .16342 Metetra
.712 .695 .832 r
.56081 .16342 .56898 .17751 .58441 .16818 .5763 .15454 Metetra
.71 .703 .841 r
.5763 .15454 .58441 .16818 .5999 .15919 .59185 .14594 Metetra
.707 .709 .849 r
.59185 .14594 .5999 .15919 .61545 .1505 .60746 .13759 Metetra
.705 .715 .857 r
.60746 .13759 .61545 .1505 .63107 .14207 .62315 .12945 Metetra
.703 .721 .864 r
.62315 .12945 .63107 .14207 .64675 .13386 .63891 .12149 Metetra
.701 .726 .87 r
.63891 .12149 .64675 .13386 .66252 .12582 .65474 .11368 Metetra
.699 .731 .875 r
.65474 .11368 .66252 .12582 .67835 .11792 .67065 .10598 Metetra
.698 .736 .88 r
.67065 .10598 .67835 .11792 .69427 .11012 .68664 .09836 Metetra
.697 .741 .885 r
.68664 .09836 .69427 .11012 .71026 .10238 .7027 .09079 Metetra
.697 .745 .889 r
.7027 .09079 .71026 .10238 .72632 .09468 .71885 .08325 Metetra
.697 .75 .893 r
.71885 .08325 .72632 .09468 .74246 .08697 .73507 .07569 Metetra
.627 .732 .923 r
.08595 .30661 .0956 .31558 .10835 .31211 .09877 .30287 Metetra
.626 .726 .919 r
.09877 .30287 .10835 .31211 .12118 .30864 .11166 .29913 Metetra
.625 .72 .915 r
.11166 .29913 .12118 .30864 .13408 .3052 .12462 .29541 Metetra
.622 .714 .912 r
.12462 .29541 .13408 .3052 .14705 .30183 .13765 .29175 Metetra
.619 .708 .908 r
.13765 .29175 .14705 .30183 .16008 .29855 .15074 .28816 Metetra
.616 .7 .905 r
.15074 .28816 .16008 .29855 .17318 .2954 .1639 .28467 Metetra
.611 .692 .901 r
.1639 .28467 .17318 .2954 .18635 .29239 .17713 .28129 Metetra
.606 .684 .897 r
.17713 .28129 .18635 .29239 .19958 .28958 .19042 .27807 Metetra
.6 .674 .892 r
.19042 .27807 .19958 .28958 .21287 .28698 .20378 .27503 Metetra
.593 .663 .887 r
.20378 .27503 .21287 .28698 .22622 .28465 .2172 .27219 Metetra
.585 .651 .881 r
.2172 .27219 .22622 .28465 .23965 .2826 .23069 .26959 Metetra
.577 .638 .875 r
.23069 .26959 .23965 .2826 .25314 .28087 .24425 .26725 Metetra
.57 .624 .867 r
.24425 .26725 .25314 .28087 .2667 .27947 .25789 .26515 Metetra
.563 .61 .858 r
.25789 .26515 .2667 .27947 .28035 .27837 .2716 .2633 Metetra
.557 .596 .848 r
.2716 .2633 .28035 .27837 .29408 .27755 .2854 .26165 Metetra
.554 .583 .837 r
.2854 .26165 .29408 .27755 .30791 .27691 .2993 .26012 Metetra
.555 .571 .826 r
.2993 .26012 .30791 .27691 .32186 .2763 .3133 .25858 Metetra
.559 .562 .813 r
.3133 .25858 .32186 .2763 .33593 .2755 .32743 .25686 Metetra
.569 .557 .801 r
.32743 .25686 .33593 .2755 .35015 .27422 .34169 .25473 Metetra
.582 .555 .79 r
.34169 .25473 .35015 .27422 .36452 .27212 .35609 .25191 Metetra
.599 .558 .78 r
.35609 .25191 .36452 .27212 .37906 .26888 .37065 .24817 Metetra
.617 .563 .772 r
.37065 .24817 .37906 .26888 .39376 .26425 .38535 .24332 Metetra
.635 .572 .766 r
.38535 .24332 .39376 .26425 .40859 .25813 .40018 .23729 Metetra
.652 .582 .763 r
.40018 .23729 .40859 .25813 .42355 .25062 .41513 .23014 Metetra
.667 .594 .764 r
.41513 .23014 .42355 .25062 .4386 .24194 .43017 .22206 Metetra
.679 .606 .767 r
.43017 .22206 .4386 .24194 .45373 .23242 .44529 .21328 Metetra
.689 .618 .772 r
.44529 .21328 .45373 .23242 .4689 .2224 .46047 .20406 Metetra
.696 .63 .779 r
.46047 .20406 .4689 .2224 .48412 .21217 .4757 .19464 Metetra
.701 .642 .787 r
.4757 .19464 .48412 .21217 .49938 .20195 .49098 .1852 Metetra
.704 .653 .797 r
.49098 .1852 .49938 .20195 .51467 .1919 .50631 .17587 Metetra
.705 .663 .806 r
.50631 .17587 .51467 .1919 .53 .1821 .52168 .16672 Metetra
.705 .673 .816 r
.52168 .16672 .53 .1821 .54538 .17261 .5371 .15781 Metetra
.704 .682 .826 r
.5371 .15781 .54538 .17261 .56081 .16342 .55258 .14913 Metetra
.703 .69 .835 r
.55258 .14913 .56081 .16342 .5763 .15454 .56812 .1407 Metetra
.701 .698 .844 r
.56812 .1407 .5763 .15454 .59185 .14594 .58373 .1325 Metetra
.699 .705 .852 r
.58373 .1325 .59185 .14594 .60746 .13759 .59941 .12449 Metetra
.698 .711 .859 r
.59941 .12449 .60746 .13759 .62315 .12945 .61516 .11666 Metetra
.696 .717 .866 r
.61516 .11666 .62315 .12945 .63891 .12149 .63098 .10897 Metetra
.694 .723 .872 r
.63098 .10897 .63891 .12149 .65474 .11368 .64689 .10139 Metetra
.693 .728 .877 r
.64689 .10139 .65474 .11368 .67065 .10598 .66287 .09389 Metetra
.692 .733 .882 r
.66287 .09389 .67065 .10598 .68664 .09836 .67893 .08646 Metetra
.692 .738 .887 r
.67893 .08646 .68664 .09836 .7027 .09079 .69507 .07907 Metetra
.691 .743 .891 r
.69507 .07907 .7027 .09079 .71885 .08325 .7113 .07169 Metetra
.692 .748 .895 r
.7113 .07169 .71885 .08325 .73507 .07569 .72761 .0643 Metetra
.635 .734 .92 r
.07621 .29755 .08595 .30661 .09877 .30287 .0891 .29353 Metetra
.634 .728 .916 r
.0891 .29353 .09877 .30287 .11166 .29913 .10205 .28951 Metetra
.632 .722 .912 r
.10205 .28951 .11166 .29913 .12462 .29541 .11507 .28551 Metetra
.63 .716 .909 r
.11507 .28551 .12462 .29541 .13765 .29175 .12816 .28155 Metetra
.628 .71 .905 r
.12816 .28155 .13765 .29175 .15074 .28816 .14132 .27765 Metetra
.625 .703 .901 r
.14132 .27765 .15074 .28816 .1639 .28467 .15455 .27381 Metetra
.622 .695 .897 r
.15455 .27381 .1639 .28467 .17713 .28129 .16784 .27005 Metetra
.617 .687 .893 r
.16784 .27005 .17713 .28129 .19042 .27807 .1812 .26642 Metetra
.612 .678 .888 r
.1812 .26642 .19042 .27807 .20378 .27503 .19463 .26292 Metetra
.607 .667 .883 r
.19463 .26292 .20378 .27503 .2172 .27219 .20812 .25958 Metetra
.601 .656 .876 r
.20812 .25958 .2172 .27219 .23069 .26959 .22168 .25642 Metetra
.594 .644 .87 r
.22168 .25642 .23069 .26959 .24425 .26725 .23531 .25345 Metetra
.588 .631 .862 r
.23531 .25345 .24425 .26725 .25789 .26515 .24902 .25068 Metetra
.582 .618 .853 r
.24902 .25068 .25789 .26515 .2716 .2633 .2628 .24808 Metetra
.578 .605 .844 r
.2628 .24808 .2716 .2633 .2854 .26165 .27667 .24562 Metetra
.575 .593 .833 r
.27667 .24562 .2854 .26165 .2993 .26012 .29063 .24324 Metetra
.575 .582 .822 r
.29063 .24324 .2993 .26012 .3133 .25858 .3047 .24083 Metetra
.578 .573 .811 r
.3047 .24083 .3133 .25858 .32743 .25686 .31888 .23825 Metetra
.584 .567 .8 r
.31888 .23825 .32743 .25686 .34169 .25473 .33319 .23533 Metetra
.594 .564 .79 r
.33319 .23533 .34169 .25473 .35609 .25191 .34762 .23186 Metetra
.606 .564 .781 r
.34762 .23186 .35609 .25191 .37065 .24817 .36219 .22767 Metetra
.62 .568 .774 r
.36219 .22767 .37065 .24817 .38535 .24332 .3769 .22262 Metetra
.634 .574 .769 r
.3769 .22262 .38535 .24332 .40018 .23729 .39173 .21666 Metetra
.648 .582 .767 r
.39173 .21666 .40018 .23729 .41513 .23014 .40667 .20983 Metetra
.66 .592 .768 r
.40667 .20983 .41513 .23014 .43017 .22206 .42171 .20227 Metetra
.67 .603 .771 r
.42171 .20227 .43017 .22206 .44529 .21328 .43682 .19415 Metetra
.678 .614 .777 r
.43682 .19415 .44529 .21328 .46047 .20406 .452 .18567 Metetra
.685 .625 .783 r
.452 .18567 .46047 .20406 .4757 .19464 .46724 .17701 Metetra
.689 .637 .792 r
.46724 .17701 .4757 .19464 .49098 .1852 .48254 .16831 Metetra
.692 .647 .801 r
.48254 .16831 .49098 .1852 .50631 .17587 .49789 .15967 Metetra
.694 .658 .81 r
.49789 .15967 .50631 .17587 .52168 .16672 .51329 .15117 Metetra
.694 .668 .82 r
.51329 .15117 .52168 .16672 .5371 .15781 .52876 .14282 Metetra
.694 .677 .829 r
.52876 .14282 .5371 .15781 .55258 .14913 .54429 .13466 Metetra
.693 .685 .838 r
.54429 .13466 .55258 .14913 .56812 .1407 .55988 .12669 Metetra
.692 .693 .846 r
.55988 .12669 .56812 .1407 .58373 .1325 .57554 .11888 Metetra
.691 .7 .854 r
.57554 .11888 .58373 .1325 .59941 .12449 .59128 .11123 Metetra
.69 .707 .861 r
.59128 .11123 .59941 .12449 .61516 .11666 .60709 .1037 Metetra
.689 .714 .868 r
.60709 .1037 .61516 .11666 .63098 .10897 .62298 .09628 Metetra
.688 .72 .874 r
.62298 .09628 .63098 .10897 .64689 .10139 .63896 .08894 Metetra
.687 .725 .879 r
.63896 .08894 .64689 .10139 .66287 .09389 .65501 .08166 Metetra
.687 .73 .884 r
.65501 .08166 .66287 .09389 .67893 .08646 .67115 .07442 Metetra
.686 .736 .888 r
.67115 .07442 .67893 .08646 .69507 .07907 .68737 .06721 Metetra
.686 .741 .893 r
.68737 .06721 .69507 .07907 .7113 .07169 .70367 .06001 Metetra
.686 .746 .897 r
.70367 .06001 .7113 .07169 .72761 .0643 .72006 .0528 Metetra
.643 .736 .917 r
.06638 .28841 .07621 .29755 .0891 .29353 .07933 .2841 Metetra
.642 .73 .913 r
.07933 .2841 .0891 .29353 .10205 .28951 .09235 .27979 Metetra
.64 .724 .909 r
.09235 .27979 .10205 .28951 .11507 .28551 .10544 .27551 Metetra
.638 .718 .906 r
.10544 .27551 .11507 .28551 .12816 .28155 .1186 .27125 Metetra
.637 .712 .902 r
.1186 .27125 .12816 .28155 .14132 .27765 .13182 .26701 Metetra
.634 .705 .898 r
.13182 .26701 .14132 .27765 .15455 .27381 .14511 .26282 Metetra
.632 .698 .893 r
.14511 .26282 .15455 .27381 .16784 .27005 .15848 .25869 Metetra
.628 .69 .889 r
.15848 .25869 .16784 .27005 .1812 .26642 .17191 .25463 Metetra
.624 .681 .883 r
.17191 .25463 .1812 .26642 .19463 .26292 .1854 .25067 Metetra
.62 .672 .878 r
.1854 .25067 .19463 .26292 .20812 .25958 .19897 .24682 Metetra
.615 .661 .872 r
.19897 .24682 .20812 .25958 .22168 .25642 .2126 .2431 Metetra
.61 .65 .865 r
.2126 .2431 .22168 .25642 .23531 .25345 .22631 .23951 Metetra
.605 .638 .857 r
.22631 .23951 .23531 .25345 .24902 .25068 .24009 .23605 Metetra
.601 .626 .848 r
.24009 .23605 .24902 .25068 .2628 .24808 .25395 .23272 Metetra
.597 .613 .839 r
.25395 .23272 .2628 .24808 .27667 .24562 .26789 .22947 Metetra
.594 .602 .829 r
.26789 .22947 .27667 .24562 .29063 .24324 .28192 .22626 Metetra
.594 .591 .819 r
.28192 .22626 .29063 .24324 .3047 .24083 .29605 .22302 Metetra
.595 .582 .808 r
.29605 .22302 .3047 .24083 .31888 .23825 .31029 .21963 Metetra
.599 .575 .798 r
.31029 .21963 .31888 .23825 .33319 .23533 .32464 .21598 Metetra
.605 .571 .789 r
.32464 .21598 .33319 .23533 .34762 .23186 .33911 .21191 Metetra
.613 .569 .781 r
.33911 .21191 .34762 .23186 .36219 .22767 .3537 .20731 Metetra
.623 .571 .776 r
.3537 .20731 .36219 .22767 .3769 .22262 .36841 .20207 Metetra
.633 .575 .772 r
.36841 .20207 .3769 .22262 .39173 .21666 .38324 .19616 Metetra
.643 .582 .771 r
.38324 .19616 .39173 .21666 .40667 .20983 .39817 .18962 Metetra
.653 .59 .772 r
.39817 .18962 .40667 .20983 .42171 .20227 .4132 .18253 Metetra
.661 .599 .775 r
.4132 .18253 .42171 .20227 .43682 .19415 .4283 .17502 Metetra
.668 .61 .781 r
.4283 .17502 .43682 .19415 .452 .18567 .44348 .16723 Metetra
.673 .62 .788 r
.44348 .16723 .452 .18567 .46724 .17701 .45873 .15928 Metetra
.677 .631 .796 r
.45873 .15928 .46724 .17701 .48254 .16831 .47404 .15129 Metetra
.68 .642 .805 r
.47404 .15129 .48254 .16831 .49789 .15967 .48941 .14333 Metetra
.682 .652 .814 r
.48941 .14333 .49789 .15967 .51329 .15117 .50485 .13545 Metetra
.683 .662 .823 r
.50485 .13545 .51329 .15117 .52876 .14282 .52035 .12767 Metetra
.684 .671 .832 r
.52035 .12767 .52876 .14282 .54429 .13466 .53592 .12003 Metetra
.684 .68 .841 r
.53592 .12003 .54429 .13466 .55988 .12669 .55157 .1125 Metetra
.683 .688 .849 r
.55157 .1125 .55988 .12669 .57554 .11888 .56728 .1051 Metetra
.683 .696 .856 r
.56728 .1051 .57554 .11888 .59128 .11123 .58308 .0978 Metetra
.682 .703 .863 r
.58308 .0978 .59128 .11123 .60709 .1037 .59895 .09059 Metetra
.681 .71 .87 r
.59895 .09059 .60709 .1037 .62298 .09628 .61491 .08345 Metetra
.681 .716 .876 r
.61491 .08345 .62298 .09628 .63896 .08894 .63095 .07635 Metetra
.681 .722 .881 r
.63095 .07635 .63896 .08894 .65501 .08166 .64707 .06929 Metetra
.681 .728 .886 r
.64707 .06929 .65501 .08166 .67115 .07442 .66328 .06225 Metetra
.68 .733 .89 r
.66328 .06225 .67115 .07442 .68737 .06721 .67958 .05522 Metetra
.68 .738 .894 r
.67958 .05522 .68737 .06721 .70367 .06001 .69596 .04819 Metetra
.68 .743 .899 r
.69596 .04819 .70367 .06001 .72006 .0528 .71244 .04117 Metetra
.651 .738 .914 r
.05646 .27918 .06638 .28841 .07933 .2841 .06948 .27457 Metetra
.649 .732 .91 r
.06948 .27457 .07933 .2841 .09235 .27979 .08257 .26997 Metetra
.648 .726 .906 r
.08257 .26997 .09235 .27979 .10544 .27551 .09572 .2654 Metetra
.646 .72 .902 r
.09572 .2654 .10544 .27551 .1186 .27125 .10894 .26083 Metetra
.645 .714 .898 r
.10894 .26083 .1186 .27125 .13182 .26701 .12224 .25627 Metetra
.643 .708 .894 r
.12224 .25627 .13182 .26701 .14511 .26282 .1356 .25172 Metetra
.641 .701 .889 r
.1356 .25172 .14511 .26282 .15848 .25869 .14903 .2472 Metetra
.639 .693 .884 r
.14903 .2472 .15848 .25869 .17191 .25463 .16254 .24271 Metetra
.636 .685 .879 r
.16254 .24271 .17191 .25463 .1854 .25067 .17611 .23828 Metetra
.632 .676 .873 r
.17611 .23828 .1854 .25067 .19897 .24682 .18975 .23392 Metetra
.629 .666 .867 r
.18975 .23392 .19897 .24682 .2126 .2431 .20346 .22963 Metetra
.625 .655 .86 r
.20346 .22963 .2126 .2431 .22631 .23951 .21725 .22542 Metetra
.621 .644 .852 r
.21725 .22542 .22631 .23951 .24009 .23605 .23111 .2213 Metetra
.617 .633 .843 r
.23111 .2213 .24009 .23605 .25395 .23272 .24504 .21723 Metetra
.614 .621 .834 r
.24504 .21723 .25395 .23272 .26789 .22947 .25906 .21321 Metetra
.612 .61 .825 r
.25906 .21321 .26789 .22947 .28192 .22626 .27317 .2092 Metetra
.61 .599 .815 r
.27317 .2092 .28192 .22626 .29605 .22302 .28736 .20515 Metetra
.61 .59 .805 r
.28736 .20515 .29605 .22302 .31029 .21963 .30166 .201 Metetra
.611 .582 .796 r
.30166 .201 .31029 .21963 .32464 .21598 .31605 .19665 Metetra
.615 .577 .788 r
.31605 .19665 .32464 .21598 .33911 .21191 .33056 .19202 Metetra
.619 .574 .782 r
.33056 .19202 .33911 .21191 .3537 .20731 .34517 .18703 Metetra
.625 .574 .777 r
.34517 .18703 .3537 .20731 .36841 .20207 .35989 .18161 Metetra
.632 .576 .774 r
.35989 .18161 .36841 .20207 .38324 .19616 .37471 .17575 Metetra
.639 .581 .774 r
.37471 .17575 .38324 .19616 .39817 .18962 .38964 .16946 Metetra
.645 .588 .775 r
.38964 .16946 .39817 .18962 .4132 .18253 .40465 .1628 Metetra
.651 .596 .779 r
.40465 .1628 .4132 .18253 .4283 .17502 .41975 .15586 Metetra
.657 .605 .785 r
.41975 .15586 .4283 .17502 .44348 .16723 .43492 .14872 Metetra
.661 .615 .792 r
.43492 .14872 .44348 .16723 .45873 .15928 .45017 .14146 Metetra
.665 .625 .8 r
.45017 .14146 .45873 .15928 .47404 .15129 .46549 .13416 Metetra
.668 .636 .809 r
.46549 .13416 .47404 .15129 .48941 .14333 .48088 .12685 Metetra
.67 .646 .818 r
.48088 .12685 .48941 .14333 .50485 .13545 .49635 .11958 Metetra
.672 .657 .827 r
.49635 .11958 .50485 .13545 .52035 .12767 .51188 .11237 Metetra
.673 .666 .835 r
.51188 .11237 .52035 .12767 .53592 .12003 .52749 .10523 Metetra
.673 .675 .844 r
.52749 .10523 .53592 .12003 .55157 .1125 .54318 .09816 Metetra
.674 .684 .852 r
.54318 .09816 .55157 .1125 .56728 .1051 .55895 .09116 Metetra
.674 .692 .859 r
.55895 .09116 .56728 .1051 .58308 .0978 .5748 .08423 Metetra
.674 .699 .866 r
.5748 .08423 .58308 .0978 .59895 .09059 .59073 .07733 Metetra
.674 .706 .872 r
.59073 .07733 .59895 .09059 .61491 .08345 .60675 .07047 Metetra
.674 .713 .878 r
.60675 .07047 .61491 .08345 .63095 .07635 .62286 .06363 Metetra
.674 .719 .883 r
.62286 .06363 .63095 .07635 .64707 .06929 .63905 .05678 Metetra
.675 .725 .887 r
.63905 .05678 .64707 .06929 .66328 .06225 .65533 .04993 Metetra
.675 .73 .892 r
.65533 .04993 .66328 .06225 .67958 .05522 .67171 .04309 Metetra
.674 .735 .896 r
.67171 .04309 .67958 .05522 .69596 .04819 .68817 .03624 Metetra
.674 .74 .9 r
.68817 .03624 .69596 .04819 .71244 .04117 .70473 .02941 Metetra
.659 .74 .91 r
.04644 .26986 .05646 .27918 .06948 .27457 .05953 .26493 Metetra
.656 .734 .907 r
.05953 .26493 .06948 .27457 .08257 .26997 .07269 .26005 Metetra
.655 .728 .903 r
.07269 .26005 .08257 .26997 .09572 .2654 .08591 .25519 Metetra
.654 .722 .899 r
.08591 .25519 .09572 .2654 .10894 .26083 .09921 .25031 Metetra
.653 .717 .895 r
.09921 .25031 .10894 .26083 .12224 .25627 .11257 .24542 Metetra
.652 .711 .891 r
.11257 .24542 .12224 .25627 .1356 .25172 .12601 .24051 Metetra
.651 .704 .886 r
.12601 .24051 .1356 .25172 .14903 .2472 .13951 .2356 Metetra
.649 .696 .88 r
.13951 .2356 .14903 .2472 .16254 .24271 .15309 .23068 Metetra
.647 .688 .875 r
.15309 .23068 .16254 .24271 .17611 .23828 .16674 .22577 Metetra
.644 .68 .869 r
.16674 .22577 .17611 .23828 .18975 .23392 .18047 .22089 Metetra
.642 .67 .862 r
.18047 .22089 .18975 .23392 .20346 .22963 .19426 .21604 Metetra
.639 .66 .855 r
.19426 .21604 .20346 .22963 .21725 .22542 .20813 .21121 Metetra
.636 .65 .847 r
.20813 .21121 .21725 .22542 .23111 .2213 .22207 .20642 Metetra
.633 .639 .839 r
.22207 .20642 .23111 .2213 .24504 .21723 .23609 .20163 Metetra
.63 .628 .83 r
.23609 .20163 .24504 .21723 .25906 .21321 .25018 .19685 Metetra
.627 .617 .82 r
.25018 .19685 .25906 .21321 .27317 .2092 .26436 .19205 Metetra
.625 .606 .811 r
.26436 .19205 .27317 .2092 .28736 .20515 .27863 .18722 Metetra
.624 .597 .802 r
.27863 .18722 .28736 .20515 .30166 .201 .29298 .18231 Metetra
.623 .588 .794 r
.29298 .18231 .30166 .201 .31605 .19665 .30743 .1773 Metetra
.623 .582 .787 r
.30743 .1773 .31605 .19665 .33056 .19202 .32197 .17213 Metetra
.625 .578 .781 r
.32197 .17213 .33056 .19202 .34517 .18703 .3366 .16677 Metetra
.627 .576 .777 r
.3366 .16677 .34517 .18703 .35989 .18161 .35133 .16119 Metetra
.63 .577 .775 r
.35133 .16119 .35989 .18161 .37471 .17575 .36615 .15536 Metetra
.634 .58 .776 r
.36615 .15536 .37471 .17575 .38964 .16946 .38107 .14931 Metetra
.638 .585 .778 r
.38107 .14931 .38964 .16946 .40465 .1628 .39607 .14306 Metetra
.642 .591 .782 r
.39607 .14306 .40465 .1628 .41975 .15586 .41115 .13666 Metetra
.646 .6 .788 r
.41115 .13666 .41975 .15586 .43492 .14872 .42632 .13014 Metetra
.649 .609 .796 r
.42632 .13014 .43492 .14872 .45017 .14146 .44157 .12354 Metetra
.652 .619 .804 r
.44157 .12354 .45017 .14146 .46549 .13416 .45689 .1169 Metetra
.655 .63 .812 r
.45689 .1169 .46549 .13416 .48088 .12685 .4723 .11024 Metetra
.658 .641 .821 r
.4723 .11024 .48088 .12685 .49635 .11958 .48778 .10358 Metetra
.66 .651 .83 r
.48778 .10358 .49635 .11958 .51188 .11237 .50335 .09693 Metetra
.662 .661 .839 r
.50335 .09693 .51188 .11237 .52749 .10523 .519 .09029 Metetra
.663 .67 .847 r
.519 .09029 .52749 .10523 .54318 .09816 .53473 .08367 Metetra
.664 .679 .854 r
.53473 .08367 .54318 .09816 .55895 .09116 .55055 .07708 Metetra
.665 .688 .862 r
.55055 .07708 .55895 .09116 .5748 .08423 .56645 .07051 Metetra
.665 .695 .868 r
.56645 .07051 .5748 .08423 .59073 .07733 .58244 .06394 Metetra
.666 .703 .874 r
.58244 .06394 .59073 .07733 .60675 .07047 .59852 .05736 Metetra
.667 .71 .88 r
.59852 .05736 .60675 .07047 .62286 .06363 .61469 .05076 Metetra
.668 .716 .885 r
.61469 .05076 .62286 .06363 .63905 .05678 .63095 .04414 Metetra
.668 .722 .889 r
.63095 .04414 .63905 .05678 .65533 .04993 .64731 .03749 Metetra
.669 .728 .894 r
.64731 .03749 .65533 .04993 .67171 .04309 .66375 .03082 Metetra
.668 .733 .898 r
.66375 .03082 .67171 .04309 .68817 .03624 .68029 .02415 Metetra
.667 .737 .902 r
.68029 .02415 .68817 .03624 .70473 .02941 .69693 .01752 Metetra
.666 .741 .907 r
.03632 .26041 .04644 .26986 .05953 .26493 .0495 .25519 Metetra
.663 .735 .903 r
.0495 .25519 .05953 .26493 .07269 .26005 .06272 .25003 Metetra
.661 .73 .9 r
.06272 .25003 .07269 .26005 .08591 .25519 .07602 .24488 Metetra
.661 .724 .896 r
.07602 .24488 .08591 .25519 .09921 .25031 .08938 .2397 Metetra
.66 .719 .892 r
.08938 .2397 .09921 .25031 .11257 .24542 .10282 .23448 Metetra
.66 .713 .887 r
.10282 .23448 .11257 .24542 .12601 .24051 .11633 .2292 Metetra
.66 .707 .882 r
.11633 .2292 .12601 .24051 .13951 .2356 .12991 .22389 Metetra
.659 .7 .876 r
.12991 .22389 .13951 .2356 .15309 .23068 .14357 .21853 Metetra
.657 .692 .871 r
.14357 .21853 .15309 .23068 .16674 .22577 .1573 .21315 Metetra
.656 .683 .864 r
.1573 .21315 .16674 .22577 .18047 .22089 .17111 .20775 Metetra
.654 .675 .857 r
.17111 .20775 .18047 .22089 .19426 .21604 .18499 .20233 Metetra
.652 .665 .85 r
.18499 .20233 .19426 .21604 .20813 .21121 .19894 .19689 Metetra
.65 .655 .842 r
.19894 .19689 .20813 .21121 .22207 .20642 .21297 .19142 Metetra
.647 .645 .834 r
.21297 .19142 .22207 .20642 .23609 .20163 .22707 .18592 Metetra
.645 .634 .825 r
.22707 .18592 .23609 .20163 .25018 .19685 .24125 .18039 Metetra
.642 .624 .816 r
.24125 .18039 .25018 .19685 .26436 .19205 .25551 .17481 Metetra
.64 .613 .807 r
.25551 .17481 .26436 .19205 .27863 .18722 .26985 .1692 Metetra
.637 .603 .799 r
.26985 .1692 .27863 .18722 .29298 .18231 .28427 .16357 Metetra
.634 .594 .792 r
.28427 .16357 .29298 .18231 .30743 .1773 .29876 .1579 Metetra
.632 .587 .785 r
.29876 .1579 .30743 .1773 .32197 .17213 .31334 .15221 Metetra
.63 .581 .78 r
.31334 .15221 .32197 .17213 .3366 .16677 .328 .14649 Metetra
.629 .578 .777 r
.328 .14649 .3366 .16677 .35133 .16119 .34273 .14074 Metetra
.629 .576 .776 r
.34273 .14074 .35133 .16119 .36615 .15536 .35755 .13495 Metetra
.629 .578 .777 r
.35755 .13495 .36615 .15536 .38107 .14931 .37246 .12912 Metetra
.63 .581 .78 r
.37246 .12912 .38107 .14931 .39607 .14306 .38744 .12327 Metetra
.632 .587 .785 r
.38744 .12327 .39607 .14306 .41115 .13666 .40252 .11738 Metetra
.634 .594 .792 r
.40252 .11738 .41115 .13666 .42632 .13014 .41767 .11147 Metetra
.637 .603 .799 r
.41767 .11147 .42632 .13014 .44157 .12354 .43291 .10552 Metetra
.639 .613 .807 r
.43291 .10552 .44157 .12354 .45689 .1169 .44824 .09954 Metetra
.642 .624 .816 r
.44824 .09954 .45689 .1169 .4723 .11024 .46366 .09352 Metetra
.645 .634 .825 r
.46366 .09352 .4723 .11024 .48778 .10358 .47916 .08745 Metetra
.648 .645 .834 r
.47916 .08745 .48778 .10358 .50335 .09693 .49475 .08135 Metetra
.65 .655 .842 r
.49475 .08135 .50335 .09693 .519 .09029 .51043 .07521 Metetra
.652 .665 .85 r
.51043 .07521 .519 .09029 .53473 .08367 .5262 .06905 Metetra
.654 .674 .857 r
.5262 .06905 .53473 .08367 .55055 .07708 .54207 .06287 Metetra
.655 .683 .864 r
.54207 .06287 .55055 .07708 .56645 .07051 .55802 .05665 Metetra
.656 .691 .871 r
.55802 .05665 .56645 .07051 .58244 .06394 .57407 .05041 Metetra
.658 .699 .877 r
.57407 .05041 .58244 .06394 .59852 .05736 .59021 .04412 Metetra
.66 .707 .882 r
.59021 .04412 .59852 .05736 .61469 .05076 .60644 .03777 Metetra
.661 .713 .887 r
.60644 .03777 .61469 .05076 .63095 .04414 .62277 .03137 Metetra
.662 .72 .891 r
.62277 .03137 .63095 .04414 .64731 .03749 .63919 .02491 Metetra
.663 .725 .895 r
.63919 .02491 .64731 .03749 .66375 .03082 .65571 .01841 Metetra
.663 .73 .9 r
.65571 .01841 .66375 .03082 .68029 .02415 .67233 .01192 Metetra
.661 .734 .904 r
.67233 .01192 .68029 .02415 .69693 .01752 .68905 .00547 Metetra
0 g
.25 Mabswid
.68874 0 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.68874 0 m
.03716 .25514 L
s
.03716 .25514 m
.68874 0 L
s
.03716 .25514 m
.04196 .25962 L
s
[(-4)] .02757 .24618 1 .93395 Mshowa
.18558 .19702 m
.19014 .20174 L
s
[(-2)] .17646 .18758 .96648 1 Mshowa
.34306 .13535 m
.34735 .14032 L
s
[(0)] .3345 .12542 .86223 1 Mshowa
.51046 .06981 m
.51442 .07504 L
s
[(2)] .50253 .05935 .75799 1 Mshowa
.68874 0 m
.69233 .00549 L
s
[(4)] .68156 -0.01098 .65374 1 Mshowa
.125 Mabswid
.07346 .24092 m
.0763 .24365 L
s
.11029 .2265 m
.1131 .22926 L
s
.14766 .21187 m
.15043 .21466 L
s
.22407 .18195 m
.22677 .18482 L
s
.26314 .16665 m
.2658 .16956 L
s
.3028 .15112 m
.30541 .15406 L
s
.38395 .11935 m
.38647 .12237 L
s
.42547 .10309 m
.42794 .10615 L
s
.46763 .08658 m
.47006 .08968 L
s
.55397 .05277 m
.55629 .05595 L
s
.59817 .03546 m
.60044 .03868 L
s
.64309 .01787 m
.6453 .02113 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 233.562},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000j@P10`40000100000000<`00IP00V@00
c000o`0c000c<`0cIP0cV@0cc00co`1V001V<`1VIP1VV@1Vc01Vo`2I002I<`2IIP2IV@2Ic02Io`3<
003<<`3<IP3<V@3<c03<o`3o003o<`3oIP3oV@3oc03ooc<003<0<c<0IS<0VC<0c3<0oc<c03<c<c<c
IS<cVC<cc3<coc=V03=V<c=VIS=VVC=Vc3=Voc>I03>I<c>IIS>IVC>Ic3>Ioc?<03?<<c?<IS?<VC?<
c3?<oc?o03?o<c?oIS?oVC?oc3?oofH006H0<fH0IVH0VFH0c6H0ofHc06Hc<fHcIVHcVFHcc6HcofIV
06IV<fIVIVIVVFIVc6IVofJI06JI<fJIIVJIVFJIc6JIofK<06K<<fK<IVK<VFK<c6K<ofKo06Ko<fKo
IVKoVFKoc6KooiT009T0<iT0IYT0VIT0c9T0oiTc09Tc<iTcIYTcVITcc9TcoiUV09UV<iUVIYUVVIUV
c9UVoiVI09VI<iVIIYVIVIVIc9VIoiW<09W<<iW<IYW<VIW<c9W<oiWo09Wo<iWoIYWoVIWoc9Wool`0
0<`0<l`0I/`0VL`0c<`0ol`c0<`c<l`cI/`cVL`cc<`colaV0<aV<laVI/aVVLaVc<aVolbI0<bI<lbI
I/bIVLbIc<bIolc<0<c<<lc<I/c<VLc<c<c<olco0<co<lcoI/coVLcoc<coool00?l0<ol0I_l0VOl0
c?l0oolc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nIooo<
0?o<<oo<I_o<VOo<c?o<oooo0?oo<oooI_ooVOooc?ooooCM/_[aghUlI<FbZ>KNfVYPFjNGSiVI09VI
<iVIIYVIc9W<09W<<iW<IYW<VIW<c9W<oiWo09Wo<iWoIYWoVIWoc9Wool`00<`0<l`0I/`0VL`0c<`0
ol`c0<`c<l`cI/`cVL`cc<`colaV0<aV<laVI/aVVLaVc?oG8ML00?oG8ML00?oG8ML00?oG8ML00?oG
8ML00<OG00<0emL0E]L00<OG00<0emL0E]L00<CG1@1Ge`00a=L0103Ge`1He`00aML00`3G001He`00
a]L200gG1017e`00amL00`3Ge`0;e`030=OG04SG003Fe`030=OG04OG003?e`@01=L00`3Ge`16e`00
f=L00`3Ge`15e`00bML300WG00@0emL0AmL00<SG1@09e`80B=L00<GG1@000h80001Ce`00`]L30006
e`00[HR]0`1Be`00_mL300;G0P001h80PXV208800P1Ae`00_ML3000;e`000:f8[HP0R:d0101Ae`00
^mL60007RH80PXV2R@040004PZd0053G002he`D000V808R]R:d0[HP00P001Zf8002]R0<0CmL009GG
100Me`8000cG0029PXV208:9PXT20004PZf2[@8000>2[@000P1?e`00UML00`3Ge`0Ke`<000cG0022
08R]R:d0[HP20006[@2]R:f810001:f8001>e`00U]L00`3Ge`0Ge`L000R9PXV208:9PP<000J2[H80
PZd20009PZd0[H:]0=L004gG002Ge`030=OG01CG1P001jf208:]PZd010001hR]0:f8[HP00P002:f8
[HP0R:f80`1=e`00V=L00`3Ge`0@e`D000V208:9PXT0RH800P002Jd0[H:]PP22[@020006PP22[H:]
100018:]001<e`00UML0103Ge`0@e`8000cG002]PZf208:]PZd20009R:f8[@2]R:f8008000J]R:d0
[HP40007[HR]R03G001;e`00U]L200kG0`003=L00880PXV2R@29PP<000R2[H:]PP22[@8000J208:]
PZd20009PZd0[@2]PZf20080BmL00:?G0`003ML0002]PZd0[H:]PZd00P0028:]PP28[HR]0`001Zf8
[@2]R0<000R8[HP0R028[@8000>80000B]L00:7G0P003]L00029PP22RH:908V20P0028T0[H:]0:f2
0P001jf208:]PZd00P0028:]PP22[@2]0`000jf2[@0204[G002Ne`<000cG0000PZf2[@2]PZd40007
PZf208:]PP030007R:f8[@2]R0020008[@2]R:d0[HP20007[HP0R:f8[@0204WG002Le`800]L20008
PXR208:9PXT30008RH:908V2RH830008PZd0[H:]PZd20007PZf208:]PP040006[H:]0:f20P000jd0
0018e`00VML4000;e`0008:]PZd0[H800P002Jd0[H:]PP22[@030008[H:]PZd0[HP20006[@2]R:f8
0`001hR]0028[HP00`000hR]R00204SG002Ge`8000?G00000P03PP0508:8PXP00P002H:9PP22RH:9
PP020008[H:]0:f2[H830006PZf208:]0`001:f2[H82000:[@00PZd0[H:]PP80AmL009CG1P002Zf2
08:]PZd0[H830008PZf2[H80PZd30007[H:]PP22[@020007R:d0[HR]R0020008[HR]0:f8[HP20007
[HR]R028[@020003R00004KG002Ae`<000GG00220004PP0308:200:20P0028:8PP22RH:90`002:f2
[@2]PZf20P001jf2[H80PZd00`001jf2[H80PZd010001H:]PZf2008000>]PZd00P16e`00SmL6000;
PZf208:]PZd0[H800`001h:]PZd0[H800P002Jd0[H:]PP22[@020006PP28[HR]0`002:f8[@2]R:f8
0P001jf808P0R:d00P001XP0R:f8[@80AML008cG1P02PP0308:200:200@0PX:20`0028:8PP22R8:8
0P002H:]PZd0[H:]PP020006[H:]0:f20P002Jd0[H:]PP22[@020006PP22[@2]0`001Zf2[@2]PP80
00>]0000A=L008[G0P003]L0002]PZf208:]PZf20`002H80PZf2[@2]PP020009[@2]PZf208:]0080
00J208:]PZd20009R:f8[@2]R:f8008000J]R:d0[HP20007[HP0R:f8[@020003R:f80080A=L006WG
0P0Le`<000?G00000h800`22PP02PP0308:200<018801@22R8:8008000V2[880PZf2[H800P001Zf2
[@2]PP8000V]0:f2[H80PZd00P001X80PZf2[@8000N208:]0:f2008000J]0:f2[H8204?G001Xe`04
0=OG01SG0`02e`<000V]PZf208:]PZd00`002Zf2[@2]PZd0[H830008PZf2[H80PZd20006PP22[H:]
0P002H:]PP28[HR]R0020006[HR]0:f80P001Zd0[@2]R0<000J8[HP0R:d20003R00004;G001Xe`04
0=OG01KG0P02e`<00h800`22PP02PP060880088018801022PX830008PZb208:/PZ`30006[8:/0:f2
0`0028:]PZf208:]0P001X80PZf2[@8000F2[H80PP030007PZd0[H:]PP020003[H:]00803ML4037G
001Xe`040=OG01?G0`003mL0002V0:J2YX80PZf2[@020009PZf2[@2]PZf200<000V208:]PZd0[H80
0P001jf208:]PZd00P0028:]PP22[H:]0`001Zf8[@2]R08000J]0:f8[HP20007[HR]R028[@020006
R028[HR]0P0>e`030=OG033G001Xe`040=OG017G0P02e`<018800`22PP02PP060880088018800`22
PP030009YX:VPP22[8:/008000N2[8:/0:b200<000N2[H:]0:f2008000N]PP22[H:]008000J2[H80
PZd20006PP22[H:]0`001Zf2[@2]PP8000>]00003ML00`3Ge`0`e`00J=L0103Ge`0>e`<000oG0000
PZJ208:VPP22YX800`002H:]PP22[H:]PP02000:[H:]0:f2[@2]PP8000N]0:f2[H:]008000R2[H80
PZf2[@8000N8[HR]0:f8008000J]0:f8[HP20006[HR]0:f80P001Zd0[HR]R0<000>8[HP00P05e`@0
1=L00`3Ge`0`e`00JML200gG0P001]L0002200B200<0PX800X8300:200<0PX800X800`22PP030009
YX:VPP22YX:V008000N2[8:/0:b200<000N2[8:/0:f2008000J]0:f2[H830006PZf208:]0P001H80
PZf200<000J2[H:]0:d20007PZd0[H:]PP0200cG00<0emL0<=L007GG0`003mL0002VPZJ208:VPZH0
YP02000;PP22YX80PZf2[H800P002Zf2[@2]PZf208820007[@2]PZf2[@020008PZf208:]PZd20006
PZf208R]0P001hR]0:f8[HP00P001Zf8[@2]R08000J]0:f8[HP20007[HR]R028[@020003[00000WG
0`0be`00L]L30004e`0000>200D0PX:20004PP800h800`22PP02PP0308:200<000VVPZJ208:VPZH0
0P001h:/PZ`0[8800`001h:/PZ`0[8800P001Z`0[H:]PP8000N]PZf208:]008000J208:]PZd20006
PP2208:]0P001X80PZf2[@<000F]PZf2000;e`030=OG033G001`e`80017G0000YP2VPZJ208:VPZH0
YP02000;PP22YX:V0:J2YX800P002Zb2[02]PZf208830006PZf2[H:]0P0028:]PP22[H:]0P001X:]
PP22[@8000N808R]R:f8008000J]R:d0[HP20006[@2]0:f80P001Zf8[@2]R08000F]0:f/[@020003
[03G03cG001]e`<000CG000018801@22PX8000B20P03PP0308:200:200<0PX800`002JJ2YX80PZJ2
YP020007PZJ208:/PP030007PZb2[02/PP020006[02/PZb20P001jb2[880PZd00P001X80PZf2[@80
00F2[H80PP030006PP22[H:]0P0018:]PZd30003[H:]0080?=L006_G0P02e`8000j2YX80PZJ208:V
PZH0YP8000^208:VPZH0YX:VPP02000:[8:/0:b2[880PP<000J2[H:]0:d20008PZf208:]PZd20006
PZf208:]0`001Zf8[HR]R08000J]R:d0[HP20006[@2]R:f80P001Zf8[@2]R08000b]0:f/[J`0[:f/
[J`203cG001Xe`<00]L300B200<0PX800X800`22PP0300>200<0PX800X800`22PP0300B200D0PZJ2
YP02000APZJ208:VPZH0[8:/PZ`0[8800`001H:/PZb2008000N/PZ`0[8:/00<000F]PZf2[@020006
PZf208:]0P001X80PZf2[@8000J2[H80PZd20004PP22[@8000>20000>mL006KG0P02e`<000b2YX80
PZJ208:VPZH3000<YX80PZJ2YP2VPZJ20P002ZJ2YP2/PZb208830007PZf2[@2]PP020007[@2]PZf2
[@020007PZf208:]PP020006[H:]PP280P001jf8[@2]R:d00P001HR]R:f8008000J][:d0[HP20006
[@2][:f/0P001:f/[J`20004[Jb][080>]L006?G0`001=L00002PP0508:2PP0018800`22000200B2
00<0PX800X800`22PP0300B200<0PX800X820008PZJ208:VPZH20008PZb208:/PZ`20006PZb2[02/
0P003h:/0:b2[880PZb2[880PP02000<[H80PZf20880PZf20`001X:]PP22[@8000b208:]PP2208:]
PZd203[G001Pe`<00]L2000=PP22YX80PZJ2YP2VPP03000=PZJ208:VPZH0YX:VPP02000:YX:V0:J2
YX80PP<000N2[8:/0:f2008000R]0:f2[H80PP8000n]PP22[H:]0:f2[H80PZd00P001ZH0R:f8[@80
00J/[Jb]0:d20005[:d0[J`010001:f/[J`20005[Jb]0:d00P001Jb]0:f/008000>]0000>ML003kG
100Le`800]L300>200<0PX800X801022PX8300:200D0PX:20004PP0308:200<018800`22PP02PP80
00R2YX80PZJ2YP800162YX80PZb2[880PZb2[02/PP020006[02/PZb20P001Zb2[02/PP8000f/PP22
[H:]0:f2[H:]008000J2[@00PZd2000<PP22[H:]0:f2[H:]0P001XR]R03G03SG000ne`030=OG01[G
0`02e`8000fVPP22YX:V0:J2YP2V00<000jVPZJ208:VPZH0YX:VPP8000ZVPZH0YX:VPP220`001h:/
PZ`0[8800`0028:]PZf208:]0P001X80PZf2[@8000J2[H80PZd20006YP2V[JJ]0P001jb][:d0[J`0
0P003:d0[Jb]0:d0[J`0[08000J][:d0[J`2000<[@2][:d0[@2][:f/0P0he`00?mL00`3Ge`0Ge`80
0mL300>200<0PX800X801022PX8200>200<0PX800X801@22PX8000:20`04PP0308:200:20P0028:V
PP22YX:V0P0028:VPP22YX:V0`001Zb2[02/PP<000F2[8:/PP020006[8:/0:b20P001j`0[8:/PZ`0
0P001H:]PP22008000F]PP22[@020006PP22[H:]0P001H:]PP22008000F]PP28[@020003R00003OG
000he`@01=L00`3Ge`0Ce`<00]L3000<YX:V0:J2YP2VPZJ20`003X80PZJ208:VPZH0YX:V0`002ZJ2
YP2VPZJ208830008PZb2[02/PZ`20007PZb2[02]PP020007[02]PZf2[@020007PZf208:]PP020005
[JJ]YZd00P001jb][:d0[J`00P003:d0[Jb][02/[Jb][0<000F/[@2][002000<[@2][:f/0:b][:f/
0P000jf/[@0303KG0011e`030=OG00oG0`02e`<000>208800h801@22PX8000:20`04PP0508:2PP00
18830003PP2200>200<0PX800X820008PZJ208:VPZH30007YX80PZJ2YP020008PZJ2YP2/PZ`20006
PZb2[02/0P001X:/0:b2[08000J2[8:/PZ`20006PZb208:]0P001h80PZf208800P000jf2[@020006
PZf208:]0P001880PZd20006R028[HR]0P0fe`00?]L0103Ge`0?e`800mL3000<PZJ2YP2VPZJ208:V
0`003ZJ2YP2VPZH0YX:V0:J20`002h:VPZH0YX:VPP2200<001^2YX:V0:b2[880PZb2[02/PZ`0[02/
PZb208800P003ZfV08:]PZd0[JJ]YP2V0P001ZfV0:b][0<000F/[Jb][0020005[Jb]0:d00P001Jb]
002/008000J]0:f/[J`20004[Jb][08000J][:d0[J`20003[@0003GG000oe`803ML300;G0`03PP05
08:2PP000h840003PP2200>200<0PX800X800`22PP0300>200D0PX:20004PP800h801`22YX:V0:H0
0`001JJ2YX:V00<0012VPP22YX:VPP22[8:/0:b20P003J`0[8:/PP22[8:/0:`00P0058:/PP22[880
PP22[H:]0:f2[H:]0P001X:]PP22[@8000b208:]PP2208R]R:d20005R:f8[@00=ML004cG0P000mL0
0002000;PZd0[H:]0:J2YX800`003h80PZJ2YP2VPZH0YX:VPP03000=PP22YX:V0:J2YX80PP030009
PZJ2YP2VPZJ2008001:/PZ`0[8:/PP22[8:/PP22[8820005[JJ]YZd00P001ZJ]YP2V[@8000jV0:J]
YZd0[Jb][:d0[@8000F/[@2][0020005[@2][:d00`001:f/[J`20005[Jb]0:d00P001Jb]0:f/0080
00R]0:f/[@2]03CG0019e`<000?G00000X801@22PX8000B200<0PP000P04PP0508:2PP0018800`22
000200B200D0PX:20004PP800h800`22PP02PP030:H0008000NVPZJ208:V008000R208:VPZH0YP80
00J2[02/PZ`20005PZb2[8800P001Zb2[02/PP8000f/0:b2[8:/0:b2[8:/008000F2[880PP020005
[@00PZd00P003880PZf2[@2]PZf2[@8000F8[HP0R0020004[HP003?G0017e`800]L3000;[H:]0:f2
[H80PZd00`003jN2Y`2VPZH0YX:VPP22YP0300>200/0YX:V0:J2YX80PP030009PZJ2YP2VPZJ20080
00RVPZH0[8:/PP80012/PZ`0[8:/PZ`0[:J/YP2V0P001ZfV0:J]YP8000F]YZfV[@020007[:f/[@2]
[002000B[@2][:d0[@2][:f/0:b][02/0P001Zf/[@2][08000B]0:f/0P002jd0[Jb][02/[Jb]0080
<mL004CG0`001=L00003PP0508:2PP000h8300:200D0PX:20004PP0308:200@000>208800h800`22
PP02PP0308:200<00h800`22PP02PP030880008001:VPZJ208:VPP2208:VPZH0YX83000<PZb2[880
PZb2[02/0P003X:/0:b2[02/0:b2[8:/0P001H:/PP22008000F/PP22[0020004PP22[@8000J208:]
PZd20004PZf2[@8000J2[H80R:d30005[HP00:d00P0be`00@ML3000>e`000:d0[H:]PP22[H84000=
[@2WPZL0Yh:WPP22YP040003PP2200>200T0PX:20:J2YX800`002h80PZJ2YP2VPZJ2008000RVPZH0
YX:VPP<000R2[02/PZb2[08000NV[:H0YZbV008000b]YZfV[@2]YZfV0:H2000D[JH0[:f/[@2]0:f/
[J`0[:f/[J`20005[Jb]0:d00P001Jb]0:f/008000b]0:f/[@2]0:f/[J`20003[Jb]008000B/[Jb]
0P0ae`00?mL200;G0P000hP0PP02PP0308:200:20`000h80PP03PP0508:2PP000X8400:200D0PX:2
0003PP0308:200:200<0PP000P04PP0308:200:200<0PP000P004jJ2YX80PZJ2YP2VPZJ2YP2VPZH0
0P001X:VPZH0[08000J2[02/PZ`2000=PZb2[880PZb2[880PP020005[880PZ`00P004X80PZb20880
PZb2[02]0:f2[@8000F2[H80PP020005[H80PZd00`002Zf8[@2]0:f8[HP2037G000le`<00]L2000:
PZf208:]PP22[@8000f208:]PP22[H80PZN200<000>2P`000h801@22PX8000B200<0PX800`003:J2
YP2VPZH0YX:VPP8000ZVPZH0YX:VPP220P002:H0[8:/PP220P003Zb20:J/YZ`0[:J/YP2V0P001ZbV
0:J]YP8000b]YZfV[JH0[:f/[J`20005[Jb]0:d00P001Jb]0:f/008001:]002/[@2]0:f/[J`0[:f/
[J`20003[Jb]00<000F][02/[@020003[000033G000je`800]L30007RH80PXR20002PP<00h801@22
PX8000>210000h80PP02PP0308:200:200D0PX:20002PP@000N2089lPW`000B200<0PP000P04PP05
08:VPZH00P004X:VPP22YX:VPP22YX:V0:J2YP8000b2[8:/PP22[8:/0:`20006PZ`0[8:/0P001H80
PZb2008000^/PZb2[02/PZb2[0020003PZb200@000F]PP22[@020005PP22[H800P002Zf8[HP0R:f8
[HP20004[HR]R080;mL003OG0`02e`8000V]0:f2[@2]PZd00`002Zf208:]PZd0[H84000;R@23PX>2
08:3PP000h800`22PP040003PP2200>200T0YX:V0:J2YX800P005ZJ2YP2VPZH0YX:V0:H0YX:VPP22
[8820005[8:/PZ`00`001ZbV0:J/YP8000b/YZbV[02]YZfV0:H20005[Jb]0:d00P004jb]0:f/[@2]
0:f/[@2]0:f/[J`00P001:f/[J`20005[Jb]0:d00P001:b]0:d20004[02/[@8000R/0:b][02/02oG
000Ie`030=OG01SG0`02e`<000R2RH80PXV2R@<000>908800h801022PX8300:200D0PX:20003PP05
08:2PP000h8300:200l0O89l07b2O01lPWb208800`04PP0308:200:20`002JJ208:VPZH0YP02000>
PZH0YX:VPP22YX:V0:`20006PZ`0[8:/0P004h:/PZb208:/PZb2[02/PZb208800P001:b208820005
[880PZ`00P004H80PZf20880PZf2[@2]R:f8008000B]R:f80P001Jf8[@2]008000B8[@001mL202GG
000Ie`030=OG01KG0P02e`<000V2[@2]PZf208800P002Zd0[H:]0:f2[H83000APP22RH80PXV208:3
PX<0Ph8010000h80PP02PP0508:2PP0018800`22YP03000PYX:V0:J2YP2VPZJ208:VPZJ208:VPZH0
[8:/PP22[882000<[:J/YZ`0[:J/YP2V0P008:bV0:J]YP2V0:b][:d0[@2][:f/0:b][:f/0:b][:f/
0P001Jf/[@2]008000F/[@2][003000F[:d00:`0[:f/0:`0[:f/[@2][:f/[@801ML0103Ge`0Te`00
5]L501CG1`002X:908V2R@29PXT20008PXV208:9PP02PP<018801@22PX8000>200<0PX8010000h80
PP03PP0;08:2PP22O880PW`010000h80PP03PP0308:200:200d0PP00PP22YX:V0:J200<000F2YX:V
PP030006PZH0YX:V0P0038:/PZb208:/PZ`0[08000F2[880PP020005[880PZ`00P004H80PZb20880
PZb20880PZb2008000F]PZf2[@020003PZf2008000F]R:d0[@020005R:d0[HP00P001:d0[HP400GG
00@0emL09=L0017G10001ML0emL001?G0P02e`8000V208:]PP22[H8010002Jf208:]PP22[@03000;
[H:]0:f2[@29PXT01`001h<0Ph:3PP000h801@22PX8000:21002PP0=0:J2YP2VPZH0YX:VPP020009
YX:V0:J2YX:V008000n2[880PZb2[02/YZbV0:H00P001ZbV0:J/YP8001:/YZbV[02]YZfV[JH0[:f/
[J`20005[Jb]0:d00P001:b]0:d20005[:d0[J`00P001:d0[J`3000@[:f/0:`0[:f/[@2][:f/[@80
00B/[Jb]0P000jb][00200CG00@0emL09=L001OG00<0e`004=L300;G0P001hV2RH80PXT010002X:9
08V2R@29PXT30007Ph80PX>20003PP@000>208800X801@22PX8000>200<0PX800X800`22PP03000;
PW`0O89l07b2O00018803P22002208:VPZH0YX:V0P001h:VPZH0YX800`0038:VPZJ208:/PZ`0[080
01>2[02/PZ`0[02/PZb20880PZb20080016/PZb2[02/PZb2[02/PZb2[0020004PP22[08000>2[H80
0`001HR]0:f8008000B]0:f80P001Jd0[HR]008000N8[HR]0=L000?G00@0emL09=L001SG0P0>e`80
0]L30007R:d0[H:]PP02000:[H80PZf208:]PP@000V]PP22[H80PZd010004h80PXV2R@23PP22Ph80
PX>2P`000X840003PP2200:200<0PX800X801`22YX80PZH00`002ZJ2YP2VPZJ208820007YX80PZb2
[0020007YZbV0:J/YP02000<[:J/YZ`0[:J/YP2V0P001JbV[02]008000B/[@2]0P006:b]0:f/[@2]
0:f/[@2]0:f/[@2]0:d0[@8000Z/[Jb]0:f/[Jb]0P001:b][:d20005[:f/0:`00P001:f/0:`20003
[@0000?G00@0emL09=L001WG00<0emL02ML70008PP22RH80PXT20008PP22RH80PXT4000:PXT0RH:9
08>2P`<000>3PP000h801@22PX8000>200<0PX8020004H80O89lPP22O880PWb2089l00@00X800`22
PP02PP0>0:J2YX80PJJ1YP2VPZH20006PZJ2YP2V0P001X:V0:b2[08001V2[8:/PP22[8:/PZ`0[8:/
PZ`0[:J/YP22008000B/YP220P001:b208820004[880PP8000B/PP220P001:d0[HP2000A[@2]R:d0
[@2]R:f808R]R:d00P0018R]R:d200?G0P0Ue`008]L300;G0`001jf8[HP0R:d00`001jf2[@2]PZd0
0`002Zf208:]PP22[H84000=R@29PXT0RH:908V2R@07000;Ph80PX<0Ph:3PP000h801@22PX8000>2
0`003X80PZJ2YP2VPZJ208:V0`001JJ2YX:V00<000j/PP2V[:J/0:bV[:H0YP8000f/YP2V[:H0YP2V
[:J/008000B/[Jb]0P005jb][:f/0:b][:f/0:b][:f/0:b][:f/008000>][:d00P001:b][:d20005
[:f/0:`00P001Jf/0:b]00<000R][000[@2][08000>]0000:ML0023G0P02e`<000N9PP00RH:900<0
00N9PP22RH:900<000V9PP22RH80PXT010002h:908>2P`23PX<000:210000h80PP02PP0508:2PP00
0h803022PX80PWb2O01lPP@000Il07b2O004PP0308:200:20P004JJ1YP2VPJJ1086VPJH0YX:V0080
00b2YX:VPP22[8:/0:`20005PZb208800P007:bV08:/0:bV0:J/YP2V0:J/YP2V08:/PP2V0884000F
[02/0:`0[HR]0:d0[HR]R028[HR]R08000>]R:d00P0018R]R:d20003R:f80080:ML001kG0P002mL0
002]R028[HR]00<000R]R028[HP0PP8000V]0:f2[@2]PZd00`003Zf208:]PP22RH80PXV20`005h:9
08>2P`23PX<0Ph:308>208:3PX<000:210000h80PP03PP0;08:20:J2YX80PZH00`002:J2YX80PZJ2
0P001Jb2[8:/00<000J/YP2V[:H2000D[:J/YZ`0[:J/YZbV0:J/YZ`0[@03[0080:d00:b]0:d20004
[:d0[@8000>/00000`000jb]00020004[J`0[08000F][02/[@020004[02/[@8000>/0:`00P003:d0
[Jb]0:d0[Jb][080:=L001kG0`0028T0RH:9PP220P002HT0RH:908V2R@020007PXV2R@29PP040009
RH80PXV208:900P000J208:3PP03PP0508:2PP000h800`22PP08000?F01lPWb2089lPP22O88000B2
0P0028:1PP2VPJJ10`007H6V0:J1YX40PZJ2YP2VPP22YP2/PZ`0[02/PZb2008001N/YZbV[02/YZbV
[02/YZbV[02/YZbV[004000CYZ`0[:J/YP2808R/R028[HR]R0020004[HR]R08000Z]R:f808R]R028
0P001Jf808R]00<000?G0=L09]L001kG00T0RJf9[@2]R:d00P001hR]R:d0[HP010001Zf208:]PP<0
00Z2[@2]PZd0[H:]0`004HV208:9PP22RH80PXV208:300/000J3PP22P`04PP0508:2PP000h801`22
PX80PZH00`004ZJ2YX80PZJ2YP2VPZJ208:/PP8000F/YZbV[002000GYZbV0:J/0:bV0:J/YP2V[02/
YZ`0[0000j`02`2/0:f/[@2]0:f/00@000>][:d00P006jb][02/0:`0[02/0:b][02/0:b][02/0:b]
[002000:[Jb][02/[Jb][08000>][:d00P0We`005mL200GG0`000hV200030006RH80PXV20`001h:9
08V2RH800`002H:908V2R@29PP04000AR@29PXT0Ph:308>2P`23PX<00`008H=N05j2089NPP22F880
PUR2089HPP22O880PWb2O01lPP03000;PWb208:1PP2VPJH00P001H6VPJJ100<000f1YP2VPZJ208:V
PZJ2008000b/PZb20880YZbV0:H20004[:H0YP8000B/YP2V0P000jbV00030004[:H0YP8000>/YP00
0P02[0040:`000:/00P0[@00R:d0[@8000B8[@2]0P0018R]0:d20004R028[@<000F]R000[@0202KG
000Fe`040=OG00?G00@0emOG0P001XV]0029[@@000R9[@2]R:d0[@8000V208:]PP22[H800`003H:9
08V2R@29PXT0RH8020005HT0Ph:308>2P`23PX<0Ph:308>20004PP0508:2PP000X84000;PP2VPZJ2
08:VPZH00`004:J208:VPZH0[:J/YP2V[:H2000I[:J/YZ`0[:J/YZbV0:J/YZbV0:J/YZbV0005[003
0:b]008002V/0:b][:f/0:b][:d0[Jb][:d0[@2][:d0[Jb][:d0[Jb][:d0[Jb][0020004[Jb][080
00>][:d00P000jb][00202KG000Fe`040=OG00?G0P03e`0508V2RH800P002XV208:9PP22RH820007
RH:9PP22R@04000=PXT0RH:908V208:9PP03000PPX<0Ph:308=NP`23GX<0PUh0GX9N05R2F01HPUP0
F888000HO01lPWb2089lPP22PH:1086VPJH0YX6V0P001H6VPJJ100<000f1YP2VPZH0[02/PZb20080
00B/YZbV0P001:bV[:H20004[:J/YP@0012/YP2V0:J/YP2V0:J/0:`00Z`20003[02/00<000B]0:f8
0P001:d0[HP30008R:d008P0R:d2000;R028[@2]0:f8[HP00P0Ue`005]L0103Ge`03e`030=OG00;G
00<0RJd00P0028T0RJf908V]10001XV]0:f2[@<000Z]PP22[H80PXV21`004H:908V208:9PP22RH80
PX>2018000>208800X800`22PP02PP0;08:2PP22YX:V0:H00`001JJ2YX:V00<000jVPP2V[:J/0:bV
[:H0YP8001>/YP2V[:H0YZ`0[:H0YZ`0[:H000:/00<0[0000P000j`0[@020004[:d0[@8000R/[@2]
0:f/[@8000B/[Jb]0`000jf/[@020004[:f/[@8000>/[J`00P001:f/[J`2000;[Jb]0:d0[J`0[:d0
0P000j`0000Te`005]L0103Ge`03e`030=OG00?G0P001hV2R@29PXT00`001XV20029PP@000V9PP22
RH80PXT0100048:908V208:3PP22Ph80PX<8000TGP1NPUh0GX80PUR2089HPP22F880PUR2089lPP22
O89l07b20`004H:1PP2VPJJ1086VPJH0YX6V008001b1YX6VP@22[8:/PP220:J/YP2V0:J/YP2V0:J/
10004JJ/YZ`0[:J/YZ`0[:J/YZ`000>/00<0[0000j`0302/002/[@2]0:f8[@8001F8[HP0R028[HP0
R028[HR]0:f8[HP00P001Jf8[HP002CG000Fe`040=OG00?G00<0emL01=L20003[HT000<000J]R@29
[HT3000:RJd0[H>]0:f2[@<000f9PP22RH80PXV208:900L001V9PP22P`23PX>208:308>2P`23PX<0
Ph8000>200D0PX:20003PP0308:200:20`002ZH0YX:VPP22YX82000RYX:VPP2V[02/YP2V[:H0YP2V
[:J/YP2V[:J/YP2V[:J/YP@00Z`00`2/[002[00<0:`0[Jb]0:d0[Jb]0P001j`00:f/0:`00P001:f/
0:`20004[J`0[08000>][0000P001:b]0:d20005[:d0[J`00`002:b]002/0:b]100Se`005mL200CG
0P07e`8000J2R@00PXT40009PXT0RH:908V200@000V9PP22RH80PXT01`00;X>205j3GP1NP`23GX<0
Pej3089NPP22GP1HPUP0F89H05R2089HPUP0O89l07`30009Nh9kPP22PH:100<000N1YP2VPJJ10080
00jVPJH0YX40PJH0[8:/PP8000B/YZbV0P000jbV[004000=YZbV0:H0YZ`0[:H0YP020004[:H0YP80
00>/YP001J`00`2/[003[00G0:`0[:f/08R]R:d0[HR]R:d0[HR]R:d00P000hR]R0020004[HR]R080
00>]R:d00P0Re`007=L00`3Ge`08e`050:f9[HT00P002Zf908V]R@29[HT3000:PhT0RH>908V2R@<0
01R9PP22RH80PXV208:908V2R@23PP22Ph870009PP22Ph80PX<000>200<0PX801`03PP0I08:VPP22
YX:V0:J2YX80PZJ2YP2/YZbV[002000@YZbV[02/YP2V[02/YP2V[0@000BV[02/0P02[0030:`000B/
01X0[:f/[J`0[:f/0:`0[:f/0:`0[:f/0:`0[0<000>/0:`00P001:d0[J`20004[@2][0<000R/[@00
[02/[@<000B][:f/0P0Re`007=L00`3Ge`09e`0<08T00880PXV208:910002H:908V2R@29PP04000=
RH80PXV208:908>2P`0>0007GP1NPUh0F00?000AF01lPW`0O89lPP22Nh9k08400`00286VPJH0YX6V
0P004h6VPJJ1086VPJJ10880YJbU0:H01@007:H0YZbV[02/YZbV[02/YZbV0:H0YZbV0:H0YP02[004
0:`000:/00@0[0000j`20009[Jb][02/[Jb]008000B8[HR]0P000hR]R0020004[HR]R08000F]R:d0
[@020003R000027G000Le`802mL0202]RJd0[HV]0`002Zf908>]P`23RH<3000:PhT0RH>908V2R@L0
01n908V2R@29PXT0Ph80GX=N05j3GP1N05j3GP1NPeh000>200D0PX:20003PP0908:2PP22YX:V0080
00R2YX80PZJ2YP<00ZH04@2V[:H0YP2V[:J/YP2V[:J/00<000V/YZbV0:J/YZ`00P04[0030:`000:/
00D0[:`0[@02000E[:d0[@2][:d0[Jb][:d0[Jb][02/008000f][000[Jb]0:d0[Jb]008000n/[J`0
[02/[J`0[02/[J`00P001:f/[J`2023G000Le`030=OG00_G00<0RH8010002HV208:9PP22R@040009
PXT0RH:908V200@003R9PP22P`23GX<0Pej308=N05j3GP1NP`22GX80PUP0F89H05R2F01HPP22F880
PWb2089lPW`0N`<001V1YX6V0:J1YX40PJJ1YP2VP@21YP2VPJJ1008000>/00000`008:bV[:H0YP2V
[02/YP2V[02/YP2V0:J/YZ`0[:J/YZ`00j`00`2/0003[0040:`0[0800Z`01P2]002/[@<000B][028
0P000jf800020004R:d0[@8000B8[@2]0P0018P0R:d4023G000Le`030=OG00cG0P001XV]0029[@L0
00Z9P`00RH<0PhV30`004H>908V3R@29PP22RH80PXV200d000eNP`2308=NP`23GX<000>200@0PX80
18800`22PP03000;PZJ208:VPP22YX800P05YP8000NV[:J/0:bV00@000j/YP2V[02/YP2V[02/00>/
00<0[0001:`00`2/[002[0060:`0[Jb]0P001j`00:f/0:`00P00:Zf/[@2][:f/[@2]0:f/0:b][:f/
0:b][:d0[Jb][:d0[Jb][:d0[Jb][08000>][:d00P0Oe`007=L00`3Ge`0=e`8000>2R@000P002XV2
08:9PP22RH870009PXT0RH:908V200/000eN05j308=NP`23GP1H00/000aHPP22F01HPUP0O884000;
N`1kPW^20:J1YX400`003H6V0:J1YX40PJJ1YX4010009:JU0:D0YJbU0:H0YZbV[02/YZbV[02/YZbV
0:H0YZ`0[:H0YP800Z`00`2/[003[0030:b/00:/00<0[0000j`20008[0000:`0[:d20003[0280080
00B]0:f80P001:d0[HP30007R:d008P0R0020003[@0001kG000Ke`<04=L200:900D0RHV90002R@@0
00F3R@29P`020006RH<0PhV30`008h>908V308:9PP22RH80GX<0Pej308=N05j308=NP`23GP1H00`0
00>208800h803`22YX80PZJ2YP2VPZJ20003YP050:H0YZ`010004:J/YZbV0:J/YZbV0:J/YZ`200B/
00<0[0000Z`01P2/[02/00B/00h0[:f/0:`0[:f/0:`0[08000B][02/0P000jf/00020003[:f/0080
00V][:f/0:b][:d00P001:b][:d20003[:f/008000R][:f/0:b][0807]L001_G00<0emL04ML01`22
RH80PXT00`002XV208:9PP22RH87000oPXT0REh0GX=N05j308=NP`23GP1NPeh0GX<0PeR305iH05QN
F01HPP22F880PUR2089HPP22Nh80PW^2N`2100<000F1YX6VP@030003PJH0008000RVP@00YZFVY@80
00B/YJbU0P007JbV[02/YP2V[02/YP2V0:J/YZ`0[:J/YP2/0:`000:/00@0[0000j`00`2/[003[00?
0:b/[02/0:`0[02/0:b]00<000R]R000[@2]R0<000R8[@00R028[@<000B]R:f80P0Me`006mL00`3G
e`0Ae`0408V9R@<00XT01`29RHT0PhT0100038>908V308>9P`23RAP001AN05j3GP1NP`23F8<0PUR2
089l00>200T0PX:208:VPZH00P002H:VPP22YX:V0002YP@001Z/YP2V[02/YP2V[02/YP2V[02/YP2V
[02/00B/00<0[:`00Z`00`3@0002[00M0:c@0:d0[Jb]0:f/[J`0[02/[J`0[02/0:b]0:d00P000jb]
[0020003[Jb]008000B/[Jb]0P000jb][0020004[Jb][08000F][:d0[@020003[00000KG100Be`00
6mL00`3Ge`0Be`<000F9PP22R@070009RH80PXV208:900L001N9GP1NPeh0GX<0Pej308=N05j3GP1H
G`09000FGP22F01HPUP0F89H05R2089kPW/0N`<000R1YX6V0:J1YP@002b1YX40P@21YX40Y@2UYZD0
Y@2U[:D0YP2V[:J/0:bV[:H0YP2V[02/YP2V00B/00L0[:b/0:`000:/00D0[:`0[00200>/00X0[:f/
[@2]0:f/0P002Jf/[@2]0:f8[@020009R:f808P0R:f8008000B]R:f80P001Jf8[HP000SG00<0emL0
4ML001_G0`0Ce`800XT300:900/0PhV308>9P`23R@03000WRH<0PhV308>9P`23R@29PhT0REh0GX=N
05j308=N05j308=NP`2300<000Z3F01HPUP0O8800h800`22PP030009PZJ208:VPP2200<000>20:H0
1:H06P2V[:J/YP2V[:J/YP2V[:J/YP2V[:J/0=000Z`08P2/d02/0=2/d:`0[=2/d03@0:d0dJ`0[02/
[Jb]0:f/[J`20007[J`00:d0[@020003[:d0008000B][02/0P000jf/00020004[:d0[@8000B/[@2]
0P001:`0[:d400OG00<0emL04ML000SG0P04e`030=OG00;G0`05e`030=OG01GG0P002HV208:9PP22
R@07000=RH80PXV205j908UNR@0D000;F01HG`1NF5h0GUP04@002G/0Nh9kPP2VP@040008YX6V0:J1
YX420004YX6VP@8000BVYJJU0P001:bU[:D2000E[:J/0:bU0:H0YZbV[02/YZbV0:H000:/00H0[:`0
[003[0030:b/00:/00@0[02/0P02[08001n/[Jb]0:d0[J`0R:f8[HP0R:f8[@2]R:f8[@2]R:f80080
00B]R:f80P000jf8[@0200KG00<0emL04ML000OG00@0emL02mL01@3GemL001WG00D0RHV90002R@<0
00V9P`23RH<0PhT02`0058V308>908UOR@29G`1NPeh0GP1N1@005Ej3GP1HP`23F01HPUP0F89H07b2
0004PP0408:VPP<000V2YP2VPZJ2YP000ZH0>02V[02/YP2V[02/YP2V[02/YP2V[02/YP2/d:`0[=2/
d03@0=2/0:c@0=00d:c@[02/dJ`0[02/0P003jf/[@2][:d0[@2][:d0[@040004[02/[@8000>/0:`0
0P001:d0[J`30008[:d00:`0[:d30006[J`00:d01]L00`3Ge`0Ae`001mL0103Ge`0;e`050=OGe`00
6]L60009RH80PXV208:900<000V9PP1NREh0GXT00P0065j908=NP`23GP1NP`1OGUl0Geh0F5l0G`<0
01MNF01HGP1NF01HGUP0F89H05R2089kPP040003N`21008002BV0:J1YX40P@21YX40PJH0YZD0YJH0
[:D0YJ`0[:D0YP2U[:D2000>[:J/0:bV0:H0YZbV[004[08000>/00000j`00`2/[002[0050:`0[000
0Z`01`2/002][:d00P000jb][0020009[HR]R028[HR]008000>8[HP00P001:f8[HP20003[HR]0080
00>8[HP00P03e`<04mL000OG00@0emL02=L300CG0P0Je`0508V9R@000XT7000=RH<0PhV308>908V3
R@0E0006GeiO05mN1@004EP0F8<0PUR2089HPP22O02200<000B2YX:V0P003h:VPP22YX:VPP2V[:J/
YP020004[:J/YP8000B/YZbV0P006jbV[:H0[=2/0:c@0=2/0:c@[02/d:c@0=00d002000;[=40dJcA
[02/0:`00P003Jf/[@2][:f/0:b][:d00P002:`0002/0:b]0`001jf/002]0:d00P001:`0[:d3000:
[J`00:d0[Jb][0801=L00`3Ge`0Ae`001mL0103Ge`08e`030=OG00CG00<0emL06]L00`22R@03000=
RH80PXV208:908V2R@07000DREh0GX<0Pej308=N05iO05mN05P30009F01HG`1NF01H00@000YN05iH
GP22F01H0`001G^2N`1k00<000V1YX6VP@21YX400P00:ZJ1YX6V0:JUYZFV0:bU[:F/0:bU[:D0Y@2U
[02/Y@2V0:J/YP2V0:J/00>/00L0[:b/0:`000:/00D0[:b/0004[0800j`0102/0:`20008[J`00:f/
[J`20003[HR]008000V8[HR]0:f8[HP00P000jf8[@020006R:f808R]100He`001mL0103Ge`08e`03
0=OG00CG00<0emL06mL200:900L0RHV908>900L000F9P`23R@02000FPhT0RH<0GhUO05n908=OP`23
GP1NG`D000UO05mH05QO05l02P000gb20002PP<000Z2YX80PZJ2YP2V0P02YP040:bV[08000BV[:J/
0P001:J/YZ`2000_YZbV0:K@0=00d:c@[02/d:`0[=00d03@[=00d03A0=6/0:`0[=6/0:`0[:d0[J`0
0`002Jb][02/[J`0[0020006[J`00:f/0P001:d0[J`30007[:d00:`0[0020005[@2][:d00`000jf/
[@0201OG0008e`802ML400?G0P0Me`0308:900L000F9PP22R@020006GXT0REj95@001UmHG`1OF0H0
00INF5h0F002F0/003Uk07^2Nh80YX6VPJH0YX6VP@21YP2VP@2UYP2VY@2U[02/Y@2U[02/YJ`0[:F/
Y@2U0:J/0:bV[0000j`01P2/[02/00>/00D0[:b/0002[0030:`000>/00h0[Jb][02/0:`0[:d0[@80
00R/[@00R:f8[@8000>8[HP00P002Jf8[HP0R:f8[@030004[@2]R08000>]00005]L001WG0P0Oe`80
0XT02`23RH<0PhT0RH>900L000R9P`23R@29G`8000V9G`1OR@23Gh<02@0015mH05P30003F01H00<0
00YHPP22F01lPW`00h802@22YX:V0:J2YP0200FV0P005JbV[02/YP2V[02/YP2V[02/0=2Vd002000Z
[=2/0:c@0=00d:c@0=00d:`0[=2/0:cA[02/0:`0[=6/d@2][:d0/`2]0P004Jb][02/[Jb]0:d0[@2]
0:f/00<000R/[@00[02/[@<000>][0000P001:b][:d20005[:f/[@005]L001WG00<0emL07mL01`22
RH80PXT01`001HUN05j9008000UNR@29GP1NPeh010003UmNG`1OGP1NG`1OF00d0P001Uld03@0=0<0
00=H05P00UP04P1HPUP0F89H07^2089kPW/0P@8000fVP@21YX6V0:J1YX6V008000BUYZFV0P005jF/
YJ`0[:F/Y@2U0:F/0:bU[02/YZ`000:/00<0[0000j`01@2/0:`000>/00<0[:`00Z`01@2/0:`000>/
00D0[Jb][0020005[J`00:d00`000jf/[@020003R:f8008000B]R:f80P000jf8[@020005R:f808P0
0P001:d0[HP401GG000Ie`030=OG023G1P001HV308>9008000>3R@003@000en9000;0005GUmN05P0
10001El005QO00@000]HPP22F880PWb20003PP0;0:J2YX80PZJ2YP000jH2000@YZbV[:H0YZbV[:H0
YZbV[08002FVd:H0[=00d03@[=00d03@[02/d:`0[=2/0:c@[02/dJ`0[02/008000_A[=40/jbc0;<0
[@020008[;<00:bc[;<20006[:d0[@2]0P001:`0[:d30008[J`00:d0[J`30004[:f/[@8000>8[HP0
0P0De`006ML202;G0P001HV208:900L000b9GP1NREh0GXT0REh2000<Peh0GX<0GeiO05mN100015l0
Gc@60005F3AH05P00P02F00>089H05R2F01kPW/0Nh83000>YX6VP@21YP2VP@21YX420004YZFVY@80
01N/YJ`0[:D0Y@2U[:F/0:bU[02/Y@2V0003[0050:`0[0000j`200:/00D0[:b/0004[08000>/0000
0j`02@2][:d0[@2][003000;[000[Jb]0:f8[HP00P000jf8[@020004R:f8[@8000F8[@2]R0030003
R:f800<05=L001WG00<0emL08mL5000@RH<0PhV308>908V3R@29P`d000EO05mO0002G`H000=O=5l0
0`001EmH05QO00D000N2F01lPW`000:20`002:J2YP2VPZH00ZH0<`2UYP2/YP2U[02/YP2U[02/YP2V
d03@0=2/d03@0=2/0:c@[02/d:`0[=2/0:c@[02/d0020007[=6/0:`0[0020007ej`0[;>//`020006
[000/jbc0P002:bc[02/0:b]0P001jb]002/0:`00P001:d0[J`30004[:f/[@8000>8[HP00`0018R]
000Ce`006ML00`3Ge`0Te`0308UN008000F9GP1NR@0:000<GXT0REj908=N05iO2`000el000020004
=00d=08000@d03@00UP00`1H0008000;PP22Nh9k086VPJH00P00:86VP@21YP2VY@2UYP2VY@2U0:F/
YJ`0[:F/0:bU0:D0YJbU0:D0[003[0030:`000:/00@0[:`00j`01@2/[:`000>/00@0[02/0P002jf/
0:b][:d0[@2]008000>/00000P003Jf8002]R:f808R]R:d00P001HR]R02800<000V8[@00R028[HP0
0P0Ce`006ML00`3Ge`0Te`0408>9P`H000F9P`23R@02000CPhT0RH<0GhUO05n908UOR@23G`090003
=5l000<000<d03@00P0085mH05QN089H05R2F01lPWb20:J2YP2VPZJ20:FVYJJU0P001:bU[:D2000n
[:F/Y@2Vd:K@0=00d:`0[=2/0:c@[02/d:`0[=2/0:c@0=00d:`0[02/0:cG[02/0:`0[=N/0:bc[02/
0:`20008/jbc0;>//j`20007[@00[02/[@030003[J`0008000>/[J`00`000jb][0020004[HR]R0<0
00>800004]L001SG0`0Ve`<000aNR@29GP1NR@29GXTG0004G`1O=0@000=O03D010000c@00002009H
01@0F5QH05N2E`1kPW/0Nh9k086VP@80012VPJJ1YP2VYJJUYP2VYJJU0P005jbU[:D0Y@2U0:F/Y@2U
0:F/0:bU0:/000:/00D0d:c@0002[0050:b/[0000j`01@2/[:`000>/00d0[02/0:b][02/[Jb]0080
00F/[@00[0020004[HR]R08000>]R:d00P000hR]R0030004R:d0[@8000B808R]0`001:f8[HP2017G
000He`030=OG02OG0P000hV300090008RH<0PhT0REl20005REl0GhT00`0018T0Gel60003Gc@000<0
00=O03D00P000c@0=003000AF01HPP22F880PWb20:J2YX800`001X6V0:JUYP8000BU[:F/0P00<JF/
YJ`0d03@YP2Vd:H0[=2/d03@0=00d:c@0=00d03@[=00d03@0=2/0:`0[02/ej`00P003]L00:cG[02/
/j`0[02/0P001k>/002c[;<00P000jbc00020007[J`00:d0[@020005[@2/[J`00P001:f8[HP20005
[HR]0:d0100Ae`006=L00`3Ge`0Ye`8000QNR@29GP1NR@8000ENR@29GP0=0008GP1NG`1O>Ul50003
=C@000800S@30004F3@0=0800UP0:P1GPUL0Nh9k07^2Nh80YW^VN`21YP2VP@2UYZD0Y@2UYP2/Y@2U
0:F/Y@8001R/YJ`0[:F/0:bU[03@Zm00d:c@0=2/d002[0050:c@[0000j`0102/[004[08000V]002/
[J`0[:d00P000j`0[0020007[J`00:f8[@020009R:f8[@2]R:f800<000B808R]0`000jf8[@030003
[HR]00804=L001SG00<0emL0:]L01P29P`23R@X000B3R@290`001HUO05n900P000AO03]O0`003Uld
03@0=3D0=@1I=00d0`002eP0F89H07b2O02200<001N1YX6V0:JU0:FV0:bU0:F/0:`0d:G@Y@02000K
d:K@0=00d03@[=00d03@0=2/d03@0=00d:c@0080012/0:cG[02/0:`0[=L0e`3G0P001ZcG0;>//`80
00n/002c[;>/0:bc[02/0:`00P001;<0[Jd300:]0`03[@<000>]RJd00`001:f908P20003[@0000oG
000He`<0:mL5000;REh008UN05j908T00`003hUN05j305mNG`1OGP1NG`060003=3/0008000<d0000
0P002Bh005P0F3@0F00;0008Nh9k07^VNjH2000:PJJ10:D0YJJUYP8002bU[:F/0:bU[02/Y@2U0:F/
Y@2U0:D0Zm2[0:_@0=2/d03@[02/d:`0[=2/00:/00X0[:b/0:f/[@2]0`001jf/0:`0[:d00`002jd0
08R]R028[HR]008000>8[HP00P000jf8[@030004[HP0R08000F]0:f8[@020005PZf2[@003mL0013G
1004e`030=OG02cG00<0RH<00P000hV3000I0004G`1OG`@000MO0000=@0e008000<d00000P0075P0
GUP0F89H07b2O022YX:V0:J1YX40YJJUYZD20009[:F/Y@2Ud:G@008003^Vd:H0YM2U0:c@[02/d:`0
[=2/0:c@0=00d:`0[02/0:`0[=N/0:`0[02/e`3G0=L0ej`0[02/0:bc[0020007/jbc0;>//`030003
/jd000800Zd20003[@2]008000F]0:f9[@020004RJf9[@<000B]0:f8100>e`004]L00`3Ge`02e`03
0=OG02kG1P000ej90003000<GXT005j908UN05j30P001EiO05mN00L000<d00000P001CD000Xd00<0
00Dd;P0d0003F00@05MlE`1kPW/0Nh9k07^VN`8000ZVPJJ1YP2VYJJU0P003JbU[:D0Y@2U0:F/YJ`0
0P008JD0YM2U0:/0Z`2[d:/0Z`2/0:c@0=2/0:c@[02/d:`0[00200>/00l0[@00[:f/0:b][02/0:`0
0P001jd0002]R:d00P000hR]R0020009[HR]R028[HR]00<000B]0:f80`000hR]R0030003PZf20080
3ML001;G00<0emL00]L00`3Ge`0_e`8000>3R@000`000h>9000D00=O00<0Gc/00P000c/d>`020004
400@=@<000<d00000P0065QN089HPP22O880YX:V0:J1086V0:JUYP80046U[:F/0:`0d:D0YM00d03@
YM00d03@0=2/d03@0=00d:`0[=2/0:cF0=J/0:`0[02/ej`0[02/ejcG0=L0ejcG[0020009/`00[;>/
0:bc008000>]0:d00P000k<0/`020004[@2][@<000>]R@000P000hV]R@030003RJf900<000B908V]
0P000hT0e`06e`@00]L001;G00<0emL00]L203;G20004hUN05j9GP1NR@29GP1NGeh0GUl02@0023/0
03@0400@0`001`X0;S@0=0000UP03@1GO5L0Nh9k07^2Nh800P00@G^VN`21YP2VP@2UYP2VY@2U0:F/
YJ`0[:F/Y@2Ud03@YM00d:_@0=2[0:_@Z`2/0:`0[=00d:`0[=2/0:`0[02/008000F]0;<0[@020006
[:d0[Jb]0P002j`00:f/[J`0R:f8008000>]R:d00`000jf800020003R:f800<000B8[@2]0P0018P0
R:d30003[H:]00801]L00`3Ge`03e`004]L00`3Ge`02e`030=OG02kG0`003]L0PhT0RH<0PhV308>9
4P02G`P000<@00000`001@X0=00d00<001mH05R2089lPP2VPZJ2086VPJH0YZD0YJH0[:D0YJbU0080
00C@YM2U0P001]2U0:_@Z`8002[@0=2/d03@0=00d:`0[=J/0:cF0=J/0:`0[02/0:cG[02/e`3G[=L0
ej`2000;/`000;>/0:d0[K<00`000k>]00050003/jd0008000B9[@2]0P001HT0RJf9008000>]RJd0
0`001Zf908V]R@<01]L00`3Ge`02e`004=L300CG00<0emL0:mL300GG300028UN05j908UN0P001EmN
05iO00H000<dG`000`00110001080003;P0d00<000QGO022Nh80PP<000FVNjIkYP020012PJJ10:D0
YJJUYP2/YJbU0:D0YJ`0d:D0Y@2U0:_@Z`2[d03@Zm00d:`0[02/0:`0[=2/0:c@0=J/0:`0[02//`2c
0P002jbc[02/0:`0[:f/008000>]R:d00P000hP000020008[@00R028[HP20003[HR]00@000>8[@00
0P001Jd0[HR]00@000>200001mL00`3Ge`01e`004]L00`3Ge`02e`030=OG02SG0`09e`0608>908V3
0P001HV305n900h000=OIEl01@000cDk=@020004=@0A40@000@d05P00UP00`1H0007000>YX6V0:J1
YX40YJJUYZD2000<[:F/0=00d:G@0=2U0P008=2[d03@Z`2/d:`0[=00d03@0=J/0:cF[02/0:cF[02/
0P002=N/0:cG[02/0P001MN/002c008000J//j`0[K<30005/jd00;<00P000jfc[@020004/jfc[@<0
00>9[@000P001:d0[HT30003RJf900@000F]0:f9[@0300OG0@01e`7G000Fe`<09]L300gG300038UN
05j908UNR@1OGP`000Dk03D0400400032@X0008001@d05Pd05MH089GPP22Nh9k07^VN`8001^VPJJ1
YP2VYJJU0:D0YJ`0[:F/Y@2Ud03@YM000P006:/0Zm2[0:_@0=2/d03@[02/0:c@[02/eP8000Z/0:bb
[02/0:bc0P001Zbc0;>//`8000J/002][:d20003R:d0008000>]R0000P000hR]00020008[HP00:d0
[HP30003R:f800<000F808:]PP040003[@0000CG00@0emL00]L001KG00<0emL08mL3017G00<0PhT0
0P005H>908V305n908UOR@29G`1OR@1UG`020003IEl000X000D:00002P05009H01H0PUR2089lPP2V
PJH0YX40PJH0YZFV0P00=:F/Y@2Ud:D0Y@2Ud:D0Y@2[0:_@0=00d03@[02/d03F0=H0eZ`0[02/0:`0
[=L0ej`0[=L20003[02/008000GG[=L0e`030006/jd0[@2]0P001k<0002c[K<00P000jfc00020003
/hT0008000B9[HV]0P0018V]0:d20004R@29[@@000F9[@2]R@0200GG0P03e`005]L00`3Ge`0Pe`<0
5=L01029GXTQ0003>`00008000D:40002@02000S=0T0=01GF5L0Eh9G07^2N`1kYP2VN`21YX40Y@2U
YP2VYJH00P001ZF/YJ`0d080026Ud:D0YM00d:/0Zm2[0:_@0=2/d03@0=J/0:cF0=J/0:`00P005k>/
0:bc0;<0/`2c[02/0:`0[;>/08R]00<000F]R000[@030003[@00008000F8[@2]R0030003R:f80080
00>]R:d00`001Zf808:]PP<000?G0=L02ML001KG00<0emL07ML301SG0`0078V308>908V305n908UO
R@29G`1OR@1UGfD0IEl80003=@0000L000<d00000P002eR2089lPP2VPJJ10080022VPJH0YZD0YJH0
[03@YM2Ud03@YM00d:G@0=2[0:_@Z`8001;@0=2/0=3F0=H0eP3F0=J/0:`20007ej`0[=L0e`020008
[=L0ejcG0=L20006[K>]0:fc0P001Jd00;>]00<000>]/`000P000k>900020003RK>900<000>9[@00
0`000hV]00020005[@2]RJd01005e`030=OG00OG000Fe`806mL301cG0P000ej9000J0003GcX000<0
00<k00001@00E0X000Td03@0F5L0Eh9G07^2Nh80YW^VN`210:FVY@2U0:FVYJJU0:F/Y@2Ud:D0YM00
d:D0Zm00d:_@0=2[0:_@0=2/0:cF0=H0eP3F0=H0eZ`0[08000Vc[;<0/`2c[;<00P001:`00;<20006
R00008R]0`000jf800020003R00000<000>800000P001:d0[HP30003R:f800@02ML00`3Ge`07e`00
5]L00`3Ge`0Ge`<08ML2000;RH<0PhT0RH<0GhT00P0035n908UO05n906EOI@L000Pk000@00X02PD0
00<:02h00`001eP0O89l08400`001H6VPJJ1008001bVYJJU0:G@YM2U0:D0Y@2Ud:D0Z`2[0:_@0=3?
0P002M00e]00d=H0eP02000@[=H0eP3F[=H0ej`0[02be`8000J/003G0=L30004/`00[@8000>c[@00
0P001Jfc002]00<000>9/`000`002HT00029[@2]R@030003RJd000<03ML00`3Ge`07e`005ML00`3G
e`0Ee`<09ML00`1NR@0K0003GcX0010000<]05L01`007W^2N`1kYW^V0:JUYZFV0:JUYZFV0:H0[03@
YM00d08001bUd03@Z`2[0:/0Z`2[d:/0Z`2/0:`0[02/eP3F0P003j`0[=L0/j`0[;<0/j`0[0020005
/j`00;<00P000hRc00020007[@00R@28[@030003[HP0008000>8[HP00`000hR]0002017G00<0emL0
1mL001GG00<0emL04]L302WG0P0028V308>908V30P002hUO05n908UO05n9008000=OI@003P0020X0
00T:05P00UP03@1lPW`0NjIkYP2VPJH00P001:FVYJH2000gYM2Ud03@YM00d:G@0=2[d03@Z`3?d03@
c`3@eP3Fd03@eP3Fd02/0:cF0=N/0;80/]L0ek80/P020003e`0000:c00D0/`00[@020006/`000;>]
0P000k>9/`030003/hT000<000>c00000P000hV]000201CG00<0emL01mL001GG0P0@e`<0;ML00`1N
R@0K0003GcYO00@000<@00X00P0010<000T2000X=01H07aGO022Nh9k07^V0:Ik0:FVY@2U0:FVY@2U
YZD0YM2U0:G@Y@8000O@0=00d:_@00<001C@Z`2[d03F[02/0:cF0=J/0:`0[08000Zc[02//`2c0;>/
10001K<008Rc00<000FcR000/`030003[@00008000>900000P0018T0[HP201OG00<0emL01mL001GG
00<0emL03ML2037G0P006HV308>908V3R@29G`1OR@29G`1OREl0GfD04P0010T00002F00U089lPP2V
NjH0YX40YJH0YZD0YJH0d:D0YM2Ud03@Y@2[d:/0Z`020008d<l0cm00e/l2000:eP3F0=K@0=00eP80
00WG[02b0;;G0=L00P000k8000020003e`0000800[<20005/`00/jd00`0018T00;<30003/hT00080
00B9/`2c100Ie`030=OG00OG000Ee`030=OG00[G0`0de`0305j901/000=O>Ul03@003Bh005L0EgaG
07^2Nh800P001g^VN`2UYP000jD0:02V0:JUYP2[0=00d:G@0=2U0:_@0=2[0:/0Zm00d:/0[=H0eP3F
0=H20003[=H0008000CG[02/0`001jbc002/0:`00P001;<008T30006RK<008Vc0`000jf9000200>9
100Ke`030=OG00OG000Ee`030=OG00OG0`0he`8000F9P`23R@02000;PhT0REl0GhT0REl00P001HUO
05mU018001T:=01H089lPP2VNjIk0:FVYJH0YP2VYJJU008000K@YM2U0:D20007d:_@0=2[d0030008
d<l0cmH0e/l30005d=H0eP000]H0103F0=H30009/]L00;80/P2b008000>c00000P000k<00002/`80
00Fc0000/`030003/hT0008000>9/`000`03e`030=OG01[G00<0emL01]L001CG00<0e`001ML303cG
00<0GXT07@000c/0000:000;2@0005MlE`1kPW/00P001JIkYW^V00801JD07P2UYZD0YJ^U0:G@Y@2U
d03@Z`2[d03@0=2[0:/0Z`8000WF[02/0:`0[=H00P001K800;>/00<000>b0;8010001K>8002c0080
00B9002c0`000k>900020003RHl000802=L00`3Ge`0Ie`030=OG00KG00000mL0000200?G00<0emL0
0]L300CG0P03e`<0@=L2000LRH<0PhV308>908UO05n908UOR@29G`1OI@1UG``000@:03@:0`000gb2
O003000=N`2UYZFVY@2UYZFVY@02000Ad:G@0=2Ud03@Z`2[d:/0cm000`002mK?0<oF0=H0eP3F0080
0]H20008e]L00;;G0=L30004ek80/`8000>c0;<00P001;<00;<20003Sk<000D000>900000P0<e`03
0=OG01SG00<0emL01]L000?G00<0emL02]L01P3GemL0e`<0A=L00`1NR@0Y0003;P1H00D000R2Nh9k
07^VN`801JD08`2U0:H0ZjF[0<l0d03@Y@2[d03@Z`2[d03@0=H0eZ/0Z`2[00<000V/eP3F0=H0ek80
0P000k<000020003/P00008000>c00000`000k<000030003ShT000804=L00`3Ge`0He`030=OG00KG
0003e`030=OG00[G00@0emOG0P18e`8000n9P`00RH<0PhT0REl0GhT02`000fEOI@0:000S0`0005P0
Nh9k07^VNjH0YZFV0:`0YZFV0=2U0:D0YM2U0:D00P002M2[d03@c`3?d0030007e/l0d03@0002eP05
0=H00=H010000mL0e`030005e`000;<01002/`<000>c00000`000hl0000201CG00<0emL05mL00`3G
e`06e`000mL00`3Ge`07e`<01ML00`3Ge`17e`0405j9GP`000V9G`1OREl0GfD030000a000004000A
F01lEg`0PW^2N`1kYP2VY@000jD0:`2UYJD0YJ^U0:G?Y@2Ud03@Z`2[d03@c`2[0:/0Z`2[eP3F0=H0
eP3F0=H01`000k<0/`0A01WG00<0emL05]L00`3Ge`06e`000mL00`3Ge`07e`030=OG00KG0P18e`<0
00^3R@29P`23R@29P`0@0003I@0000P00283001H089kPP2VNjH0YZD0YJbU0:D0YM2Ud03@YM00d:G@
0P002Z/0cm00d<l0cmH30006eP3F0=H00]H20009eP3F0=L0e`3G008000>b00001P000k<0000601kG
00<0emL05ML00`3Ge`06e`0000CG00002ML00`3Ge`08e`030=OG04KG3@001En908UO008000R9G`1O
I@1UG`d000`302d0EgaG07^2Nh820007YJJUYP2U0004Y@090:F[Y@2Uc`3?008000b[d:/0Z`3?d03@
0=H30006eZ/0Z`2/0P000mH0eP060003/P0000d08ML00`3Ge`0Fe`030=OG00GG0003e`030=OG00OG
1008e`030=OG04OG0P0028>908V308>97@0030X00022Nh80YW^VN`8002B/YJbU[03@YM2U0<l0Y@2U
d:D0Zm00d<l0cm00e/l0c`3?0<lN02KG00<0emL05ML00`3Ge`05e`006]L00`3Ge`18e`P001J9GP1O
R@29GhT0REl0GfD0IEl0GfEO20004`T005MlE`1kPW^20:JUYZFVY@001:D02`3@0:/0cjG?0<nU0080
01;@0=00d<l0c`3?0<l0c`3?0;420003eP3F008000>b08h0300Ze`030=OG01CG00<0emL01ML001_G
0P19e`0908>908V308>901`000X30000Nh9k07^V0P001JF/YJbU0080013@YM00d<o@0=2Ud03@Z`3?
0P003m3?0<oF0=H0eP3F0=H0eP020004eP00eP8000>b00002@0_e`030=OG01?G00<0emL01ML001gG
00<0emL0AmL8000<REh0GhT0REn908UO4P001Bh005Ml00<000ZVPP2UYZFV0=000ZD07`2[d:/0YLnU
0:G?0<nU0:/0cm00d03F0=H0eP3F0=H00P001;800;8;037G00<0emL04mL00`3Ge`05e`007]L00`3G
e`17e`0408>900:93@0036F908UU06F906EOI@@000D302d0F003000AYZbV[02/YJ`0d:`0YM00d<l0
0P002M2U0:_@Z`3?d0030008e/l0c`3?0<l20005eP3F0=H03P0de`030=OG01;G00<0emL01ML001oG
00<0emL0AmL50008GXT0REh0GXTH000Q;@1GO5L0PZJ2YP2V0=2/d02U0=2[d03@0<l0cjD0YLl000;?
0`001/l0cmH0eP8000??000010000k80000503WG00<0emL04ML00`3Ge`05e`008=L00`3Ge`17e`04
08V900:91P02R@0408V900>900<0RFD02P009`<0=022F880[:J/YP2U0:c@[02U0<o@0=2/0:D0Zm00
d<l0c`3?eP030003eP3F00D000?F00001`0le`030=OG017G00<0emL01ML0027G0P18e`D000R2R@29
GP1NR@X000QOR@29G`1OI@D000T^07aGO02VPZH00P005jc@[=2/0:_@Z`2[d:/0YLnU0:G?0<l000;?
00<0c`001P001;400;85043G00<0emL04ML00`3Ge`04e`008mL00`3Ge`16e`0308V900T00XT00`29
R@0=0004RFD00`<000=HPUP010001Zf90:c@[08001O@c`2/d:c@0=2[0<o@0=3?0<l0c`3?e@030004
eP00/@D0@mL00`3Ge`0@e`030=OG00CG000Te`030=OG04KG0P0028V208:908V21P002HUO05n9G`1O
R@090003=2d0008000J8R@29R8T40008R8T0d03@Zm020008YLl0cjD0c`02c`060<l0e@3E10000k40
000204KG00<0emL03mL00`3Ge`04e`009ML00`3Ge`16e`0308V900H00XT01029R@02R@L00XT00`29
R@040008;UP^08V]RJd30006[HT0RJf90P005=2/d03@[02[0<o@0=00e/l0c`3?0`000mD0000304SG
00<0emL03mL00`3Ge`04e`009]L204OG0P0028V208:908V21P001HV305n900L000Z9G`00=2dd08V8
0P001XT0RHR9R0<000J8R@3@Z`02[08000>Uc`000/l0203?0<l0c`3?1`1:e`030=OG00kG00<0emL0
1=L002SG00<0emL0AML00`29R@0600:900<0RHT01P02R@0408V9R@H000=H;P000P001XV]R@29[@80
01R908V]R@2/0:c@[=00d<l0c`3?eP3E0=D30004eP0004gG00<0emL03ML00`3Ge`04e`00:ML00`3G
e`15e`8000F9PP22R@060005PXT0RH801`0018T0IHT40006R8T0RHR90`001hV8R@29R8T00P04[00>
0:d0c`3?0<l0c`3E0=D504kG00<0emL03ML00`3Ge`04e`00:]L00`3Ge`15e`H00XT00`29R@0600:9
00<0RHT02@000hV]R@040006[HT0RJf910001:f90:`2000<[J`00=3?0<l0c`3?0`000k00001@e`03
0=OG00gG00<0emL00mL002_G0P16e`0708:9PP22R@030005RH80PXT01P000h>90002R@L000J8R@29
R8T40006R8T0RHR90P002:b][:f/0<l00/l01@3?003?00@0D]L00`3Ge`0<e`030=OG00?G000]e`03
0=OG04CG1P02R@0308V900<00XT00`29R@0600:910000hV]R@040006[HT0RJf910001Jf90:b]0080
00R/003F0=D0e@D0E=L00`3Ge`0;e`030=OG00?G000^e`030=OG04CG00<0PXT01`001HV208:900<0
00F9PP28R@0300:900<0=0000P001XR908V8R@@000J8R@29R8T30005[HR]0:d02@1Ee`030=OG00_G
00<0emL00mL002oG00<0emL0A=L20005[HT0RJd01`000jf900050003[HT000<000IO=000[HT40006
[HT0RJf910001:f90:`20006[J`0[02/101Ge`030=OG00[G00<0emL00mL0033G00<0emL0A=L00`22
R@030005RH80PXT010001H80R8V800<000B8R@291P001XR90028R@@000J8R@29R8T20004[:f/00:/
00<0d0000P1Ie`030=OG00WG00<0emL00mL0037G0P15e`8000F]R@29[@030005[HT0RJd010001HT0
RJf900@000R9GhT0[HV]R@8000J]R@00[HT40009[HT0[02/d03@00<0FmL00`3Ge`08e`030=OG00?G
000ce`030=OG04?G00<0PXT00`001HV208:900<000>9PP001P002XP0001NGeh0R8T20006R028RHR9
0P001XR908V8R@800Z`00`3@Z`0305_G00<0emL02=L00`3Ge`03e`00==L00`3Ge`13e`8000>]R@00
1@000jf900020005RJd0[HT00`03e`H000J]RJd0[HT20004[@2]R@@000J]R@2/0:`305gG00<0emL0
2=L00`3Ge`02e`00=ML00`3Ge`13e`<000F2R@29PP030005PXT0RH800`07e`<000EO08R9R0030004
R8V8R@8000J8R@00R8T20004Zm0005oG00<0emL01mL00`3Ge`02e`00=]L204GG00<0[HT00`001HV]
0:f900<03=L60005RJd0[HT00P001Zd0[HV]R@8000>]R@000`1Oe`030=OG00OG00<0emL00]L003SG
00<0emL0@mL20005PXT0RH800`0Ae`<000>8RHP00`001XR9R028R@8000F808R9R002067G00<0emL0
1]L00`3Ge`02e`00>ML00`3Ge`13e`030:f900<05]L40006RJd0[HV]0`001Jf9[@2]00@0H]L00`3G
e`05e`030=OG00;G000je`030=OG04?G0P0Ke`0408R9R0@000J9R028RHP20003RHP006CG00<0emL0
1=L00`3Ge`02e`00>mL204?G00<0emL06mL30006RJd0[HV]100018V]001Ue`030=OG00CG00<0emL0
0]L003gG00<0emL0@=L00`3Ge`0Le`0408R9R0@000J9R028RHP206KG00<0emL01=L00`3Ge`01e`00
?]L00`3Ge`0oe`030=OG01gG0`001]L00:f9[@@0JML00`3Ge`03e`030=OG007G000oe`030=OG03kG
00<0emL08mL306gG00<0emL00mL00`3Ge`01e`00@=L00`3Ge`0me`030=OG09CG00<0emL00]L00`3G
e`01e`00@ML203gG00<0emL0UML01@3GemL000?G0013e`030=OG03[G00<0emL0U]L0103Ge`03e`00
A=L00`3Ge`0ie`030=OG09KG00@0emL00mL004GG00<0emL0>=L00`3Ge`2Ge`030=L000?G0016e`80
>=L00`3Ge`2He`030=L000;G0018e`030=OG03GG00<0emL0VML200;G0019e`030=OG03CG00<0emL0
VML200;G001:e`030=OG03;G00<0emL0V]L200;G001;e`80<]L00`3Ge`2Fe`@01=L004gG00<0emL0
;mL00`3Ge`2Be`@02=L004kG00<0emL0;]L00`3Ge`2>e`@03=L004oG00<0emL0;ML00`3Ge`2:e`@0
4=L0053G0P0]e`030=OG08OG0`0De`00D]L00`3Ge`0Ze`030=OG08?G100Ge`00DmL00`3Ge`0Ye`03
0=OG07oG100Ke`00E=L00`3Ge`0Xe`030=OG07_G100Oe`00EML00`3Ge`0We`030=OG07SG0`0Se`00
E]L202OG00<0emL0M=L402KG001He`030=OG02CG00<0emL0L=L402[G001Ie`030=OG02?G00<0emL0
K=L402kG001Je`030=OG02;G00<0emL0J=L403;G001Ke`808]L00`3Ge`1Ue`<0=]L005gG00<0emL0
7mL00`3Ge`1Qe`@0>ML005kG00<0emL07]L00`3Ge`1Me`@0?ML005oG00<0emL07ML00`3Ge`1Ie`@0
@ML0063G0P0Me`030=OG05GG1015e`00H]L00`3Ge`0Je`030=OG05;G0`19e`00HmL00`3Ge`0Ie`03
0=OG04kG101<e`00I=L00`3Ge`0He`030=OG04[G101@e`00IML00`3Ge`0Ge`030=OG04KG101De`00
I]L201OG00<0emL0@mL305SG001Xe`030=OG01CG00<0emL0?mL405_G001Ye`030=OG01?G00<0emL0
>mL405oG001Ze`030=OG01;G00<0emL0=mL406?G001[e`804]L00`3Ge`0ce`@0ImL006gG00<0emL0
3]L00`3Ge`0ae`<0JmL006kG00<0emL03ML00`3Ge`0]e`@0K]L006oG00<0emL03=L00`3Ge`0Ye`@0
L]L0073G0P0<e`030=OG02GG101fe`00L]L00`3Ge`09e`030=OG027G101je`00LmL00`3Ge`08e`03
0=OG01kG0`1ne`00M=L00`3Ge`07e`030=OG01[G1021e`00MML00`3Ge`06e`030=OG01KG1025e`00
M]L200KG00<0emL04]L408WG001he`030=OG00?G00<0emL03mL308gG001ie`030=OG00;G00<0emL0
2mL4093G001je`050=OGe`002ML409CG001ke`8000?G0=L01=L409SG001me`8000?G00000P2Le`00
O]L20:3G003oeb7G003oeb7G0000\
\>"],
  ImageRangeCache->{{{0, 287}, {232.562, 0}} -> {-0.0748616, 0.0116279, \
0.0035951, 0.0035951}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  SurfaceGraphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.1 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{993, 782},
WindowMargins->{{Automatic, 81}, {101, Automatic}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1705, 50, 814, 18, 101, "Input"],

Cell[CellGroupData[{
Cell[2544, 72, 693, 10, 239, "Input"],
Cell[3240, 84, 199401, 4736, 242, 158628, 4228, "GraphicsData", "PostScript", \
"Graphics"],
Cell[202644, 4822, 137, 3, 31, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

