(************** Content-type: application/mathematica **************

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    151875,       3892]*)
(*NotebookOutlinePosition[    152507,       3914]*)
(*  CellTagsIndexPosition[    152463,       3910]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
    \(\(\( (*\ 
      VARMEM : \ 
          Circular\ membrane\ of\ radius\ 1\ with\ symmetric\ surface\ \
density . \ FOr\ constant\ density\ \((alph = 
                0)\)\ the\ eigenvalue\ must\ be\ om = \ \(\(2.404825\)\(.\)\)\
\ *) \)\(\[IndentingNewLine]\)\( (*\ 
      Step\ 1\  : 
        Define\ the\ boundary\ and\ plot\ a\ density\ distribution\ *) \)\(\
\[IndentingNewLine]\)\(Clear[n, pl1, pl2, dth, x, y]; n = 6; 
    dth = Pi/\((2. *n)\); R = 1. ; Table[x[l] = R*Cos[l*dth], {l, 1, n}]; 
    Table[y[l] = R*Sin[l*dth], {l, 1, n}];\[IndentingNewLine]
    pl1 = 
      ListPlot[Table[{x[l], y[l]}, {l, 1, n}], Frame \[Rule] True, 
        AspectRatio \[Rule] 1. , PlotStyle \[Rule] PointSize[1/40], 
        DisplayFunction -> Identity]\[IndentingNewLine]
    pl2 = 
      Plot[y = Sqrt[R^2 - x^2], {x, 0, 1. }, AspectRatio \[Rule] 1. , 
        DisplayFunction \[Rule] Identity]\[IndentingNewLine]
    Show[pl1, pl2, DisplayFunction \[Rule] $DisplayFunction]\)\)\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.0238095 0.952381 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -3 -9 ]
[.97619 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02381 -6 -4.5 ]
[-0.0125 .02381 0 4.5 ]
[-0.0125 .21429 -18 -4.5 ]
[-0.0125 .21429 0 4.5 ]
[-0.0125 .40476 -18 -4.5 ]
[-0.0125 .40476 0 4.5 ]
[-0.0125 .59524 -18 -4.5 ]
[-0.0125 .59524 0 4.5 ]
[-0.0125 .78571 -18 -4.5 ]
[-0.0125 .78571 0 4.5 ]
[-0.0125 .97619 -6 -4.5 ]
[-0.0125 .97619 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 1 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(0.2)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(0.4)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(0.6)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(0.8)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02381 m
.00625 .02381 L
s
[(0)] -0.0125 .02381 1 0 Mshowa
0 .21429 m
.00625 .21429 L
s
[(0.2)] -0.0125 .21429 1 0 Mshowa
0 .40476 m
.00625 .40476 L
s
[(0.4)] -0.0125 .40476 1 0 Mshowa
0 .59524 m
.00625 .59524 L
s
[(0.6)] -0.0125 .59524 1 0 Mshowa
0 .78571 m
.00625 .78571 L
s
[(0.8)] -0.0125 .78571 1 0 Mshowa
0 .97619 m
.00625 .97619 L
s
[(1)] -0.0125 .97619 1 0 Mshowa
.125 Mabswid
0 .07143 m
.00375 .07143 L
s
0 .11905 m
.00375 .11905 L
s
0 .16667 m
.00375 .16667 L
s
0 .2619 m
.00375 .2619 L
s
0 .30952 m
.00375 .30952 L
s
0 .35714 m
.00375 .35714 L
s
0 .45238 m
.00375 .45238 L
s
0 .5 m
.00375 .5 L
s
0 .54762 m
.00375 .54762 L
s
0 .64286 m
.00375 .64286 L
s
0 .69048 m
.00375 .69048 L
s
0 .7381 m
.00375 .7381 L
s
0 .83333 m
.00375 .83333 L
s
0 .88095 m
.00375 .88095 L
s
0 .92857 m
.00375 .92857 L
s
.25 Mabswid
0 0 m
0 1 L
s
.02381 .99375 m
.02381 1 L
s
.21429 .99375 m
.21429 1 L
s
.40476 .99375 m
.40476 1 L
s
.59524 .99375 m
.59524 1 L
s
.78571 .99375 m
.78571 1 L
s
.97619 .99375 m
.97619 1 L
s
.125 Mabswid
.07143 .99625 m
.07143 1 L
s
.11905 .99625 m
.11905 1 L
s
.16667 .99625 m
.16667 1 L
s
.2619 .99625 m
.2619 1 L
s
.30952 .99625 m
.30952 1 L
s
.35714 .99625 m
.35714 1 L
s
.45238 .99625 m
.45238 1 L
s
.5 .99625 m
.5 1 L
s
.54762 .99625 m
.54762 1 L
s
.64286 .99625 m
.64286 1 L
s
.69048 .99625 m
.69048 1 L
s
.7381 .99625 m
.7381 1 L
s
.83333 .99625 m
.83333 1 L
s
.88095 .99625 m
.88095 1 L
s
.92857 .99625 m
.92857 1 L
s
.25 Mabswid
0 1 m
1 1 L
s
.99375 .02381 m
1 .02381 L
s
.99375 .21429 m
1 .21429 L
s
.99375 .40476 m
1 .40476 L
s
.99375 .59524 m
1 .59524 L
s
.99375 .78571 m
1 .78571 L
s
.99375 .97619 m
1 .97619 L
s
.125 Mabswid
.99625 .07143 m
1 .07143 L
s
.99625 .11905 m
1 .11905 L
s
.99625 .16667 m
1 .16667 L
s
.99625 .2619 m
1 .2619 L
s
.99625 .30952 m
1 .30952 L
s
.99625 .35714 m
1 .35714 L
s
.99625 .45238 m
1 .45238 L
s
.99625 .5 m
1 .5 L
s
.99625 .54762 m
1 .54762 L
s
.99625 .64286 m
1 .64286 L
s
.99625 .69048 m
1 .69048 L
s
.99625 .7381 m
1 .7381 L
s
.99625 .83333 m
1 .83333 L
s
.99625 .88095 m
1 .88095 L
s
.99625 .92857 m
1 .92857 L
s
.25 Mabswid
1 0 m
1 1 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.025 w
.94374 .2703 Mdot
.8486 .5 Mdot
.69724 .69724 Mdot
.5 .8486 Mdot
.2703 .94374 Mdot
.02381 .97619 Mdot
.5 Mabswid
.02381 .97619 m
.02499 .97619 L
.02605 .97619 L
.02729 .97618 L
.02846 .97618 L
.03053 .97617 L
.03279 .97615 L
.03527 .97612 L
.0379 .97609 L
.04262 .976 L
.04749 .9759 L
.05205 .97577 L
.06244 .97541 L
.07305 .97492 L
.08274 .97437 L
.10458 .97276 L
.12357 .97095 L
.14429 .96854 L
.18493 .96246 L
.22406 .9549 L
.26565 .94497 L
.30571 .93351 L
.34426 .92066 L
.38527 .90493 L
.42475 .88768 L
.46273 .86902 L
.50315 .84677 L
.54206 .82284 L
.58342 .79444 L
.62326 .76387 L
.66159 .7311 L
.70238 .69207 L
.74164 .6497 L
.77939 .60357 L
.8196 .54702 L
.85828 .48281 L
.89942 .39842 L
.91995 .34624 L
.93905 .28719 L
.94829 .25266 L
.95701 .214 L
.96183 .18858 L
.96706 .15539 L
.96937 .13762 L
.97181 .11506 L
.9739 .08989 L
.97508 .06976 L
.97619 .02408 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000000<`00IP00V@00
c000o`0c000c<`0cIP0cV@0cc00co`1V001V<`1VIP1VV@1Vc01Vo`2I002I<`2IIP2IV@2Ic02Io`3<
003<<`3<IP3<V@3<c03<o`3o003o<`3oIP3oV@3oc03ooc<003<0<c<0IS<0VC<0c3<0oc<c03<c<c<c
IS<cVC<cc3<coc=V03=V<c=VIS=VVC=Vc3=Voc>I03>I<c>IIS>IVC>Ic3>Ioc?<03?<<c?<IS?<VC?<
c3?<oc?o03?o<c?oIS?oVC?oc3?oofH006H0<fH0IVH0VFH0c6H0ofHc06Hc<fHcIVHcVFHcc6HcofIV
06IV<fIVIVIVVFIVc6IVofJI06JI<fJIIVJIVFJIc6JIofK<06K<<fK<IVK<VFK<c6K<ofKo06Ko<fKo
IVKoVFKoc6KooiT009T0<iT0IYT0VIT0c9T0oiTc09Tc<iTcIYTcVITcc9TcoiUV09UV<iUVIYUVVIUV
c9UVoiVI09VI<iVIIYVIVIVIc9VIoiW<09W<<iW<IYW<VIW<c9W<oiWo09Wo<iWoIYWoVIWoc9Wool`0
0<`0<l`0I/`0VL`0c<`0ol`c0<`c<l`cI/`cVL`cc<`colaV0<aV<laVI/aVVLaVc<aVolbI0<bI<lbI
I/bIVLbIc<bIolc<0<c<<lc<I/c<VLc<c<c<olco0<co<lcoI/coVLcoc<coool00?l0<ol0I_l0VOl0
c?l0oolc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nIooo<
0?o<<oo<I_o<VOo<c?o<oooo0?oo<oooI_ooVOooc?ooooCM/_[aghUlI<FbZ>KNfVYPFjNGSol0VOl0
c?l0oolc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nIooo<
0?o<<oo<I_o<VOo<c?o<oooo0?oo<oooI_ooVOooc?oooooG8ML00?oG8ML00?oG8ML00?oG8ML00?oG
8ML00?oG8ML00?oG8ML001[G0P0[e`801=L00`3Ge`02e`@08mL200CG00<0emL01=L00`3Ge`0Se`80
1=L00`3Ge`03e`809=L200CG00<0emL00mL202[G1006e`006ML0103Ge`0Ye`040=OG00SG00<0emL0
8mL0103Ge`0:e`030=OG02;G00@0emL02=L0103Ge`0Re`040=OG00SG00@0emL0:mL00`3Ge`05e`00
6ML0103Ge`0Ye`040=OG00WG00<0emL08]L0103Ge`07e`D08mL0103Ge`08e`040=OG02;G00@0emL0
2=L0103Ge`0[e`030=OG00GG000Ie`040=OG02WG00@0emL02]L00`3Ge`0Qe`040=OG00OG00@0emL0
9=L0103Ge`08e`<08mL0103Ge`09e`80;=L00`3Ge`05e`006ML0103Ge`0Ye`040=OG00_G00<0emL0
8=L0103Ge`08e`030=L002CG00@0emL02=L00`3Ge`0Se`040=OG00SG00@0emL0:mL00`3Ge`05e`00
6ML0103Ge`0Ye`040=OG00SG00@0emL08]L0103Ge`09e`809=L0103Ge`08e`030=OG02?G00@0emL0
2=L0103Ge`0Ye`<01mL001[G0P0[e`802]L202CG0P0;e`030=OG02?G0P0:e`<08mL200[G0P0/e`03
0=OG00GG003oeb7G003oeb7G003oeb7G000Eeol02`01e`005ML00`3Ge`03e`030=OG00[G00<0emL0
2ML00`3Ge`0:e`030=OG00[G00<0emL02ML00`3Ge`0:e`030=OG00[G00<0emL02ML00`3Ge`0:e`03
0=OG00[G00<0emL02ML00`3Ge`0:e`030=OG00[G00<0emL02ML00`3Ge`0:e`030=OG00WG00<0emL0
2]L00`3Ge`0:e`030=OG00WG00<0emL02]L00`3Ge`03e`400ML001GG00<0emL00mL00`3Ge`0`e`03
0=OG02oG00<0emL0<=L00`3Ge`0_e`030=OG033G00<0emL00mL1007G000Ee`030=OG0?oG1mL1007G
000Ee`030=OG0?oG1mL1007G000>e`801ML00`3Ge`3oe`OG0@01e`003ML0103Ge`04e`030=OG0?oG
1mL1007G000=e`040=OG00CG0P3oe`;G00<0emL00]L2007G000=e`040=OG00CG00<0emL0omL1e`03
0=OG00?G0@01e`003ML0103Ge`04e`030=OG0?oG0ML00`3Ge`03e`400ML000gG00@0emL01=L00`3G
e`3oe`7G00<0emL00mL1007G000>e`801ML00`3Ge`3oe`7G00<0emL00mL1007G000Ee`030=OG0?oG
0ML00`3Ge`03e`400ML001GG00<0emL0omL1e`030=OG00?G0@01e`005ML00`3Ge`3oe`7G00<0emL0
0mL1007G000Ee`030=OG0?oG0ML00`3Ge`03e`400ML001GG00<0emL0omL1e`030=OG00?G0@01e`00
5ML00`3Ge`3oe`7G00<0emL00mL1007G000Ee`030=OG0?oG0ML00`3Ge`03e`400ML001GG0P3oe`;G
00<0emL00]L2007G000Ee`030=OG0?oG0ML00`3Ge`03e`400ML001GG00<0emL0omL1e`030=OG00?G
0@01e`005ML00`3Ge`3oe`030=OG00CG0@01e`005ML00`3Ge`3oe`030=OG00CG0@01e`005ML00`3G
e`3oe`030=OG00CG0@01e`005ML00`3Ge`3oe`030=OG00CG0@01e`005ML00`3Ge`3oe`030=OG00CG
0@01e`005ML00`3Ge`3oe`030=OG00CG0@01e`005ML00`3Ge`3oe`030=OG00CG0@01e`005ML00`3G
e`3oe`030=OG00CG0@01e`005ML00`3Ge`3oe`030=OG00CG0@01e`005ML00`3Ge`3oe`030=OG00CG
0@01e`005ML20?oG0ML00`3Ge`03e`800ML001GG00<0emL0omL00`3Ge`04e`400ML001GG00<0emL0
o]L00`3Ge`05e`400ML001GG00<0emL0o]L00`3Ge`05e`400ML001GG00<0emL0o]L00`3Ge`05e`40
0ML001GG00<0emL0o]L00`3Ge`05e`400ML001GG00<0emL0o]L00`3Ge`05e`400ML001GG00<0emL0
o]L00`3Ge`05e`400ML001GG00<0emL0o]L00`3Ge`05e`400ML001GG00<0emL0o]L00`3Ge`05e`40
0ML001GG00<0emL0o]L00`3Ge`05e`400ML001GG00<0emL0o]L00`3Ge`05e`400ML001GG00<0emL0
oML00`3Ge`06e`400ML001GG0P3ne`030=OG00GG0P01e`005ML00`3Ge`3me`030=OG00KG0@01e`00
5ML00`3Ge`3me`030=OG00KG0@01e`005ML00`3Ge`3le`030=OG00OG0@01e`005ML00`3Ge`3le`03
0=OG00OG0@01e`005ML00`3Ge`3le`030=OG00OG0@01e`005ML00`3Ge`3le`030=OG00OG0@01e`00
5ML00`3Ge`3le`030=OG00OG0@01e`005ML00`3Ge`3le`030=OG00OG0@01e`005ML00`3Ge`3ke`03
0=OG00SG0@01e`000]L200CG00<0emL00]L400CG00<0emL0nmL00`3Ge`08e`400ML00005e`3Ge`00
2=L00`3Ge`05e`030=OG0?_G00<0emL02=L1007G00001ML0emL000WG00<0emL01=L20?cG00<0emL0
1mL2007G00001ML0emL000[G00<0emL00mL00`3Ge`3ke`030=OG00SG0@01e`0000GG0=OG000;e`03
0=OG00;G00<0emL0nmL00`3Ge`08e`400ML00005e`3Ge`002=L0103Ge`04e`030=OG0?[G00<0emL0
2ML1007G0002e`802]L200GG00<0emL0n]L00`3Ge`09e`400ML001GG00<0emL0n]L00`3Ge`09e`40
0ML001GG00<0emL0n]L00`3Ge`09e`400ML001GG00<0emL0n]L00`3Ge`09e`400ML001GG00<0emL0
nML00`3Ge`0:e`400ML001GG00<0emL0nML00`3Ge`0:e`400ML001GG00<0emL0nML00`3Ge`0:e`40
0ML001GG00<0emL0nML00`3Ge`0:e`400ML001GG00<0emL0n=L00`3Ge`0;e`400ML001GG0P3ge`D0
2]L2007G000Ee`030=OG0?KG1@0;e`400ML001GG00<0emL0mML600_G0@01e`005ML00`3Ge`3fe`D0
2mL1007G000Ee`030=OG0?KG1@0;e`400ML001GG00<0emL0mmL200gG0@01e`005ML00`3Ge`3fe`03
0=OG00gG0@01e`005ML00`3Ge`3fe`030=OG00gG0@01e`005ML00`3Ge`3fe`030=OG00gG0@01e`00
5ML00`3Ge`3ee`030=OG00kG0@01e`005ML00`3Ge`3ee`030=OG00kG0@01e`005ML00`3Ge`3ee`03
0=OG00kG0@01e`005ML00`3Ge`3de`030=OG00oG0@01e`005ML20?GG00<0emL03]L2007G000Ee`03
0=OG0?CG00<0emL03mL1007G000Ee`030=OG0??G00<0emL04=L1007G000Ee`030=OG0??G00<0emL0
4=L1007G000Ee`030=OG0??G00<0emL04=L1007G000Ee`030=OG0?;G00<0emL04ML1007G000Ee`03
0=OG0?;G00<0emL04ML1007G000Ee`030=OG0?;G00<0emL04ML1007G000Ee`030=OG0?7G00<0emL0
4]L1007G000Ee`030=OG0?7G00<0emL04]L1007G000Ee`030=OG0?7G00<0emL04]L1007G000Ee`03
0=OG0?3G00<0emL04mL1007G000Ee`80lML00`3Ge`0Be`800ML001GG00<0emL0l=L00`3Ge`0Ce`40
0ML001GG00<0emL0kmL00`3Ge`0De`400ML001GG00<0emL0kmL00`3Ge`0De`400ML001GG00<0emL0
k]L00`3Ge`0Ee`400ML001GG00<0emL0k]L00`3Ge`0Ee`400ML001GG00<0emL0k]L00`3Ge`0Ee`40
0ML001GG00<0emL0kML00`3Ge`0Fe`400ML001GG00<0emL0kML00`3Ge`0Fe`400ML001GG00<0emL0
kML00`3Ge`0Fe`400ML001GG00<0emL0k=L00`3Ge`0Ge`400ML000;G0P04e`030=OG00CG00<0emL0
0mL00`3Ge`3/e`030=OG01OG0@01e`0000GG0=OG000:e`030=OG00?G00<0emL0k=L00`3Ge`0Ge`40
0ML00005e`3Ge`001mL500CG0P3/e`030=OG01OG0P01e`0000GG0=OG0007e`040=OG00GG00<0emL0
jmL00`3Ge`0He`400ML00005e`3Ge`002=L00`3G0005e`030=OG0>[G00<0emL06ML1007G00001ML0
emL000WG0P05e`030=OG0>[G00<0emL06ML1007G0002e`802mL00`3Ge`03e`030=OG0>WG00<0emL0
6]L1007G000Ee`030=OG0>WG00<0emL06]L1007G000Ee`030=OG0>SG00<0emL06mL1007G000Ee`03
0=OG0>SG00<0emL06mL1007G000Ee`030=OG0>OG00<0emL07=L1007G000Ee`030=OG0>OG00<0emL0
7=L1007G000Ee`030=OG0>KG00<0emL07ML1007G000Ee`030=OG0>KG00<0emL07ML1007G000Ee`03
0=OG0>GG00<0emL07]L1007G000Ee`80i]L00`3Ge`0Me`800ML001GG00<0emL0i=L00`3Ge`0Oe`40
0ML001GG00<0emL0i=L00`3Ge`0Oe`400ML001GG00<0emL0hmL00`3Ge`0Pe`400ML001GG00<0emL0
hmL00`3Ge`0Pe`400ML001GG00<0emL0h]L00`3Ge`0Qe`400ML001GG00<0emL0h]L00`3Ge`0Qe`40
0ML001GG00<0emL0hML00`3Ge`0Re`400ML001GG00<0emL0hML00`3Ge`0Re`400ML001GG00<0emL0
h=L00`3Ge`0Se`400ML001GG00<0emL0g=L502GG0@01e`005ML00`3Ge`3Le`D09ML1007G000Ee`80
g=L602CG0P01e`005ML00`3Ge`3Le`D09ML1007G000Ee`030=OG0=cG1@0Ue`400ML001GG00<0emL0
g=L00`3G000We`400ML001GG00<0emL0g=L00`3Ge`0We`400ML001GG00<0emL0fmL00`3Ge`0Xe`40
0ML001GG00<0emL0fmL00`3Ge`0Xe`400ML001GG00<0emL0f]L00`3Ge`0Ye`400ML001GG00<0emL0
fML00`3Ge`0Ze`400ML001GG00<0emL0fML00`3Ge`0Ze`400ML001GG00<0emL0f=L00`3Ge`0[e`40
0ML001GG00<0emL0emL00`3Ge`0/e`400ML001GG00<0emL0emL00`3Ge`0/e`400ML001GG0P3Ge`03
0=OG02cG0P01e`005ML00`3Ge`3Ee`030=OG02kG0@01e`005ML00`3Ge`3Ee`030=OG02kG0@01e`00
5ML00`3Ge`3De`030=OG02oG0@01e`005ML00`3Ge`3Ce`030=OG033G0@01e`005ML00`3Ge`3Ce`03
0=OG033G0@01e`005ML00`3Ge`3Be`030=OG037G0@01e`005ML00`3Ge`3Ae`030=OG03;G0@01e`00
5ML00`3Ge`3Ae`030=OG03;G0@01e`005ML00`3Ge`3@e`030=OG03?G0@01e`000]L200CG00<0emL0
0mL200GG00<0emL0cmL00`3Ge`0de`400ML00005e`3Ge`002=L0103Ge`04e`030=OG0<oG00<0emL0
==L1007G00001ML0emL000SG00@0emL01=L20<oG00<0emL0==L2007G00001ML0emL000SG0`05e`03
0=OG0<gG00<0emL0=]L1007G00001ML0emL000SG00<0emL01ML00`3Ge`3=e`030=OG03KG0@01e`00
00GG0=OG0008e`030=OG00GG00<0emL0c=L00`3Ge`0ge`400ML000;G0P0:e`<01=L00`3Ge`3;e`03
0=OG03SG0@01e`005ML00`3Ge`3:e`030=OG03WG0@01e`005ML00`3Ge`39e`030=OG03[G0@01e`00
5ML00`3Ge`39e`030=OG03[G0@01e`005ML00`3Ge`38e`030=OG03_G0@01e`005ML00`3Ge`37e`03
0=OG03cG0@01e`005ML00`3Ge`36e`030=OG03gG0@01e`005ML00`3Ge`35e`030=OG03kG0@01e`00
5ML00`3Ge`34e`030=OG03oG0@01e`005ML20<GG00<0emL0?]L2007G000Ee`030=OG0<?G00<0emL0
@=L1007G000Ee`030=OG0<;G00<0emL0@ML1007G000Ee`030=OG0<7G00<0emL0@]L1007G000Ee`03
0=OG0<3G00<0emL0@mL1007G000Ee`030=OG0;oG00<0emL0A=L1007G000Ee`030=OG0;kG00<0emL0
AML1007G000Ee`030=OG0;gG00<0emL0A]L1007G000Ee`030=OG0;cG00<0emL0AmL1007G000Ee`03
0=OG0;_G00<0emL0B=L1007G000Ee`030=OG0;[G00<0emL0BML1007G000Ee`030=OG0;WG00<0emL0
B]L1007G000Ee`030=OG0;CG1@1=e`400ML001GG0P2ee`D0C=L2007G000Ee`030=OG0;?G1P1=e`40
0ML001GG00<0emL0]=L504gG0@01e`005ML00`3Ge`2de`D0CML1007G000Ee`030=OG0;?G00@0emL0
CmL1007G000Ee`030=OG0;;G00<0emL0DML1007G000Ee`030=OG0;;G00<0emL0DML1007G000Ee`03
0=OG0;7G00<0emL0D]L1007G000Ee`030=OG0;3G00<0emL0DmL1007G000Ee`030=OG0:oG00<0emL0
E=L1007G000Ee`030=OG0:kG00<0emL0EML1007G000Ee`030=OG0:gG00<0emL0E]L1007G000Ee`80
[=L205SG0P01e`005ML00`3Ge`2Ze`030=OG05WG0@01e`005ML00`3Ge`2Ye`030=OG05[G0@01e`00
5ML00`3Ge`2We`80GML1007G000Ee`030=OG0:KG00<0emL0GML1007G000Ee`030=OG0:GG00<0emL0
G]L1007G000Ee`030=OG0:?G0P1Qe`400ML001GG00<0emL0X]L00`3Ge`1Qe`400ML001GG00<0emL0
XML00`3Ge`1Re`400ML001GG00<0emL0WmL206GG0@01e`005ML00`3Ge`2Ne`030=OG06GG0@01e`00
0]L200CG00<0emL00mL200GG00<0emL0WML00`3Ge`1Ve`400ML00005e`3Ge`002=L0103Ge`04e`03
0=OG09cG00<0emL0ImL1007G00001ML0emL000SG00@0emL01=L209_G0P1Ye`800ML00005e`3Ge`00
2ML200GG00<0emL0VML00`3Ge`1Ze`400ML00005e`3Ge`002=L0103Ge`04e`030=OG09SG00<0emL0
JmL1007G00001ML0emL000SG00@0emL01=L00`3Ge`2Fe`80K]L1007G0002e`802]L200GG00<0emL0
UML00`3Ge`1^e`400ML001GG00<0emL0U=L00`3Ge`1_e`400ML001GG00<0emL0T]L207;G0@01e`00
5ML00`3Ge`2Ae`030=OG07;G0@01e`005ML00`3Ge`2@e`030=OG07?G0@01e`005ML00`3Ge`2>e`80
M]L1007G000Ee`030=OG08gG00<0emL0M]L1007G000Ee`030=OG08_G0P1ie`400ML001GG00<0emL0
RML207_G0@01e`005ML208SG0P1le`800ML001GG00<0emL0QML207oG0@01e`005ML00`3Ge`20e`D0
PML1007G000Ee`030=OG083G1@21e`400ML001GG00<0emL0OmL6087G0@01e`005ML00`3Ge`1ne`L0
PML1007G000Ee`030=OG07gG00<0emL01@21e`400ML001GG00<0emL0NmL200GG00<0emL0PML1007G
000Ee`030=OG07WG0P2;e`400ML001GG00<0emL0N=L00`3Ge`2;e`400ML001GG00<0emL0M]L208kG
0@01e`005ML00`3Ge`1de`80T=L1007G000Ee`80LmL2097G0P01e`005ML00`3Ge`1`e`80U=L1007G
000Ee`030=OG06gG0`2Fe`400ML001GG00<0emL0JmL209WG0@01e`005ML00`3Ge`1Ye`80VmL1007G
000Ee`030=OG06OG0P2Me`400ML001GG00<0emL0IML209oG0@01e`005ML00`3Ge`1Re`<0XML1007G
000Ee`030=OG05oG0`2Te`400ML001GG00<0emL0GML20:OG0@01e`005ML00`3Ge`1Je`<0ZML1007G
000Ee`030=OG05OG0`2/e`400ML001GG00<0emL0E=L30:oG0@01e`005ML2057G102ae`800ML001GG
00<0emL0CML30;KG0@01e`005ML00`3Ge`13e`D000?G00000P2ie`400ML001GG00<0emL0@mL60;gG
0@01e`005ML00`3Ge`12e`H0_]L1007G000Ee`030=OG03kG10000mL000030;kG0@01e`005ML00`3G
e`0je`@01ML50;kG0@01e`005ML00`3Ge`0fe`@02mL00`3Ge`2ne`400ML001GG00<0emL0<ML50=3G
0@01e`005ML00`3Ge`0/e`D0eML1007G000Ee`040=OGe`D08=L60=[G0@01e`003ML400CG00@0emOG
1@0Fe`X0h=L1007G000?e`030=OG00?G00<0emL01P05ea40j]L1007G000?e`030=OG00?G0P02e`X0
n]L2007G000?e`030=OG00?G00@0emOG1@3oe`7G0@01e`003mL00`3Ge`03e`030=OG00?G00<0emL0
omL1e`400ML000gG0`05e`030=OG0?oG1mL1007G000?e`030=OG00?G00<0emL00mL00`3Ge`0`e`03
0=OG02oG00<0emL0<=L00`3Ge`0_e`030=OG033G00<0emL00mL1007G000Ee`030=OG00?G00<0emL0
2]L00`3Ge`09e`030=OG00[G00<0emL02]L00`3Ge`09e`030=OG00[G00<0emL02]L00`3Ge`09e`03
0=OG00[G00<0emL02]L00`3Ge`09e`030=OG00[G00<0emL02]L00`3Ge`09e`030=OG00[G00<0emL0
2ML00`3Ge`0:e`030=OG00[G00<0emL02ML00`3Ge`0:e`030=OG00?G0@01e`005MOo00/00ML00?oG
8ML00?oG8ML00?oG8ML00?oG8ML00001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.109303, -0.0917566, \
0.00395401, 0.00395401}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Clear[alph, rho0, pro, rho, R, PL, x, y]; rho0 = 1. ; alph = 0.5; 
    R = 1. ; rho[x_, y_] = 
      rho0*\((alph*\((R^2 - x^2 - y^2)\) + 1. )\);\), "\[IndentingNewLine]", 
    \(Off[Plot3D::plnc]; Off[Plot3D::gval]; Clear[x, y]\), "\n", 
    \(PL = 
      Plot3D[rho[x, y], {x, \(-R\), R}, {y, \(-R\), R}, 
        PlotPoints \[Rule] 30]\)}], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .81114 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% SurfaceGraphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.11022e-16 1.04977 -0.0679587 1.04977 [
[.02757 .24618 -12 -8.70276 ]
[.02757 .24618 0 .29724 ]
[.17646 .18758 -23.5978 -9 ]
[.17646 .18758 .40224 0 ]
[.3345 .12542 -5.5867 -9 ]
[.3345 .12542 .4133 0 ]
[.50253 .05935 -15.8219 -9 ]
[.50253 .05935 2.17811 0 ]
[.68156 -0.01098 -4.96123 -9 ]
[.68156 -0.01098 1.03877 0 ]
[.70096 -0.00478 0 -6.26206 ]
[.70096 -0.00478 12 2.73794 ]
[.78313 .12104 0 -6.13858 ]
[.78313 .12104 24 2.86142 ]
[.8565 .23339 0 -6.03127 ]
[.8565 .23339 6 2.96873 ]
[.9224 .33431 0 -5.93715 ]
[.9224 .33431 18 3.06285 ]
[.98191 .42546 0 -5.85393 ]
[.98191 .42546 6 3.14607 ]
[.02411 .26511 -18 -2.74232 ]
[.02411 .26511 0 6.25768 ]
[.01567 .31801 -24 -2.78705 ]
[.01567 .31801 0 6.21295 ]
[.00694 .37277 -6 -2.8335 ]
[.00694 .37277 0 6.1665 ]
[-0.00211 .42947 -24 -2.88179 ]
[-0.00211 .42947 0 6.11821 ]
[-0.01149 .48823 -18 -2.932 ]
[-0.01149 .48823 0 6.068 ]
[ 0 0 0 0 ]
[ 1 .81114 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.03716 .25514 m
.68874 0 L
s
.03716 .25514 m
.04196 .25962 L
s
[(-1)] .02757 .24618 1 .93395 Mshowa
.18558 .19702 m
.19014 .20174 L
s
[(-0.5)] .17646 .18758 .96648 1 Mshowa
.34306 .13535 m
.34735 .14032 L
s
[(0)] .3345 .12542 .86223 1 Mshowa
.51046 .06981 m
.51442 .07504 L
s
[(0.5)] .50253 .05935 .75799 1 Mshowa
.68874 0 m
.69233 .00549 L
s
[(1)] .68156 -0.01098 .65374 1 Mshowa
.125 Mabswid
.06616 .24378 m
.06901 .2465 L
s
.09549 .2323 m
.09832 .23504 L
s
.12517 .22067 m
.12797 .22345 L
s
.1552 .20892 m
.15797 .21172 L
s
.21633 .18498 m
.21903 .18784 L
s
.24744 .1728 m
.25012 .17569 L
s
.27893 .16047 m
.28157 .16339 L
s
.3108 .14799 m
.31341 .15094 L
s
.37572 .12257 m
.37826 .12558 L
s
.40878 .10962 m
.41128 .11266 L
s
.44225 .09652 m
.44471 .09959 L
s
.47614 .08324 m
.47856 .08635 L
s
.54521 .0562 m
.54755 .05937 L
s
.58041 .04242 m
.5827 .04562 L
s
.61605 .02846 m
.6183 .03169 L
s
.65216 .01432 m
.65436 .01759 L
s
.25 Mabswid
.68874 0 m
.96935 .42924 L
s
.68874 0 m
.68263 .00239 L
s
[(-1)] .70096 -0.00478 -1 .39157 Mshowa
.7708 .12553 m
.76464 .12778 L
s
[(-0.5)] .78313 .12104 -1 .36413 Mshowa
.84407 .23761 m
.83786 .23973 L
s
[(0)] .8565 .23339 -1 .34028 Mshowa
.9099 .3383 m
.90365 .34029 L
s
[(0.5)] .9224 .33431 -1 .31937 Mshowa
.96935 .42924 m
.96306 .43113 L
s
[(1)] .98191 .42546 -1 .30087 Mshowa
.125 Mabswid
.70593 .0263 m
.70226 .02771 L
s
.72272 .05198 m
.71904 .05338 L
s
.73912 .07706 m
.73543 .07845 L
s
.75514 .10158 m
.75145 .10294 L
s
.78611 .14895 m
.78241 .15028 L
s
.80108 .17185 m
.79737 .17317 L
s
.81573 .19425 m
.81201 .19555 L
s
.83006 .21617 m
.82633 .21745 L
s
.8578 .2586 m
.85407 .25986 L
s
.87123 .27915 m
.8675 .28039 L
s
.88439 .29928 m
.88065 .3005 L
s
.89727 .31899 m
.89353 .3202 L
s
.92227 .35722 m
.91851 .3584 L
s
.93439 .37576 m
.93063 .37693 L
s
.94627 .39394 m
.94251 .3951 L
s
.95792 .41176 m
.95416 .41291 L
s
.25 Mabswid
.03716 .25514 m
0 .48963 L
s
.03634 .26033 m
.04245 .25795 L
s
[(0.5)] .02411 .26511 1 -0.3906 Mshowa
.02794 .31335 m
.03407 .31101 L
s
[(0.75)] .01567 .31801 1 -0.38066 Mshowa
.01924 .36821 m
.02539 .36593 L
s
[(1)] .00694 .37277 1 -0.37033 Mshowa
.01024 .42503 m
.01641 .42281 L
s
[(1.25)] -0.00211 .42947 1 -0.3596 Mshowa
.00091 .48392 m
.0071 .48176 L
s
[(1.5)] -0.01149 .48823 1 -0.34844 Mshowa
.125 Mabswid
.03468 .27079 m
.03835 .26937 L
s
.03301 .28132 m
.03668 .2799 L
s
.03133 .29192 m
.035 .29051 L
s
.02964 .3026 m
.03332 .30119 L
s
.02622 .32417 m
.0299 .32277 L
s
.02449 .33506 m
.02818 .33368 L
s
.02276 .34604 m
.02644 .34466 L
s
.021 .35709 m
.02469 .35571 L
s
.01747 .37942 m
.02116 .37806 L
s
.01568 .3907 m
.01937 .38935 L
s
.01388 .40206 m
.01758 .40072 L
s
.01206 .41351 m
.01576 .41217 L
s
.0084 .43664 m
.0121 .43532 L
s
.00654 .44833 m
.01025 .44702 L
s
.00468 .46011 m
.00839 .4588 L
s
.0028 .47197 m
.00651 .47067 L
s
.25 Mabswid
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.39787 .81114 L
s
.39787 .81114 m
.40529 .59895 L
s
.40529 .59895 m
.03716 .25514 L
s
.68874 0 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.68874 0 m
.03716 .25514 L
s
.40529 .59895 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.39787 .81114 L
s
.39787 .81114 m
.40529 .59895 L
s
0 0 m
1 0 L
1 .81114 L
0 .81114 L
closepath
clip
newpath
.5 Mabswid
.58 .052 0 r
.39408 .6067 .40512 .60371 .42243 .6112 .41148 .61428 Metetra
.551 .015 0 r
.41148 .61428 .42243 .6112 .44 .61786 .42916 .62103 Metetra
.519 0 0 r
.42916 .62103 .44 .61786 .45783 .62369 .4471 .62694 Metetra
.484 0 0 r
.4471 .62694 .45783 .62369 .47591 .62865 .46529 .63197 Metetra
.446 0 0 r
.46529 .63197 .47591 .62865 .49424 .63272 .48374 .63611 Metetra
.404 0 0 r
.48374 .63611 .49424 .63272 .51279 .6359 .50241 .63933 Metetra
.358 0 0 r
.50241 .63933 .51279 .6359 .53156 .63815 .52132 .64163 Metetra
.308 0 0 r
.52132 .64163 .53156 .63815 .55053 .63946 .54043 .64297 Metetra
.254 0 0 r
.54043 .64297 .55053 .63946 .5697 .63982 .55975 .64335 Metetra
.197 0 0 r
.55975 .64335 .5697 .63982 .58905 .6392 .57925 .64275 Metetra
.137 0 0 r
.57925 .64275 .58905 .6392 .60857 .6376 .59893 .64115 Metetra
.075 0 0 r
.59893 .64115 .60857 .6376 .62823 .63501 .61876 .63854 Metetra
.01 0 0 r
.61876 .63854 .62823 .63501 .64804 .6314 .63874 .63491 Metetra
.63874 .63491 .64804 .6314 .66796 .62678 .65884 .63025 Metetra
.65884 .63025 .66796 .62678 .688 .62113 .67905 .62456 Metetra
.67905 .62456 .688 .62113 .70812 .61445 .69936 .61782 Metetra
.69936 .61782 .70812 .61445 .72831 .60674 .71975 .61003 Metetra
.312 .785 .684 r
.71975 .61003 .72831 .60674 .74857 .59798 .74019 .60119 Metetra
.371 .822 .705 r
.74019 .60119 .74857 .59798 .76886 .58819 .76068 .5913 Metetra
.426 .854 .722 r
.76068 .5913 .76886 .58819 .78917 .57736 .7812 .58036 Metetra
.477 .882 .736 r
.7812 .58036 .78917 .57736 .80949 .5655 .80172 .56837 Metetra
.524 .906 .746 r
.80172 .56837 .80949 .5655 .82979 .5526 .82223 .55534 Metetra
.567 .925 .752 r
.82223 .55534 .82979 .5526 .85006 .53868 .84272 .54127 Metetra
.607 .942 .756 r
.84272 .54127 .85006 .53868 .87029 .52374 .86315 .52617 Metetra
.643 .955 .758 r
.86315 .52617 .87029 .52374 .89044 .5078 .88352 .51006 Metetra
.675 .965 .757 r
.88352 .51006 .89044 .5078 .91051 .49087 .90381 .49294 Metetra
.704 .973 .755 r
.90381 .49294 .91051 .49087 .93048 .47295 .92399 .47483 Metetra
.73 .979 .751 r
.92399 .47483 .93048 .47295 .95032 .45407 .94406 .45574 Metetra
.753 .983 .746 r
.94406 .45574 .95032 .45407 .97003 .43424 .96398 .4357 Metetra
.567 .023 0 r
.38286 .60882 .39408 .6067 .41148 .61428 .40035 .61649 Metetra
.535 0 0 r
.40035 .61649 .41148 .61428 .42916 .62103 .41812 .62332 Metetra
.499 0 0 r
.41812 .62332 .42916 .62103 .4471 .62694 .43616 .6293 Metetra
.46 0 0 r
.43616 .6293 .4471 .62694 .46529 .63197 .45447 .6344 Metetra
.417 0 0 r
.45447 .6344 .46529 .63197 .48374 .63611 .47303 .63859 Metetra
.37 0 0 r
.47303 .63859 .48374 .63611 .50241 .63933 .49183 .64187 Metetra
.318 0 0 r
.49183 .64187 .50241 .63933 .52132 .64163 .51087 .6442 Metetra
.263 0 0 r
.51087 .6442 .52132 .64163 .54043 .64297 .53012 .64557 Metetra
.203 0 0 r
.53012 .64557 .54043 .64297 .55975 .64335 .54958 .64597 Metetra
.14 0 0 r
.54958 .64597 .55975 .64335 .57925 .64275 .56923 .64537 Metetra
.074 0 0 r
.56923 .64537 .57925 .64275 .59893 .64115 .58906 .64377 Metetra
.007 0 0 r
.58906 .64377 .59893 .64115 .61876 .63854 .60906 .64114 Metetra
.60906 .64114 .61876 .63854 .63874 .63491 .6292 .63749 Metetra
.6292 .63749 .63874 .63491 .65884 .63025 .64948 .63279 Metetra
.2 .719 .69 r
.64948 .63279 .65884 .63025 .67905 .62456 .66987 .62704 Metetra
.266 .765 .719 r
.66987 .62704 .67905 .62456 .69936 .61782 .69036 .62024 Metetra
.329 .806 .744 r
.69036 .62024 .69936 .61782 .71975 .61003 .71094 .61238 Metetra
.389 .843 .765 r
.71094 .61238 .71975 .61003 .74019 .60119 .73158 .60345 Metetra
.445 .875 .781 r
.73158 .60345 .74019 .60119 .76068 .5913 .75226 .59346 Metetra
.497 .902 .794 r
.75226 .59346 .76068 .5913 .7812 .58036 .77298 .58241 Metetra
.545 .924 .802 r
.77298 .58241 .7812 .58036 .80172 .56837 .7937 .5703 Metetra
.588 .943 .807 r
.7937 .5703 .80172 .56837 .82223 .55534 .81442 .55713 Metetra
.628 .958 .81 r
.81442 .55713 .82223 .55534 .84272 .54127 .83511 .54291 Metetra
.663 .97 .809 r
.83511 .54291 .84272 .54127 .86315 .52617 .85576 .52766 Metetra
.695 .979 .807 r
.85576 .52766 .86315 .52617 .88352 .51006 .87634 .51137 Metetra
.723 .986 .803 r
.87634 .51137 .88352 .51006 .90381 .49294 .89685 .49407 Metetra
.749 .991 .798 r
.89685 .49407 .90381 .49294 .92399 .47483 .91724 .47576 Metetra
.772 .994 .791 r
.91724 .47576 .92399 .47483 .94406 .45574 .93753 .45647 Metetra
.792 .996 .784 r
.93753 .45647 .94406 .45574 .96398 .4357 .95767 .43621 Metetra
.551 0 0 r
.37147 .61004 .38286 .60882 .40035 .61649 .38904 .61779 Metetra
.515 0 0 r
.38904 .61779 .40035 .61649 .41812 .62332 .4069 .6247 Metetra
.475 0 0 r
.4069 .6247 .41812 .62332 .43616 .6293 .42504 .63075 Metetra
.431 0 0 r
.42504 .63075 .43616 .6293 .45447 .6344 .44345 .6359 Metetra
.382 0 0 r
.44345 .6359 .45447 .6344 .47303 .63859 .46213 .64015 Metetra
.329 0 0 r
.46213 .64015 .47303 .63859 .49183 .64187 .48105 .64346 Metetra
.271 0 0 r
.48105 .64346 .49183 .64187 .51087 .6442 .50021 .64583 Metetra
.21 0 0 r
.50021 .64583 .51087 .6442 .53012 .64557 .5196 .64722 Metetra
.144 0 0 r
.5196 .64722 .53012 .64557 .54958 .64597 .5392 .64763 Metetra
.076 0 0 r
.5392 .64763 .54958 .64597 .56923 .64537 .559 .64704 Metetra
.005 0 0 r
.559 .64704 .56923 .64537 .58906 .64377 .57898 .64543 Metetra
.57898 .64543 .58906 .64377 .60906 .64114 .59913 .64278 Metetra
.138 .681 .71 r
.59913 .64278 .60906 .64114 .6292 .63749 .61944 .6391 Metetra
.209 .732 .745 r
.61944 .6391 .6292 .63749 .64948 .63279 .63989 .63436 Metetra
.277 .779 .775 r
.63989 .63436 .64948 .63279 .66987 .62704 .66045 .62856 Metetra
.342 .82 .8 r
.66045 .62856 .66987 .62704 .69036 .62024 .68113 .62169 Metetra
.403 .857 .819 r
.68113 .62169 .69036 .62024 .71094 .61238 .70189 .61375 Metetra
.46 .888 .834 r
.70189 .61375 .71094 .61238 .73158 .60345 .72271 .60474 Metetra
.513 .914 .845 r
.72271 .60474 .73158 .60345 .75226 .59346 .74359 .59464 Metetra
.56 .935 .852 r
.74359 .59464 .75226 .59346 .77298 .58241 .76451 .58348 Metetra
.603 .953 .856 r
.76451 .58348 .77298 .58241 .7937 .5703 .78544 .57124 Metetra
.642 .967 .856 r
.78544 .57124 .7937 .5703 .81442 .55713 .80636 .55794 Metetra
.677 .978 .854 r
.80636 .55794 .81442 .55713 .83511 .54291 .82726 .54357 Metetra
.709 .986 .85 r
.82726 .54357 .83511 .54291 .85576 .52766 .84811 .52815 Metetra
.737 .992 .845 r
.84811 .52815 .85576 .52766 .87634 .51137 .86891 .5117 Metetra
.762 .996 .838 r
.86891 .5117 .87634 .51137 .89685 .49407 .88962 .49421 Metetra
.784 .999 .83 r
.88962 .49421 .89685 .49407 .91724 .47576 .91024 .47571 Metetra
.804 1 .822 r
.91024 .47571 .91724 .47576 .93753 .45647 .93073 .45622 Metetra
.822 1 .813 r
.93073 .45622 .93753 .45647 .95767 .43621 .95109 .43574 Metetra
.53 0 0 r
.3599 .61034 .37147 .61004 .38904 .61779 .37755 .61816 Metetra
.49 0 0 r
.37755 .61816 .38904 .61779 .4069 .6247 .3955 .62514 Metetra
.445 0 0 r
.3955 .62514 .4069 .6247 .42504 .63075 .41373 .63125 Metetra
.395 0 0 r
.41373 .63125 .42504 .63075 .44345 .6359 .43225 .63646 Metetra
.34 0 0 r
.43225 .63646 .44345 .6359 .46213 .64015 .45103 .64075 Metetra
.281 0 0 r
.45103 .64075 .46213 .64015 .48105 .64346 .47007 .6441 Metetra
.217 0 0 r
.47007 .6441 .48105 .64346 .50021 .64583 .48935 .64649 Metetra
.15 0 0 r
.48935 .64649 .50021 .64583 .5196 .64722 .50887 .64791 Metetra
.079 0 0 r
.50887 .64791 .5196 .64722 .5392 .64763 .5286 .64832 Metetra
.006 0 0 r
.5286 .64832 .5392 .64763 .559 .64704 .54854 .64772 Metetra
.069 .631 .719 r
.54854 .64772 .559 .64704 .57898 .64543 .56868 .6461 Metetra
.142 .688 .759 r
.56868 .6461 .57898 .64543 .59913 .64278 .58898 .64343 Metetra
.215 .739 .794 r
.58898 .64343 .59913 .64278 .61944 .6391 .60945 .63971 Metetra
.285 .786 .824 r
.60945 .63971 .61944 .6391 .63989 .63436 .63006 .63493 Metetra
.351 .827 .848 r
.63006 .63493 .63989 .63436 .66045 .62856 .6508 .62907 Metetra
.413 .862 .867 r
.6508 .62907 .66045 .62856 .68113 .62169 .67165 .62213 Metetra
.47 .893 .88 r
.67165 .62213 .68113 .62169 .70189 .61375 .69259 .61412 Metetra
.522 .918 .889 r
.69259 .61412 .70189 .61375 .72271 .60474 .71361 .60501 Metetra
.57 .938 .895 r
.71361 .60501 .72271 .60474 .74359 .59464 .73468 .59482 Metetra
.613 .955 .896 r
.73468 .59482 .74359 .59464 .76451 .58348 .75579 .58354 Metetra
.651 .968 .895 r
.75579 .58354 .76451 .58348 .78544 .57124 .77691 .57117 Metetra
.686 .978 .892 r
.77691 .57117 .78544 .57124 .80636 .55794 .79804 .55773 Metetra
.717 .985 .887 r
.79804 .55773 .80636 .55794 .82726 .54357 .81914 .54322 Metetra
.744 .991 .88 r
.81914 .54322 .82726 .54357 .84811 .52815 .84021 .52764 Metetra
.769 .994 .872 r
.84021 .52764 .84811 .52815 .86891 .5117 .86121 .51101 Metetra
.791 .996 .863 r
.86121 .51101 .86891 .5117 .88962 .49421 .88213 .49335 Metetra
.81 .997 .854 r
.88213 .49335 .88962 .49421 .91024 .47571 .90296 .47466 Metetra
.828 .997 .844 r
.90296 .47466 .91024 .47571 .93073 .45622 .92367 .45496 Metetra
.843 .996 .834 r
.92367 .45496 .93073 .45622 .95109 .43574 .94424 .43428 Metetra
.504 0 0 r
.34816 .60969 .3599 .61034 .37755 .61816 .36589 .61758 Metetra
.459 0 0 r
.36589 .61758 .37755 .61816 .3955 .62514 .38392 .62462 Metetra
.408 0 0 r
.38392 .62462 .3955 .62514 .41373 .63125 .40224 .63078 Metetra
.352 0 0 r
.40224 .63078 .41373 .63125 .43225 .63646 .42085 .63603 Metetra
.292 0 0 r
.42085 .63603 .43225 .63646 .45103 .64075 .43974 .64036 Metetra
.226 0 0 r
.43974 .64036 .45103 .64075 .47007 .6441 .45889 .64374 Metetra
.156 0 0 r
.45889 .64374 .47007 .6441 .48935 .64649 .47829 .64616 Metetra
.083 0 0 r
.47829 .64616 .48935 .64649 .50887 .64791 .49793 .64758 Metetra
0 .57 .715 r
.49793 .64758 .50887 .64791 .5286 .64832 .5178 .648 Metetra
.068 .631 .761 r
.5178 .648 .5286 .64832 .54854 .64772 .53788 .6474 Metetra
.143 .687 .801 r
.53788 .6474 .54854 .64772 .56868 .6461 .55815 .64575 Metetra
.217 .739 .837 r
.55815 .64575 .56868 .6461 .58898 .64343 .57861 .64306 Metetra
.288 .785 .866 r
.57861 .64306 .58898 .64343 .60945 .63971 .59924 .6393 Metetra
.355 .826 .889 r
.59924 .6393 .60945 .63971 .63006 .63493 .62001 .63447 Metetra
.417 .86 .906 r
.62001 .63447 .63006 .63493 .6508 .62907 .64092 .62855 Metetra
.474 .89 .918 r
.64092 .62855 .6508 .62907 .67165 .62213 .66194 .62154 Metetra
.526 .914 .926 r
.66194 .62154 .67165 .62213 .69259 .61412 .68306 .61344 Metetra
.574 .934 .929 r
.68306 .61344 .69259 .61412 .71361 .60501 .70426 .60424 Metetra
.616 .95 .93 r
.70426 .60424 .71361 .60501 .73468 .59482 .72552 .59395 Metetra
.654 .962 .927 r
.72552 .59395 .73468 .59482 .75579 .58354 .74682 .58255 Metetra
.688 .971 .923 r
.74682 .58255 .75579 .58354 .77691 .57117 .76814 .57006 Metetra
.719 .978 .916 r
.76814 .57006 .77691 .57117 .79804 .55773 .78947 .55648 Metetra
.746 .983 .908 r
.78947 .55648 .79804 .55773 .81914 .54322 .81077 .54182 Metetra
.77 .986 .9 r
.81077 .54182 .81914 .54322 .84021 .52764 .83204 .52608 Metetra
.792 .988 .89 r
.83204 .52608 .84021 .52764 .86121 .51101 .85325 .50928 Metetra
.811 .989 .88 r
.85325 .50928 .86121 .51101 .88213 .49335 .87438 .49144 Metetra
.828 .989 .869 r
.87438 .49144 .88213 .49335 .90296 .47466 .89542 .47256 Metetra
.844 .988 .858 r
.89542 .47256 .90296 .47466 .92367 .45496 .91634 .45266 Metetra
.858 .987 .847 r
.91634 .45266 .92367 .45496 .94424 .43428 .93713 .43177 Metetra
.473 0 0 r
.33626 .60806 .34816 .60969 .36589 .61758 .35405 .61602 Metetra
.421 0 0 r
.35405 .61602 .36589 .61758 .38392 .62462 .37216 .62311 Metetra
.364 0 0 r
.37216 .62311 .38392 .62462 .40224 .63078 .39057 .62931 Metetra
.303 0 0 r
.39057 .62931 .40224 .63078 .42085 .63603 .40928 .63461 Metetra
.236 0 0 r
.40928 .63461 .42085 .63603 .43974 .64036 .42826 .63897 Metetra
.164 0 0 r
.42826 .63897 .43974 .64036 .45889 .64374 .44752 .64237 Metetra
.09 0 0 r
.44752 .64237 .45889 .64374 .47829 .64616 .46703 .6448 Metetra
0 .563 .75 r
.46703 .6448 .47829 .64616 .49793 .64758 .4868 .64623 Metetra
.064 .624 .796 r
.4868 .64623 .49793 .64758 .5178 .648 .50679 .64664 Metetra
.141 .68 .837 r
.50679 .64664 .5178 .648 .53788 .6474 .527 .64602 Metetra
.215 .732 .871 r
.527 .64602 .53788 .6474 .55815 .64575 .54742 .64436 Metetra
.287 .777 .899 r
.54742 .64436 .55815 .64575 .57861 .64306 .56802 .64163 Metetra
.354 .817 .921 r
.56802 .64163 .57861 .64306 .59924 .6393 .5888 .63783 Metetra
.416 .851 .937 r
.5888 .63783 .59924 .6393 .62001 .63447 .60974 .63294 Metetra
.474 .88 .948 r
.60974 .63294 .62001 .63447 .64092 .62855 .63081 .62696 Metetra
.526 .903 .954 r
.63081 .62696 .64092 .62855 .66194 .62154 .652 .61988 Metetra
.572 .922 .957 r
.652 .61988 .66194 .62154 .68306 .61344 .67329 .6117 Metetra
.615 .938 .956 r
.67329 .6117 .68306 .61344 .70426 .60424 .69467 .6024 Metetra
.652 .95 .952 r
.69467 .6024 .70426 .60424 .72552 .59395 .71612 .592 Metetra
.686 .959 .946 r
.71612 .592 .72552 .59395 .74682 .58255 .7376 .58049 Metetra
.716 .965 .939 r
.7376 .58049 .74682 .58255 .76814 .57006 .75912 .56787 Metetra
.743 .97 .93 r
.75912 .56787 .76814 .57006 .78947 .55648 .78064 .55415 Metetra
.767 .973 .921 r
.78064 .55415 .78947 .55648 .81077 .54182 .80214 .53934 Metetra
.788 .975 .911 r
.80214 .53934 .81077 .54182 .83204 .52608 .82361 .52345 Metetra
.807 .976 .9 r
.82361 .52345 .83204 .52608 .85325 .50928 .84503 .50648 Metetra
.824 .976 .889 r
.84503 .50648 .85325 .50928 .87438 .49144 .86637 .48846 Metetra
.84 .976 .878 r
.86637 .48846 .87438 .49144 .89542 .47256 .88761 .46939 Metetra
.854 .974 .867 r
.88761 .46939 .89542 .47256 .91634 .45266 .90874 .4493 Metetra
.866 .973 .856 r
.90874 .4493 .91634 .45266 .93713 .43177 .92974 .4282 Metetra
.434 0 0 r
.3242 .60544 .33626 .60806 .35405 .61602 .34206 .61344 Metetra
.377 0 0 r
.34206 .61344 .35405 .61602 .37216 .62311 .36024 .62058 Metetra
.314 0 0 r
.36024 .62058 .37216 .62311 .39057 .62931 .37873 .62682 Metetra
.246 0 0 r
.37873 .62682 .39057 .62931 .40928 .63461 .39752 .63214 Metetra
.174 0 0 r
.39752 .63214 .40928 .63461 .42826 .63897 .4166 .63653 Metetra
0 .487 .726 r
.4166 .63653 .42826 .63897 .44752 .64237 .43596 .63995 Metetra
0 .551 .777 r
.43596 .63995 .44752 .64237 .46703 .6448 .45559 .64238 Metetra
.058 .611 .824 r
.45559 .64238 .46703 .6448 .4868 .64623 .47546 .64381 Metetra
.135 .667 .864 r
.47546 .64381 .4868 .64623 .50679 .64664 .49558 .64422 Metetra
.21 .718 .898 r
.49558 .64422 .50679 .64664 .527 .64602 .51592 .64358 Metetra
.282 .763 .925 r
.51592 .64358 .527 .64602 .54742 .64436 .53647 .64189 Metetra
.349 .802 .946 r
.53647 .64189 .54742 .64436 .56802 .64163 .55722 .63912 Metetra
.411 .835 .961 r
.55722 .63912 .56802 .64163 .5888 .63783 .57815 .63528 Metetra
.468 .863 .97 r
.57815 .63528 .5888 .63783 .60974 .63294 .59923 .63033 Metetra
.52 .887 .975 r
.59923 .63033 .60974 .63294 .63081 .62696 .62047 .62429 Metetra
.566 .905 .976 r
.62047 .62429 .63081 .62696 .652 .61988 .64182 .61713 Metetra
.608 .92 .974 r
.64182 .61713 .652 .61988 .67329 .6117 .66329 .60886 Metetra
.646 .932 .97 r
.66329 .60886 .67329 .6117 .69467 .6024 .68484 .59946 Metetra
.679 .941 .964 r
.68484 .59946 .69467 .6024 .71612 .592 .70647 .58895 Metetra
.709 .948 .956 r
.70647 .58895 .71612 .592 .7376 .58049 .72814 .57732 Metetra
.735 .953 .947 r
.72814 .57732 .7376 .58049 .75912 .56787 .74984 .56458 Metetra
.759 .956 .937 r
.74984 .56458 .75912 .56787 .78064 .55415 .77156 .55072 Metetra
.781 .958 .926 r
.77156 .55072 .78064 .55415 .80214 .53934 .79326 .53576 Metetra
.8 .959 .916 r
.79326 .53576 .80214 .53934 .82361 .52345 .81492 .51971 Metetra
.817 .96 .904 r
.81492 .51971 .82361 .52345 .84503 .50648 .83654 .50258 Metetra
.832 .96 .893 r
.83654 .50258 .84503 .50648 .86637 .48846 .85808 .48438 Metetra
.846 .959 .882 r
.85808 .48438 .86637 .48846 .88761 .46939 .87953 .46512 Metetra
.859 .958 .871 r
.87953 .46512 .88761 .46939 .90874 .4493 .90087 .44484 Metetra
.871 .956 .86 r
.90087 .44484 .90874 .4493 .92974 .4282 .92207 .42354 Metetra
.389 0 0 r
.31198 .60179 .3242 .60544 .34206 .61344 .32991 .60984 Metetra
.326 0 0 r
.32991 .60984 .34206 .61344 .36024 .62058 .34816 .61701 Metetra
.257 0 0 r
.34816 .61701 .36024 .62058 .37873 .62682 .36673 .62328 Metetra
0 .405 .691 r
.36673 .62328 .37873 .62682 .39752 .63214 .3856 .62862 Metetra
0 .47 .747 r
.3856 .62862 .39752 .63214 .4166 .63653 .40477 .63302 Metetra
0 .533 .798 r
.40477 .63302 .4166 .63653 .43596 .63995 .42422 .63645 Metetra
.049 .593 .844 r
.42422 .63645 .43596 .63995 .45559 .64238 .44395 .63889 Metetra
.127 .648 .884 r
.44395 .63889 .45559 .64238 .47546 .64381 .46394 .64031 Metetra
.202 .698 .917 r
.46394 .64031 .47546 .64381 .49558 .64422 .48417 .6407 Metetra
.273 .743 .943 r
.48417 .6407 .49558 .64422 .51592 .64358 .50464 .64004 Metetra
.34 .781 .963 r
.50464 .64004 .51592 .64358 .53647 .64189 .52532 .63831 Metetra
.402 .814 .976 r
.52532 .63831 .53647 .64189 .55722 .63912 .5462 .6355 Metetra
.459 .842 .985 r
.5462 .6355 .55722 .63912 .57815 .63528 .56727 .6316 Metetra
.51 .865 .989 r
.56727 .6316 .57815 .63528 .59923 .63033 .58851 .6266 Metetra
.556 .883 .99 r
.58851 .6266 .59923 .63033 .62047 .62429 .6099 .62048 Metetra
.598 .898 .987 r
.6099 .62048 .62047 .62429 .64182 .61713 .63142 .61325 Metetra
.635 .91 .982 r
.63142 .61325 .64182 .61713 .66329 .60886 .65305 .60488 Metetra
.668 .919 .975 r
.65305 .60488 .66329 .60886 .68484 .59946 .67478 .59539 Metetra
.698 .926 .967 r
.67478 .59539 .68484 .59946 .70647 .58895 .69658 .58477 Metetra
.725 .932 .958 r
.69658 .58477 .70647 .58895 .72814 .57732 .71843 .57302 Metetra
.748 .935 .948 r
.71843 .57302 .72814 .57732 .74984 .56458 .74032 .56015 Metetra
.77 .938 .937 r
.74032 .56015 .74984 .56458 .77156 .55072 .76222 .54615 Metetra
.789 .94 .926 r
.76222 .54615 .77156 .55072 .79326 .53576 .78411 .53105 Metetra
.806 .941 .915 r
.78411 .53105 .79326 .53576 .81492 .51971 .80598 .51484 Metetra
.822 .941 .904 r
.80598 .51484 .81492 .51971 .83654 .50258 .82779 .49754 Metetra
.836 .941 .893 r
.82779 .49754 .83654 .50258 .85808 .48438 .84954 .47916 Metetra
.849 .94 .882 r
.84954 .47916 .85808 .48438 .87953 .46512 .87119 .45973 Metetra
.861 .939 .871 r
.87119 .45973 .87953 .46512 .90087 .44484 .89273 .43925 Metetra
.872 .938 .86 r
.89273 .43925 .90087 .44484 .92207 .42354 .91414 .41775 Metetra
.338 0 0 r
.29963 .5971 .31198 .60179 .32991 .60984 .31761 .60518 Metetra
.269 0 0 r
.31761 .60518 .32991 .60984 .34816 .61701 .33592 .61237 Metetra
0 .384 .705 r
.33592 .61237 .34816 .61701 .36673 .62328 .35456 .61866 Metetra
0 .449 .761 r
.35456 .61866 .36673 .62328 .3856 .62862 .37351 .62402 Metetra
0 .511 .812 r
.37351 .62402 .3856 .62862 .40477 .63302 .39276 .62843 Metetra
.038 .57 .858 r
.39276 .62843 .40477 .63302 .42422 .63645 .41231 .63185 Metetra
.116 .625 .896 r
.41231 .63185 .42422 .63645 .44395 .63889 .43213 .63428 Metetra
.191 .674 .928 r
.43213 .63428 .44395 .63889 .46394 .64031 .45222 .63569 Metetra
.262 .718 .954 r
.45222 .63569 .46394 .64031 .48417 .6407 .47257 .63606 Metetra
.328 .756 .973 r
.47257 .63606 .48417 .6407 .50464 .64004 .49316 .63537 Metetra
.39 .789 .986 r
.49316 .63537 .50464 .64004 .52532 .63831 .51397 .6336 Metetra
.446 .816 .993 r
.51397 .6336 .52532 .63831 .5462 .6355 .53498 .63075 Metetra
.497 .839 .997 r
.53498 .63075 .5462 .6355 .56727 .6316 .55619 .62679 Metetra
.543 .858 .997 r
.55619 .62679 .56727 .6316 .58851 .6266 .57757 .62172 Metetra
.584 .873 .994 r
.57757 .62172 .58851 .6266 .6099 .62048 .59911 .61553 Metetra
.621 .885 .989 r
.59911 .61553 .6099 .62048 .63142 .61325 .62079 .60821 Metetra
.654 .895 .982 r
.62079 .60821 .63142 .61325 .65305 .60488 .64258 .59976 Metetra
.684 .902 .974 r
.64258 .59976 .65305 .60488 .67478 .59539 .66448 .59016 Metetra
.711 .908 .964 r
.66448 .59016 .67478 .59539 .69658 .58477 .68645 .57943 Metetra
.735 .912 .955 r
.68645 .57943 .69658 .58477 .71843 .57302 .70848 .56756 Metetra
.756 .916 .944 r
.70848 .56756 .71843 .57302 .74032 .56015 .73055 .55456 Metetra
.776 .918 .934 r
.73055 .55456 .74032 .56015 .76222 .54615 .75264 .54042 Metetra
.793 .92 .923 r
.75264 .54042 .76222 .54615 .78411 .53105 .77472 .52517 Metetra
.809 .92 .912 r
.77472 .52517 .78411 .53105 .80598 .51484 .79677 .5088 Metetra
.823 .921 .901 r
.79677 .5088 .80598 .51484 .82779 .49754 .81878 .49134 Metetra
.837 .921 .89 r
.81878 .49134 .82779 .49754 .84954 .47916 .84072 .47279 Metetra
.849 .92 .879 r
.84072 .47279 .84954 .47916 .87119 .45973 .86258 .45318 Metetra
.86 .92 .869 r
.86258 .45318 .87119 .45973 .89273 .43925 .88432 .43251 Metetra
.87 .919 .858 r
.88432 .43251 .89273 .43925 .91414 .41775 .90593 .41081 Metetra
0 .296 .655 r
.28714 .59134 .29963 .5971 .31761 .60518 .30517 .59943 Metetra
0 .361 .714 r
.30517 .59943 .31761 .60518 .33592 .61237 .32354 .60665 Metetra
0 .425 .769 r
.32354 .60665 .33592 .61237 .35456 .61866 .34224 .61295 Metetra
0 .486 .82 r
.34224 .61295 .35456 .61866 .37351 .62402 .36126 .61831 Metetra
.026 .544 .865 r
.36126 .61831 .37351 .62402 .39276 .62843 .38059 .62271 Metetra
.103 .598 .903 r
.38059 .62271 .39276 .62843 .41231 .63185 .40022 .62613 Metetra
.177 .647 .934 r
.40022 .62613 .41231 .63185 .43213 .63428 .42014 .62855 Metetra
.248 .69 .958 r
.42014 .62855 .43213 .63428 .45222 .63569 .44033 .62993 Metetra
.314 .728 .976 r
.44033 .62993 .45222 .63569 .47257 .63606 .46078 .63027 Metetra
.375 .76 .989 r
.46078 .63027 .47257 .63606 .49316 .63537 .48148 .62954 Metetra
.43 .788 .996 r
.48148 .62954 .49316 .63537 .51397 .6336 .50241 .62773 Metetra
.481 .811 1 r
.50241 .62773 .51397 .6336 .53498 .63075 .52356 .62483 Metetra
.527 .83 1 r
.52356 .62483 .53498 .63075 .55619 .62679 .5449 .62081 Metetra
.568 .845 .997 r
.5449 .62081 .55619 .62679 .57757 .62172 .56642 .61567 Metetra
.605 .858 .991 r
.56642 .61567 .57757 .62172 .59911 .61553 .58811 .6094 Metetra
.638 .868 .985 r
.58811 .6094 .59911 .61553 .62079 .60821 .60994 .60199 Metetra
.668 .876 .977 r
.60994 .60199 .62079 .60821 .64258 .59976 .63189 .59344 Metetra
.695 .883 .968 r
.63189 .59344 .64258 .59976 .66448 .59016 .65395 .58375 Metetra
.719 .888 .958 r
.65395 .58375 .66448 .59016 .68645 .57943 .67609 .5729 Metetra
.741 .892 .948 r
.67609 .5729 .68645 .57943 .70848 .56756 .69829 .56091 Metetra
.76 .895 .938 r
.69829 .56091 .70848 .56756 .73055 .55456 .72054 .54777 Metetra
.778 .897 .927 r
.72054 .54777 .73055 .55456 .75264 .54042 .7428 .5335 Metetra
.794 .898 .916 r
.7428 .5335 .75264 .54042 .77472 .52517 .76507 .5181 Metetra
.809 .899 .906 r
.76507 .5181 .77472 .52517 .79677 .5088 .78731 .50158 Metetra
.822 .9 .895 r
.78731 .50158 .79677 .5088 .81878 .49134 .80951 .48396 Metetra
.835 .9 .885 r
.80951 .48396 .81878 .49134 .84072 .47279 .83165 .46524 Metetra
.846 .9 .875 r
.83165 .46524 .84072 .47279 .86258 .45318 .85369 .44544 Metetra
.857 .9 .865 r
.85369 .44544 .86258 .45318 .88432 .43251 .87563 .42459 Metetra
.866 .9 .855 r
.87563 .42459 .88432 .43251 .90593 .41081 .89744 .40271 Metetra
0 .335 .718 r
.27451 .58448 .28714 .59134 .30517 .59943 .29259 .59259 Metetra
0 .398 .772 r
.29259 .59259 .30517 .59943 .32354 .60665 .31101 .59981 Metetra
0 .458 .822 r
.31101 .59981 .32354 .60665 .34224 .61295 .32977 .60611 Metetra
.011 .515 .866 r
.32977 .60611 .34224 .61295 .36126 .61831 .34885 .61147 Metetra
.088 .568 .903 r
.34885 .61147 .36126 .61831 .38059 .62271 .36826 .61586 Metetra
.161 .616 .934 r
.36826 .61586 .38059 .62271 .40022 .62613 .38797 .61927 Metetra
.231 .659 .958 r
.38797 .61927 .40022 .62613 .42014 .62855 .40798 .62166 Metetra
.297 .697 .975 r
.40798 .62166 .42014 .62855 .44033 .62993 .42826 .62301 Metetra
.357 .729 .987 r
.42826 .62301 .44033 .62993 .46078 .63027 .44882 .62331 Metetra
.413 .757 .995 r
.44882 .62331 .46078 .63027 .48148 .62954 .46963 .62254 Metetra
.463 .78 .998 r
.46963 .62254 .48148 .62954 .50241 .62773 .49067 .62068 Metetra
.509 .799 .998 r
.49067 .62068 .50241 .62773 .52356 .62483 .51194 .61772 Metetra
.55 .816 .995 r
.51194 .61772 .52356 .62483 .5449 .62081 .53341 .61363 Metetra
.587 .829 .99 r
.53341 .61363 .5449 .62081 .56642 .61567 .55507 .60842 Metetra
.62 .84 .984 r
.55507 .60842 .56642 .61567 .58811 .6094 .57689 .60207 Metetra
.65 .849 .976 r
.57689 .60207 .58811 .6094 .60994 .60199 .59887 .59457 Metetra
.677 .856 .968 r
.59887 .59457 .60994 .60199 .63189 .59344 .62097 .58592 Metetra
.701 .862 .958 r
.62097 .58592 .63189 .59344 .65395 .58375 .64319 .57612 Metetra
.723 .867 .949 r
.64319 .57612 .65395 .58375 .67609 .5729 .66549 .56516 Metetra
.743 .87 .939 r
.66549 .56516 .67609 .5729 .69829 .56091 .68786 .55304 Metetra
.761 .873 .929 r
.68786 .55304 .69829 .56091 .72054 .54777 .71028 .53978 Metetra
.778 .875 .919 r
.71028 .53978 .72054 .54777 .7428 .5335 .73272 .52537 Metetra
.793 .877 .908 r
.73272 .52537 .7428 .5335 .76507 .5181 .75517 .50982 Metetra
.807 .878 .898 r
.75517 .50982 .76507 .5181 .78731 .50158 .7776 .49315 Metetra
.82 .879 .888 r
.7776 .49315 .78731 .50158 .80951 .48396 .79998 .47536 Metetra
.831 .88 .879 r
.79998 .47536 .80951 .48396 .83165 .46524 .82231 .45647 Metetra
.842 .88 .869 r
.82231 .45647 .83165 .46524 .85369 .44544 .84455 .4365 Metetra
.852 .881 .859 r
.84455 .4365 .85369 .44544 .87563 .42459 .86668 .41547 Metetra
.862 .881 .85 r
.86668 .41547 .87563 .42459 .89744 .40271 .88868 .3934 Metetra
0 .369 .771 r
.26177 .57652 .27451 .58448 .29259 .59259 .27988 .58463 Metetra
0 .428 .819 r
.27988 .58463 .29259 .59259 .31101 .59981 .29835 .59184 Metetra
0 .484 .862 r
.29835 .59184 .31101 .59981 .32977 .60611 .31716 .59813 Metetra
.071 .537 .899 r
.31716 .59813 .32977 .60611 .34885 .61147 .33631 .60348 Metetra
.144 .584 .929 r
.33631 .60348 .34885 .61147 .36826 .61586 .35578 .60785 Metetra
.213 .627 .952 r
.35578 .60785 .36826 .61586 .38797 .61927 .37556 .61123 Metetra
.278 .664 .97 r
.37556 .61123 .38797 .61927 .40798 .62166 .39565 .61359 Metetra
.338 .696 .982 r
.39565 .61359 .40798 .62166 .42826 .62301 .41603 .61491 Metetra
.393 .724 .989 r
.41603 .61491 .42826 .62301 .44882 .62331 .43668 .61516 Metetra
.443 .748 .993 r
.43668 .61516 .44882 .62331 .46963 .62254 .45759 .61434 Metetra
.489 .768 .993 r
.45759 .61434 .46963 .62254 .49067 .62068 .47874 .61242 Metetra
.53 .785 .991 r
.47874 .61242 .49067 .62068 .51194 .61772 .50013 .60939 Metetra
.567 .799 .987 r
.50013 .60939 .51194 .61772 .53341 .61363 .52172 .60524 Metetra
.601 .811 .981 r
.52172 .60524 .53341 .61363 .55507 .60842 .54351 .59994 Metetra
.631 .821 .973 r
.54351 .59994 .55507 .60842 .57689 .60207 .56547 .59351 Metetra
.658 .829 .965 r
.56547 .59351 .57689 .60207 .59887 .59457 .58759 .58591 Metetra
.683 .835 .957 r
.58759 .58591 .59887 .59457 .62097 .58592 .60984 .57716 Metetra
.705 .841 .947 r
.60984 .57716 .62097 .58592 .64319 .57612 .6322 .56725 Metetra
.725 .845 .938 r
.6322 .56725 .64319 .57612 .66549 .56516 .65467 .55617 Metetra
.744 .849 .928 r
.65467 .55617 .66549 .56516 .68786 .55304 .6772 .54394 Metetra
.761 .852 .919 r
.6772 .54394 .68786 .55304 .71028 .53978 .69978 .53054 Metetra
.776 .854 .909 r
.69978 .53054 .71028 .53978 .73272 .52537 .7224 .51599 Metetra
.79 .856 .899 r
.7224 .51599 .73272 .52537 .75517 .50982 .74502 .5003 Metetra
.804 .858 .89 r
.74502 .5003 .75517 .50982 .7776 .49315 .76763 .48347 Metetra
.816 .859 .88 r
.76763 .48347 .7776 .49315 .79998 .47536 .7902 .46553 Metetra
.827 .86 .871 r
.7902 .46553 .79998 .47536 .82231 .45647 .81271 .44648 Metetra
.837 .861 .862 r
.81271 .44648 .82231 .45647 .84455 .4365 .83514 .42634 Metetra
.847 .861 .853 r
.83514 .42634 .84455 .4365 .86668 .41547 .85746 .40513 Metetra
.856 .862 .844 r
.85746 .40513 .86668 .41547 .88868 .3934 .87966 .38287 Metetra
0 .397 .813 r
.24891 .56743 .26177 .57652 .27988 .58463 .26706 .57553 Metetra
0 .452 .855 r
.26706 .57553 .27988 .58463 .29835 .59184 .28556 .58272 Metetra
.053 .504 .891 r
.28556 .58272 .29835 .59184 .31716 .59813 .30442 .589 Metetra
.125 .551 .92 r
.30442 .589 .31716 .59813 .33631 .60348 .32362 .59432 Metetra
.193 .593 .944 r
.32362 .59432 .33631 .60348 .35578 .60785 .34316 .59866 Metetra
.258 .63 .961 r
.34316 .59866 .35578 .60785 .37556 .61123 .36301 .602 Metetra
.317 .663 .973 r
.36301 .602 .37556 .61123 .39565 .61359 .38317 .60432 Metetra
.372 .691 .981 r
.38317 .60432 .39565 .61359 .41603 .61491 .40363 .60559 Metetra
.422 .716 .985 r
.40363 .60559 .41603 .61491 .43668 .61516 .42437 .6058 Metetra
.468 .736 .986 r
.42437 .6058 .43668 .61516 .45759 .61434 .44538 .60492 Metetra
.509 .754 .984 r
.44538 .60492 .45759 .61434 .47874 .61242 .46664 .60293 Metetra
.546 .769 .98 r
.46664 .60293 .47874 .61242 .50013 .60939 .48813 .59983 Metetra
.58 .781 .975 r
.48813 .59983 .50013 .60939 .52172 .60524 .50984 .5956 Metetra
.61 .792 .968 r
.50984 .5956 .52172 .60524 .54351 .59994 .53175 .59022 Metetra
.638 .801 .961 r
.53175 .59022 .54351 .59994 .56547 .59351 .55385 .5837 Metetra
.663 .808 .953 r
.55385 .5837 .56547 .59351 .58759 .58591 .5761 .57601 Metetra
.686 .815 .944 r
.5761 .57601 .58759 .58591 .60984 .57716 .59849 .56715 Metetra
.707 .82 .935 r
.59849 .56715 .60984 .57716 .6322 .56725 .621 .55713 Metetra
.725 .824 .926 r
.621 .55713 .6322 .56725 .65467 .55617 .64362 .54593 Metetra
.743 .828 .917 r
.64362 .54593 .65467 .55617 .6772 .54394 .66631 .53357 Metetra
.759 .831 .908 r
.66631 .53357 .6772 .54394 .69978 .53054 .68906 .52004 Metetra
.773 .834 .899 r
.68906 .52004 .69978 .53054 .7224 .51599 .71184 .50536 Metetra
.787 .836 .89 r
.71184 .50536 .7224 .51599 .74502 .5003 .73463 .48952 Metetra
.799 .838 .881 r
.73463 .48952 .74502 .5003 .76763 .48347 .75741 .47254 Metetra
.811 .84 .872 r
.75741 .47254 .76763 .48347 .7902 .46553 .78016 .45444 Metetra
.822 .841 .863 r
.78016 .45444 .7902 .46553 .81271 .44648 .80285 .43523 Metetra
.832 .842 .855 r
.80285 .43523 .81271 .44648 .83514 .42634 .82546 .41492 Metetra
.841 .843 .846 r
.82546 .41492 .83514 .42634 .85746 .40513 .84797 .39354 Metetra
.85 .844 .838 r
.84797 .39354 .85746 .40513 .87966 .38287 .87036 .37111 Metetra
0 .419 .844 r
.23595 .5572 .24891 .56743 .26706 .57553 .25412 .56527 Metetra
.034 .47 .879 r
.25412 .56527 .26706 .57553 .28556 .58272 .27266 .57244 Metetra
.105 .516 .909 r
.27266 .57244 .28556 .58272 .30442 .589 .29156 .57868 Metetra
.173 .558 .932 r
.29156 .57868 .30442 .589 .32362 .59432 .31081 .58396 Metetra
.236 .596 .95 r
.31081 .58396 .32362 .59432 .34316 .59866 .3304 .58827 Metetra
.296 .629 .962 r
.3304 .58827 .34316 .59866 .36301 .602 .35032 .59157 Metetra
.35 .658 .971 r
.35032 .59157 .36301 .602 .38317 .60432 .37055 .59383 Metetra
.4 .683 .975 r
.37055 .59383 .38317 .60432 .40363 .60559 .39109 .59505 Metetra
.446 .704 .977 r
.39109 .59505 .40363 .60559 .42437 .6058 .41191 .5952 Metetra
.487 .723 .975 r
.41191 .5952 .42437 .6058 .44538 .60492 .43301 .59425 Metetra
.525 .738 .972 r
.43301 .59425 .44538 .60492 .46664 .60293 .45436 .5922 Metetra
.559 .752 .968 r
.45436 .5922 .46664 .60293 .48813 .59983 .47596 .58902 Metetra
.59 .763 .962 r
.47596 .58902 .48813 .59983 .50984 .5956 .49778 .5847 Metetra
.617 .773 .955 r
.49778 .5847 .50984 .5956 .53175 .59022 .51981 .57924 Metetra
.643 .781 .948 r
.51981 .57924 .53175 .59022 .55385 .5837 .54203 .57261 Metetra
.666 .788 .94 r
.54203 .57261 .55385 .5837 .5761 .57601 .56441 .56482 Metetra
.687 .795 .931 r
.56441 .56482 .5761 .57601 .59849 .56715 .58694 .55586 Metetra
.706 .8 .923 r
.58694 .55586 .59849 .56715 .621 .55713 .60959 .54572 Metetra
.724 .804 .914 r
.60959 .54572 .621 .55713 .64362 .54593 .63235 .53441 Metetra
.74 .808 .906 r
.63235 .53441 .64362 .54593 .66631 .53357 .6552 .52192 Metetra
.755 .811 .897 r
.6552 .52192 .66631 .53357 .68906 .52004 .6781 .50826 Metetra
.769 .814 .888 r
.6781 .50826 .68906 .52004 .71184 .50536 .70104 .49344 Metetra
.782 .817 .88 r
.70104 .49344 .71184 .50536 .73463 .48952 .724 .47746 Metetra
.794 .819 .871 r
.724 .47746 .73463 .48952 .75741 .47254 .74695 .46033 Metetra
.805 .821 .863 r
.74695 .46033 .75741 .47254 .78016 .45444 .76988 .44207 Metetra
.816 .822 .855 r
.76988 .44207 .78016 .45444 .80285 .43523 .79274 .4227 Metetra
.826 .824 .847 r
.79274 .4227 .80285 .43523 .82546 .41492 .81553 .40223 Metetra
.835 .825 .839 r
.81553 .40223 .82546 .41492 .84797 .39354 .83822 .38068 Metetra
.843 .826 .831 r
.83822 .38068 .84797 .39354 .87036 .37111 .86079 .35808 Metetra
.014 .436 .866 r
.22289 .5458 .23595 .5572 .25412 .56527 .24108 .55384 Metetra
.084 .482 .895 r
.24108 .55384 .25412 .56527 .27266 .57244 .25965 .56097 Metetra
.151 .524 .918 r
.25965 .56097 .27266 .57244 .29156 .57868 .27859 .56717 Metetra
.214 .561 .936 r
.27859 .56717 .29156 .57868 .31081 .58396 .29788 .57241 Metetra
.273 .595 .949 r
.29788 .57241 .31081 .58396 .3304 .58827 .31752 .57666 Metetra
.327 .624 .958 r
.31752 .57666 .3304 .58827 .35032 .59157 .33749 .5799 Metetra
.377 .65 .963 r
.33749 .5799 .35032 .59157 .37055 .59383 .35779 .58211 Metetra
.423 .672 .965 r
.35779 .58211 .37055 .59383 .39109 .59505 .37839 .58327 Metetra
.465 .691 .965 r
.37839 .58327 .39109 .59505 .41191 .5952 .3993 .58334 Metetra
.502 .708 .963 r
.3993 .58334 .41191 .5952 .43301 .59425 .42048 .58233 Metetra
.537 .722 .959 r
.42048 .58233 .43301 .59425 .45436 .5922 .44193 .58019 Metetra
.568 .735 .954 r
.44193 .58019 .45436 .5922 .47596 .58902 .46362 .57693 Metetra
.596 .745 .948 r
.46362 .57693 .47596 .58902 .49778 .5847 .48555 .57253 Metetra
.622 .754 .941 r
.48555 .57253 .49778 .5847 .51981 .57924 .50769 .56697 Metetra
.646 .762 .934 r
.50769 .56697 .51981 .57924 .54203 .57261 .53002 .56024 Metetra
.667 .769 .926 r
.53002 .56024 .54203 .57261 .56441 .56482 .55253 .55235 Metetra
.687 .775 .918 r
.55253 .55235 .56441 .56482 .58694 .55586 .57519 .54327 Metetra
.705 .78 .91 r
.57519 .54327 .58694 .55586 .60959 .54572 .59798 .53302 Metetra
.722 .785 .902 r
.59798 .53302 .60959 .54572 .63235 .53441 .62088 .52158 Metetra
.737 .789 .894 r
.62088 .52158 .63235 .53441 .6552 .52192 .64387 .50897 Metetra
.752 .792 .886 r
.64387 .50897 .6552 .52192 .6781 .50826 .66692 .49517 Metetra
.765 .796 .878 r
.66692 .49517 .6781 .50826 .70104 .49344 .69002 .48021 Metetra
.777 .798 .87 r
.69002 .48021 .70104 .49344 .724 .47746 .71314 .46409 Metetra
.789 .801 .862 r
.71314 .46409 .724 .47746 .74695 .46033 .73626 .44682 Metetra
.8 .803 .854 r
.73626 .44682 .74695 .46033 .76988 .44207 .75934 .42841 Metetra
.81 .805 .847 r
.75934 .42841 .76988 .44207 .79274 .4227 .78238 .40888 Metetra
.819 .807 .839 r
.78238 .40888 .79274 .4227 .81553 .40223 .80535 .38825 Metetra
.828 .808 .832 r
.80535 .38825 .81553 .40223 .83822 .38068 .82822 .36654 Metetra
.837 .81 .824 r
.82822 .36654 .83822 .38068 .86079 .35808 .85096 .34377 Metetra
.062 .447 .879 r
.20975 .53323 .22289 .5458 .24108 .55384 .22796 .54122 Metetra
.129 .489 .903 r
.22796 .54122 .24108 .55384 .25965 .56097 .24655 .5483 Metetra
.191 .527 .921 r
.24655 .5483 .25965 .56097 .27859 .56717 .26551 .55444 Metetra
.25 .561 .935 r
.26551 .55444 .27859 .56717 .29788 .57241 .28484 .55963 Metetra
.304 .591 .944 r
.28484 .55963 .29788 .57241 .31752 .57666 .30452 .56382 Metetra
.354 .617 .95 r
.30452 .56382 .31752 .57666 .33749 .5799 .32455 .567 Metetra
.4 .64 .953 r
.32455 .567 .33749 .5799 .35779 .58211 .3449 .56914 Metetra
.442 .66 .954 r
.3449 .56914 .35779 .58211 .37839 .58327 .36557 .57022 Metetra
.48 .678 .952 r
.36557 .57022 .37839 .58327 .3993 .58334 .38654 .57022 Metetra
.515 .693 .949 r
.38654 .57022 .3993 .58334 .42048 .58233 .4078 .56912 Metetra
.546 .706 .945 r
.4078 .56912 .42048 .58233 .44193 .58019 .42933 .5669 Metetra
.575 .718 .94 r
.42933 .5669 .44193 .58019 .46362 .57693 .45112 .56355 Metetra
.601 .728 .934 r
.45112 .56355 .46362 .57693 .48555 .57253 .47315 .55905 Metetra
.625 .737 .927 r
.47315 .55905 .48555 .57253 .50769 .56697 .49539 .55339 Metetra
.647 .744 .92 r
.49539 .55339 .50769 .56697 .53002 .56024 .51784 .54657 Metetra
.668 .751 .913 r
.51784 .54657 .53002 .56024 .55253 .55235 .54046 .53856 Metetra
.686 .757 .905 r
.54046 .53856 .55253 .55235 .57519 .54327 .56324 .52937 Metetra
.703 .762 .898 r
.56324 .52937 .57519 .54327 .59798 .53302 .58616 .519 Metetra
.719 .767 .89 r
.58616 .519 .59798 .53302 .62088 .52158 .6092 .50744 Metetra
.734 .771 .883 r
.6092 .50744 .62088 .52158 .64387 .50897 .63233 .4947 Metetra
.747 .775 .875 r
.63233 .4947 .64387 .50897 .66692 .49517 .65553 .48077 Metetra
.76 .778 .868 r
.65553 .48077 .66692 .49517 .69002 .48021 .67878 .46567 Metetra
.772 .781 .86 r
.67878 .46567 .69002 .48021 .71314 .46409 .70205 .44941 Metetra
.783 .784 .853 r
.70205 .44941 .71314 .46409 .73626 .44682 .72532 .43199 Metetra
.794 .786 .845 r
.72532 .43199 .73626 .44682 .75934 .42841 .74858 .41344 Metetra
.804 .788 .838 r
.74858 .41344 .75934 .42841 .78238 .40888 .77178 .39376 Metetra
.813 .79 .831 r
.77178 .39376 .78238 .40888 .80535 .38825 .79491 .37297 Metetra
.822 .792 .824 r
.79491 .37297 .80535 .38825 .82822 .36654 .81795 .35111 Metetra
.83 .794 .817 r
.81795 .35111 .82822 .36654 .85096 .34377 .84087 .32818 Metetra
.106 .455 .886 r
.19653 .51947 .20975 .53323 .22796 .54122 .21475 .5274 Metetra
.168 .493 .905 r
.21475 .5274 .22796 .54122 .24655 .5483 .23336 .53442 Metetra
.226 .527 .919 r
.23336 .53442 .24655 .5483 .26551 .55444 .25234 .5405 Metetra
.281 .558 .929 r
.25234 .5405 .26551 .55444 .28484 .55963 .2717 .54561 Metetra
.331 .585 .936 r
.2717 .54561 .28484 .55963 .30452 .56382 .29142 .54973 Metetra
.376 .609 .94 r
.29142 .54973 .30452 .56382 .32455 .567 .31149 .55284 Metetra
.419 .63 .941 r
.31149 .55284 .32455 .567 .3449 .56914 .33189 .5549 Metetra
.457 .648 .941 r
.33189 .5549 .3449 .56914 .36557 .57022 .35262 .5559 Metetra
.492 .664 .939 r
.35262 .5559 .36557 .57022 .38654 .57022 .37366 .55582 Metetra
.524 .678 .935 r
.37366 .55582 .38654 .57022 .4078 .56912 .39499 .55463 Metetra
.553 .691 .931 r
.39499 .55463 .4078 .56912 .42933 .5669 .4166 .55232 Metetra
.58 .702 .925 r
.4166 .55232 .42933 .5669 .45112 .56355 .43847 .54887 Metetra
.605 .711 .919 r
.43847 .54887 .45112 .56355 .47315 .55905 .46059 .54427 Metetra
.627 .72 .913 r
.46059 .54427 .47315 .55905 .49539 .55339 .48293 .5385 Metetra
.648 .727 .907 r
.48293 .5385 .49539 .55339 .51784 .54657 .50548 .53157 Metetra
.667 .734 .9 r
.50548 .53157 .51784 .54657 .54046 .53856 .52821 .52345 Metetra
.684 .74 .893 r
.52821 .52345 .54046 .53856 .56324 .52937 .55111 .51414 Metetra
.701 .745 .886 r
.55111 .51414 .56324 .52937 .58616 .519 .57416 .50365 Metetra
.716 .75 .879 r
.57416 .50365 .58616 .519 .6092 .50744 .59732 .49196 Metetra
.73 .754 .872 r
.59732 .49196 .6092 .50744 .63233 .4947 .62058 .47909 Metetra
.743 .758 .864 r
.62058 .47909 .63233 .4947 .65553 .48077 .64392 .46504 Metetra
.755 .761 .857 r
.64392 .46504 .65553 .48077 .67878 .46567 .66732 .4498 Metetra
.767 .764 .851 r
.66732 .4498 .67878 .46567 .70205 .44941 .69074 .4334 Metetra
.778 .767 .844 r
.69074 .4334 .70205 .44941 .72532 .43199 .71416 .41584 Metetra
.788 .77 .837 r
.71416 .41584 .72532 .43199 .74858 .41344 .73757 .39714 Metetra
.797 .772 .83 r
.73757 .39714 .74858 .41344 .77178 .39376 .76094 .37731 Metetra
.806 .775 .824 r
.76094 .37731 .77178 .39376 .79491 .37297 .78423 .35638 Metetra
.815 .777 .817 r
.78423 .35638 .79491 .37297 .81795 .35111 .80744 .33436 Metetra
.823 .779 .811 r
.80744 .33436 .81795 .35111 .84087 .32818 .83053 .31127 Metetra
.145 .46 .887 r
.18325 .50452 .19653 .51947 .21475 .5274 .20147 .51237 Metetra
.203 .494 .902 r
.20147 .51237 .21475 .5274 .23336 .53442 .22009 .51932 Metetra
.257 .525 .913 r
.22009 .51932 .23336 .53442 .25234 .5405 .23909 .52532 Metetra
.307 .553 .921 r
.23909 .52532 .25234 .5405 .2717 .54561 .25847 .53035 Metetra
.353 .578 .926 r
.25847 .53035 .2717 .54561 .29142 .54973 .27822 .53439 Metetra
.395 .599 .928 r
.27822 .53439 .29142 .54973 .31149 .55284 .29833 .53741 Metetra
.434 .619 .929 r
.29833 .53741 .31149 .55284 .33189 .5549 .31877 .53939 Metetra
.469 .636 .927 r
.31877 .53939 .33189 .5549 .35262 .5559 .33955 .5403 Metetra
.502 .651 .925 r
.33955 .5403 .35262 .5559 .37366 .55582 .36065 .54012 Metetra
.532 .664 .921 r
.36065 .54012 .37366 .55582 .39499 .55463 .38204 .53883 Metetra
.559 .676 .917 r
.38204 .53883 .39499 .55463 .4166 .55232 .40373 .53642 Metetra
.584 .686 .911 r
.40373 .53642 .4166 .55232 .43847 .54887 .42568 .53287 Metetra
.607 .695 .906 r
.42568 .53287 .43847 .54887 .46059 .54427 .44788 .52816 Metetra
.628 .703 .9 r
.44788 .52816 .46059 .54427 .48293 .5385 .47031 .52228 Metetra
.648 .711 .894 r
.47031 .52228 .48293 .5385 .50548 .53157 .49296 .51523 Metetra
.666 .717 .887 r
.49296 .51523 .50548 .53157 .52821 .52345 .5158 .507 Metetra
.682 .723 .881 r
.5158 .507 .52821 .52345 .55111 .51414 .53881 .49757 Metetra
.698 .729 .874 r
.53881 .49757 .55111 .51414 .57416 .50365 .56197 .48695 Metetra
.712 .733 .867 r
.56197 .48695 .57416 .50365 .59732 .49196 .58525 .47514 Metetra
.726 .738 .861 r
.58525 .47514 .59732 .49196 .62058 .47909 .60864 .46214 Metetra
.738 .742 .854 r
.60864 .46214 .62058 .47909 .64392 .46504 .63212 .44795 Metetra
.75 .745 .848 r
.63212 .44795 .64392 .46504 .66732 .4498 .65565 .43258 Metetra
.761 .749 .841 r
.65565 .43258 .66732 .4498 .69074 .4334 .67921 .41604 Metetra
.772 .752 .835 r
.67921 .41604 .69074 .4334 .71416 .41584 .70278 .39835 Metetra
.782 .755 .829 r
.70278 .39835 .71416 .41584 .73757 .39714 .72634 .3795 Metetra
.791 .757 .822 r
.72634 .3795 .73757 .39714 .76094 .37731 .74986 .35953 Metetra
.8 .76 .816 r
.74986 .35953 .76094 .37731 .78423 .35638 .77331 .33845 Metetra
.809 .762 .81 r
.77331 .33845 .78423 .35638 .80744 .33436 .79668 .31629 Metetra
.817 .764 .804 r
.79668 .31629 .80744 .33436 .83053 .31127 .81994 .29305 Metetra
.178 .461 .885 r
.16991 .48836 .18325 .50452 .20147 .51237 .18813 .49613 Metetra
.232 .493 .897 r
.18813 .49613 .20147 .51237 .22009 .51932 .20676 .50299 Metetra
.282 .522 .906 r
.20676 .50299 .22009 .51932 .23909 .52532 .22577 .5089 Metetra
.329 .547 .911 r
.22577 .5089 .23909 .52532 .25847 .53035 .24517 .51384 Metetra
.371 .57 .915 r
.24517 .51384 .25847 .53035 .27822 .53439 .26494 .51779 Metetra
.411 .59 .916 r
.26494 .51779 .27822 .53439 .29833 .53741 .28507 .52071 Metetra
.447 .608 .916 r
.28507 .52071 .29833 .53741 .31877 .53939 .30556 .52259 Metetra
.48 .623 .914 r
.30556 .52259 .31877 .53939 .33955 .5403 .32638 .52339 Metetra
.51 .637 .911 r
.32638 .52339 .33955 .5403 .36065 .54012 .34753 .52311 Metetra
.538 .65 .907 r
.34753 .52311 .36065 .54012 .38204 .53883 .36898 .52172 Metetra
.563 .661 .903 r
.36898 .52172 .38204 .53883 .40373 .53642 .39073 .5192 Metetra
.587 .671 .898 r
.39073 .5192 .40373 .53642 .42568 .53287 .41275 .51554 Metetra
.608 .68 .893 r
.41275 .51554 .42568 .53287 .44788 .52816 .43503 .51071 Metetra
.628 .688 .887 r
.43503 .51071 .44788 .52816 .47031 .52228 .45755 .50472 Metetra
.647 .695 .881 r
.45755 .50472 .47031 .52228 .49296 .51523 .48029 .49755 Metetra
.664 .702 .875 r
.48029 .49755 .49296 .51523 .5158 .507 .50322 .4892 Metetra
.68 .708 .869 r
.50322 .4892 .5158 .507 .53881 .49757 .52634 .47965 Metetra
.695 .713 .863 r
.52634 .47965 .53881 .49757 .56197 .48695 .5496 .46891 Metetra
.708 .718 .857 r
.5496 .46891 .56197 .48695 .58525 .47514 .57301 .45697 Metetra
.721 .723 .851 r
.57301 .45697 .58525 .47514 .60864 .46214 .59652 .44384 Metetra
.734 .727 .844 r
.59652 .44384 .60864 .46214 .63212 .44795 .62012 .42951 Metetra
.745 .73 .838 r
.62012 .42951 .63212 .44795 .65565 .43258 .64378 .41401 Metetra
.756 .734 .832 r
.64378 .41401 .65565 .43258 .67921 .41604 .66748 .39734 Metetra
.766 .737 .826 r
.66748 .39734 .67921 .41604 .70278 .39835 .69119 .3795 Metetra
.776 .74 .82 r
.69119 .3795 .70278 .39835 .72634 .3795 .71489 .36052 Metetra
.785 .743 .815 r
.71489 .36052 .72634 .3795 .74986 .35953 .73856 .34041 Metetra
.794 .746 .809 r
.73856 .34041 .74986 .35953 .77331 .33845 .76216 .31919 Metetra
.802 .748 .803 r
.76216 .31919 .77331 .33845 .79668 .31629 .78569 .29688 Metetra
.81 .751 .797 r
.78569 .29688 .79668 .31629 .81994 .29305 .8091 .27351 Metetra
.208 .461 .88 r
.15654 .471 .16991 .48836 .18813 .49613 .17475 .47866 Metetra
.258 .491 .89 r
.17475 .47866 .18813 .49613 .20676 .50299 .19337 .48542 Metetra
.305 .517 .896 r
.19337 .48542 .20676 .50299 .22577 .5089 .21239 .49123 Metetra
.348 .54 .901 r
.21239 .49123 .22577 .5089 .24517 .51384 .2318 .49607 Metetra
.387 .561 .903 r
.2318 .49607 .24517 .51384 .26494 .51779 .25158 .49991 Metetra
.424 .58 .903 r
.25158 .49991 .26494 .51779 .28507 .52071 .27174 .50272 Metetra
.457 .597 .903 r
.27174 .50272 .28507 .52071 .30556 .52259 .29226 .50449 Metetra
.488 .612 .9 r
.29226 .50449 .30556 .52259 .32638 .52339 .31312 .50519 Metetra
.516 .625 .898 r
.31312 .50519 .32638 .52339 .34753 .52311 .33431 .50479 Metetra
.542 .637 .894 r
.33431 .50479 .34753 .52311 .36898 .52172 .35581 .50329 Metetra
.566 .648 .89 r
.35581 .50329 .36898 .52172 .39073 .5192 .37762 .50065 Metetra
.588 .657 .885 r
.37762 .50065 .39073 .5192 .41275 .51554 .39971 .49687 Metetra
.609 .666 .88 r
.39971 .49687 .41275 .51554 .43503 .51071 .42206 .49193 Metetra
.628 .674 .875 r
.42206 .49193 .43503 .51071 .45755 .50472 .44465 .48582 Metetra
.645 .681 .869 r
.44465 .48582 .45755 .50472 .48029 .49755 .46747 .47853 Metetra
.662 .687 .864 r
.46747 .47853 .48029 .49755 .50322 .4892 .4905 .47004 Metetra
.677 .693 .858 r
.4905 .47004 .50322 .4892 .52634 .47965 .51371 .46037 Metetra
.691 .699 .852 r
.51371 .46037 .52634 .47965 .5496 .46891 .53708 .4495 Metetra
.705 .704 .846 r
.53708 .4495 .5496 .46891 .57301 .45697 .56059 .43743 Metetra
.717 .708 .841 r
.56059 .43743 .57301 .45697 .59652 .44384 .58421 .42417 Metetra
.729 .713 .835 r
.58421 .42417 .59652 .44384 .62012 .42951 .60793 .40971 Metetra
.74 .716 .829 r
.60793 .40971 .62012 .42951 .64378 .41401 .63171 .39408 Metetra
.751 .72 .824 r
.63171 .39408 .64378 .41401 .66748 .39734 .65554 .37727 Metetra
.761 .724 .818 r
.65554 .37727 .66748 .39734 .69119 .3795 .67939 .3593 Metetra
.77 .727 .813 r
.67939 .3593 .69119 .3795 .71489 .36052 .70323 .34018 Metetra
.779 .73 .807 r
.70323 .34018 .71489 .36052 .73856 .34041 .72703 .31994 Metetra
.788 .733 .802 r
.72703 .31994 .73856 .34041 .76216 .31919 .75079 .29858 Metetra
.796 .735 .796 r
.75079 .29858 .76216 .31919 .78569 .29688 .77446 .27614 Metetra
.804 .738 .791 r
.77446 .27614 .78569 .29688 .8091 .27351 .79802 .25264 Metetra
.233 .46 .873 r
.14313 .45241 .15654 .471 .17475 .47866 .16133 .45997 Metetra
.28 .487 .881 r
.16133 .45997 .17475 .47866 .19337 .48542 .17994 .46661 Metetra
.324 .511 .886 r
.17994 .46661 .19337 .48542 .21239 .49123 .19896 .4723 Metetra
.364 .533 .889 r
.19896 .4723 .21239 .49123 .2318 .49607 .21837 .47703 Metetra
.401 .553 .891 r
.21837 .47703 .2318 .49607 .25158 .49991 .23817 .48075 Metetra
.435 .57 .891 r
.23817 .48075 .25158 .49991 .27174 .50272 .25834 .48345 Metetra
.466 .586 .89 r
.25834 .48345 .27174 .50272 .29226 .50449 .27888 .4851 Metetra
.495 .6 .888 r
.27888 .4851 .29226 .50449 .31312 .50519 .29977 .48567 Metetra
.521 .613 .885 r
.29977 .48567 .31312 .50519 .33431 .50479 .321 .48516 Metetra
.546 .624 .881 r
.321 .48516 .33431 .50479 .35581 .50329 .34255 .48353 Metetra
.568 .635 .877 r
.34255 .48353 .35581 .50329 .37762 .50065 .36441 .48077 Metetra
.589 .644 .873 r
.36441 .48077 .37762 .50065 .39971 .49687 .38655 .47686 Metetra
.609 .652 .868 r
.38655 .47686 .39971 .49687 .42206 .49193 .40896 .4718 Metetra
.627 .66 .863 r
.40896 .4718 .42206 .49193 .44465 .48582 .43163 .46556 Metetra
.644 .667 .858 r
.43163 .46556 .44465 .48582 .46747 .47853 .45453 .45814 Metetra
.659 .674 .853 r
.45453 .45814 .46747 .47853 .4905 .47004 .47763 .44953 Metetra
.674 .68 .847 r
.47763 .44953 .4905 .47004 .51371 .46037 .50093 .43972 Metetra
.688 .685 .842 r
.50093 .43972 .51371 .46037 .53708 .4495 .5244 .42872 Metetra
.701 .69 .837 r
.5244 .42872 .53708 .4495 .56059 .43743 .54801 .41652 Metetra
.713 .695 .831 r
.54801 .41652 .56059 .43743 .58421 .42417 .57174 .40313 Metetra
.724 .699 .826 r
.57174 .40313 .58421 .42417 .60793 .40971 .59557 .38854 Metetra
.735 .703 .821 r
.59557 .38854 .60793 .40971 .63171 .39408 .61947 .37278 Metetra
.745 .707 .815 r
.61947 .37278 .63171 .39408 .65554 .37727 .64342 .35584 Metetra
.755 .711 .81 r
.64342 .35584 .65554 .37727 .67939 .3593 .66739 .33774 Metetra
.764 .714 .805 r
.66739 .33774 .67939 .3593 .70323 .34018 .69136 .31849 Metetra
.773 .717 .8 r
.69136 .31849 .70323 .34018 .72703 .31994 .7153 .29811 Metetra
.782 .72 .795 r
.7153 .29811 .72703 .31994 .75079 .29858 .73919 .27663 Metetra
.79 .723 .79 r
.73919 .27663 .75079 .29858 .77446 .27614 .76301 .25406 Metetra
.798 .726 .785 r
.76301 .25406 .77446 .27614 .79802 .25264 .78672 .23043 Metetra
.256 .458 .865 r
.12971 .43262 .14313 .45241 .16133 .45997 .14789 .44005 Metetra
.3 .483 .872 r
.14789 .44005 .16133 .45997 .17994 .46661 .16648 .44656 Metetra
.34 .505 .876 r
.16648 .44656 .17994 .46661 .19896 .4723 .18549 .45212 Metetra
.377 .526 .878 r
.18549 .45212 .19896 .4723 .21837 .47703 .2049 .45672 Metetra
.412 .544 .879 r
.2049 .45672 .21837 .47703 .23817 .48075 .2247 .46031 Metetra
.444 .561 .879 r
.2247 .46031 .23817 .48075 .25834 .48345 .24489 .46288 Metetra
.473 .576 .877 r
.24489 .46288 .25834 .48345 .27888 .4851 .26545 .4644 Metetra
.5 .589 .875 r
.26545 .4644 .27888 .4851 .29977 .48567 .28636 .46485 Metetra
.525 .601 .872 r
.28636 .46485 .29977 .48567 .321 .48516 .30762 .4642 Metetra
.549 .612 .869 r
.30762 .4642 .321 .48516 .34255 .48353 .3292 .46244 Metetra
.57 .622 .865 r
.3292 .46244 .34255 .48353 .36441 .48077 .3511 .45955 Metetra
.59 .631 .861 r
.3511 .45955 .36441 .48077 .38655 .47686 .37329 .45551 Metetra
.608 .64 .856 r
.37329 .45551 .38655 .47686 .40896 .4718 .39576 .45032 Metetra
.626 .647 .852 r
.39576 .45032 .40896 .4718 .43163 .46556 .41849 .44394 Metetra
.642 .654 .847 r
.41849 .44394 .43163 .46556 .45453 .45814 .44146 .43639 Metetra
.657 .661 .842 r
.44146 .43639 .45453 .45814 .47763 .44953 .46464 .42765 Metetra
.671 .667 .837 r
.46464 .42765 .47763 .44953 .50093 .43972 .48802 .41771 Metetra
.684 .672 .832 r
.48802 .41771 .50093 .43972 .5244 .42872 .51157 .40658 Metetra
.697 .677 .827 r
.51157 .40658 .5244 .42872 .54801 .41652 .53527 .39425 Metetra
.709 .682 .822 r
.53527 .39425 .54801 .41652 .57174 .40313 .5591 .38072 Metetra
.72 .687 .817 r
.5591 .38072 .57174 .40313 .59557 .38854 .58304 .36601 Metetra
.73 .691 .812 r
.58304 .36601 .59557 .38854 .61947 .37278 .60705 .35011 Metetra
.74 .695 .807 r
.60705 .35011 .61947 .37278 .64342 .35584 .63111 .33304 Metetra
.75 .698 .803 r
.63111 .33304 .64342 .35584 .66739 .33774 .6552 .31481 Metetra
.759 .702 .798 r
.6552 .31481 .66739 .33774 .69136 .31849 .6793 .29544 Metetra
.768 .705 .793 r
.6793 .29544 .69136 .31849 .7153 .29811 .70337 .27494 Metetra
.776 .708 .788 r
.70337 .27494 .7153 .29811 .73919 .27663 .72739 .25333 Metetra
.784 .711 .783 r
.72739 .25333 .73919 .27663 .76301 .25406 .75134 .23064 Metetra
.791 .714 .778 r
.75134 .23064 .76301 .25406 .78672 .23043 .77519 .20689 Metetra
.275 .454 .857 r
.11628 .4116 .12971 .43262 .14789 .44005 .13443 .41889 Metetra
.316 .478 .862 r
.13443 .41889 .14789 .44005 .16648 .44656 .15301 .42526 Metetra
.354 .499 .865 r
.15301 .42526 .16648 .44656 .18549 .45212 .172 .43069 Metetra
.389 .518 .867 r
.172 .43069 .18549 .45212 .2049 .45672 .1914 .43514 Metetra
.422 .536 .867 r
.1914 .43514 .2049 .45672 .2247 .46031 .2112 .4386 Metetra
.452 .551 .867 r
.2112 .4386 .2247 .46031 .24489 .46288 .23139 .44102 Metetra
.479 .566 .865 r
.23139 .44102 .24489 .46288 .26545 .4644 .25196 .4424 Metetra
.505 .579 .863 r
.25196 .4424 .26545 .4644 .28636 .46485 .27289 .44271 Metetra
.529 .59 .86 r
.27289 .44271 .28636 .46485 .30762 .4642 .29417 .44193 Metetra
.551 .601 .857 r
.29417 .44193 .30762 .4642 .3292 .46244 .31578 .44003 Metetra
.571 .611 .853 r
.31578 .44003 .3292 .46244 .3511 .45955 .33771 .437 Metetra
.59 .62 .85 r
.33771 .437 .3511 .45955 .37329 .45551 .35995 .43282 Metetra
.608 .628 .845 r
.35995 .43282 .37329 .45551 .39576 .45032 .38247 .42748 Metetra
.624 .635 .841 r
.38247 .42748 .39576 .45032 .41849 .44394 .40525 .42097 Metetra
.64 .642 .837 r
.40525 .42097 .41849 .44394 .44146 .43639 .42828 .41328 Metetra
.654 .649 .832 r
.42828 .41328 .44146 .43639 .46464 .42765 .45153 .40441 Metetra
.668 .655 .828 r
.45153 .40441 .46464 .42765 .48802 .41771 .47498 .39433 Metetra
.681 .66 .823 r
.47498 .39433 .48802 .41771 .51157 .40658 .49861 .38307 Metetra
.693 .665 .818 r
.49861 .38307 .51157 .40658 .53527 .39425 .5224 .3706 Metetra
.704 .67 .814 r
.5224 .3706 .53527 .39425 .5591 .38072 .54632 .35694 Metetra
.715 .675 .809 r
.54632 .35694 .5591 .38072 .58304 .36601 .57035 .3421 Metetra
.726 .679 .804 r
.57035 .3421 .58304 .36601 .60705 .35011 .59446 .32607 Metetra
.735 .683 .8 r
.59446 .32607 .60705 .35011 .63111 .33304 .61863 .30888 Metetra
.745 .687 .795 r
.61863 .30888 .63111 .33304 .6552 .31481 .64284 .29052 Metetra
.754 .69 .791 r
.64284 .29052 .6552 .31481 .6793 .29544 .66705 .27103 Metetra
.762 .694 .786 r
.66705 .27103 .6793 .29544 .70337 .27494 .69124 .25041 Metetra
.77 .697 .782 r
.69124 .25041 .70337 .27494 .72739 .25333 .71539 .22869 Metetra
.778 .7 .777 r
.71539 .22869 .72739 .25333 .75134 .23064 .73946 .20588 Metetra
.786 .703 .773 r
.73946 .20588 .75134 .23064 .77519 .20689 .76344 .18202 Metetra
.292 .451 .847 r
.10286 .38938 .11628 .4116 .13443 .41889 .12098 .39651 Metetra
.331 .473 .852 r
.12098 .39651 .13443 .41889 .15301 .42526 .13953 .40273 Metetra
.366 .493 .854 r
.13953 .40273 .15301 .42526 .172 .43069 .1585 .408 Metetra
.399 .511 .856 r
.1585 .408 .172 .43069 .1914 .43514 .17788 .4123 Metetra
.43 .527 .856 r
.17788 .4123 .1914 .43514 .2112 .4386 .19767 .4156 Metetra
.458 .542 .855 r
.19767 .4156 .2112 .4386 .23139 .44102 .21786 .41788 Metetra
.484 .556 .854 r
.21786 .41788 .23139 .44102 .25196 .4424 .23843 .41911 Metetra
.509 .569 .852 r
.23843 .41911 .25196 .4424 .27289 .44271 .25937 .41927 Metetra
.531 .58 .849 r
.25937 .41927 .27289 .44271 .29417 .44193 .28066 .41833 Metetra
.552 .59 .846 r
.28066 .41833 .29417 .44193 .31578 .44003 .3023 .41628 Metetra
.572 .6 .843 r
.3023 .41628 .31578 .44003 .33771 .437 .32426 .41311 Metetra
.59 .609 .839 r
.32426 .41311 .33771 .437 .35995 .43282 .34653 .40879 Metetra
.607 .617 .835 r
.34653 .40879 .35995 .43282 .38247 .42748 .36909 .40331 Metetra
.623 .624 .831 r
.36909 .40331 .38247 .42748 .40525 .42097 .39192 .39665 Metetra
.638 .631 .827 r
.39192 .39665 .40525 .42097 .42828 .41328 .415 .38882 Metetra
.652 .637 .823 r
.415 .38882 .42828 .41328 .45153 .40441 .43831 .3798 Metetra
.665 .643 .819 r
.43831 .3798 .45153 .40441 .47498 .39433 .46183 .36959 Metetra
.677 .649 .814 r
.46183 .36959 .47498 .39433 .49861 .38307 .48553 .35819 Metetra
.689 .654 .81 r
.48553 .35819 .49861 .38307 .5224 .3706 .5094 .34559 Metetra
.7 .659 .806 r
.5094 .34559 .5224 .3706 .54632 .35694 .5334 .3318 Metetra
.711 .663 .801 r
.5334 .3318 .54632 .35694 .57035 .3421 .55752 .31683 Metetra
.721 .668 .797 r
.55752 .31683 .57035 .3421 .59446 .32607 .58173 .30067 Metetra
.731 .672 .793 r
.58173 .30067 .59446 .32607 .61863 .30888 .606 .28335 Metetra
.74 .676 .788 r
.606 .28335 .61863 .30888 .64284 .29052 .6303 .26488 Metetra
.748 .679 .784 r
.6303 .26488 .64284 .29052 .66705 .27103 .65462 .24527 Metetra
.757 .683 .78 r
.65462 .24527 .66705 .27103 .69124 .25041 .67893 .22453 Metetra
.765 .686 .775 r
.67893 .22453 .69124 .25041 .71539 .22869 .70319 .2027 Metetra
.773 .689 .771 r
.70319 .2027 .71539 .22869 .73946 .20588 .72739 .17979 Metetra
.78 .692 .767 r
.72739 .17979 .73946 .20588 .76344 .18202 .7515 .15583 Metetra
.307 .447 .838 r
.08946 .36595 .10286 .38938 .12098 .39651 .10754 .37291 Metetra
.343 .468 .842 r
.10754 .37291 .12098 .39651 .13953 .40273 .12606 .37896 Metetra
.377 .486 .844 r
.12606 .37896 .13953 .40273 .1585 .408 .145 .38407 Metetra
.408 .504 .845 r
.145 .38407 .1585 .408 .17788 .4123 .16436 .3882 Metetra
.437 .52 .845 r
.16436 .3882 .17788 .4123 .19767 .4156 .18414 .39134 Metetra
.464 .534 .844 r
.18414 .39134 .19767 .4156 .21786 .41788 .20431 .39346 Metetra
.489 .547 .843 r
.20431 .39346 .21786 .41788 .23843 .41911 .22488 .39452 Metetra
.512 .559 .841 r
.22488 .39452 .23843 .41911 .25937 .41927 .24582 .39452 Metetra
.533 .57 .838 r
.24582 .39452 .25937 .41927 .28066 .41833 .26712 .39343 Metetra
.553 .58 .835 r
.26712 .39343 .28066 .41833 .3023 .41628 .28877 .39122 Metetra
.572 .589 .832 r
.28877 .39122 .3023 .41628 .32426 .41311 .31076 .38789 Metetra
.589 .598 .829 r
.31076 .38789 .32426 .41311 .34653 .40879 .33305 .38342 Metetra
.606 .606 .825 r
.33305 .38342 .34653 .40879 .36909 .40331 .35565 .37779 Metetra
.621 .613 .822 r
.35565 .37779 .36909 .40331 .39192 .39665 .37851 .37099 Metetra
.635 .62 .818 r
.37851 .37099 .39192 .39665 .415 .38882 .40164 .36301 Metetra
.649 .626 .814 r
.40164 .36301 .415 .38882 .43831 .3798 .425 .35385 Metetra
.662 .632 .81 r
.425 .35385 .43831 .3798 .46183 .36959 .44858 .3435 Metetra
.674 .638 .806 r
.44858 .3435 .46183 .36959 .48553 .35819 .47234 .33195 Metetra
.685 .643 .802 r
.47234 .33195 .48553 .35819 .5094 .34559 .49628 .31922 Metetra
.696 .648 .798 r
.49628 .31922 .5094 .34559 .5334 .3318 .52036 .3053 Metetra
.707 .653 .794 r
.52036 .3053 .5334 .3318 .55752 .31683 .54456 .29019 Metetra
.716 .657 .79 r
.54456 .29019 .55752 .31683 .58173 .30067 .56885 .27392 Metetra
.726 .661 .786 r
.56885 .27392 .58173 .30067 .606 .28335 .59321 .25648 Metetra
.735 .665 .781 r
.59321 .25648 .606 .28335 .6303 .26488 .61761 .23789 Metetra
.743 .669 .777 r
.61761 .23789 .6303 .26488 .65462 .24527 .64203 .21816 Metetra
.752 .672 .773 r
.64203 .21816 .65462 .24527 .67893 .22453 .66644 .19732 Metetra
.76 .676 .769 r
.66644 .19732 .67893 .22453 .70319 .2027 .69082 .17538 Metetra
.767 .679 .765 r
.69082 .17538 .70319 .2027 .72739 .17979 .71513 .15237 Metetra
.775 .682 .761 r
.71513 .15237 .72739 .17979 .7515 .15583 .73935 .12832 Metetra
.32 .442 .829 r
.0761 .34132 .08946 .36595 .10754 .37291 .09413 .3481 Metetra
.354 .462 .832 r
.09413 .3481 .10754 .37291 .12606 .37896 .11261 .35397 Metetra
.386 .48 .834 r
.11261 .35397 .12606 .37896 .145 .38407 .13152 .35889 Metetra
.416 .497 .834 r
.13152 .35889 .145 .38407 .16436 .3882 .15085 .36285 Metetra
.443 .512 .834 r
.15085 .36285 .16436 .3882 .18414 .39134 .1706 .36581 Metetra
.468 .526 .834 r
.1706 .36581 .18414 .39134 .20431 .39346 .19076 .36775 Metetra
.492 .538 .832 r
.19076 .36775 .20431 .39346 .22488 .39452 .21132 .36865 Metetra
.514 .55 .83 r
.21132 .36865 .22488 .39452 .24582 .39452 .23225 .36848 Metetra
.535 .561 .828 r
.23225 .36848 .24582 .39452 .26712 .39343 .25356 .36722 Metetra
.554 .57 .825 r
.25356 .36722 .26712 .39343 .28877 .39122 .27521 .36485 Metetra
.572 .58 .822 r
.27521 .36485 .28877 .39122 .31076 .38789 .29721 .36136 Metetra
.589 .588 .819 r
.29721 .36136 .31076 .38789 .33305 .38342 .31953 .35672 Metetra
.604 .596 .816 r
.31953 .35672 .33305 .38342 .35565 .37779 .34214 .35093 Metetra
.619 .603 .813 r
.34214 .35093 .35565 .37779 .37851 .37099 .36504 .34398 Metetra
.633 .61 .809 r
.36504 .34398 .37851 .37099 .40164 .36301 .38821 .33585 Metetra
.646 .616 .805 r
.38821 .33585 .40164 .36301 .425 .35385 .41161 .32654 Metetra
.659 .622 .802 r
.41161 .32654 .425 .35385 .44858 .3435 .43524 .31605 Metetra
.67 .628 .798 r
.43524 .31605 .44858 .3435 .47234 .33195 .45906 .30437 Metetra
.682 .633 .794 r
.45906 .30437 .47234 .33195 .49628 .31922 .48306 .2915 Metetra
.692 .638 .79 r
.48306 .2915 .49628 .31922 .52036 .3053 .5072 .27745 Metetra
.702 .642 .787 r
.5072 .27745 .52036 .3053 .54456 .29019 .53147 .26222 Metetra
.712 .647 .783 r
.53147 .26222 .54456 .29019 .56885 .27392 .55584 .24582 Metetra
.721 .651 .779 r
.55584 .24582 .56885 .27392 .59321 .25648 .58028 .22826 Metetra
.73 .655 .775 r
.58028 .22826 .59321 .25648 .61761 .23789 .60478 .20955 Metetra
.739 .659 .771 r
.60478 .20955 .61761 .23789 .64203 .21816 .62929 .18972 Metetra
.747 .662 .767 r
.62929 .18972 .64203 .21816 .66644 .19732 .6538 .16878 Metetra
.755 .666 .764 r
.6538 .16878 .66644 .19732 .69082 .17538 .67827 .14674 Metetra
.762 .669 .76 r
.67827 .14674 .69082 .17538 .71513 .15237 .70269 .12364 Metetra
.769 .672 .756 r
.70269 .12364 .71513 .15237 .73935 .12832 .72703 .0995 Metetra
.332 .438 .82 r
.06278 .31549 .0761 .34132 .09413 .3481 .08076 .32208 Metetra
.364 .457 .822 r
.08076 .32208 .09413 .3481 .11261 .35397 .09919 .32776 Metetra
.394 .474 .824 r
.09919 .32776 .11261 .35397 .13152 .35889 .11806 .33249 Metetra
.422 .49 .824 r
.11806 .33249 .13152 .35889 .15085 .36285 .13736 .33626 Metetra
.448 .504 .824 r
.13736 .33626 .15085 .36285 .1706 .36581 .15709 .33903 Metetra
.472 .518 .823 r
.15709 .33903 .1706 .36581 .19076 .36775 .17722 .34079 Metetra
.495 .53 .822 r
.17722 .34079 .19076 .36775 .21132 .36865 .19776 .3415 Metetra
.516 .541 .82 r
.19776 .3415 .21132 .36865 .23225 .36848 .21868 .34115 Metetra
.536 .552 .818 r
.21868 .34115 .23225 .36848 .25356 .36722 .23998 .33972 Metetra
.554 .561 .816 r
.23998 .33972 .25356 .36722 .27521 .36485 .26164 .33718 Metetra
.571 .57 .813 r
.26164 .33718 .27521 .36485 .29721 .36136 .28364 .33351 Metetra
.588 .579 .81 r
.28364 .33351 .29721 .36136 .31953 .35672 .30596 .32871 Metetra
.603 .586 .807 r
.30596 .32871 .31953 .35672 .34214 .35093 .3286 .32276 Metetra
.617 .593 .804 r
.3286 .32276 .34214 .35093 .36504 .34398 .35152 .31565 Metetra
.631 .6 .801 r
.35152 .31565 .36504 .34398 .38821 .33585 .37471 .30737 Metetra
.644 .606 .797 r
.37471 .30737 .38821 .33585 .41161 .32654 .39816 .29791 Metetra
.656 .612 .794 r
.39816 .29791 .41161 .32654 .43524 .31605 .42182 .28727 Metetra
.667 .618 .79 r
.42182 .28727 .43524 .31605 .45906 .30437 .44569 .27545 Metetra
.678 .623 .787 r
.44569 .27545 .45906 .30437 .48306 .2915 .46974 .26244 Metetra
.688 .628 .783 r
.46974 .26244 .48306 .2915 .5072 .27745 .49394 .24826 Metetra
.698 .633 .78 r
.49394 .24826 .5072 .27745 .53147 .26222 .51828 .2329 Metetra
.708 .637 .776 r
.51828 .2329 .53147 .26222 .55584 .24582 .54272 .21638 Metetra
.717 .641 .772 r
.54272 .21638 .55584 .24582 .58028 .22826 .56723 .19871 Metetra
.726 .646 .769 r
.56723 .19871 .58028 .22826 .60478 .20955 .59181 .1799 Metetra
.734 .649 .765 r
.59181 .1799 .60478 .20955 .62929 .18972 .6164 .15996 Metetra
.742 .653 .762 r
.6164 .15996 .62929 .18972 .6538 .16878 .641 .13892 Metetra
.75 .657 .758 r
.641 .13892 .6538 .16878 .67827 .14674 .66557 .1168 Metetra
.757 .66 .754 r
.66557 .1168 .67827 .14674 .70269 .12364 .69009 .09361 Metetra
.764 .663 .751 r
.69009 .09361 .70269 .12364 .72703 .0995 .71453 .0694 Metetra
.342 .433 .81 r
.04952 .28849 .06278 .31549 .08076 .32208 .06745 .29487 Metetra
.372 .451 .813 r
.06745 .29487 .08076 .32208 .09919 .32776 .08583 .30034 Metetra
.401 .468 .814 r
.08583 .30034 .09919 .32776 .11806 .33249 .10465 .30487 Metetra
.428 .483 .815 r
.10465 .30487 .11806 .33249 .13736 .33626 .12391 .30844 Metetra
.453 .497 .815 r
.12391 .30844 .13736 .33626 .15709 .33903 .1436 .31102 Metetra
.476 .51 .814 r
.1436 .31102 .15709 .33903 .17722 .34079 .1637 .31258 Metetra
.497 .522 .813 r
.1637 .31258 .17722 .34079 .19776 .3415 .18421 .3131 Metetra
.518 .533 .811 r
.18421 .3131 .19776 .3415 .21868 .34115 .20512 .31256 Metetra
.537 .543 .809 r
.20512 .31256 .21868 .34115 .23998 .33972 .2264 .31094 Metetra
.554 .553 .807 r
.2264 .31094 .23998 .33972 .26164 .33718 .24805 .30822 Metetra
.571 .561 .804 r
.24805 .30822 .26164 .33718 .28364 .33351 .27005 .30438 Metetra
.587 .57 .802 r
.27005 .30438 .28364 .33351 .30596 .32871 .29238 .2994 Metetra
.601 .577 .799 r
.29238 .2994 .30596 .32871 .3286 .32276 .31502 .29329 Metetra
.615 .584 .796 r
.31502 .29329 .3286 .32276 .35152 .31565 .33796 .28601 Metetra
.628 .591 .793 r
.33796 .28601 .35152 .31565 .37471 .30737 .36118 .27757 Metetra
.641 .597 .789 r
.36118 .27757 .37471 .30737 .39816 .29791 .38464 .26796 Metetra
.653 .603 .786 r
.38464 .26796 .39816 .29791 .42182 .28727 .40834 .25717 Metetra
.664 .609 .783 r
.40834 .25717 .42182 .28727 .44569 .27545 .43225 .24521 Metetra
.675 .614 .78 r
.43225 .24521 .44569 .27545 .46974 .26244 .45634 .23206 Metetra
.685 .619 .776 r
.45634 .23206 .46974 .26244 .49394 .24826 .4806 .21775 Metetra
.694 .624 .773 r
.4806 .21775 .49394 .24826 .51828 .2329 .50499 .20227 Metetra
.704 .628 .77 r
.50499 .20227 .51828 .2329 .54272 .21638 .52949 .18563 Metetra
.713 .632 .766 r
.52949 .18563 .54272 .21638 .56723 .19871 .55407 .16785 Metetra
.721 .636 .763 r
.55407 .16785 .56723 .19871 .59181 .1799 .57871 .14893 Metetra
.729 .64 .759 r
.57871 .14893 .59181 .1799 .6164 .15996 .60339 .1289 Metetra
.737 .644 .756 r
.60339 .1289 .6164 .15996 .641 .13892 .62807 .10777 Metetra
.745 .648 .753 r
.62807 .10777 .641 .13892 .66557 .1168 .65272 .08556 Metetra
.752 .651 .749 r
.65272 .08556 .66557 .1168 .69009 .09361 .67733 .0623 Metetra
.759 .654 .746 r
.67733 .0623 .69009 .09361 .71453 .0694 .70186 .03802 Metetra
.35 .429 .802 r
.03634 .26033 .04952 .28849 .06745 .29487 .0542 .26649 Metetra
.38 .446 .804 r
.0542 .26649 .06745 .29487 .08583 .30034 .07252 .27174 Metetra
.407 .462 .805 r
.07252 .27174 .08583 .30034 .10465 .30487 .09129 .27605 Metetra
.433 .477 .805 r
.09129 .27605 .10465 .30487 .12391 .30844 .11051 .27941 Metetra
.456 .49 .805 r
.11051 .27941 .12391 .30844 .1436 .31102 .13015 .28177 Metetra
.479 .503 .805 r
.13015 .28177 .1436 .31102 .1637 .31258 .15022 .28313 Metetra
.499 .514 .804 r
.15022 .28313 .1637 .31258 .18421 .3131 .1707 .28345 Metetra
.519 .525 .802 r
.1707 .28345 .18421 .3131 .20512 .31256 .19158 .28271 Metetra
.537 .535 .8 r
.19158 .28271 .20512 .31256 .2264 .31094 .21284 .2809 Metetra
.554 .544 .798 r
.21284 .2809 .2264 .31094 .24805 .30822 .23447 .27799 Metetra
.57 .553 .796 r
.23447 .27799 .24805 .30822 .27005 .30438 .25646 .27396 Metetra
.585 .561 .793 r
.25646 .27396 .27005 .30438 .29238 .2994 .27879 .26881 Metetra
.6 .568 .791 r
.27879 .26881 .29238 .2994 .31502 .29329 .30143 .26252 Metetra
.613 .576 .788 r
.30143 .26252 .31502 .29329 .33796 .28601 .32438 .25508 Metetra
.626 .582 .785 r
.32438 .25508 .33796 .28601 .36118 .27757 .34761 .24647 Metetra
.638 .588 .782 r
.34761 .24647 .36118 .27757 .38464 .26796 .37109 .23671 Metetra
.65 .594 .779 r
.37109 .23671 .38464 .26796 .40834 .25717 .39482 .22577 Metetra
.661 .6 .776 r
.39482 .22577 .40834 .25717 .43225 .24521 .41876 .21366 Metetra
.671 .605 .773 r
.41876 .21366 .43225 .24521 .45634 .23206 .44288 .20038 Metetra
.681 .61 .77 r
.44288 .20038 .45634 .23206 .4806 .21775 .46718 .18594 Metetra
.691 .615 .767 r
.46718 .18594 .4806 .21775 .50499 .20227 .49162 .17034 Metetra
.7 .619 .763 r
.49162 .17034 .50499 .20227 .52949 .18563 .51617 .15358 Metetra
.708 .624 .76 r
.51617 .15358 .52949 .18563 .55407 .16785 .54081 .13569 Metetra
.717 .628 .757 r
.54081 .13569 .55407 .16785 .57871 .14893 .56552 .11667 Metetra
.725 .632 .754 r
.56552 .11667 .57871 .14893 .60339 .1289 .59026 .09655 Metetra
.733 .635 .751 r
.59026 .09655 .60339 .1289 .62807 .10777 .61501 .07534 Metetra
.74 .639 .747 r
.61501 .07534 .62807 .10777 .65272 .08556 .63974 .05305 Metetra
.747 .642 .744 r
.63974 .05305 .65272 .08556 .67733 .0623 .66443 .02973 Metetra
.754 .646 .741 r
.66443 .02973 .67733 .0623 .70186 .03802 .68905 .00539 Metetra
0 g
.25 Mabswid
.68874 0 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.68874 0 m
.03716 .25514 L
s
.03716 .25514 m
.68874 0 L
s
.03716 .25514 m
.04196 .25962 L
s
[(-1)] .02757 .24618 1 .93395 Mshowa
.18558 .19702 m
.19014 .20174 L
s
[(-0.5)] .17646 .18758 .96648 1 Mshowa
.34306 .13535 m
.34735 .14032 L
s
[(0)] .3345 .12542 .86223 1 Mshowa
.51046 .06981 m
.51442 .07504 L
s
[(0.5)] .50253 .05935 .75799 1 Mshowa
.68874 0 m
.69233 .00549 L
s
[(1)] .68156 -0.01098 .65374 1 Mshowa
.125 Mabswid
.06616 .24378 m
.06901 .2465 L
s
.09549 .2323 m
.09832 .23504 L
s
.12517 .22067 m
.12797 .22345 L
s
.1552 .20892 m
.15797 .21172 L
s
.21633 .18498 m
.21903 .18784 L
s
.24744 .1728 m
.25012 .17569 L
s
.27893 .16047 m
.28157 .16339 L
s
.3108 .14799 m
.31341 .15094 L
s
.37572 .12257 m
.37826 .12558 L
s
.40878 .10962 m
.41128 .11266 L
s
.44225 .09652 m
.44471 .09959 L
s
.47614 .08324 m
.47856 .08635 L
s
.54521 .0562 m
.54755 .05937 L
s
.58041 .04242 m
.5827 .04562 L
s
.61605 .02846 m
.6183 .03169 L
s
.65216 .01432 m
.65436 .01759 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 233.562},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000j@P10`40000100000000<`00IP00V@00
c000o`0c000c<`0cIP0cV@0cc00co`1V001V<`1VIP1VV@1Vc01Vo`2I002I<`2IIP2IV@2Ic02Io`3<
003<<`3<IP3<V@3<c03<o`3o003o<`3oIP3oV@3oc03ooc<003<0<c<0IS<0VC<0c3<0oc<c03<c<c<c
IS<cVC<cc3<coc=V03=V<c=VIS=VVC=Vc3=Voc>I03>I<c>IIS>IVC>Ic3>Ioc?<03?<<c?<IS?<VC?<
c3?<oc?o03?o<c?oIS?oVC?oc3?oofH006H0<fH0IVH0VFH0c6H0ofHc06Hc<fHcIVHcVFHcc6HcofIV
06IV<fIVIVIVVFIVc6IVofJI06JI<fJIIVJIVFJIc6JIofK<06K<<fK<IVK<VFK<c6K<ofKo06Ko<fKo
IVKoVFKoc6KooiT009T0<iT0IYT0VIT0c9T0oiTc09Tc<iTcIYTcVITcc9TcoiUV09UV<iUVIYUVVIUV
c9UVoiVI09VI<iVIIYVIVIVIc9VIoiW<09W<<iW<IYW<VIW<c9W<oiWo09Wo<iWoIYWoVIWoc9Wool`0
0<`0<l`0I/`0VL`0c<`0ol`c0<`c<l`cI/`cVL`cc<`colaV0<aV<laVI/aVVLaVc<aVolbI0<bI<lbI
I/bIVLbIc<bIolc<0<c<<lc<I/c<VLc<c<c<olco0<co<lcoI/coVLcoc<coool00?l0<ol0I_l0VOl0
c?l0oolc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nIooo<
0?o<<oo<I_o<VOo<c?o<oooo0?oo<oooI_ooVOooc?ooooCM/_[aghUlI<FbZ>KNfVYPFjNGSol0VOl0
c?l0oolc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nIooo<
0?o<<oo<I_o<VOo<c?o<oooo0?oo<oooI_ooVOooc?oooooG8ML00?oG8ML00?oG8ML00?oG8ML00?oG
8ML00?oG8ML00<KG101Fe`00b=L00`3Ge`1Ee`00b=L00`3Ge`1Ee`00b=L00`3Ge`1Ee`00b=L00`3G
e`1Ee`00a]L300gG1016e`00b=L00`3Ge`0=e`030=OG04GG003He`030=OG04GG003@e`@01=L00`3G
e`15e`00f=L00`3Ge`15e`00bmL200WG0`17e`00bML500[G00<0emL0AML00<KG0`03e`80D]L00<CG
0P05e`8000?G0=L0D=L00<7G0`06e`060:H00=L0D=L00;oG0P02e`030=OG00?G00<0PJH00P000mL0
e`1?e`00_=L300WG00@0YZbV0P02e`030=OG04gG002ie`<02mL01`21YX6V0:H0101>e`00]mL300cG
00T0YZbV[:H0YP000]L00`3Ge`1<e`00SML200CG00<0emL00]L301WG0`03e`030=OG00SG0P002JJ1
YX6VP@210002e`030=OG04_G002<e`040=OG00_G00<0emL05=L2013G00`0YZ`0[:J/YZ`0[003e`03
0=OG04[G002<e`040=OG00_G00<0emL04ML3013G0P002H6VP@21YX6VP@0300?G00<0emL0B]L008cG
00@0emL02=L301;G0P000mL0e`0?e`0@0:bV[:J/0:bV[:J/0:bV00?G00<0emL0BML008cG00@0emL0
2=L00`3Ge`0?e`<04mL0302VPJJ1YX6V0:J1YP8000>1YP000mL00`3Ge`19e`00S=L0103Ge`08e`03
0=OG00gG0P0Ee`0C0:bV[:J/YZbV0:J/0:`0[:J/0002e`80B]L008gG0P09e`@02ML301KG0P002H6V
PJJ1YX6VP@020007YX40PJJ10004e`030=OG04OG002Se`800]L00`3Ge`0Ce`0F0:bV0:J/YZbV[:J/
0:bV[02/YZbV00?G00<0emL0AmL00:3G0`0Ie`0<0:J1YP2VPJJ1YX6V0P002H6VP@21YX6V0004e`03
0=OG04KG002Me`<06mL06@2/YZbV[02/YZbV[02/YP2V[02/YZbV[0001=L00`3Ge`15e`00VmL301cG
01P0YX6VPJJ1086VPJH0YX6V0:J1086VPJH200CG00<0emL0AML009SG0`03e`030=OG01SG01`0[:J/
YZbV[:H0YZbV0:J/YP2V[02/YZ`0[:H01=L00`3Ge`14e`00U]L201oG0`006h6VPJJ1YX6V0:J1086V
PJJ10840PJH0YZFV0003e`030=L004GG002Ce`<08=L03@2V[:H0YZbV[:J/YZ`00P004:J/YZbV[02/
0:`0[:J/YP05e`030=OG04?G002Ae`800]L00`3Ge`0Me`0H086VPJH0YX6VPJJ1YX40PJJ1YX6VP@21
0P001jJUYZFVY@001ML00`3Ge`12e`00S]L302;G0P003:J/YZbV0:J/YZbV[0<000R/YZbV[:J/YP80
00R/YZbV[:J/00KG00<0emL0@ML008cG0P0Te`0U0:J1YX6VPJJ1086VPJH0YX6V0:J1YX6VPJH0YP2V
YJJUYZFV0005e`030=OG047G001/e`806mL402CG0P006:J/YZbV[:J/0:bV[02/YZbV0:J/YZbV[080
00ZV0:J/YZbV[:H01]L00`3Ge`10e`00JmL0103Ge`0He`809mL0302VP@21YX6VPJJ1YP<000jVPJJ1
YP2VPJJ1YP2VP@8000JVYJJUYZD200GG0`11e`00JmL0103Ge`0Ee`<0:=L07P2/YZ`0[:J/YZbV[:H0
YZbV[:J/YZ`0[:J/0:bV[08000VV[:J/YP2V[0001]L00`3Ge`0<e`801=L00`3Ge`02e`<09ML006_G
00@0emL04mL202[G00d0YX6VPJH0YX6VPJJ1008001^VPJJ1YX6VP@21YP2VPJJ1YP2VYJJU0:F/Y@00
1mL00`3Ge`0:e`040=OG00_G00<0emL08]L006_G00@0emL04=L30003e`3G02SG01T0[:J/YZbV0:J/
YZbV0:J/0:bV[:J/YZbV0080012/YZbV[:H0YZbV[02/YZ`02=L00`3Ge`09e`040=OG00_G00<0emL0
8]L006_G00@0emL03]L202gG0280YX6VPJJ1YX40PJJ1086VP@21YX6VPJJ1YP2VPJJ1YX6V0P002JFV
0:bU[:F/0007e`030=OG00?G1002e`040=OG00SG0`0Ue`00K=L200cG0`0]e`<001RV[:J/YZbV[02/
YP2V[:J/0:bV[:J/YZ`20007YZbV[:J/YP020009[02/YZbV[:H000SG00<0emL02=L0103Ge`08e`03
0=OG02GG001he`8000?G0=L0;=L03@21YX40PJJ1YX6VPJH00P008X6VPJJ1YP2VPJJ1YP2VP@21YX6V
PJH0YP2/YJbU[:F/Y@07e`802ML0103Ge`08e`030=OG02GG001ee`<0<=L06P2V[:J/0:bV[:J/YZbV
0:J/YZbV[:H0YZbV0P002ZbV[02/YZbV[:H30009YZbV[:J/YZ`000KG00<0e`002]L200WG100Te`00
L]L3037G0P00386VPJJ1086VPJJ1YP<0026VPJJ1YX6V0:J1086VPJJ1086VPJJ1YP2/Y@2U[:F/YJ`0
0P09e`030=OG03[G001`e`<0<]L06P2/YZbV[:J/YP2V[:J/0:bV[02/YZbV[:J/0P002jJ/YZbV[:H0
YZbV00<000bV[02/YZbV[02/YP08e`030=OG03[G001]e`<00mL00`3Ge`0]e`<003F1YX6VPJJ1YP2V
PJH0YX6VP@21YX6VPJJ1086VPJJ1YX6V0:J10:F/0:bU[02/YJ`0[:F/0009e`030=OG03WG001[e`80
=ML03@22[880YZbV[:J/YZ`00`005jbV[:J/0:bV[:J/YP2V0:J/YZbV[:J/0080016V[:H0YZbV0:J/
0:bV[:J/0009e`030=OG03SG001Xe`<0=ML2000aPJJ1YP2VPJJ1YX6VP@21YX6VPJJ1YP2VPJJ108:V
0:J1YX6VPJJ10:F/YJ`0[:F/Y@020007[:F/YJbU0008e`80>]L006KG0P02e`030=OG03;G00l0[8:/
PZb2[02/YZbV[:H00P002jbV[:J/YZbV0:J/008000^V[:J/0:bV[:J/YP02000C[:J/YP2V[:J/0:bV
[:J/YZbV0009e`030=OG03OG001Se`<0=mL3000IPJJ1YX6VP@21YX6VP@22YP2VPJJ1YX6VP@02000G
YX:VPZJ2086VPJJ108:V0:bU[:D0YJ`00P002JF/YJbU[:F/000:e`030=OG03KG000ge`801=L00`3G
e`02e`<07=L203WG00l0PZJ208:/PZb2[880YZ`00P006:J/YP2V[:J/YZbV[02/YZbV[:J/YP2V[080
01BV[:H0YZbV[02/0:bV0:J/YZbV[0802]L00`3Ge`0fe`00=]L0103Ge`0;e`030=OG01KG0`000mL0
e`0ge`0M08:VPZH0YX6VPJJ1YP2V0:J2YX:VPP21YX6VPJH00P005H:VPZJ2YX:V0:H0YX:VPZJ20:F/
Y@02000=[:J/0:bU[:F/0:bV000:e`030=OG03GG000fe`040=OG00_G00<0emL05=L203_G0P00<h:V
PZJ208:/PZb2[8:/0:bV[:J/YZ`0[:J/YZ`0[:H0YZbV[:J/YZ`0[:J/YZbV[02/YP02000>[:J/YZ`0
[:J/0:bV[00;e`030=OG03CG000`e`@00]L0103Ge`08e`<05=L303cG00l0YX:VPZJ2YX80PJJ1YX40
0`002h:VPZJ2YX:V0:J1008000^VPZH0YX:VPZJ2YP020008PZJ2YX:VPZH2000AYP2V[:J/YP2U[02/
YZbV[0002ML203KG000fe`040=OG00SG00<0emL04]L303cG0`00?H:VPZJ2YX:V0:b2[880PZb20:J/
YZbV[:H0YP2V[:J/YP2V[:J/YZ`0[:H0YZbV[:J/YP2V[02/YZbV[:H00P001jbV[:J/YP002mL00`3G
e`0ce`00=]L0103Ge`08e`030=OG00oG0`0ne`0Z08:VPP22YX:VPZJ2086VP@22YX:V0:J2YX:VPZJ2
08:VPZJ2YX80PZJ20P007jJ2YP2VPZJ2YX80PP2V0:J/YZbV[02/YZbV[:J/YP002mL00`3Ge`0be`00
=mL200WG100;e`<0?mL2000=PZJ2YP2VPZJ2YX:VPP03000<PZb2[880YZbV[:J/0`008JbV[:J/YZ`0
[:H0YZbV[:H0YZbV[:H0YZ`0[02/YZbV[0020009YZbV[:J/YZ`000_G00<0emL0<]L004oG0`10e`0Z
0:J2YX:VPZH0YX:VPZJ2YP2VPZJ2YX:VPP22YX:V0:J2YP2VPZJ2YX:V0P0048:VPZJ2YX80PZJ208:/
PZ`2000AYZbV[02/YP2V[:J/YZ`0[0002mL00`3Ge`0ae`00C=L3047G0`003H:VPZJ2YX80PZJ2YX80
0`00:h:/PZb2[8:/0:bV[02/YZbV0:J/YZbV[:H0YZbV[:J/YZ`0[:H0YZbV[:H00P004JbV[02/YZ`0
[:J/YZ`0[:H000cG00<0emL0<=L004[G0P13e`0M08:VPP22YX:VPZJ208:VPP22YX80PZJ2YX:VPZH0
0`005jJ2YX:V0:J2YX:VPP2208:VPZJ2YX:V008001Z2[8:/PZb20:J/0:bV[:J/0:bV[02/YZbV00[G
0P0be`00AmL304?G0P003X:VPZH0YX:VPZJ2YP2V0P00A8:/PZ`0[8:/PZb2[880YZbV[:J/YZ`0[:J/
YP2V[02/YZbV[:J/YP2V[:J/YZbV[02/0:bV[:J/YP2V[02/YZbV[:H02mL00`3Ge`0_e`00AML200?G
00<0emL0?]L2000NYX:VPZJ2YP2VPZJ2YX:V0:J2YX:VPZH0YX:VPZJ20P002jJ2YX:VPZJ208:V0080
00^2YX:V0:J2YX:VPP020008[8:/PZb2[8820008[:J/YZbV[:H20008[:J/YZbV[00<e`030=OG02kG
0012e`<0A=L2000?PP22YX:VPZJ208:VPZJ200<001V2[8:/PZb208:/PZb20:J/0:bV[:J/YZbV0080
01N/YZbV[:H0YZbV[:H0YZ`0[:J/YZbV[002000CYZbV[:J/YZ`0[:J/YZbV[:J/000;e`030=OG02kG
0010e`80AML2000OYX:VPP22YX:VPZJ208:VPP22YX80PZJ2YX:VPP22YP02000HPZJ208:VPZJ2YX:V
0:J2YX:VPZJ208:V0P002X:/PP22[8:/PZ`20008YP2V[:J/YZ`20008YZbV[:J/YZ`200cG00<0emL0
;ML003gG0`000mL0e`12e`800122YX:VPZH0YX:VPZJ2YP2V0P0078:/PZ`0[8:/PZb2[02/0:bV[:J/
YP2V[:J/YZ`2000EYZbV[:J/YZ`0[02/YZbV[:H0YZbV008001N/0:`0[:J/YZ`0[:H0YZbV[:J/0:bV
000;e`030=OG02gG000ke`80A]L3001IPZJ2YX:VPP22YX:VPZJ2YP2VPZJ2YX80PZJ2YX:VPZH0YX:V
PZJ2YP2VPZJ2YP2VPP22YX:VPZJ2YP2/PZb2[8:/0:b20:J/YZ`0[02/YZ`0[:J/0:bV[:H00P001:bV
[00;e`802=L202CG000Je`@06]L304KG0P004H:VPP22YX:VPZJ208:VPZJ200<000f2[8:/PZb208:/
PZb200<000^V[:J/YZbV[02/YP02000:[:J/0:bV[:J/YP<000RV[:J/YZbV[08001^V[:J/YP2V0:J/
0:bV[:J/0:bV0:J/YZbV[0003=L00`3Ge`04e`040=OG02?G000Le`030=OG01OG0P000mL0e`14e`80
1H80302VPZJ2YX:V0:J2YP8000j2YX80PZJ2YX:V0:J2YP8002n2YX80PZJ2YX:VPP2208:VPZJ2YP2V
PZJ208:/PP22[8:/PZb20:J/YZbV[02/YP02000A[:J/YZbV0:H0YZbV[:J/YP003=L00`3Ge`04e`04
0=OG02?G000Le`030=OG01CG0`17e`<000nVPZJ2YX:V0:J2YX:VPZH00`003JJ2YX:V0:b2[8:/PZ`0
0`00AJb2[8:/0:bV[:J/YZbV0:J/YZbV[:H0YZbV0:J/YZ`0[:J/YZbV0:H0YZbV[:H0YZ`0[:J/YZbV
[:H0YZbV[:J/YZbV000<e`030=OG00?G00@0emL08mL001CG1004e`030=OG017G0`18e`800h800`22
PP04PP0W08:VPZJ2YX80PZJ2YX:VPP22YX:VPZJ208:VPZJ2YX:V0:J2YX:V00<000RVPZJ2YX:VPP<0
01J2[8:/PZ`0[8:/PP22[02/YZbV[02/0P001jJ/YZbV[:H00P002:bV[:J/YZbV0P0=e`030=OG00;G
00@0emL08mL001cG00<0emL03mL200;G00<0emL0A=L2000BPZJ2YX80PZJ2YX:VPP22YX:V0`003JJ2
YX:VPZJ208:/PZ`00`003:b2[8:/PZb20:J/YP8001N/YZ`0[:J/YZbV[02/YZbV[:J/YP2V[0020009
YZbV[02/YZbV008001>/YP2V[:J/YP2V[02/YZbV[:H000:/00<0emL02]L200?G00@0emL08mL001[G
0`0>e`<0BML300N200<0PX8018800`2VPP02000LYX:V0:J2YX:VPZH0YX:V0:J2YP2VPZJ2YX:VPP<0
01N2YX:VPP22YX:VPZH0YP2/PZb2[8:/PP02000S[8:/PZb20:J/YZ`0[:J/0:bV[:H0YZbV0:J/YZbV
0:J/YP002mL300CG0P0Te`007=L00`3Ge`0:e`80B]L2000BPZJ208:VPZJ2YP2VPZJ2YX:V0P003X:V
PZJ208:VPZJ2YX:V0`00<jb2[880PZb2[8:/PZ`0[:J/YZbV[:H0YZbV[02/YP2V[:J/YZbV[02/YZbV
[:J/YP2V[002000BYZbV[02/YP2V[:J/YP2V[:H01:`00`3Ge`0<e`030=OG02OG000Ve`<000?G0=L0
A]L300F200<0PX801H800`22PP02PP<001j2YX:VPZJ208:VPZJ2YX80PZJ2YX:VPP22YX:VPZH2000;
PZJ2YX:VPZH0YX800P002jJ2YX80PZb2[8:/008000R2[8:/PZb2[0<001Z/YP2V[:H0YP2V[:J/YZ`0
[:H0YZbV[:J/00gG00<0emL09mL002CG0P19e`<001>V0:J2YX:VPZH0YX:VPZJ208:V00800122YX80
PZJ2YX:V0:J2YX:V0`006Jb2[8:/PZ`0[8:/PZ`0[880YZbV[:J/YZ`00P005:J/YZbV[02/YZbV[02/
YP2V[:J/0`004j`0[:J/0:bV[:H0YZbV[:J/YZ`00P07[0030=OG00cG00<0emL09]L002;G0P18e`<0
1H800`22PP04PP0308:200F20P05PP0K0:J2YX:VPZH0YX:V0:J2YP2VPZJ2YX:V0:J2008001RVPZH0
YX:VPZJ2YX80PZJ2YX:VPZH0[8820005[8:/0:`00`000jb200020007YZbV[02/YP02000@[:J/YZbV
[:H0YZbV[:J/YP803mL00`3Ge`0Ue`008]L204GG0`005H80YX:VPZJ208:VPZJ2YX80PZJ2YP03000@
YX:VPZJ208:VPZJ2YX80PP8001b/PZb208:/PZb2[880PP22[8:/PZ`0[:J/YZbV0P004:bV[:J/YZbV
0:H0YZbV[:H2000=[:J/YP2V[:H0YZbV[002000<YZ`0[:J/YZbV0:`01J`0102/[00=e`809mL000kG
0P04e`030=OG00;G0`06e`<0@=L400F200<0PX800h800`22PP05PP0308:200800h800`22PP04PP07
08:VPZJ2YP02000]PZJ2YX:VPP22YX:VPZJ208:VPZJ2YX80PZJ2YX80PZH0YX:VPZJ2YX80PZb200<0
00n208:/PP2V[:J/0:bV[:H00P005JbV0:J/YZbV0:J/0:bV[:H0YZbV000?e`030=OG02CG000=e`04
0=OG00_G00<0emL00mL20003GP000080=mL500:200<0PX8018803P22YX:VPZH0YX:VPZJ20`004H:V
PZJ208:VPZJ2YP2VPZJ2008000n/0:b2[8:/PZ`0[8:/PZ`00`002jb2[8:/PZb20:J/008000ZV[:H0
YZbV[:J/1P001JJ/YZbV00<001:V[:J/YZ`0[:H0YP2V[:H0YZ`200B/00@0[:`01J`00`3Ge`0=e`03
0=OG02?G000=e`040=OG00_G00<0emL00]L30005=5Pd03@01@0_e`<000Ul07b2O89lPP001H800`22
PP04PP0308:200:20P000h80PP05PP0308:200F202h0YP00PZJ2YP2VPZJ2YX:V0:J2YP2VPZH0YX:V
PZJ2YP2V0:J2YX:VPP22YX:V1@00;:b2[8:/PZ`0[:J/YZbV[:H0YP2V[:H0YZ`0[02/YZbV[:H0YP2V
[:J/YZ`03mL00`3Ge`0Se`003ML0103Ge`08e`<01ML03@3G05iHGP1NF5h0GUP01@0Ve`@01H800`22
PP03PP0308:200B200T0YX:VPZJ208800P004ZJ2YX80PZJ2YX:V0:J2YX:VPP80012/PZb2[880PZb2
[8:/PP220P006:b2[880PZb2[8:/PZ`0[:J/YZbV[02/YP<000ZV[:H0YZbV[:J/0P004jJ/YZbV[:J/
YP2V[:J/YP2V[0002:`00`2/[006[0030=OG00gG00<0emL08]L000gG00@0emL02=L00`3Ge`05e`80
00[G05PdF01H=5P00eP00`1NF00501_G1P00489H07b2O89lPP22O89lPP06PP0308:200>20`06PP03
08:200B200<0PX800X83000?YX:VPZJ2YX80PZJ2YX:V008000f2YX:VPZJ208:VPZJ200<000N2YX:V
PZJ200@001F/PZb2[880PZb2[02/PP2V[:J/YZ`00`001jbV[:J/0:`00P001jJ/YZbV[:H00P002ZbV
[:J/YZ`0[00>e`808mL000gG00@0emL02=L00`3Ge`05e`0G0=OG05QNF01HGUP0F5iHGP22F880PUP0
6`02PP0308:200B200<0PX800h800`22PP04PP0308:200B200<0PP000P004h80PZJ2YX:VPP22YX:V
PZJ208800P004:J2YP2/PZb2[8:/0:b2[882000=[02/PZb2[8:/0:b2[0020007YZbV0:J/YP03000=
YP2V[:J/YZbV[02/YP02000D[:J/0:bV[:J/0:bV[02/YZbV[002[0030:b/00>/00@0[:`01J`0103@
[00?e`030=OG027G000>e`802ML400CG00`0emOG03AH=00dF004F00i05QNF5h0GUQNF01HPUP0F89H
PUP0F89HPP22F89HPP22F89HPP22F89HPP22O89lPW`0O89lPW`000F20`05PP0308:200F200<0PX80
1882000@PZJ2YX80PZJ2YX:VPZH0YP8000b2YX:V0:J2YX:VPZH30005YX:VPZH010003X:VPP2208:/
PZb2[8:/0P00;8:/PZb2[02/YZ`0[:J/YP2V[:J/0:`0[02/YZbV0:J/YP2V[:J/0:bV[:H03mL00`3G
e`0Pe`008=L200?G0`0095h0GUQN05iHGP22F89H05R2F880PUR2F01HPUR2F01NPUj200F200<0PX80
0X800`22PP04PP0308:200>200<0PX8018800`220002000EPP22YX:VPZH0YX:VPZJ2YP2VPZJ200<0
00n2YX:VPZJ208:/PZb2[8800P005Jb2[8:/PP22[8:/PZb20:J/YZbV[003000J[:J/YP2V[02/YZbV
[:J/YP2V[:J/YZbV0:H2000:[:J/YZbV0:J/00>/00<0[0000Z`00`2/[003[00:0:b/0=2/d:c@013G
00<0emL07mL0023G00<0emL00]L00`0dF0030003F3@000AH03H0GUQN05iHGUQN089HPP22F89HPP22
F89H05R2F89H05R2F89H05R2F89H07b2O89lPP22O88400F200<0PX8018800`22PP05PP04088000>2
00d0PZJ2YX:V0:J2YX:V00<000fVPZJ2YX:VPP22YX:V008000B208:V0`001JJ208:V008000^2[8:/
0:b2[8:/PP02000^[8:/PZb2[880YZbV[:J/YZ`0[02/YZbV0:H0YP2V[:J/YZ`0[02/YZbV[:J/00oG
00<0emL07mL0023G00<0emL00mL0101HGeP3000PF01HGUP0F89HPP22F89H05R2F880PUR2F01NPUj2
GP05PP0308:200:200<0PX8018800`22PP02PPD00X800`22PP04PP0?0:J2YX:VPP22YX:VPZJ20080
02FVPZJ2YP2VPZJ2YX:V0:b2[02/PZ`0[8:/PZb2[02/PZ`0[8:/00<000J/YZbV[:H2000R[:J/YZbV
0:J/YZbV0:J/0:bV[:J/YP2V0:J/YZbV[:J/00J/00<0[0002:`02`3@[=2/d:c@0=0000oG00<0emL0
7]L0023G0P04e`0705PdF3@0=004009H02h0F5iH05QNF5iH05R2F01HPUR2F01HPUR2089HPUR2089H
PUR2089HPUR2089l0P000h80PP05PP0308:200B200<0PX8018800`22PP02PP<01h802@2VPZJ2YX80
PP02000=YX:VPP22YX:VPZJ2YP03000IYP000:H0YX:VPZJ2YP2/PZb2[8:/PP22[002000DPZb208:/
PZb208:/0:bV[:J/YZ`20007YZbV[:J/YP02000@[:J/YZbV[02/0:bV[:J/00:/00<0emL03=L2023G
000Pe`030=OG00CG00X0GeQO05mHG`1O1@00689H05R2F880PUR2F01HPUR2089NPUj200F200<0PX80
0X800`22PP02PP@018800`22PP03PP0308:200B200X0PZJ2YX:V0:J20P008ZJ2YP2VPZJ2YX80PZJ2
YX:VPP22[8:/PZb208:/PZb2[884000:[8:/PP2V[:J/YP<001BV[:J/YZbV[02/0:bV[:J/YP2V[080
00^V[:J/0:bV[:J/0002[0030:b/00>/00@0[0001J`03P2/[02/d:c@0=2/d:`03mL00`3Ge`0Me`00
8=L200GG00T0=5PdF01H=00015P00`1N000:000@PP22F89HPP22F89H05R2F0`000V2F01lPWb2O000
1X800`22PP04PP0308:200>20`05PP0308:200F200D0PZJ2YP03000=YX:VPZJ2YP2VPZJ2YP03000^
YX:VPZJ2YX80PZJ208:/PP22[8:/PZb2[02/PZb2[8:/0:`0[8:/PZb2[02/YP8000^/YZ`0[:J/YP2V
[002000=YZbV[02/YZbV0:J/0005[0030=OG00kG00<0emL07=L001oG0P07e`0I05QOF01HGeP0F5mH
05QOF5l0PeR3F01HP`0@00:200<0PX800h800`22PP04PP0308:200>200<0PX800h800`22PP04PP03
0:J200<001>208:VPZJ2YX80PZJ2YX:V0:J2008000f/PZ`0[8:/PZb2[02/00<000f/PZ`0[8:/PZb2
[02/008000^V[:J/0:bV[:J/YP03000DYZbV[:J/YZ`0[:J/YZbV[:H0YP06[0040:b/00B/0P02[003
0:b/00>/00/0d03@[=2/d:c@000?e`030=OG01cG0006e`801=L00`3Ge`03e`030=OG00;G0`05e`03
0=OG00KG0`001UPd03AH00AH0380F5iH05QNF5iH05QNF01HPUR2F01HPUR2089HPUR2089HPUR2089H
PUR2089lPWb200J200<0PX800h8300F200<0PX8018800`22PP05PP8000b2YX:VPP22YX:VPZH5000I
YX:VPP22YX:VPZJ2YP2/PZb2[8:/0:b2[002000:PZb208:/PZb2[08002F2[8:/PZb2[880YZbV[:J/
YP2V0:J/YZbV[02/0:bV[:J/YZ`000N/00<0[0003mL00`3Ge`0Ke`001ML0103Ge`09e`030=OG00GG
00<0emL00]L00`3Ge`07e`0305l000<0025HG`1OF5l0GeQOF01HPeR308=HPeP0F8=HP`23GX=NP`00
18800`22PP03PP0308:200B200<0PX800h800`22PP03PP0308:200<001F208:VPZJ2YP2VPZJ2YX:V
0:J2YX800`002h:/PZb2[880PZb20080012/0022[8:/PZb208:/PZb20`002JJ/YZbV[:H0YP02000E
[:J/YZ`0[:J/YZ`0[:H0YZbV[:J/00<02:`00`2/[005[0801j`0302]0=2/d:c@0=6/00kG0`07e`80
1=L00`3Ge`02e`<01mL000GG00@0emL02]L00`3Ge`04e`030=OG00;G0P08e`0503AH=5P01004F00b
05iHGP1NF5iH05QNF5h0PUR2F880PUR2F01HPUR2F01HPUR2F01HPUR2F01lPWb2O004PP@01H800`22
PP04PP0308:200B200<0PX800P03PP0708:VPZJ2YP04000@PP00YP2VPZJ2YX:V0:J2YP8001N2YX80
PZb2[8:/PP22[8:/PZb2[02/PP02000M[8:/0:b2[8:/0:bV[02/YZbV[:H0YP2V[:J/YZ`00`001ZbV
[:J/00:/00<0[:`00Z`00`2/[002[0030=OG00gG00<0emL01=L0103Ge`0;e`030=OG00CG0005e`04
0=OG00[G00@0emOG0`05e`030=OG00SG00L0=5ld05QO00@001aH05QOF5l0PeR3F01HPeR308=HPeP0
GX=NPeh018800`22PP03PP0308:200B200@0PX:21P02PP0308:200B200h0YX:VPZJ208:VPZJ2YP<0
00Z/PZb2[02/PZb210003j`008:/PZ`0[8:/PZb2[003000Y[8:/PZ`0[:J/YZbV0:H0YZbV[:J/YP2V
0:J/YZbV[02/YZ`0[:J/YP001J`0102/[005[0040:b/00B/0100[Jb][02/d03A[=6/dJ`03mL00`3G
e`03e`040=OG00_G00<0emL01=L000GG00@0emL02mL0103Ge`07e`030=OG00WG00P0=5Pd03AH009H
1@009UP0F5iHGP1NF5iH05R2F89H05R2F880PUR2F880PUR2F880PUR21P03PP0308:200>200<0PX80
18800`22PP04PP03088000<000>208801X840003PZJ2008003:VPZJ2YX80PZJ2YX:VPP22YX:VPZJ2
YP2/PZb208:/0:b2[8:/PZb208:/PZb2[880PP8000V/YZbV[:H0YZ`00P001jJ/YZ`0[:H00P002:bV
[:H0YZ`01J`00`2/0006[0804=L00`3Ge`02e`040=OG00SG0`07e`001ML0103Ge`08e`040=OG00;G
00<0emL01=L200_G00l0GcAO05mHG`1OF5l0GeP01@004eR308=HPeP0F8=HP`23GX=NP`0018801022
PX86000:Ph80PX>2Ph:300F200<0PX8018801P22YX:VPP<000^2YX:VPZH0[8:/PP030004PZb2[080
00j208:/PZb2[880PZb2[08000b208:/PZb2[880YZ`2000;YZbV[02/YZbV[:H00P005:bV[:J/YZbV
0:J/YZbV[:J/0:`01Z`00`2/0006[00E0:`0[Jb][:f/[@3A[=6/dJ`0[=4000oG00<0emL00]L0103G
e`08e`030=OG00OG0006e`802ML400;G1003e`030=OG00_G0P001SAH05Pd00AH00L0GUQN05iH01/0
00YHPP22F89HPUP01X800`22PP03PP0308:200B200<0PP000P02PP0308:200B200<0PP000P03PP0B
08800:J2YP2VPZJ2YX:V0:J20P003:J2YP2VPZJ2YX:VPP8001J/PZb2[880PZb2[880PZ`0[8:/PZb2
0P007:bV[:J/YZbV[02/YZbV[:J/YP2V[:J/YZbV[007[0030:`000B/00D0[:b/000>e`<00mL0103G
e`08e`030=OG00OG000Ne`803=L00`0d0002000jF5mH05QOF01HGeQO08=HPeP0F8=HP`23GX=N05j3
GX=N08:3PX<0Ph:3PX<0Ph:3PX<0Ph:3PX>200F200<0PX800h83000;PZJ2YX80PZJ2YX800`001X:/
PZb2[08000j2[8:/PZ`0[8:/PZb2[08001Z2[8:/PZ`0[8:/PZb2[02/YZbV[:J/YP2V[08001>V[:H0
YZbV[:H0YZd0[:J/YZbV008000>]0:`01J`00`2/0006[00F0:d0[Jb][:d0dJ`0[=6/0:cA[=6/013G
00@0emOG0P09e`@01]L001kG00<0emL03=L00`0dF0020003=5P000AH02`0F5iH05QNF5h0GUQNF01H
PUR2F01HPUR2089HPUR2089HPUP0F89HPUR200J200<0PX800h800`22000200:200<0PX8018800`22
000200:200<0PX800X82000>PP2VPZJ2YX80PZJ2YX83000=PZJ2YX:VPZH0YX:VPP03000DPZb2[8:/
PZ`0[02/PZb2[880PZ`2000PPZb20:J/YZbV0:J/YP2V[:J/YP2V[02/YZbV[02/YP03[0801:`00`2/
0005[0030:`000oG00<0emL05]L001kG00<0emL03=L0101O=5l3000hG`1OF5l0GeQOF01HPeR308=H
PeP0GX=NP`23GX=NP`23PX>208:3PX>208:3PX>208:3PX>2P`03PP@000b2Ph:3PP22YX:VPZH20008
PZJ2YX:V0:`2000NPZf208:/PZb2[880PZb208:]PP22[8:/PZb208:/0P00::J/YP2V[:J/YZbV[02/
YZbV[:J/0:`0[JJ]YZfV0:J/YP2/[Jb][002[08000F/[Jb]0002[08001R][:f/0:`0[=6/dJcA[02/
dJcA[02/e`0@e`030=OG01GG000Ne`803]L01P1H=5P0F0@00UP0;01NF5h0GUQNF01HGUQN089HPUP0
F89HPUP0F89HPUP0F89HPP22F89HPUP01H8400>200<0PX8018800`22PP030003PP2200B20`06PP09
08:VPZJ2YP2V008000f2YX:V0:J2YX:VPZJ2008000b/PZb2[02/PZb2[883000BPZb2[8:/PZ`0[8:/
PZb2[02/0P006ZJ/YZbV[02/0:bV[:J/YP2V0:J/YZbV[:H01j`200B/00<0[:`00Z`00`3Ge`0>e`03
0=OG01CG000Ne`030=OG00gG00X0=5ld05QOF01H1@00:eQO08=HPeP0F8=HP`23GX=N05j3GX=N08:3
PX<0Ph:3PX<0Ph:3PX<0Ph800`003X80PX>2Ph80PX>2Ph:30`001jJ2YX80PZH00`007jf208:]PZf2
[@2/PZb2[8:/0:f2[H:]PZd0[8:/PZ`00`002jbV[:J/YZ`0[:J/008000ZV[JH0YZbV[:J/0P00>JJ]
YZfV[JJ]0:f/[Jb][:f/[@2][:f/[Jb][02/[Jb][:f/0:`0[=6/dJ`0[=40dJ`0[=N/ejcG000>e`80
5]L001gG00<0emL03mL03P0dF3@0=5P0GUQNF01H1@008UQN05iHGUP0F89HPP22F89HPP22F89HPP22
F89H05R2F88400F200<0PX800h800`22PP030003PP2200B20`05PP0308:200F200D0YX:VPP03000;
PZJ2YX:VPP22YX800P003:b2[02/PZb2[880PP80036/PZb2[02/PZb2[02/PP22[8:/PZ`0[02/YZbV
[:J/0:`0[:J/YZbV0:H0YZbV[:H000:/00<0[:`00Z`01`2/[:`0[0001Z`00`2/000?e`030=OG01?G
000Me`<03mL2000A=5l0GeQO05mHG`1OF5mH05P02`001Uj308=NPa4000n3PP22Ph:3PX<0Ph:3PX<0
0`001h>2Ph80PZH00`004jd0[H:]PZf2[@2]PZf2[H80PZ`00P002h:]PP22[H:]PZf200<001V2[H:]
PP2V[:J/YZbV0:J]YZfV[JJ]0:bV008003f]YZd0[JJ]YZd0[Jb]0:f/[Jb]0:f/0:b][:f/0:b]0:f/
[J`0[:f/[@3A[02/dJcA[02/ejcG[=L0ej`0013G00<0emL04]L001GG1004e`030=OG013G0`006UP0
F3AH05iHGP1NF5h0GUQNF01HGUQN089H1P003X9H05R2F89H05R2F8801X800`22PP04PP0308800080
00>20880188300F200<0PX801H800`22PP03PP<001^VPZJ2YP2VPZJ2YX:V0:b2[8:/PZb208:/PZ`0
0P005H80PZb2[8:/PP2208:/PZb2[02/PP020008[8:/PP2V[:H20007[:J/YP2V[0020008YZbV[02/
YP05[0<01J`00`2/0004[0030:b/00:/00<0emL03ML00`3Ge`0Be`005mL00`3Ge`03e`030=OG013G
00<0=5l01000=UP0F5mH05QOF5l0PeR3F01NPej308=NPeh0GX=NPeh0PX>2P`23PX>2P`23PX>2P`23
PX>2P`<000N3PX>208:300<001>W0:f2[H:]PP22[H:]PZf208:]00<000j]0:f2[H:]PZd0[H:]PP80
05f]0:f2[H:]PZd0[:J/0:fV[@2]YZfV[JJ]YP2V[JJ]YZfV0:H0[:f/[Jb][02/0:b][:f/[@2]0:f/
[Jb][02/0:b][:f/[J`0[=6/dJ`0[=40ejcG0=N/ej`0[0003mL00`3Ge`0Ae`005mL00`3Ge`03e`80
4]L01P0dF3@0=0@002MNF01HGUP0F5iHGP1NF5iH05R2F880PUR2F880PUR2F880PUR2F0001X800`22
000200:200@0PX:21005PP0308:200B200<0PX80188300F200X0YX:VPZJ208:V0P0038:VPP22[8:/
PZb2[0<000^/PZb2[02/PZb2[002000VPP22[8:/PZb208:/PZb2[8:/PP2V[:J/YZbV[02/YZbV[:J/
YP07[0<00j`00`2/[002[0030:`000B/00D0[:b/000=e`030=L001;G000Ge`030=OG00?G00<0emL0
4]L02@0dG`1OF5l0G`03000ZGeQOF01HPeR308=NPeh0GX=NP`23GX=NP`23PX>208:3PX>208:3PX>2
0P0018>2Ph85000EPX<0Yh:WPZN208:]PZf2[@2]PZf20080012]0:f2[H:]PP22[H:]PZf20P009Jf2
[H:]PP22[H:]PZf20:J]YZfV[JJ]0:fV[@2]YZd0[JJ]YZd00P002:`0[:f/[Jb]0P007:`0[:f/[Jb]
0:d0[Jb][:f/0:`0[:f/[J`0[=42000D[02/dJcA[=40ejcG[02/ejcG[00>e`030=OG013G000Ge`03
0=OG00;G00<0emL04mL02`1H=5P0F3AH05hd00@0029N05iHGUP0F5iHGP22F89HPP22F89H05R2F89H
05R2F8800X830003PP2200<00X800`22PP03PP0308:200B200<0PX80188010220004PP0308:200B2
00D0PZJ2YP02000>PP22YX:VPZJ208:/PZ`3000:[8:/PZb2[880PP8002N/PZb2[02/PZ`0[8:/0:b2
[8:/0:bV[02/YZbV[02/YP2V[:J/YP000Z`0102/[:`200>/00<0[0001Z`00`2/0003[0030:b/00:/
00<0[0003]L00`3Ge`0?e`005ML300CG0P0Ee`8000`dG`1OF01HGeP0F5l:000FGX<0Pej3GP1NPej3
GP22Ph:308>2P`X001R2Ph:3PP22Ph:3PP22Yh:WPZL0[H:]PZd3000@[H:]PZf208:]PZf2[@2]PP80
00j]PZd0[H:]PZf2[@2]PP8001J]PZd0[JJ]YZfV[JH0YZfV[JJ]YP2V0P004Zf/[Jb]0:f/[@2][:f/
[@2][08000N][:f/0:b]008000f/[Jb]0:d0dJcA[=6/008001CA[=6/d@3G[=L0e`3G[=N/0:cG00kG
00<0emL03mL001OG00<0emL00]L00`3Ge`0De`0303@0008001<dF3@0=5hd05QNF5h0GUQNF01H01L0
00=NPP001H800`22PP04PP0308:200>200<0PX8018800`22000200:200<0PX801H800`22PP04PP80
00j2YX:VPZH0YX:VPZJ2YP8000b2[8:/PP22[8:/PZ`2000CPP22[8:/PZb208:/PZb2[880PP02000B
[:J/YZbV0:H0YZbV[:J/0:`01j`00`2/[004[0040:`000:/0P05[0030:b/00:/00H0[;://P0=e`80
4=L001cG00<0emL05ML00`0dG`03000RG`1OF5l0GeQOF01HPeR308=NPeh0GX=NP`23GX=NP`23PP<0
01j2Ph:3PP22Ph:3PP22Ph:3PX<0Ph:3PX<0Yh:WPZL3000B[H:]PZd0[H:]PZf2[@2]PZf20P003Zd0
[H:]PZf2[@2]PZf20`002h:]PZf2[H80YZfV008000V]YZd0[JJ]YZd00P009:`0[:f/[Jb][02/[Jb]
[:f/[J`0[:f/[Jb][:d0[Jb][:f/[@8000V/dJcA[02/dJ`00`004jcG[=N/e`3G0=N/0:cG[=L0e`00
3]L00`3Ge`0=e`007=L201KG00H0F3AH05P4000K=5h0GUQNF01HGUQN05iHGP22F89HPP22F89H00<0
00YHPUP0GX9NPUh01H800`22PP04PP0308:200>200<0PP000P02PP0308:200B200<0PX801H804P22
0022YX80PZJ2YX:VPP22YP8000b2[880PZb2[8:/0:`2000DPZb2[8:/0:b2[02/PZ`0[8:/PZ`20008
PP2V[:J/YZ`2000;YP2V[:J/YZ`0[0001J`0102/[002[0801J`200F/00l0[:`0[02//Zbb0=J/eP00
3ML00`3Ge`0=e`007=L00`3Ge`0Fe`0805ldG`1O=5l4000EF5mHGeP0F8=H05j3GX<0Pej3GP1N00<0
01eN08:3PX<0Ph:3PX<0Ph:3PX>208:3PX>208:3PP04000C[H:]PZd0[H:]PZf2[@2]PZf2[@03000>
[H:]PZf208:]PZf2[H82000H[H:]PZd0[H:]PZf2[@2]YZfV[JJ]YP2V0P009:f/[Jb]0:f/[@2][:d0
[Jb][:d0[Jb]0:f/[Jb]0:f/0:b][08002B][:d0d@3A[=6/dJ`0[02/ejcG0=N/ej`0[=N/e`3G[=L0
e`0=e`030=OG00cG000Ke`030=OG01OG00/0=5Pd03AH=00dGP04000?F5h0GUQNF01HGUQN089H00<0
015HPUR2089HPUR2089NPUj20005PP0308:200:21@03PP0308:200B200<0PX8018800`22PP03000?
PP2VPZJ2YX:VPP22YX:V00<000b/PZb2[8:/0:b2[882000D[02/PZb2[8:/PP22[8:/PZb20882000B
[8:/PZ`0[:J/0:bV[:J/0:bV0P04[0030:`000J/00<0[:`01:`00`2/[00200:/00<0[:`00Z`03P2/
0:bb0=J/eP3F[=H03ML00`3Ge`0;e`006mL201WG0P0035ld03AO=01HGeP0F0H000J308=NPeh3000H
GX<0Pej3GX<0Ph:3PP22Ph:3PP22Ph:31P005X:308>2Ph:30:f2[H:]PZd0[H:]PZd3000@[H:]PZd0
[H:]PZf2[@2]PP8000f]PZd0[H:]PZf208:]008000Z2[H:]0:fV[JJ]0P004jH0[:f/[Jb][02/[Jb]
[:f/0:`00P008jf/[Jb][02/0:b][:f/[J`0[:f/[Jb]0=40dJcA[02/ejcG00<001CG[=N/0:cG0=L0
ejcG0=N/ejcG00_G0P07e`@00]L001_G00<0emL06ML4000?F3AH=00dGP1NF5iH05QN00X000]HPP22
F89H05R2F00<00:200<0PX8018800`22PP03PP0308:200B200<0PX800`000h80PP05PP0808:VPZJ2
YX83000=PZb2[880PZb2[8:/PP02000E[8:/PZb208:/PZ`0[8:/0:b2[8:/008001B208:/PZb2[880
YZbV[:J/YZbV00J/0`05[0040:b/00>/00<0[:`01:`00`2/[002[00A0:bb[;80eZcF[02/eZcF0=L0
0P0;e`030=OG00KG00<0emL00ML001_G00<0emL06]L00`0d0003000=G`1OF5l0GeQOF01NP`030006
Pej308=N2`008X:3PP22Ph:3PP22Ph:3PP22Ph:3PP22Ph:3PX<0[H:]PZd3000A[H:]PZd0[H:]PZf2
08:]PZd00P003X80PZf2[H:]PP22[H:]0P002h80PZf2[H:]PP2V008001>]YZfV[@2][:d0[Jb]0:f/
[Jb]008000R/0:b][:f/[@<000b][:f/[@2][:d0[J`2000IdJcA[02/0:cG[=N/e`3G0=N/0:cG[=L0
e`02000<[02/ejcG0=Nb0;802mL00`3Ge`05e`030=OG007G000Ke`806mL01P0d=3@0G`@000HdGP1N
F5h3000NGUP0F5iHGP22F89H05R2F880PUj2GX80PUj2GX801H800`22PP04PP0308:200>200<0PX80
0`000h80PP05PP0308:200B200<0YX800P003Zb2[880PZb2[8:/0:b20P002jb2[02/PZb2[8:/0080
00V2[8:/PZb208800P004Zb2[8:/0:b2[02/PZ`0[:J/YP800j`01@2/[:`000B/00<0[0001j`00`2/
[004[0030:b/00<000f//Zbb0;>//j`0[=J/008000OG[02/ej`000[G00<0emL01ML00`3Ge`01e`00
00?G00000P03e`030=OG00;G1002e`<01ML00`3Ge`0Ke`0805ldG`1O=5l7000bG`23GX<0Pej3GP1N
Pej308=NPej308>2Ph:308>2Ph:308>2Ph:308>2Ph:308>2Ph84000B[H:]PZd0[H:]PZf208:]PZf2
0`003X:]PZf2[@2]PZf2[H:]0P002h:]PZf2[@2]PZf2008001B]YP2V[JJ]YZfV0:b][:f/[J`0[080
00N][:f/[@2]008000N/[Jb][02/008001B][:f/[J`0[=6/dJcA[02/0:cG[08000CG[=N/0P005]N/
e`3G[=N/0:`0[02bek80/]Nb0;8200SG0P06e`030=OG007G0003e`030=OG00OG00<0emL01]L01@3G
emL001oG0P001C@0=5ld00L002=H05QNF5h0GUQNF01HPUR2089HPUP0GX9NPUh0GX9NPUj20004PP03
08:200:21P02PP0308:200B200<0PX8018800`22PP0300:200d0[8:/PZb2[02/PZb200<000Z2[8:/
PZb208:/0P002X:/PZ`0[8:/PZ`2000CPP22[8:/PZb208:/PZb2[8:/0008[0030:b/00F/00<0[000
1J`01`2/[:`0[0001J`06`2/002b0;>//j`0[;>/0:cG[02/ej`0/]L0eP0200?G1@04e`<00mL000?G
00<0emL02=L00`3Ge`05e`040=OGe`807mL80005F5mH05P01@008Eh0GX=NP`23GX=NP`23GX=N08:3
PX>208:3PX>208:3PP06000FRH:908V2RH:90:f2[H:]PP22[H:]PP<00122[H:]PP22[H:]PZf208:]
0P002h:]PP22[H:]PZf2008001F]YZfV[JJ]0:fV[@2][:d0[Jb][:d00P008:`0[:f/[Jb]0:d0[Jb]
[:f/0:`0[:f/[J`0[:d0dJcA0P003jcG[=N/0:cG[=N/0:cG[002000?ejcG[02/ej`0/P2b0;;G0080
00Nbe`3G/P2b00P01]L00`3Ge`01e`000mL00`3Ge`09e`040=OGe`<01=L00`3Ge`0Ne`H000aO=00d
G`1OF5mH05P:000BPUP0F89HPP22GX9NPP22GX9N1@0015j2GP05PP0308:200>200<0PX8018800`22
PP0300:200<0PX8018802022[8:/PZb20P002jb2[8:/0:b2[8:/008000^208:/PZb2[880PP02000D
[8:/PZ`0[8:/0:b2[02/PZb2[002[0030:b/00>/00@0[:`00j`200B/00<0[0001Z`00`2/0002[080
00B//jbc0`005k>/0:bc[02/ej`0[=L0ek;G0=Jb0;;F008000>b0;800`0:e`000mL00`3Ge`0:e`04
0=OG00KG00<0emL07ML30003=5ld00@001=OF5l0GeQO05mNGeh0GX=NP`23018001^2P`23PX>2P`29
PXV2RH80PXV2RH80PZf2[H800`004X:]PZf208:]PZf2[H80PZf2[@8002>208:]PZf2[@2]PZd0[H:]
0:fV[JJ]YZfV0:b][:f/[J`0[0020008[Jb][:d0[J`20007[Jb][02/[@02000R[:f/[@2]0:f/[Jb]
[:d0ejcG[=N/0:cG0=L0ejcG[=L0e`8000^/0:cG[02bek80/P020005ek;G0=L00P001k;G002b0;80
0P02e`030=OG00OG00001=L00009e`040=OG00;G00<0emL01=L201_G0`02e`0703Dd=@1O=003000]
=01HGeQO05mHGeP0F5mH05R3F8<0Pej3GX<0Pej3GX<0PUj2GX80PUj2GX8000J200<0PX800X800`22
PP0300:200<0PX8018800`22PP04PP030:b2008000b/PZ`0[8:/PZb20882000;[8:/PZ`0[8:/PZ`0
0P005880PZb2[8:/PP22[8:/PZb208801Z`00`2/0007[0030:b/00B/0P000jd0[002[08000V/[Jb]
0;>//j`00P000k>//`02000C[;>/0:cG[02/e`3G0=L0eP3F/P030003/P2b00800mL00`3Ge`07e`00
0mL00`3Ge`08e`800mL400?G00<0emL05mL300KG0P001SAO05ldG`D003=OF5l0GeiO08=NPeh0GX=N
P`23GX=N08:3PX>208:3PX>208:3PX>2P`29PXV2R@29PXT010004h:]PZf208:]PZf2[H80PZf2[H80
0`0038:]PZf2[@2]PZf2[@8001J2[H:]PZf2[@2]YZd0[Jb]0:f/[Jb]0P006J`0[:f/[Jb][02/[Jb]
[:f/[@2][:f/[J`00P005Jd0[Jb][02//jbc0=L0ejcG[=L0e`020007[02/ejcG[003000<[02bek80
/]L0ek;G0`002=Nb0;80/P2b0P04e`030=OG00OG000Ie`030=OG01GG0`0:e`@000LdGc@0=5ld00D0
02IHGeQO05mHGeP0F8=H05j3GX=N05j3GX=N05j2GX9N05j2GX9N00B21@03PP0308:200B200<0PX80
18800`22PP03000<PXP0[8:/PZb208:/0`003:b208:/PZb2[880PP8001>/PZb2[02/PZ`0[8:/0:b2
[8:/008000>20:`01:`20003[@2/00>/00L0[:f/[@2/008001Z/[Jb][:d0[Jb][:d0/jbc[02//jbc
[02//`<000gG[02/e`3G/]L0/`2c00T01ML00`3Ge`07e`006ML201?G0`0>e`0303/0008000UO=01H
G`1OGUl02@0078<0Pej3GP1NPej3GP22Ph:308>2Ph:308>2Ph86000FRH80PXV2RH:90:f2[H:]PP22
[H:]PP<000f2[H:]PP22[H:]PZf2008001R]PZf2[H80PZf2[H:]PP2/[Jb][:f/0:`2000I[Jb][:d0
[Jb]0:f/[@2][:f/0:b][:d0[@02000C[:f/[Jb]0;>//jbc[;<0e`3G[0020009ejcG[02/0:cG0080
00J/ej`0/]L2000A/]Nb0;;G0=L0ek80/P2b0;800P06e`030=OG00OG000Ie`030=OG00oG0`0Ae`04
03@e=0@000mO=5l0GcAO=01HGeP0F5l01@002h<0Pej3GX<0Pej300`000YNP`23PX>2Ph801H800`22
PP04PP0308:200<000j2R@28PXR2R880PZb2[08000j208:/PZb2[02/PZb2[08001>208:/PZb2[880
PZb2[8:/PP22008000N/PZb2[02/0080046/[Jb][:d0[Jb][:f/[@2]0:f/[Jb]0:f/0:`0[;>//j`0
[;<0/`2c[;>/0:`0[02/0:`0/]L0/`2c/P2b0;80/P0200OG00<0emL01mL001WG00<0emL03=L301GG
00H0=3/d03@3000BF5l0GeiO05mNGeh0GX=NP`232`008H>2P`23PX>2P`29PXV2R@29PXV2R@29PXV2
RH80PZf2[@04000?PZf2[H80PZf2[H:]0:f2008000j]PZf208:]PZf2[@2]PP8000V]R:d0[Jb][:d0
0P00:J`0[:f/[Jb][02/[Jb][:f/[@2][:f/[Jb]0:d0[Jb][:d0/j`0[;>/008000WG[=N/0:cG[=L0
0P007JcG[=L0ejcG[02bek80/]Nb0;;G0=Nb0;80/P2b00@02=L00`3Ge`07e`006ML200[G0`0Ie`80
00De03/d>`04000a=5ldG`1OF5l0GeQOF5l0GeiO08=NPej308=NPeh0GX=NPeh0GX=NPeh0PX>2Ph:3
0005PPD00123PX<0RH:9PXV208:8PXR20`003H:]PZf2[@2/PZb2[8800`002H:/PZb2[02/PP020009
[H:]0:b2[8:/008000N208:/PZb2008000j]0:f/[Jb]0:f/0:b][08000j][:f/0:`0[:f/[J`0[080
00Vc0;>//jbc0;<00P001:`0[;<30004/j`0/P8000Rc/P2b0;80/P8000>b0=L02=L00`3Ge`07e`00
6ML00`3Ge`07e`807ML40005GcAO05l01000<5h0GUmNG`23GX=N05j3GX<0Pej3GP22Ph:3PP22Ph:3
PP22RH:9PP22RH:9PP22R@<001:90:f2[H:]PP22[H:]PZd0[H83000=PZd0[H:]PZf2[@2]PP03000:
PZd0[HR]R:f8[@8000V/[Jb][:d0[J`00P004:f/[@2][:f/0:b][02/[J`2000C[Jb][02/0:bc[;>/
/j`0[=N/e`02000F[=N/e`3G[=N/e`3G[=N/0;;G0=Nbe`8000Bbe`3G2`0;e`030=OG00KG000He`03
0=OG00GG0`0Oe`0303Dd00<000Ld03AO=00d00D002MH05QOF5mH05iOGP1NPej3GP1NPej3GP1NPej3
GP1NPej308>2Ph8010004X>2Ph:308>2Ph:3PP22RH:9PP<000f2RH:9PP22[H:]PZf200<000^2[H:]
PP22[8:/PP020009[@2]PZf2[H:]008000R2[H:]PZd0[08001J8[HR]R02/0:b][:f/[J`0[:f/[Jb]
0P003j`00:d0/jbc[;<0/`2c[0020006/jbc[02/0P000k>//`03000:/`2c/P2b0;80/P8000>b0=L0
2mL00`3Ge`06e`006=L00`3G0002e`<08mL0100k=3/40009=5ld05iOGP1N00/001IN05j3GX<0Ph:3
PX<0Ph:3PX<0RH:91P004h:9PP22RH:9PP22[H:]PZd0[H800`003X:]0:f2[H:]PP22[H:]0P0038:]
0:f2[H:]PP28[@8000V8[HP0[:f/[J`00P006Jd0[Jb][:f/[@2][:f/[Jb][02/[Jb][:d00P009j`0
[;>//`2c[;>//`3G[=N/e`3G[02/0:cG[=N/0;;G0=L0e`3G/P020008ek80/P2b0;8400gG00<0emL0
1]L000CG1003e`030=OG00;G0`05e`D09]L01`0d=C@0=3/00`004Ul0GcAO=01HGeP0F5mHG`1OGQH0
01J3GX<0Ph:3PX<0Ph:3PX>208:3PX>20`003h:9PXV208:9PXV2R@2]PP02000<[H:]PP22[H:]PZf2
0P005:f2[H:]PP22[H80PZf208:]PZf20P001jd0[HR]R:d00P003J`0[:f/[@2][:f/0:`00P002Zf/
[Jb]0;<0/j`20009/jbc[02//jbc008000^//`2c[;<0/k80/P0;00oG00<0emL01]L000KG00<0emL0
2]L00`3Ge`02e`80:]L20006>c@0=5ld1000>5mNG`1OGUmN05j3GX<0Pej3GP1NPej308=NPej308V2
RH:908V2RH:908V2RH:908V2RH:90:f20`003h:]0:f2[H:]PP22[H:]PP03000<PZf2[H:]PP22[H:]
0P002XP0R:f8[HR]0:d20008[:f/[J`0[:d2000?[:f/0:b][:d0[Jb][02/008001Zc[;>//j`0[;>/
/jbc0;>/0:`0[=N/ej`0[08000CG0=Nb0P001MNbe`3G008000>be`000P001ML0/`2b00804=L00`3G
e`06e`001]L00`3Ge`0:e`030=OG00?G00<0emL0:ML40006>c@k05ld1000<El0GeQO05mHGeP0GUmN
G`23GX=NP`23GX=N05j3GX=N05j3GX=N08:3PX>208:3PX<010003h:9PXV2R@29PXV2R@29PP03000=
PXT0[H:]PZf2[@2]PP02000D[H:]0:f2[H:]PZd0[H:]PZf2[H820008[HR]R:f808P2000=[Jb][:f/
0:b][:f/[@020005[02/[J`00P002K>//j`0[;>//`02000;[;>//`2c[02//j`00P001;>b0;8;017G
00<0emL01]L000KG00<0emL01mL300OG0P0Ze`0303@0008000PdG`1O=5l0G`D002IO08=NPeh0GX=N
P`23GX=N05j3GX=N08:9PXV208:9PXV208:9PPH00129PXT0[H:]PZf208:]PZf20`003X:]PZf2[@2]
PZf2[H:]0P002hR]R:f8[@2]R:f8008000N]0:f/[Jb]0080012/0:b][:f/[J`0[:f/[Jb]0P004Z`0
[;>//`2c[;>/0:`0[;>//`8000V/003G0=N/ej`00P005ML0003G/P2bek80/]L0e`2c0;<0/P0201;G
00<0emL01]L000KG00<0emL01mL00`3Ge`09e`030=OG02SG00<043D010002SAO=00dGcAO05l5000L
G`1OGUmN05j3GX=N05j3GX<0Pej3GX<0Pej3GPD001B2Ph80PX>2Ph:308V2RH:9PP22R@8000n2R@29
PXV2RH80PZf2[H800P002jd0[H:]PZf208:]008001:2[H80PZf2[@2]R:d0[HR]R:d2000=R02/[Jb]
0:f/[J`0[002000M[Jb][:f/0:bc[;<0/jbc[;<0/jbc[02//j`0[;<00P001K:c/P2b008000Fc0;<0
/P0401CG00<0emL01ML000CG0`09e`030=OG00[G00<0emL0:=L20003>`0k00@000`d05iOGP1NGeiO
05lL000FPXV208:9PXV208:9PXV208:]PZf2[@<000n]PZf2[@2]PZf2[H80PZd00P002hR]R028[HR]
R:f8008000R][:f/[J`0[08000R][:f/[@2][08000J][:f/0:`2000=/jbc[;>/0:bc[;>//`020003
[02/008000Vc[;>//`2c0=L00P005;;G/P2bek80/P2b0;80/]L0/`2c100Ee`030=OG00GG0006e`03
0=OG00OG100:e`030=OG02SG100013/d03@5000f=01HGeP0GUmNG`1OGUmN05j3GX=N05j3GX<0Pej3
GX<0Pej3GX<0Ph:3PX<0Ph:3PX>208:90`003hV208:9PXV208:9PXV2R@03000;[H:]PZf208:]PZd0
0P004X80PZf2[H:]PP28[HR]R:f8[@8000j8[HR]R:f80:b][:f/[@8002>/0:b][:d0[Jb][02//jbc
[;<0/jbc0;>//j`0[;>/0;:c/P030006/[<0/`2b1@0Ee`030=OG00GG000Oe`80:=L00`0k=0030007
=00eGcD0>`05000]GP1NGeiO08=NPeh0GX=NP`29GXUNR@29PXV208:9PXV2R@29PXV2R@29PXV200@0
00n]PZf2[@2]PZf2[H80PZd00`003:f808R]R:f8[@2]R08000V]R:d0[Jb][:d00P001j`0[:f/[J`0
0P001jd0[Jb][:d00P003J`0[;>//`2c[;>/0:`00P000k>//`020005[@2//j`00P001K>]002c0080
00Bb0;;G0P001k;G002b0;802@000mL0e`0De`030=OG00GG000Qe`030=OG02KG00@0=A0e10002C@k
05ldGc@0=005000RGUl0GeiO08=NPej308=NPeh0GX=NPeh0GX=NPeh0PX>2P`H00122RH80PXV2RH:9
08V2RH:90`0038V2RH:90:f2[H:]PP<000V2[H:]PZd0[H800P001jf8[HP0R:d00P003hR]R028[HR]
0:f8[HP0[002000X[Jb][:f/0:b][:d0/jbc[02/0:bc[02//jbc[02//`2c/[<0/k80/P8000>c0;80
0`04e`030=OG01;G00<0emL01ML002;G00<0emL09]L20004=00d>`<000MO05lkGc/000=O00<0G`00
1@0048<0Pej3GP1NREj9GP22RH8<000CRH:908V2RH:90:f2[H:]PP22[@03000<[H80R:f8[HR]0:f8
0`002HR]0:f8[HR]R0030007[:f/[Jb][0020008[Jb][:f/0:`2000=/jbc[;>/0:bc[;>//`020003
[@2/008000Vc[K>]/jd0[K<00P04/`8000Fc003G/P020006/`00/P2b1P06e`030=OG017G00<0emL0
1ML002?G00<0emL09]L40003=3/d00D000hdG`1O=5ld05iOGUl0Ga0001]NPeh0GX=NPeh0PXV2RH80
PXV2RH:908V2RH80100038V2RH:908V2RH:9PP<000V2[H:]PZd0[H800`0028R]0:f8[HR]0P0048P0
R:f8[HR]R028[HR]R:d2000BR02/[Jb]0:f/[J`0[;>//jbc0P002j`00;>//jbc0;>/008000Nc002b
/`2c008000>b08h00`09e`030=OG013G00<0emL01ML002CG00<0emL09]L50005>`1O>el01@03G`03
05mO009O02L0Gh=OP`29GhUO05n9GhUO08>9PhV308:9PXT0RH:9PXV208:9PXT01P003H:]PP22[H:]
PZd0[HP00`002XR]0:f8[HR]R:d20009R:f8[HR]0:f/008000V][:d0[Jb][:d00P003Jd0[;>//`2c
[K>]0:`00P004K>]/jd0[@2]/jfc0;>]/`2c008000>c00000[<01P2c/k<0/`/02]L00`3Ge`0Ae`03
0=OG00CG000Ue`80:=L00`0@00030006>c@k05ld10009Ul0GeiOGP1NGeh0GX=NPeh0GX=NP`23GX=N
P`23GX=NP`29PXV21P0048V2R@29PXV2R@29PXV2RH83000;PZf2[H80PZf2[H800P002Jd0[HR]R:f8
[@020009R:f8[HR]0:f8008000J]R:f808P2000;[HR]R:f80:b][:d00P001Jbc[02/008000^c[000
/jbc[02//`02000:/[<00;:c0;<0/`H03=L00`3Ge`0@e`030=OG00CG000We`030=OG02KG0`000cD0
00020007G`1O>el0G`05000KG`23Gh=O05n9GhUO05n9GhT0RH>9PhT0RH:900H001>3RH<0PhV3RH<0
PZf2[H:]0:f200<000b9[@2]R:f8[HP0R:d20009RJf908R]R:f8008000V]0:f/[Jb][:d00P07[@07
0:fc[K>]/`02000;[@00/`2c[K>]/jd00P000k>]0004/`8000Bc00000[<00`2c/`040003/`2c00<0
3mL00`3Ge`0?e`030=OG00CG000Xe`030=OG02GG00P04@0043/0>`@000Pd03YO>Ul0Ga/001F9GXT0
RH:9PXV208:9PXV208:9PXT0100038:9PXV208:]PZf2[@<000V]PZf2[H80R:d00P002HR]R028[HR]
R0020007[@2]R:f8[@020005R000[HP00P002jf8[HR]0;>//jbc008000n//`00[;>//`2c[;<0/k80
0P001[>b0;80SPH04=L00`3Ge`0?e`030=OG00CG000Ye`030=OG02GG00<0>a000P000c/0>`02>`@0
0el00`1OG`02G`0X08=OPel0GhUOREl0GhUOR@29PhV3R@29PhV3R@29PhV3R@29PhV3R@D000f]RJd0
[HV]RJf908R]00<000V]R@29[HV]RJd00`002Jf9[HV]R@2/[@0200B]00<0[Jd00P001K>]/jfc0080
00F]/jfc[@020004/`2c[@8000>c[K<00P000k<0/`0200:c0P02/`8000>c00002@0Be`030=OG00kG
00<0emL01=L002[G0P0Ve`8000<@00000`0013@0=3/4000[>P1NGeh0GUmNGeh0GUmNG`23GX=NP`23
GX=N05j9GXUNR@29PXV2R@29PP02000?RH80PXV2RH80PXV2RH:900<000V]PZf2[H80PZd00`002Jf8
08R]R:f8[@030007[HR]R:f8[@020005R:f8[HP00P002jd0[HR]R028/hRc008000V//jbc0;>//j`0
0P002K>/0;:c/P2b/`040003SP2>00@05=L00`3Ge`0=e`030=OG00CG000/e`030=OG02CG10000a0k
00030005>elk03/01@0075l0Gh=OPel0GhUOR@29GhUOR@29PhV308>9PhT:000>PhV3RH<0RJf9[HT0
RJd3000:[HT0RJf9[HV]R@8000V]RJf9[HT0RJd00`000jf90005[@8000Fc002]/`020006[K>]/`2c
0P000jfc[@020004/`00[@800k<200:c0P02/`800[<0102c0;<601OG00<0emL03=L00`3Ge`04e`00
;ML00`3Ge`0Te`D000<k03/010001c@0>Ulj03X0700058UNR@29PXV2R@29PXV2RH80PXV210002hV2
RH:90:f2[H:]008000V808R]R:f8[HP00P002Jf8[HR]R028[@020005R:f8[HP00P006jf8[HR]R:d0
/hRcR028/hRcR02//jbc0;>//`020005SP00/k8010000k<0/P0401SG00<0emL03=L00`3Ge`04e`00
;]L00`3Ge`0Ue`03010000<00S/00`0k00040003>`00009O02P0GfEOIEl0GhUOR@29GhUOR@29PhV3
08>9PhV308>9PhV3R@29PhV31@003HV]R@29[HV]RJd0[HT00P002Jf9[@2]RJf9[@020008R@29[HV]
RJd30005/jfc[K<00P001jd0[K>]/jd00P000k<0/`020004[K>]/`8000>c0;<00P03/`030;>c0080
00>c00002P0Je`030=OG00cG00<0emL00mL002oG0P0Ve`<000<@0000100013/d03X8000OGeiO05mN
GeiO08=NPeh0GXUNREh0GXUNREh0PXV2R@060009PXV208:9PXV2008000>9PXT010002HR]R:f8[@2]
R0020007[HR]R028[@030006[HP00:f80P001jf8[HP0R:d00P0018RcR;<20003R;>8008000BcR;>8
0P002K>/002cSP2>/`040003SP0000@07ML00`3Ge`0;e`030=OG00?G000ae`030=OG02GG0`000c/0
>`040008>`0kGc]O05l5000FI@29GhUOR@29GhUO08>9PhV308>9P`H00hT00`29R@03R@070:f9[HV]
R@04000:[HV]0:f9[HV]R@<000N9[HV]RJf9008000NcRK>9/hVc008000N]/jfc[K>]008000Bc[K>]
0P000k>]000200Bc0P02/`800[<20003/`00008000>c0000100Oe`030=OG00_G00<0emL00mL003;G
00<0emL09ML50003>a0k00@000XjGcX0>UljG`1O5P004ej9GP22RH:9PP22RH:9PXT0RH800`0028:9
08V8RHR90P0038R]0028R@2]R:f8[@8000N808R]R:f8008000N]0:f8[HR]008000B8002c0P000hRc
R0020004/`00R08000>cR;<00P000hh0000<02;G00<0emL02]L00`3Ge`03e`00<mL00`3Ge`0Ue`L0
00<k03/010000c/0G`02G`0L05mUGfD0REn9GhT0REn9G`1OREn9G`23RH>900J900<0RHT00XT4000<
RJf9[HT0RJf9[HV]0`001Jf9[HV]008000Z9002cRK>908Vc0P001hVcRK<0/jd00P002k>]/jfc0;>]
/jd000Fc00@0/k>c0P02/`8000>c00000P000hh0000302GG00<0emL02ML00`3Ge`03e`00==L202KG
2P000c@0>P050003>P1O00=O00<0Gel00Ul05P1NREj908UNREj9GP1NREj908V2RH86000=RH:908V2
RH:9PP28R@030009RHP0R8V8RHR9008000J8[HR]R:d30006[HR]R:f80`001HRcR;>8008000>c0;<0
0P0018VcRK<20006R@0008jc0P001Xh00;<0S`D0:=L00`3Ge`08e`030=OG00?G000fe`030=OG02CG
30001C]O>`0k00X000b9G`1OREn908UOREl;00>900<0RHT018T01@2]RJf900@000V]RJf9[HT0RJd0
0`001Zf9002cR@8000JcR@00/hT30006RK<00:fc0P000jfc[@0300>c0P02/`8000>cS`00100018l0
0;<502WG00<0emL02=L00`3Ge`03e`00=mL00`3Ge`0Ue`@000<@00001P0033X0>elk03]O>el0I@`0
01AOREl0GhUOR@29GhUOREl0PXV2R@H00hT20004RHR9R0@01XT30006RJf9[HV]0P001XVcRK>9/`<0
00>cRK<00P000hVcR@030007RK<008VcR@040003S`0000H0;=L00`3Ge`08e`030=OG00;G000he`03
0=OG02KG1@000c/000080006>`00IEmU0P0045mUG`1OREn908UOREn9G`04R@800hT600>900<0RHT0
18T50003RJf9008000>]R@000P001hVc0;>9/hT00P001K<008Vc00<000>cRK<00`001;>?/hl20007
/hl00;>?/`040005Sk<008h0100_e`030=OG00OG00<0emL00]L003WG0P0Xe`d000<k00002@001Ul0
GfEOI@8000=OREl02`0015n9G`06R@0308V900<00XT00`29R@04R@<01HT00`29[@020004RJf9[@<0
00FcRK>9/`020004R@29/`8000>9/hT00P000k<000030005Shh008l01@0`e`030=OG00OG00<0emL0
0]L003_G00<0emL09mL800035`00008000=U>fD00P001EmUG`1O00/000AURFD01HT00`29R@03R@80
0hT400J900<0[HT00`001hVc0029/hT010000k>9/`030006/hT00;>90P000k>9/`030003/hnc0080
00F?/`00S`020003S`0000D0==L00`3Ge`06e`030=OG00;G000le`030=OG02SG10000aL000020003
>P0000L000Dk05mUG`020004IEmUG`8000n9GhUO05n9GhUO05n9GhT01@03R@8018T400J91004R@<0
00JcRK>9/hT30003RK>9008000>cRK<00`001K>9002?00X0=mL00`3Ge`05e`030=OG00;G000me`03
0=OG02[G10000c/000040005>fDk03/07003R@800hT60003ShV?008000>9/`000P001[>9002cR@80
00JcR@00/hT30003RK>900<000>?/`000P000k>?000=03[G00<0emL01=L00`3Ge`02e`00?]L00`3G
e`0[e``000Dk03]O>`02000DIC]U06EOIEmU06EOIEl0GhUOREl20004RFF9I@D000=URFD00P04R@@0
1XT30005RHn9ShT00`000hV?R@030003RHl0008000>?RHl01@0018l006@503cG00<0emL01=L00`3G
e`02e`00?mL202gG50000fD00004I@0508UURFD00P000hUUR@0600>900<0RHT00hT50003RHn90080
00>cR@000P001XV?0029/`8000>9/hT00`000hncS`0200>?1@02S`8000>?00000`0oe`030=OG00CG
00<0emL00ML0047G00<0emL0;ML<00<k00<0I@0040000hUUR@020008IHUURFD0IHT20004IHT000B9
10001XV?RHn9S`<000>?R@000P000hV?R@030003RHl0008000F?001TS`0704?G00<0emL00mL00`3G
e`01e`00@]L00`3Ge`0_e``000IU001OIEl200=U0P0016F9IHT20003IHUU00X000B?RHn91P000hn9
S`020003RHl0008000>?R@000P000hV?R@0300:?0`02S`8000>?00001P16e`030=OG00;G00<0emL0
0ML004?G00<0emL0<MLO00=U0P0018UURFD50003IHUU008000B9IHUU10000hn9S`020003IHmU00<0
00=USfD00P000hmU000904[G00<0emL00]L00`3Ge`01e`00A=L203CG4@03I@8016D20003RFF900H0
00=USfD00P000hn9S`060003RHn900@000>?RHl00P000fF?I@070003I@0000<0CmL01@3GemL000?G
0016e`030=OG03CG7003I@8000AURFF91@000hUUR@060003IHmU00@000>?I@0010000fA[000505?G
00@0emL00mL004OG00<0emL0=mLQ0003SfF?00D000>?IHl01P000fF?000<05OG00@0emL00mL004SG
00<0emL0=mL0103GemL@0004>fDkI@/00fD500=U3P1Le`030=L000?G0019e`80=mL00`3Ge`06ead0
0VD@067G00<0e`000]L004_G00<0emL0==L00`3Ge`0;eb<0JML200;G001<e`030=OG03?G00<0emL0
6mL507OG0P02e`00CML00`3Ge`0ae`030=OG09SG0P02e`00C]L2037G00<0emL0U=L400CG001@e`03
0=OG02kG00<0emL0T=L400SG001Ae`030=OG02gG00<0emL0S=L400cG001Be`030=OG02cG00<0emL0
R=L4013G001Ce`80;=L00`3Ge`24e`@05=L005GG00<0emL0:ML00`3Ge`21e`<06=L005KG00<0emL0
:=L00`3Ge`1me`@06mL005OG00<0emL09mL00`3Ge`1ie`@07mL005SG00<0emL09]L00`3Ge`1ee`@0
8mL005WG0P0Ve`030=OG077G100We`00FmL00`3Ge`0Se`030=OG06gG100[e`00G=L00`3Ge`0Re`03
0=OG06[G0`0_e`00GML00`3Ge`0Qe`030=OG06KG100be`00G]L2027G00<0emL0H]L403KG001Pe`03
0=OG01kG00<0emL0G]L403[G001Qe`030=OG01gG00<0emL0F]L403kG001Re`030=OG01cG00<0emL0
E]L404;G001Se`807=L00`3Ge`1Ce`<0A]L006GG00<0emL06ML00`3Ge`1?e`@0BML006KG00<0emL0
6=L00`3Ge`1;e`@0CML006OG00<0emL05mL00`3Ge`17e`@0DML006SG0P0Ge`030=OG04?G101Ee`00
J]L00`3Ge`0De`030=OG043G0`1Ie`00JmL00`3Ge`0Ce`030=OG03cG101Le`00K=L00`3Ge`0Be`03
0=OG03SG101Pe`00KML201;G00<0emL0==L406CG001_e`030=OG00oG00<0emL0<=L406SG001`e`03
0=OG00gG00<0emL0;ML406cG001ae`030=OG00cG00<0emL0:]L3073G001be`030=OG00_G00<0emL0
9]L407?G001ce`802mL00`3Ge`0Re`@0MmL007GG00<0emL02=L00`3Ge`0Ne`@0NmL007KG00<0emL0
1mL00`3Ge`0Je`@0OmL007OG00<0emL01]L00`3Ge`0Fe`@0PmL007SG0P06e`030=OG01?G0`27e`00
N]L00`3Ge`03e`030=OG00oG102:e`00NmL00`3Ge`02e`030=OG00_G102>e`00O=L01@3GemL000WG
102Be`00OML20003e`3G00CG102Fe`00OmL20003e`000080V]L0083G0P2Ne`00omLQe`00omLQe`00
omLQe`00omLQe`00\
\>"],
  ImageRangeCache->{{{0, 287}, {232.562, 0}} -> {-0.0895518, 0.00531371, \
0.00364738, 0.00364738}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  SurfaceGraphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{\( (*\ 
        Step\ 2 : \ 
          Arrange\ four - fold\ loop\ for\ eigenvalue\ om\ \((q)\), \ 
        number\ of\ iteration\ \((p)\), \ 
        for\ l\ and\ k\ for\ the\ matrix . \ Start\ iteration\ with\ n = \(4  
              or\ 6\ and\ iterat = 
            6. \ Then\ refine\ the\ search\ interval\ for\ om\ by\ modifying\ \
omlast\ as\ soon\ as\ det\ changes\ sign\)\ *) \), "\n", "\n", 
      StyleBox[\(\(Clear[om, omlast, x, y, Eyoung, rho0, alph, R, dth];\)\n
        Eyoung = 1. ; rho0 = 1. ; alph = 0.1; R = 1. ; \ dth = Pi/\((2*n)\); 
        n = 6;\n
        Table[x[l] = R*Cos[l*dth], {l, 1, n}]; 
        Table[y[l] = R*Sin[l*dth], {l, 1, n}];\n
        \(Clear[sol1, tyl1, X1, FX1, Y1, FY1, M, omeg, detf, Detfct];\)\ \n
        \(M = Table[l*k, {l, 1, n}, {k, 1, n}];\)\n
        \(For[q = 1, \ q\  < \ 2, \nom1 = 2.3; omlast = 4. ; iterat = 6; 
            deltaom = \((omlast - om1)\)/iterat; om = om1; \n
            b[1] = om1 - 0.00001; delta = om1/n; \n
            Table[b[k + 1] = b[k] - delta, {k, 1, 
                n - 1}]; \n (*Print["\<beta's = \>", 
                Table[b[k], {k, 1, n}]]; *) \n
            For[p = 1, \ p\  < \ iterat + 1, \n
              For[l = 1, \ 
                l\  < \ n + 1, \ \n\(For[k = 1, \ 
                  k\  < \ n + 1, \n (*delta = om1/n; \nb[1] = om - 0.00001; \n
                    Table[b[k + 1] = b[l] - delta, {k, 1, n - 1}]; \n
                    Table[b[k], {k, 1, n}]; *) \n (*Print[{"\<omega= \>", 
                        om, "\<k= \>", k, "\<l= \>", l, "\<beta= \>", 
                        b[k]}]; *) \n
                  sol1 = NDSolve[{\(X1''\)[x] + 
                            X1[x]*\((\(-b[k]^2\)*Eyoung + 
                                    om^2*rho0*\((1.  + 
                                        alph*\((R^2 - x^2)\))\))\)/Eyoung == 
                          0, \ \(X1'\)[0. ] == 0.0, \ X1[0. ] == 1. }, 
                      X1, {x, 0. , 2. *Pi}]; \n
                  FX1[x_, b[k]] = X1[x]\  /. \ First[sol1]; \n
                  tyl1 = NDSolve[{\(Y1''\)[y] + b[k]^2*Y1[y] - 
                            Y1[y]*om^2*rho0*alph*y^2/Eyoung == 
                          0, \ \(Y1'\)[0] == 0.0, \ Y1[0] == 1. }, 
                      Y1, {y, 0. , 2. *Pi}]; \n
                  FY1[y_, b[k]] = Y1[y]\  /. \ First[tyl1]; \n
                  Table[M[\([\)\(l, k\)\(]\)] = 
                      FX1[x[l], b[k]]*
                        FY1[y[l], b[k]]]; \n; \(k++\)]; \)\n; \(l++\)]; \n
              omeg[p] = om; detf[p] = Det[M]; \n
              Print[{"\<iteration= \>", p, "\<omega= \>", 
                  omeg[p], "\<Det= \>", detf[p]}]; \n
              om = om + deltaom; \n\(p++\)]; \n\(q++\)];\)\),
        FontSize->18]}]], "Input"],

Cell[BoxData[
    RowBox[{"\n", 
      RowBox[{
        StyleBox[\(Clear[Detfct];\),
          FontSize->18], 
        StyleBox["\n",
          FontSize->18], 
        StyleBox[\(Detfct = Table[{omeg[p], detf[p]}, {p, 1, iterat - 1}];\),
          FontSize->18], 
        StyleBox["\n",
          FontSize->18], 
        StyleBox[\(ListPlot[Detfct, PlotJoined -> True]\),
          FontSize->18], 
        StyleBox["\n",
          FontSize->18], 
        StyleBox[\( (*\ 
            RESULT\ FOR\ CONSTANT\ DENSITY\ SHOULD\ \(BE\  : \ om\) = 
              2.404825\ \ *) \),
          FontSize->18], "\[IndentingNewLine]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\( (*\ 
        Step\ 3 : \ Check\ and\ refine\ result\ *) \)\(\n\)\(Clear[HI, om]; 
      HI = Interpolation[Detfct];\n
      \(Plot[HI[om], {om, 2.3, 2.6}];\)\n
      FindRoot[HI[om] == 0, {om, {2.3, 2.6}}]\)\),
      FontSize->18]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-7.27778 3.1746 0.557492 2.39343e+11 [
[.18254 .54499 -12 -9 ]
[.18254 .54499 12 0 ]
[.34127 .54499 -9 -9 ]
[.34127 .54499 9 0 ]
[.5 .54499 -12 -9 ]
[.5 .54499 12 0 ]
[.65873 .54499 -9 -9 ]
[.65873 .54499 9 0 ]
[.81746 .54499 -12 -9 ]
[.81746 .54499 12 0 ]
[.97619 .54499 -9 -9 ]
[.97619 .54499 9 0 ]
[.01131 .07881 -43.5 -6.25 ]
[.01131 .07881 0 6.25 ]
[.01131 .19848 -55.5 -6.25 ]
[.01131 .19848 0 6.25 ]
[.01131 .31815 -43.5 -6.25 ]
[.01131 .31815 0 6.25 ]
[.01131 .43782 -43.5 -6.25 ]
[.01131 .43782 0 6.25 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .55749 m
.18254 .56374 L
s
[(2.35)] .18254 .54499 0 1 Mshowa
.34127 .55749 m
.34127 .56374 L
s
[(2.4)] .34127 .54499 0 1 Mshowa
.5 .55749 m
.5 .56374 L
s
[(2.45)] .5 .54499 0 1 Mshowa
.65873 .55749 m
.65873 .56374 L
s
[(2.5)] .65873 .54499 0 1 Mshowa
.81746 .55749 m
.81746 .56374 L
s
[(2.55)] .81746 .54499 0 1 Mshowa
.97619 .55749 m
.97619 .56374 L
s
[(2.6)] .97619 .54499 0 1 Mshowa
.125 Mabswid
.05556 .55749 m
.05556 .56124 L
s
.0873 .55749 m
.0873 .56124 L
s
.11905 .55749 m
.11905 .56124 L
s
.15079 .55749 m
.15079 .56124 L
s
.21429 .55749 m
.21429 .56124 L
s
.24603 .55749 m
.24603 .56124 L
s
.27778 .55749 m
.27778 .56124 L
s
.30952 .55749 m
.30952 .56124 L
s
.37302 .55749 m
.37302 .56124 L
s
.40476 .55749 m
.40476 .56124 L
s
.43651 .55749 m
.43651 .56124 L
s
.46825 .55749 m
.46825 .56124 L
s
.53175 .55749 m
.53175 .56124 L
s
.56349 .55749 m
.56349 .56124 L
s
.59524 .55749 m
.59524 .56124 L
s
.62698 .55749 m
.62698 .56124 L
s
.69048 .55749 m
.69048 .56124 L
s
.72222 .55749 m
.72222 .56124 L
s
.75397 .55749 m
.75397 .56124 L
s
.78571 .55749 m
.78571 .56124 L
s
.84921 .55749 m
.84921 .56124 L
s
.88095 .55749 m
.88095 .56124 L
s
.9127 .55749 m
.9127 .56124 L
s
.94444 .55749 m
.94444 .56124 L
s
.25 Mabswid
0 .55749 m
1 .55749 L
s
.02381 .07881 m
.03006 .07881 L
s
gsave
.01131 .07881 -43.5 -4.25 Mabsadd m
1 1 Mabs scale
/Courier findfont 10 scalefont setfont
(-2) show
/Math1Mono findfont 10 scalefont setfont
(\\264) show
/Courier findfont 10 scalefont setfont
(10) show
0 5.25 rmoveto
/Courier findfont 7.5 scalefont setfont
(-12) show
grestore
.02381 .19848 m
.03006 .19848 L
s
gsave
.01131 .19848 -55.5 -4.25 Mabsadd m
1 1 Mabs scale
/Courier findfont 10 scalefont setfont
(-1.5) show
/Math1Mono findfont 10 scalefont setfont
(\\264) show
/Courier findfont 10 scalefont setfont
(10) show
0 5.25 rmoveto
/Courier findfont 7.5 scalefont setfont
(-12) show
grestore
.02381 .31815 m
.03006 .31815 L
s
gsave
.01131 .31815 -43.5 -4.25 Mabsadd m
1 1 Mabs scale
/Courier findfont 10 scalefont setfont
(-1) show
/Math1Mono findfont 10 scalefont setfont
(\\264) show
/Courier findfont 10 scalefont setfont
(10) show
0 5.25 rmoveto
/Courier findfont 7.5 scalefont setfont
(-12) show
grestore
.02381 .43782 m
.03006 .43782 L
s
gsave
.01131 .43782 -43.5 -4.25 Mabsadd m
1 1 Mabs scale
/Courier findfont 10 scalefont setfont
(-5) show
/Math1Mono findfont 10 scalefont setfont
(\\264) show
/Courier findfont 10 scalefont setfont
(10) show
0 5.25 rmoveto
/Courier findfont 7.5 scalefont setfont
(-13) show
grestore
.125 Mabswid
.02381 .10274 m
.02756 .10274 L
s
.02381 .12667 m
.02756 .12667 L
s
.02381 .15061 m
.02756 .15061 L
s
.02381 .17454 m
.02756 .17454 L
s
.02381 .22241 m
.02756 .22241 L
s
.02381 .24635 m
.02756 .24635 L
s
.02381 .27028 m
.02756 .27028 L
s
.02381 .29421 m
.02756 .29421 L
s
.02381 .34208 m
.02756 .34208 L
s
.02381 .36602 m
.02756 .36602 L
s
.02381 .38995 m
.02756 .38995 L
s
.02381 .41389 m
.02756 .41389 L
s
.02381 .46175 m
.02756 .46175 L
s
.02381 .48569 m
.02756 .48569 L
s
.02381 .50962 m
.02756 .50962 L
s
.02381 .53356 m
.02756 .53356 L
s
.02381 .05487 m
.02756 .05487 L
s
.02381 .03094 m
.02756 .03094 L
s
.02381 .007 m
.02756 .007 L
s
.02381 .58143 m
.02756 .58143 L
s
.02381 .60536 m
.02756 .60536 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .60332 m
.06244 .56864 L
.10458 .53196 L
.14415 .4986 L
.18221 .46749 L
.22272 .4354 L
.26171 .40551 L
.30316 .37479 L
.34309 .34621 L
.3815 .31964 L
.42237 .29235 L
.46172 .26702 L
.49955 .24352 L
.53984 .21941 L
.57861 .19708 L
.61984 .17428 L
.65954 .15319 L
.69774 .13373 L
.73838 .11388 L
.77751 .09559 L
.81909 .07702 L
.85916 .05997 L
.89771 .04432 L
.93871 .02848 L
.97619 .01472 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/@P10`40000100000000<`00IP00V@00
c000o`0c000c<`0cIP0cV@0cc00co`1V001V<`1VIP1VV@1Vc01Vo`2I002I<`2IIP2IV@2Ic02Io`3<
003<<`3<IP3<V@3<c03<o`3o003o<`3oIP3oV@3oc03ooc<003<0<c<0IS<0VC<0c3<0oc<c03<c<c<c
IS<cVC<cc3<coc=V03=V<c=VIS=VVC=Vc3=Voc>I03>I<c>IIS>IVC>Ic3>Ioc?<03?<<c?<IS?<VC?<
c3?<oc?o03?o<c?oIS?oVC?oc3?oofH006H0<fH0IVH0VFH0c6H0ofHc06Hc<fHcIVHcVFHcc6HcofIV
06IV<fIVIVIVVFIVc6IVofJI06JI<fJIIVJIVFJIc6JIofK<06K<<fK<IVK<VFK<c6K<ofKo06Ko<fKo
IVKoVFKoc6KooiT009T0<iT0IYT0VIT0c9T0oiTc09Tc<iTcIYTcVITcc9TcoiUV09UV<iUVIYUVVIUV
c9UVoiVI09VI<iVIIYVIVIVIc9VIoiW<09W<<iW<IYW<VIW<c9W<oiWo09Wo<iWoIYWoVIWoc9Wool`0
0<`0<l`0I/`0VL`0c<`0ol`c0<`c<l`cI/`cVL`cc<`colaV0<aV<laVI/aVVLaVc<aVolbI0<bI<lbI
I/bIVLbIc<bIolc<0<c<<lc<I/c<VLc<c<c<olco0<co<lcoI/coVLcoc<coool00?l0<ol0I_l0VOl0
c?l0oolc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nIooo<
0?o<<oo<I_o<VOo<c?o<oooo0?oo<oooI_ooVOooc?ooooCM/_[aghUlI<FbZ>KNfVYPFjNGSol0VOl0
c?l0oolc0?lc<olcI_lcVOlcc?lcoomV0?mV<omVI_mVVOmVc?mVoonI0?nI<onII_nIVOnIc?nIooo<
0?o<<oo<I_o<VOo<c?o<oooo0?oo<oooI_ooVOooc?oooooG8ML00?oG8ML00?oG8ML00?oG8ML00?oG
8ML00?oG8ML00?oG8ML00?oG8ML00?oG8ML00?oG8ML00?oG8ML00?oG8ML00?oG8ML00?oG8ML00?oG
8ML00?oG8ML00?oG8ML003[G00<0emL0hmL003[G0P3Te`00>]L00`3Ge`3Se`00>]L00`3Ge`3He`80
2ML003[G00<0emL0eML300_G000je`030=OG0=;G0`0>e`00>]L00`3Ge`3?e`<04ML003[G0P3>e`80
5=L003[G00<0emL0b]L301KG000je`030=OG0<SG0P0Ie`00>]L00`3Ge`36e`806mL003[G00<0emL0
a=L201gG000je`80`mL201oG000je`030=OG0<3G0P0Qe`00>]L00`3Ge`2me`<08mL001?G1002e`06
0=OGe`3G1003e`804]L00`3Ge`2ke`809]L001?G00<0emL01=L00`3G0004e`050=OGe`000]L00`3G
e`0?e`030=OG0;SG0`0Xe`005=L00`3Ge`04e`030=OG00?G00D0emOG0002e`030=OG00oG00<0emL0
]]L202_G000=e`@01=L00`3Ge`02e`030=L000CG00D0emOG0002e`030=OG00oG0P2de`<0;ML001KG
00@0emL00mL01@3GemL000?G00@0emL04ML00`3Ge`2ae`80<=L001?G00@0emL02=L300?G00@0emL0
1mL300;G0`02e`030=OG0:oG0P0be`005=L200_G00<0emL00]L200WG00D0emOG0004e`030=OG0:gG
0P0de`00:]L400?G00<0emL00]L01@3GemL00:cG0`0fe`00<ML00`3Ge`03e`030=OG0080ZML203WG
000`e`800mL00`3G0002e`030=OG0:KG0P0ke`00<ML00`3Ge`02e`050=OGe`00Y]L203gG000je`03
0=OG0:;G0P0oe`00>]L00`3Ge`2Pe`80@ML003[G00<0emL0W]L204?G000je`80WML204GG000je`03
0=OG09[G0P17e`00>]L00`3Ge`2Ge`<0BML003[G00<0emL0UML204cG000je`030=OG09?G0P1>e`00
>]L00`3Ge`2Ae`80D=L003[G0P2@e`80D]L003[G00<0emL0SML205CG000je`030=OG08_G0P1Fe`00
>]L00`3Ge`29e`80F=L003[G00<0emL0QmL205[G000je`80QmL00`3Ge`1Je`00>]L00`3Ge`24e`80
GML000OG1003e`030=OG00;G0`03e`060=OGe`3G1003e`804]L00`3Ge`22e`80GmL000WG00<0emL0
2]L01`3GemL0e`001=L01@3GemL000;G00<0emL03mL00`3Ge`20e`80HML000WG00<0emL02]L00`3G
e`02e`030=OG00?G00D0emOG0002e`030=OG00oG00<0emL0O]L206?G00000mL0000200CG00<0emL0
1mL300CG00<0e`001=L01@3GemL000;G00<0emL03mL00`3Ge`1me`030=OG06?G0009e`030=OG00OG
00<0emL00mL01@3GemL000?G00D0emOG0002e`030=OG00oG0P1le`80I]L000OG0`09e`030=OG00WG
0`03e`040=OG017G00<0emL0NML206SG0009e`030=OG00OG100:e`030=OG00;G0P08e`<00]L300;G
00<0emL0MmL206[G000ae`050=OGe`001=L00`3Ge`1ee`80K=L002[G1003e`030=OG00;G00D0emOG
001fe`030=OG06cG000ae`030=OG00?G00<0emL00P1ce`80KmL0033G0P03e`030=L000;G00<0emL0
LML00`3Ge`1_e`00<ML00`3Ge`02e`050=OGe`00LML207;G000je`030=OG06kG00<0emL0L]L003[G
00<0emL0K=L207GG000je`030=OG06_G00<0emL0MML003[G0P1Ze`80N=L003[G00<0emL0ImL207[G
000je`030=OG06GG0P1le`00>]L00`3Ge`1Se`80O]L003[G00<0emL0H]L00`3Ge`1ne`00>]L2067G
0P21e`00>]L00`3Ge`1Oe`030=OG087G000je`030=OG05gG0P24e`00>]L00`3Ge`1Le`030=OG08CG
000je`030=OG05[G0P27e`00>]L00`3Ge`1Ie`030=OG08OG000je`80F=L208[G000je`030=OG05GG
0P2<e`004mL400;G00H0emOG0=L400?G0P0Be`030=OG05CG00<0emL0S=L001GG00<0emL00]L00`3G
0004e`050=OGe`000]L00`3Ge`0?e`030=OG05;G0P2?e`005ML00`3Ge`03e`030=OG00?G00D0emOG
0002e`030=OG00oG00<0emL0D=L2097G000=e`@01=L00`3Ge`02e`030=L000CG00D0emOG0002e`03
0=OG00oG0P1@e`030=OG097G000Ee`050=OGe`000mL01@3GemL000?G00@0emL04ML00`3Ge`1>e`03
0=OG09;G000Ce`<02ML300?G00@0emL01mL300;G0`02e`030=OG04gG00<0emL0TmL001GG00<0emL0
2ML00`3Ge`02e`802ML01@3GemL000CG00<0emL0C=L00`3Ge`2De`00:]L400?G00<0emL00]L01@3G
emL004cG0P2Ge`00<ML00`3Ge`03e`040=OG04_G00<0emL0UmL0033G0P03e`030=L000;G0P19e`03
0=OG09SG000ae`030=OG00;G00D0emOG0019e`030=OG09WG000je`030=OG04GG0P2Le`00>]L00`3G
e`13e`80W]L003[G00<0emL0@]L00`3Ge`2Ne`00>]L2047G0P2Qe`00>]L00`3Ge`0ne`80XmL003[G
00<0emL0?ML00`3Ge`2Se`00>]L00`3Ge`0le`030=OG0:CG000je`030=OG03[G0P2We`00>]L00`3G
e`0ie`030=OG0:OG000je`80>ML00`3Ge`2Xe`00>]L00`3Ge`0fe`80ZmL003[G00<0emL0=ML00`3G
e`2[e`00>]L00`3Ge`0de`030=OG0:cG000je`030=OG03?G00<0emL0[ML003[G0P0be`80/=L003[G
00<0emL0<=L00`3Ge`2`e`004mL300?G00H0emOG0=L400?G0P0Be`030=OG02oG00<0emL0/ML001KG
00L0emOG0=L000CG00D0emOG0002e`030=OG00oG00<0emL0;ML20;CG000Fe`030=OG00;G00<0emL0
0mL01@3GemL000;G00<0emL03mL00`3Ge`0/e`030=OG0;CG000=e`@00]L300CG00<0e`001=L01@3G
emL000;G00<0emL03mL00`3Ge`0[e`030=OG0;GG000Ce`030=OG00?G00D0emOG0003e`050=OGe`00
0]L00`3Ge`0?e`80:mL00`3Ge`2fe`004mL00`3Ge`09e`<00mL0103Ge`0Ae`030=OG02SG0P2ie`00
4mL400[G00<0emL00]L200SG0`03e`050=OGe`00:ML00`3Ge`2ie`00<ML01`3GemL0e`000]L00`3G
e`0Ve`030=OG0;[G000Ze`@00mL00`3Ge`03e`040=OG02OG00<0emL0^mL0037G00<0emL00]L200;G
0P0Te`80_]L0033G0P03e`030=L000;G00<0emL08]L00`3Ge`2ne`00<ML00`3Ge`02e`050=OGe`00
8mL00`3Ge`2oe`00>]L00`3Ge`0Pe`030=OG0<3G000je`030=OG01oG00<0emL0`ML003[G00<0emL0
7]L00`3Ge`32e`00>]L201gG0P35e`00>]L00`3Ge`0Ke`030=OG0<GG000je`030=OG01[G00<0emL0
a]L003[G00<0emL06ML00`3Ge`37e`00>]L00`3Ge`0He`030=OG0<SG000je`805mL20<_G000je`03
0=OG01GG1@03e`030=OG00?G0P03e`<04mL400?G00<0emL01=L00`3Ge`0Ae`@00mL00`3Ge`04e`04
0=OGe`<04]L400?G00<0emL00]L301?G1003e`030=OG00;G0`03e`<04mL400?G00<0emL00mL200?G
000je`030=OG01CG00<0e`002mL0103Ge`05e`030=OG013G00<0emL02mL00`3Ge`0Ae`030=OG00_G
00<0emL01=L00`3Ge`0?e`030=OG00cG00<0emL04=L00`3Ge`0<e`030=OG00?G00<0emL04=L00`3G
e`09e`040=OG00;G000je`030=OG01;G0P03e`030=OG00_G00<0emL00mL00`3Ge`0Ae`030=OG00OG
1@0Ce`030=OG00OG1@05e`030=OG013G00<0emL02mL00`3Ge`0Ae`030=OG00_G00<0emL00mL00`3G
e`0Ae`030=OG00SG00@0emL00]L003[G00<0emL04ML00`3Ge`04e`030=OG00SG0P03e`<05ML00`3G
e`06e`040=OG01GG00<0emL01]L0103Ge`03e`<05=L00`3Ge`07e`<05ML00`3Ge`07e`<00mL301GG
00<0emL01mL300?G000je`030=OG013G00<0emL01]L00`3Ge`09e`040=OG01SG00<0emL01]L00`3G
000Fe`030=OG00KG00<0e`000mL00`3Ge`0Ee`030=OG00KG00<0emL05]L00`3Ge`06e`030=OG00?G
00<0emL05]L00`3Ge`06e`030=OG00?G000je`804=L00`3Ge`04e`040=OG00SG00@0emL00]L00`3G
e`0Ce`040=OG00WG0P0Ce`040=OG00WG0P03e`030=OG01;G00@0emL02=L00`3Ge`0Ce`040=OG00SG
00<0emL00mL00`3Ge`0Ce`040=OG00SG00<0emL00mL003[G00<0emL03]L00`3Ge`06e`802]L200?G
100Ce`802mL00`3Ge`0Be`802mL0103GemL401;G0P09e`@04mL200WG1002e`@04mL200[G0`02e`00
>]L00`3Ge`0=e`030=OG0=?G000je`030=OG00cG00<0emL0e=L003[G00<0emL02]L20=OG000denP0
1=L003[G00<0emL01=L01@3GemL000?G00<0emL01=L00`3Ge`04e`030=OG00CG00<0emL01ML00`3G
e`04e`030=OG00CG00<0emL01ML00`3Ge`04e`030=OG00CG00<0emL01ML00`3Ge`04e`030=OG00CG
00<0emL01ML00`3Ge`04e`030=OG00CG00<0emL01ML00`3Ge`04e`030=OG00CG00<0emL01ML00`3G
e`04e`030=OG00CG00<0emL01ML00`3Ge`04e`030=OG00CG00<0emL01ML00`3Ge`04e`030=OG00CG
00<0emL01ML00`3Ge`07e`00>]L00`3Ge`07e`030=OG01OG00<0emL08]L00`3Ge`0Re`030=OG027G
00<0emL08]L00`3Ge`0Re`030=OG00OG000je`030=OG00KG00<0emL0f]L003[G00<0emL01ML00`3G
e`3Ke`00>]L00`3Ge`04e`030=OG0=cG000je`801=L00`3Ge`3Me`00>]L0103GemL20>3G000je`04
0=OG0>;G000je`030=L00>?G000je`80i=L003[G0P3Te`00>]L00`3Ge`3Se`00>]L00`3Ge`3Se`00
>]L00`3Ge`3Se`00omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00
omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00omLQe`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {2.22025, -2.6411*^-12, \
0.00136602, 1.81187*^-14}}],

Cell[BoxData[
    \({Null\^2\ \((om \[Rule] 2.323357043482287`)\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{\(om = 2.32336\), "\n", 
      StyleBox[\( (*\ 
          Now\ solve\ the\ linear\ equations\ for\ the\ amplitudes\ Amp\ *) \
\),
        FontSize->18]}], "\n", 
    StyleBox[\(Clear[bbf, rdutn, B, An, A, Amp, boundary, fxy]; nf = n - 1;\),
      
      FontSize->18], "\n", 
    StyleBox[\(bbf = Table[\(-M[\([ifit, n]\)]\), {ifit, 1, n - 1}];\),
      FontSize->18], "\n", 
    RowBox[{
      StyleBox[\(rdutn = 
            Table[M[\([ifit, klfit]\)], {ifit, 1, n - 1}, {klfit, 1, 
                n - 1}];\),
        FontSize->18], 
      StyleBox["\n",
        FontSize->18], 
      StyleBox[\( (*MatrixForm[rdutn]*) \),
        FontSize->18]}], "\n", 
    StyleBox[\(B = LinearSolve[rdutn, bbf];\),
      FontSize->18], "\n", 
    StyleBox[\(An = {1.0};\),
      FontSize->18], "\n", 
    StyleBox[\(A = Table[B[\([lk]\)], {lk, 1, n - 1}]\),
      FontSize->18]}], "Input"],

Cell[BoxData[
    \(2.32336`\)], "Output"],

Cell[BoxData[
    \({\(-0.04658177312586851`\), 
      0.38360317545509587`, \(-1.3414665683627114`\), 
      2.506396579142135`, \(-2.5019593001431186`\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(\n\)\( (*\ 
        Step\ 4 : \ 
          Check\ satisfaction\ of\ boundary\ condition\ *) \)\(\n\)\(\(Amp = 
        Join[A, An]\)\(\n\)
      \)\),
      FontSize->18]], "Input"],

Cell[BoxData[
    \({\(-0.04658177312586851`\), 
      0.38360317545509587`, \(-1.3414665683627114`\), 
      2.506396579142135`, \(-2.5019593001431186`\), 1.`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        StyleBox[
          RowBox[{"b", 
            StyleBox["oundary",
              FontSize->18]}]], 
        StyleBox[" ",
          FontSize->18], 
        StyleBox["=",
          FontSize->18], 
        StyleBox[" ",
          FontSize->18], 
        StyleBox[\(M\  . \ Amp\),
          FontSize->18]}], "\n"}]], "Input"],

Cell[BoxData[
    \({1.1102230246251565`*^-16, 0.`, 1.1102230246251565`*^-16, 
      5.551115123125783`*^-17, \(-3.3306690738754696`*^-16\), 
      0.000017143692302434843`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\( (*\ 
        Step\ 5 : \ 
          Check\ the\ satisfaction\ of\ the\ boundary\ condition\ *) \), 
      "\[IndentingNewLine]", 
      RowBox[{\(Clear[fxy];\), "\n", 
        StyleBox[\(fxy[x_, y_] = 
              Sum[Amp[\([k]\)]*FX1[x, b[k]]*FY1[y, b[k]], {k, 1, 
                  n}] (*\ \(/;\)\(x^2 + y^2 <= R^2\)*) \ ;\),
          FontSize->18], 
        StyleBox["\n",
          FontSize->18], 
        StyleBox[\(Do[Print[fxy[x[l], y[l]]], {l, n}]\),
          FontSize->18], "\n"}]}]], "Input"],

Cell[BoxData[
    \(\(-6.938292265390444`*^-6\)\)], "Print"],

Cell[BoxData[
    \(\(-6.288443865187787`*^-6\)\)], "Print"],

Cell[BoxData[
    \(\(-6.319656537079332`*^-6\)\)], "Print"],

Cell[BoxData[
    \(\(-5.780277107736431`*^-6\)\)], "Print"],

Cell[BoxData[
    \(\(-6.170190152032795`*^-6\)\)], "Print"],

Cell[BoxData[
    \(\(-7.766912393347702`*^-6\)\)], "Print"],

Cell[BoxData[
    \(Null\^3\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.1 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{1056, 813},
WindowMargins->{{100, Automatic}, {Automatic, 21}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1727, 52, 1004, 19, 216, "Input"],
Cell[2734, 73, 130, 3, 31, "Output"],
Cell[2867, 78, 130, 3, 31, "Output"],
Cell[3000, 83, 16686, 556, 296, 5075, 408, "GraphicsData", "PostScript", \
"Graphics"],
Cell[19689, 641, 130, 3, 31, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19856, 649, 373, 7, 101, "Input"],
Cell[20232, 658, 112079, 2605, 242, 72368, 2110, "GraphicsData", \
"PostScript", "Graphics"],
Cell[132314, 3265, 137, 3, 31, "Output"]
}, Open  ]],
Cell[132466, 3271, 2777, 49, 906, "Input"],
Cell[135246, 3322, 637, 18, 147, "Input"],

Cell[CellGroupData[{
Cell[135908, 3344, 273, 6, 101, "Input"],
Cell[136184, 3352, 12414, 417, 186, 4803, 319, "GraphicsData", "PostScript", \
"Graphics"],
Cell[148601, 3771, 80, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[148718, 3777, 906, 25, 216, "Input"],
Cell[149627, 3804, 42, 1, 31, "Output"],
Cell[149672, 3807, 169, 3, 31, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[149878, 3815, 212, 6, 101, "Input"],
Cell[150093, 3823, 174, 3, 31, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[150304, 3831, 371, 14, 55, "Input"],
Cell[150678, 3847, 187, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[150902, 3855, 535, 13, 147, "Input"],
Cell[151440, 3870, 60, 1, 32, "Print"],
Cell[151503, 3873, 60, 1, 32, "Print"],
Cell[151566, 3876, 60, 1, 32, "Print"],
Cell[151629, 3879, 60, 1, 32, "Print"],
Cell[151692, 3882, 60, 1, 32, "Print"],
Cell[151755, 3885, 60, 1, 32, "Print"],
Cell[151818, 3888, 41, 1, 36, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

